    namespace std {
       inline namespace _LIBCPP_ABI_NAMESPACE {
      template <bool, class _Tp = void> struct enable_if {
       typedef _Tp type;
     };
      template <bool _Bp, class _Tp = void> using __enable_if_t __attribute__(()) = typename enable_if<_Bp, _Tp>::type;
      template <bool _Bp, class _Tp = void> using enable_if_t = typename enable_if<_Bp, _Tp>::type;
      }
       inline namespace _LIBCPP_ABI_NAMESPACE {
      template <class _Tp, _Tp __v> struct integral_constant {
       static constexpr const _Tp value = __v;
     };
      typedef integral_constant<bool, true> true_type;
      typedef integral_constant<bool, false> false_type;
      template <bool _Val> using _BoolConstant __attribute__(()) = integral_constant<bool, _Val>;
      template <class _Tp, class _Up> using _IsSame = _BoolConstant<__is_same(_Tp, _Up)>;
      template <class _Tp> using __remove_cv_t = __remove_cv(_Tp);
      }
       inline namespace _LIBCPP_ABI_NAMESPACE {
      template <class _Tp> struct is_integral : _BoolConstant<__is_integral(_Tp)> {};
      template <class _Tp> using __libcpp_remove_reference_t = __remove_reference_t(_Tp);
      template <class _Tp> using remove_reference_t = __libcpp_remove_reference_t<_Tp>;
      template <class _Tp> using __make_const_lvalue_ref = const __libcpp_remove_reference_t<_Tp>&;
      template <class _Tp> _Tp&& __declval(int);
      template <class _Tp> decltype(std::__declval<_Tp>(0)) declval() noexcept;
      template <class _Tp> inline constexpr bool is_reference_v = __is_reference(_Tp);
      template <class _Tp> inline constexpr bool is_lvalue_reference_v = __is_lvalue_reference(_Tp);
      template <class _T1, class _T2> struct is_convertible : public integral_constant<bool, __is_convertible(_T1, _T2)> {};
      template <class _From, class _To> inline constexpr bool is_convertible_v = is_convertible<_From, _To>::value;
      template <class _From, class _To> concept convertible_to = is_convertible_v<_From, _To> && requires {
     static_cast<_To>(std::declval);
     };
      template <class _Tp, class _Up> concept __same_as_impl = _IsSame<_Tp, _Up>::value;
      template <class _Tp, class _Up> concept same_as = __same_as_impl<_Tp, _Up> && __same_as_impl<_Up, _Tp>;
      template <bool _Bp, class _If, class _Then> struct conditional {
       using type __attribute__(()) = _If;
     };
      template <bool _Bp, class _IfRes, class _ElseRes> using conditional_t __attribute__(()) = typename conditional<_Bp, _IfRes, _ElseRes>::type;
      template <class _Tp> using __decay_t __attribute__(()) = __decay(_Tp);
      template <class _Tp> using __remove_cvref_t __attribute__(()) = __remove_cvref(_Tp);
      template <class _Tp> using remove_cvref_t = __remove_cvref_t<_Tp>;
      template <class _Tp, class _Up> using __cond_type = decltype(std::declval<_Up>());
      template <class _Tp, class _Up, class = void> struct __common_type3 {
       using type = remove_cvref_t<__cond_type<const _Tp&, const _Up&>>;
     };
      template <class _Tp, class _Up, class = void> struct __common_type2_imp : __common_type3<_Tp, _Up> {};
      template <class... _Tp> struct common_type;
      template <class _Tp> struct common_type<_Tp> : public common_type<_Tp, _Tp> {};
      template <class _Tp, class _Up> struct common_type<_Tp, _Up>     : conditional<_IsSame<_Tp, __decay_t<_Tp> >::value && _IsSame<_Up, __decay_t<_Up> >::value,                   __common_type2_imp<_Tp, _Up>,                   common_type<> >::type {};
      template <class... _Tp> using common_type_t = typename common_type<_Tp...>::type;
      template <class _Tp> struct add_const {
       typedef __attribute__(()) const _Tp type;
     };
      template <class _From, class _To> struct __copy_cv ;
      template <class _From, class _To> using __copy_cv_t = typename __copy_cv<_From, _To>::type;
      template <class _Tp> using __add_lvalue_reference_t = __add_lvalue_reference(_Tp);
      template <class _Tp> using __add_rvalue_reference_t = __add_rvalue_reference(_Tp);
      template <class _Xp, class _Yp> using __cond_res = decltype(false ? 0 : 0);
      template <class _Ap, class _Bp, class _Xp = remove_reference_t<_Ap>, class _Yp = remove_reference_t<_Bp>> struct __common_ref;
      template <class _Xp, class _Yp> using __common_ref_t = typename __common_ref<_Xp, _Yp>::__type;
      template <class _Xp, class _Yp> using __cv_cond_res = __cond_res<__copy_cv_t<_Xp, _Yp>&, __copy_cv_t<_Yp, _Xp>&>;
      template <class _Ap, class _Bp, class _Xp, class _Yp>   requires     requires {
     typename __cv_cond_res<_Xp, _Yp>;
     }
      &&     is_reference_v<__cv_cond_res<_Xp, _Yp>> struct __common_ref<_Ap&, _Bp&, _Xp, _Yp> ;
      template <class _Xp, class _Yp> using __common_ref_C = remove_reference_t<__common_ref_t<_Xp&, _Yp&>>&&;
      template <class _Ap, class _Bp, class _Xp, class _Yp>   requires     requires {
     typename __common_ref_C<_Xp, _Yp>;
     }
      &&     is_convertible_v<_Ap&&, __common_ref_C<_Xp, _Yp>> &&     is_convertible_v<_Bp&&, __common_ref_C<_Xp, _Yp>> struct __common_ref<_Ap&&, _Bp&&, _Xp, _Yp> ;
      template <class...> struct common_reference;
      template <class... _Types> using common_reference_t = typename common_reference<_Types...>::type;
      template <class _Tp, class _Up> concept common_reference_with =     same_as<common_reference_t<_Tp, _Up>, common_reference_t<_Up, _Tp>> &&     convertible_to<_Tp, common_reference_t<_Tp, _Up>> && convertible_to<_Up, common_reference_t<_Tp, _Up>>;
      }
       inline namespace _LIBCPP_ABI_NAMESPACE {
      template <class _Tp>  inline __attribute__(()) __attribute__(()) constexpr _Tp&& forward( __libcpp_remove_reference_t<_Tp>& __t) noexcept ;
      template <class _Fp, class... _Args> void  __invoke()     noexcept                ;
      }
       inline namespace _LIBCPP_ABI_NAMESPACE {
      template <class...> class tuple;
      template<class _Tp, _Tp... _Ip> struct integer_sequence {};
      template<size_t... _Ip>     using index_sequence = integer_sequence<size_t, _Ip...>;
      template <class _Tp, _Tp _Ep> using __make_integer_sequence __attribute__(()) = __make_integer_seq<integer_sequence, _Tp, _Ep>;
      template<class _Tp, _Tp _Np>     using make_integer_sequence = __make_integer_sequence<_Tp, _Np>;
      template<size_t _Np>     using make_index_sequence = make_integer_sequence<size_t, _Np>;
      template <class ..._Tp> struct __tuple_types ;
      template <size_t _Ip, class _Tp> struct tuple_element;
      template <size_t _Ip, class ..._Types> struct tuple_element<_Ip, __tuple_types<_Types...> > {
         typedef __attribute__(()) __type_pack_element<_Ip, _Types...> type;
     };
      template <size_t _Ip, class ..._Tp> using tuple_element_t __attribute__(()) = typename tuple_element <_Ip, _Tp...>::type;
      template <bool ..._Preds> struct __all_dummy;
      template <bool ..._Pred> struct __all : _IsSame<__all_dummy<>, __all_dummy<>> {};
      template <size_t _Ip, class ..._Tp> struct tuple_element<_Ip, tuple<_Tp...> > {
         typedef __attribute__(()) typename tuple_element<_Ip, __tuple_types<_Tp...> >::type type;
     };
      template <bool _CanCopy, bool _CanMove> struct __sfinae_ctor_base {};
      template <bool _CanCopy, bool _CanMove> struct __sfinae_assign_base {};
      template <class _Tp> struct is_copy_constructible     : public integral_constant<bool, __is_constructible(_Tp, __add_lvalue_reference_t<typename add_const<_Tp>::type>)> {};
      template <class _Tp> inline constexpr bool is_copy_constructible_v = is_copy_constructible<_Tp>::value;
      }
       inline namespace _LIBCPP_ABI_NAMESPACE {
      template <class _Tp> struct is_default_constructible : public integral_constant<bool, __is_constructible(_Tp)> {};
      template <class _Tp> inline constexpr bool is_enum_v = __is_enum(_Tp);
      template <class _Tp> struct is_move_constructible     : public integral_constant<bool, __is_constructible(_Tp, __add_rvalue_reference_t<_Tp>)> {};
      template <class _Tp> inline constexpr bool is_move_constructible_v = is_move_constructible<_Tp>::value;
      template <class _Tp> struct is_nothrow_move_constructible     : public integral_constant<bool, __is_nothrow_constructible(_Tp, __add_rvalue_reference_t<_Tp>)> {};
      template <class _Lhs, class _Rhs> concept assignable_from =     is_lvalue_reference_v<_Lhs> &&     common_reference_with<__make_const_lvalue_ref<_Lhs>, __make_const_lvalue_ref<_Rhs>> &&     requires(_Lhs __lhs, _Rhs&& __rhs) {
           {
    __lhs = std::forward }
     -> same_as<_Lhs>;
         };
      template <class _Tp> struct is_destructible : _BoolConstant<__is_destructible(_Tp)> {};
      template <class _Tp> struct __libcpp_is_floating_point : public false_type {};
      template <class _Tp> struct is_floating_point : public __libcpp_is_floating_point<__remove_cv_t<_Tp> > {};
      template <class _Tp> struct is_arithmetic     : public integral_constant<bool, is_integral<_Tp>::value || is_floating_point<_Tp>::value> {};
      template <class _Tp> inline constexpr bool is_class_v = __is_class(_Tp);
      template <class _Tp> inline constexpr bool is_union_v = __is_union(_Tp);
      template <class _Tp> concept __class_or_enum = is_class_v<_Tp> || is_union_v<_Tp> || is_enum_v<_Tp>;
      template <class _Tp> struct is_nothrow_move_assignable     : public integral_constant<bool,                                __is_nothrow_assignable(__add_lvalue_reference_t<_Tp>, __add_rvalue_reference_t<_Tp>)> {};
      template <class _Tp> struct is_move_assignable     : public integral_constant<bool, __is_assignable(__add_lvalue_reference_t<_Tp>, __add_rvalue_reference_t<_Tp>)> {};
      template <class _Tp> inline constexpr bool is_move_assignable_v = is_move_assignable<_Tp>::value;
      }
       inline namespace _LIBCPP_ABI_NAMESPACE {
      namespace ranges {
     
    struct __fn {};
    
     inline namespace __cpo {
    inline constexpr auto swap = __fn{};
    }
     }
      template <class _Tp> concept swappable = requires() {
     ranges::swap;
     };
      template <template <class...> class _Templ, class... _Args, class = _Templ > void  __sfinae_test_impl();
      template <template <class...> class _Templ, class... _Args> using _IsValidExpansion __attribute__(()) = decltype(std::__sfinae_test_impl<_Templ, _Args...>);
      }
      }
        namespace std {
       inline namespace _LIBCPP_ABI_NAMESPACE {
      template <class _Tp> using __test_for_primary_template = __enable_if_t<_IsSame<_Tp, typename _Tp::__primary_template>::value>;
      template <class _Tp> using __is_primary_template = _IsValidExpansion<__test_for_primary_template, _Tp>;
      template <class> struct iterator_traits;
      template<class> struct indirectly_readable_traits ;
      }
       inline namespace _LIBCPP_ABI_NAMESPACE {
      template <class _Tp> using __with_reference = _Tp&;
      template <class _Tp> concept __can_reference = requires {
       typename __with_reference<_Tp>;
     };
      template <class _Tp> concept __dereferenceable = requires(_Tp& __t) {
       
    *__t 
     -> __can_reference;
     };
      template<__dereferenceable _Tp> using iter_reference_t = decltype(*std::declval<_Tp&>);
      template <class _Ip> using iter_value_t = typename conditional_t<__is_primary_template<iterator_traits<remove_cvref_t<_Ip> > >::value,                                             indirectly_readable_traits<remove_cvref_t<_Ip> >,                                             iterator_traits<remove_cvref_t<_Ip> > >::value_type;
      namespace ranges {
     
    template <class _Tp> concept __unqualified_iter_move =   __class_or_enum<remove_cvref_t<_Tp>> &&   requires () {
       iter_move(std::forward<_Tp>);
     };
    struct Trans_NS___iter_move___fn {};
    
     inline namespace __cpo {
      inline constexpr auto iter_move = Trans_NS___iter_move___fn{};
    }
     }
      template<__dereferenceable _Tp>   requires requires() {
     {
    ranges::iter_move }
     -> __can_reference;
     }
      using iter_rvalue_reference_t = decltype(ranges::iter_move);
      template<class _In> concept __indirectly_readable_impl =   requires(const _In __i) {
         
    *__i 
     -> same_asiter_rvalue_reference_t_In;
       }
      &&   common_reference_with<iter_reference_t<_In>&&, iter_value_t<_In>&> &&   common_reference_with<iter_reference_t<_In>&&, iter_rvalue_reference_t<_In>&&> &&   common_reference_with<iter_rvalue_reference_t<_In>&&, const iter_value_t<_In>&>;
      template <class _Tp> struct is_copy_assignable     : public integral_constant<           bool,           __is_assignable(__add_lvalue_reference_t<_Tp>, __add_lvalue_reference_t<typename add_const<_Tp>::type>)> {};
      template <class _Tp> inline constexpr bool is_copy_assignable_v = is_copy_assignable<_Tp>::value;
      template <class _Tp> inline constexpr bool is_nothrow_default_constructible_v = __is_nothrow_constructible(_Tp);
      template <class _Tp, bool = is_arithmetic<_Tp>::value> class __libcpp_numeric_limits ;
      template <class _Tp, int __digits, bool _IsSigned> struct __libcpp_compute_min ;
      template <class _Tp> class __libcpp_numeric_limits<_Tp, true> ;
      template <class _Tp> class numeric_limits     : private __libcpp_numeric_limits<__remove_cv_t<_Tp> > {};
      template <class _Tp, bool> struct __dependent_type : public _Tp {};
      template <class _Tp> struct is_trivially_copy_assignable     : public integral_constant<bool,                                __is_trivially_assignable(__add_lvalue_reference_t<_Tp>,                                                          __add_lvalue_reference_t<typename add_const<_Tp>::type>)> {};
      template <class _Tp> struct is_trivially_copy_constructible     : public integral_constant<bool, __is_trivially_constructible(_Tp, __add_lvalue_reference_t<const _Tp>)> {};
      template <class _Tp> struct is_trivially_destructible     : public integral_constant<bool, __is_trivially_destructible(_Tp)> {};
      template <class _Tp> struct is_trivially_move_assignable     : public integral_constant<           bool,           __is_trivially_assignable(__add_lvalue_reference_t<_Tp>, __add_rvalue_reference_t<_Tp>)> {};
      template <class _Tp> struct is_trivially_move_constructible     : public integral_constant<bool, __is_trivially_constructible(_Tp, __add_rvalue_reference_t<_Tp>)> {};
      struct in_place_t {};
      inline constexpr in_place_t in_place;
      template <size_t _Idx> struct in_place_index_t {};
      template <size_t _Idx> inline constexpr in_place_index_t<_Idx> in_place_index;
      }
       template<class _Ep> class initializer_list {
          const _Ep* __begin_;
          size_t __size_;
           public:     typedef _Ep value_type;
                    __attribute__(()) __attribute__(())     constexpr     const _Ep* begin() const noexcept {
    return __begin_;
    }
          __attribute__(()) __attribute__(())     constexpr     const _Ep* end() const noexcept {
    return __begin_ + __size_;
    }
      };
       inline namespace _LIBCPP_ABI_NAMESPACE {
      template<class _Tp, size_t _Size> struct __farray {
       _Tp __buf_[_Size] ;
       __attribute__(()) __attribute__(()) constexpr   const _Tp &operator[](size_t __n) const noexcept {
          return __buf_[__n];
      }
     };
      template <class... _Types> class variant;
      template <size_t _Ip, class _Tp> struct variant_alternative;
      template <size_t _Ip, class _Tp> using variant_alternative_t = typename variant_alternative<_Ip, _Tp>::type;
      template <size_t _Ip, class... _Types> struct variant_alternative<_Ip, variant<_Types...>> {
       using type = __type_pack_element<_Ip, _Types...>;
     };
      inline constexpr size_t variant_npos = static_cast<size_t>(-1);
       void  __choose_index_type() ;
      template <size_t _NumAlts> using __variant_index_t =   std::tuple_element_t<       0,       std::tuple<unsigned char, unsigned short, unsigned int>   >;
      template <class _IndexType> constexpr _IndexType __variant_npos = static_cast<_IndexType>(-1);
      
     struct __valueless_t ;
     enum class _Trait {
    _TriviallyAvailable, _Available, _Unavailable };
     template <typename _Tp,           template <typename> class _IsTriviallyAvailable,           template <typename> class _IsAvailable> constexpr _Trait __trait =     _IsTriviallyAvailable<_Tp>::value         ? _Trait::_TriviallyAvailable         : _IsAvailable<_Tp>::value ? _Trait::_Available : _Trait::_Unavailable;
      __attribute__(()) __attribute__(()) constexpr _Trait __common_trait(initializer_list<_Trait> __traits) {
      _Trait __result = _Trait::_TriviallyAvailable;
      for (_Trait __t : __traits) 
       if (static_cast<int>(__t) > static_cast<int>(__result)) 
         __result = __t;
       
     
      return __result;
    }
     template <typename... _Types> struct __traits {
      static constexpr _Trait __copy_constructible_trait =       __common_trait({
  __trait<_Types,                               is_trivially_copy_constructible,                               is_copy_constructible>...}
   );
      static constexpr _Trait __move_constructible_trait =       __common_trait({
  __trait<_Types,                               is_trivially_move_constructible,                               is_move_constructible>...}
   );
      static constexpr _Trait __copy_assignable_trait = __common_trait(       {
  __copy_constructible_trait,        __trait<_Types, is_trivially_copy_assignable, is_copy_assignable>...}
   );
      static constexpr _Trait __move_assignable_trait = __common_trait(       {
  __move_constructible_trait,        __trait<_Types, is_trivially_move_assignable, is_move_assignable>...}
   );
      static constexpr _Trait __destructible_trait = __common_trait(       {
  __trait<_Types, is_trivially_destructible, is_destructible>...}
   );
    };
     
     namespace __visitation {
    struct __base {
     template <class _Visitor, class... _Vs>   __attribute__(()) __attribute__(())   static constexpr decltype(auto) __visit_alt(_Visitor&& __visitor,                                               _Vs&&... __vs) {
       constexpr auto __fmatrix =         __make_fmatrix<_Visitor&&,                        decltype(std::forward<_Vs>(__vs).__as_base())...>();
       return __at(__fmatrix, __vs.index()...)(         std::forward<_Visitor>(__visitor),         std::forward<_Vs>(__vs).__as_base()...);
     }
   private:   template <class _Tp>   __attribute__(()) __attribute__(())   static constexpr const _Tp& __at(const _Tp& __elem) {
   return __elem;
   }
     template <class _Tp, size_t _Np, typename... _Indices>   __attribute__(()) __attribute__(())   static constexpr auto&& __at(const __farray<_Tp, _Np>& __elems,                                size_t __index, _Indices... __indices) {
       return __at(__elems[__index], __indices...);
     }
     template <class... _Fs>   __attribute__(()) __attribute__(())   static constexpr auto __make_farray(_Fs&&... __fs) {
       using __result = __farray<common_type_t<__remove_cvref_t<_Fs>...>, sizeof...(_Fs)>;
       return __result
 {
 std::forward<_Fs>(__fs)...}
 ;
     }
     template <size_t... _Is>   struct __dispatcher {
       template <class _Fp, class... _Vs>     __attribute__(()) __attribute__(())     static constexpr decltype(auto) __dispatch(_Fp __f, _Vs... __vs) {}
     };
     template <class _Fp, class... _Vs, size_t... _Is>   __attribute__(()) __attribute__(())   static constexpr auto __make_dispatch(index_sequence<_Is...>) {
       return __dispatcher<>::template __dispatch<_Fp, _Vs...>;
     }
     template <class _Fp, class... _Vs, size_t... _Is>   __attribute__(()) __attribute__(())   static constexpr auto __make_fmatrix_impl(index_sequence<_Is...> __is) {
       return __make_dispatch<_Fp, _Vs...>(__is);
     }
     template <class _Fp, class... _Vs, size_t... _Is, size_t... _Js, class... _Ls>   __attribute__(()) __attribute__(())   static constexpr auto __make_fmatrix_impl(index_sequence<>,                                             index_sequence<_Js...>,                                             _Ls... __ls) {
       return __base::__make_farray(__make_fmatrix_impl<_Fp, _Vs...>(         index_sequence<_Is..., _Js>{}
  , __ls...)...);
     }
     template <class _Fp, class... _Vs>   __attribute__(()) __attribute__(())   static constexpr auto __make_fmatrix() {
       return __make_fmatrix_impl<_Fp, _Vs...>(         index_sequence<>{}
  , make_index_sequence<__remove_cvref_t<_Vs>::__size()>{}
  ...);
     }
   };
    }
     template <size_t _Index, class _Tp> struct __alt {
      using __value_type = _Tp;
      template <class... _Args>   __attribute__(()) __attribute__(())   explicit constexpr __alt( _Args&&... __args)       : __value() {}
      __value_type __value;
    };
     template <_Trait _DestructibleTrait, size_t _Index, class... _Types> union __union;
     template <size_t _Index, class _Tp, class... _Types> union __union<_Trait::_Available, _Index, _Tp, _Types...> {
    template <class... _Args> __attribute__(()) __attribute__(()) explicit constexpr __union(in_place_index_t<0>, _Args&&... __args) : __head(in_place, std::forward<_Args>...) {}
    ~__union() {}
    __alt<_Index, _Tp> __head;
    };
     template <_Trait _DestructibleTrait, class... _Types> class __base {
    public:   using __index_t = __variant_index_t<sizeof...(_Types)>;
         template <size_t _Ip, class... _Args>   __attribute__(()) __attribute__(())   explicit constexpr __base(in_place_index_t<_Ip>, _Args&&... __args)       :         __data(in_place_index<_Ip>, std::forward<_Args>...),         __index() {}
      void  valueless_by_exception() const noexcept ;
      __attribute__(()) __attribute__(())   constexpr size_t index() const noexcept {
       return __index == __variant_npos<__index_t> ? variant_npos : __index;
     }
      __attribute__(()) __attribute__(())   constexpr auto&& __as_base() const & {
   return *this;
   }
      __attribute__(()) __attribute__(())   static constexpr size_t __size() {
   return sizeof...(_Types);
   }
      __union<_DestructibleTrait, 0, _Types...> __data;
      __index_t __index;
    };
     template <class _Traits, _Trait = _Traits::__destructible_trait> class __dtor;
     template <class... _Types> class __dtor<__traits<_Types...>, _Trait::_Available> : public __base<_Trait::_Available, _Types...> {
    using __base_type = __base<_Trait::_Available, _Types...>;
    public: using __base_type::__base_type;
      ~__dtor() {
   __destroy();
   }
      protected: inline __attribute__(()) __attribute__(()) void __destroy() noexcept {
   if (!0) 
   __visitation::__base::__visit_alt( [] noexcept {}
  , *this);
   
   }
    };
     template <class _Traits> class __ctor : public __dtor<_Traits> {
      using __base_type = __dtor<_Traits>;
    public:   using __base_type::__base_type;
    protected:       };
     template <class _Traits, _Trait = _Traits::__move_constructible_trait> class __move_constructor;
     template <class... _Types> class __move_constructor<__traits<_Types...>, _Trait::_Available> : public __ctor<__traits<_Types...>> {
    using __base_type = __ctor<__traits<_Types...>>;
    public: using __base_type::__base_type;
      };
     template <class _Traits, _Trait = _Traits::__copy_constructible_trait> class __copy_constructor;
     template <class... _Types> class __copy_constructor<__traits<_Types...>, _Trait::_Available> : public __move_constructor<__traits<_Types...>> {
    using __base_type = __move_constructor<__traits<_Types...>>;
    public: using __base_type::__base_type;
      };
     template <class _Traits> class __assignment : public __copy_constructor<_Traits> {
      using __base_type = __copy_constructor<_Traits>;
    public:   using __base_type::__base_type;
       protected:       };
     template <class _Traits, _Trait = _Traits::__move_assignable_trait> class __move_assignment;
     template <class... _Types> class __move_assignment<__traits<_Types...>, _Trait::_Available> : public __assignment<__traits<_Types...>> {
    using __base_type = __assignment<__traits<_Types...>>;
    public: using __base_type::__base_type;
      };
     template <class _Traits, _Trait = _Traits::__copy_assignable_trait> class __copy_assignment;
     template <class... _Types> class __copy_assignment<__traits<_Types...>, _Trait::_Available> : public __move_assignment<__traits<_Types...>> {
    using __base_type = __move_assignment<__traits<_Types...>>;
    public: using __base_type::__base_type;
      };
     template <class... _Types> class __impl     : public __copy_assignment<__traits<_Types...>> {
      using __base_type = __copy_assignment<__traits<_Types...>>;
    public:   using __base_type::__base_type;
                      private:    };
     
      template <class... _Types> class __declspec() variant     : private __sfinae_ctor_base<           __all<>::value,           __all<>::value>,       private __sfinae_assign_base<           __all<>::value,           __all<>::value> {
       using __first_type = variant_alternative_t<0, variant>;
     public:   template <bool _Dummy = true,             enable_if_t<__dependent_type<is_default_constructible<__first_type>,                                          _Dummy>::value,                         int> = 0>   __attribute__(()) __attribute__(())   constexpr variant() noexcept       : __impl_(in_place_index<0>) {}
           private:   __impl<_Types...> __impl_;
     };
      }
      }
        struct foo {
        ~foo() ;
       };
        int main() {
        std::variant<foo> v;
       }
