namespace std { inline namespace _LIBCPP_ABI_NAMESPACE { }}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
[[noreturn]] __attribute__((__format__(__printf__, 1, 2)))
void __libcpp_verbose_abort(const char *__format, ...);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <bool, class _Tp = void>
struct enable_if {};
template <class _Tp>
struct enable_if<true, _Tp> {
  typedef _Tp type;
};
template <bool _Bp, class _Tp = void>
using __enable_if_t __attribute__((__nodebug__)) = typename enable_if<_Bp, _Tp>::type;
template <bool _Bp, class _Tp = void>
using enable_if_t = typename enable_if<_Bp, _Tp>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, _Tp __v>
struct integral_constant {
  static constexpr const _Tp value = __v;
  typedef _Tp value_type;
  typedef integral_constant type;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr operator value_type() const noexcept { return value; }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr value_type operator()() const noexcept { return value; }
};
template <class _Tp, _Tp __v>
constexpr const _Tp integral_constant<_Tp, __v>::value;
typedef integral_constant<bool, true> true_type;
typedef integral_constant<bool, false> false_type;
template <bool _Val>
using _BoolConstant __attribute__((__nodebug__)) = integral_constant<bool, _Val>;
template <bool __b>
using bool_constant = integral_constant<bool, __b>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Up>
struct is_same : _BoolConstant<__is_same(_Tp, _Up)> {};
template <class _Tp, class _Up>
inline constexpr bool is_same_v = __is_same(_Tp, _Up);
template <class _Tp, class _Up>
using _IsSame = _BoolConstant<__is_same(_Tp, _Up)>;
template <class _Tp, class _Up>
using _IsNotSame = _BoolConstant<!__is_same(_Tp, _Up)>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
enum class _OrdResult : signed char {
  __less = -1,
  __equiv = 0,
  __greater = 1
};
enum class _NCmpResult : signed char {
  __unordered = -127
};
class partial_ordering;
class weak_ordering;
class strong_ordering;
template<class _Tp, class... _Args>
inline constexpr bool __one_of_v = (is_same_v<_Tp, _Args> || ...);
struct _CmpUnspecifiedParam {
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
  _CmpUnspecifiedParam(int _CmpUnspecifiedParam::*) noexcept {}
  template<class _Tp, class = enable_if_t<!__one_of_v<_Tp, int, partial_ordering, weak_ordering, strong_ordering>>>
  _CmpUnspecifiedParam(_Tp) = delete;
};
class partial_ordering {
  using _ValueT = signed char;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr partial_ordering(_OrdResult __v) noexcept
      : __value_(_ValueT(__v)) {}
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr partial_ordering(_NCmpResult __v) noexcept
      : __value_(_ValueT(__v)) {}
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr bool __is_ordered() const noexcept {
    return __value_ != _ValueT(_NCmpResult::__unordered);
  }
public:
  static const partial_ordering less;
  static const partial_ordering equivalent;
  static const partial_ordering greater;
  static const partial_ordering unordered;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator==(partial_ordering, partial_ordering) noexcept = default;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator==(partial_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__is_ordered() && __v.__value_ == 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator< (partial_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__is_ordered() && __v.__value_ < 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator<=(partial_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__is_ordered() && __v.__value_ <= 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator> (partial_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__is_ordered() && __v.__value_ > 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator>=(partial_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__is_ordered() && __v.__value_ >= 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator< (_CmpUnspecifiedParam, partial_ordering __v) noexcept {
    return __v.__is_ordered() && 0 < __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator<=(_CmpUnspecifiedParam, partial_ordering __v) noexcept {
    return __v.__is_ordered() && 0 <= __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator> (_CmpUnspecifiedParam, partial_ordering __v) noexcept {
    return __v.__is_ordered() && 0 > __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator>=(_CmpUnspecifiedParam, partial_ordering __v) noexcept {
    return __v.__is_ordered() && 0 >= __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr partial_ordering operator<=>(partial_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr partial_ordering operator<=>(_CmpUnspecifiedParam, partial_ordering __v) noexcept {
    return __v < 0 ? partial_ordering::greater : (__v > 0 ? partial_ordering::less : __v);
  }
private:
  _ValueT __value_;
};
inline constexpr partial_ordering partial_ordering::less(_OrdResult::__less);
inline constexpr partial_ordering partial_ordering::equivalent(_OrdResult::__equiv);
inline constexpr partial_ordering partial_ordering::greater(_OrdResult::__greater);
inline constexpr partial_ordering partial_ordering::unordered(_NCmpResult ::__unordered);
class weak_ordering {
  using _ValueT = signed char;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr weak_ordering(_OrdResult __v) noexcept : __value_(_ValueT(__v)) {}
public:
  static const weak_ordering less;
  static const weak_ordering equivalent;
  static const weak_ordering greater;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr operator partial_ordering() const noexcept {
    return __value_ == 0 ? partial_ordering::equivalent
        : (__value_ < 0 ? partial_ordering::less : partial_ordering::greater);
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator==(weak_ordering, weak_ordering) noexcept = default;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator==(weak_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__value_ == 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator< (weak_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__value_ < 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator<=(weak_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__value_ <= 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator> (weak_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__value_ > 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator>=(weak_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__value_ >= 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator< (_CmpUnspecifiedParam, weak_ordering __v) noexcept {
    return 0 < __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator<=(_CmpUnspecifiedParam, weak_ordering __v) noexcept {
    return 0 <= __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator> (_CmpUnspecifiedParam, weak_ordering __v) noexcept {
    return 0 > __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator>=(_CmpUnspecifiedParam, weak_ordering __v) noexcept {
    return 0 >= __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr weak_ordering operator<=>(weak_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr weak_ordering operator<=>(_CmpUnspecifiedParam, weak_ordering __v) noexcept {
    return __v < 0 ? weak_ordering::greater : (__v > 0 ? weak_ordering::less : __v);
  }
private:
  _ValueT __value_;
};
inline constexpr weak_ordering weak_ordering::less(_OrdResult::__less);
inline constexpr weak_ordering weak_ordering::equivalent(_OrdResult::__equiv);
inline constexpr weak_ordering weak_ordering::greater(_OrdResult::__greater);
class strong_ordering {
  using _ValueT = signed char;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr strong_ordering(_OrdResult __v) noexcept : __value_(_ValueT(__v)) {}
public:
  static const strong_ordering less;
  static const strong_ordering equal;
  static const strong_ordering equivalent;
  static const strong_ordering greater;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr operator partial_ordering() const noexcept {
    return __value_ == 0 ? partial_ordering::equivalent
        : (__value_ < 0 ? partial_ordering::less : partial_ordering::greater);
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr operator weak_ordering() const noexcept {
    return __value_ == 0 ? weak_ordering::equivalent
        : (__value_ < 0 ? weak_ordering::less : weak_ordering::greater);
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator==(strong_ordering, strong_ordering) noexcept = default;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator==(strong_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__value_ == 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator< (strong_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__value_ < 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator<=(strong_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__value_ <= 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator> (strong_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__value_ > 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator>=(strong_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v.__value_ >= 0;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator< (_CmpUnspecifiedParam, strong_ordering __v) noexcept {
    return 0 < __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator<=(_CmpUnspecifiedParam, strong_ordering __v) noexcept {
    return 0 <= __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator> (_CmpUnspecifiedParam, strong_ordering __v) noexcept {
    return 0 > __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr bool operator>=(_CmpUnspecifiedParam, strong_ordering __v) noexcept {
    return 0 >= __v.__value_;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr strong_ordering operator<=>(strong_ordering __v, _CmpUnspecifiedParam) noexcept {
    return __v;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  friend constexpr strong_ordering operator<=>(_CmpUnspecifiedParam, strong_ordering __v) noexcept {
    return __v < 0 ? strong_ordering::greater : (__v > 0 ? strong_ordering::less : __v);
  }
private:
  _ValueT __value_;
};
inline constexpr strong_ordering strong_ordering::less(_OrdResult::__less);
inline constexpr strong_ordering strong_ordering::equal(_OrdResult::__equiv);
inline constexpr strong_ordering strong_ordering::equivalent(_OrdResult::__equiv);
inline constexpr strong_ordering strong_ordering::greater(_OrdResult::__greater);
template <class _Tp>
concept __comparison_category = __one_of_v<_Tp, partial_ordering, weak_ordering, strong_ordering>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct remove_const {
  using type __attribute__((__nodebug__)) = __remove_const(_Tp);
};
template <class _Tp>
using __remove_const_t = __remove_const(_Tp);
template <class _Tp>
using remove_const_t = __remove_const_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct remove_volatile {
  using type __attribute__((__nodebug__)) = __remove_volatile(_Tp);
};
template <class _Tp>
using __remove_volatile_t = __remove_volatile(_Tp);
template <class _Tp>
using remove_volatile_t = __remove_volatile_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct remove_cv {
  using type __attribute__((__nodebug__)) = __remove_cv(_Tp);
};
template <class _Tp>
using __remove_cv_t = __remove_cv(_Tp);
template <class _Tp>
using remove_cv_t = __remove_cv_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp> struct __libcpp_is_integral { enum { value = 0 }; };
template <> struct __libcpp_is_integral<bool> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<char> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<signed char> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<unsigned char> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<wchar_t> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<char8_t> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<char16_t> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<char32_t> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<short> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<unsigned short> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<int> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<unsigned int> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<long> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<unsigned long> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<long long> { enum { value = 1 }; };
template <> struct __libcpp_is_integral<unsigned long long> { enum { value = 1 }; };
template <class _Tp>
struct is_integral : _BoolConstant<__is_integral(_Tp)> {};
template <class _Tp>
inline constexpr bool is_integral_v = __is_integral(_Tp);
}}
typedef long long int ptrdiff_t;
typedef long long unsigned int size_t;
typedef long long unsigned int rsize_t;
namespace std { typedef decltype(nullptr) nullptr_t; }
using ::std::nullptr_t;
typedef double max_align_t;
 typedef decltype(nullptr) nullptr_t;
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
using ::nullptr_t;
using ::ptrdiff_t __attribute__((__using_if_exists__));
using ::size_t __attribute__((__using_if_exists__));
using ::max_align_t __attribute__((__using_if_exists__));
}}
namespace std
{
enum class byte : unsigned char {};
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr byte operator| (byte __lhs, byte __rhs) noexcept
{
    return static_cast<byte>(
      static_cast<unsigned char>(
         static_cast<unsigned int>(__lhs) | static_cast<unsigned int>(__rhs)
    ));
}
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr byte& operator|=(byte& __lhs, byte __rhs) noexcept
{ return __lhs = __lhs | __rhs; }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr byte operator& (byte __lhs, byte __rhs) noexcept
{
    return static_cast<byte>(
      static_cast<unsigned char>(
         static_cast<unsigned int>(__lhs) & static_cast<unsigned int>(__rhs)
    ));
}
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr byte& operator&=(byte& __lhs, byte __rhs) noexcept
{ return __lhs = __lhs & __rhs; }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr byte operator^ (byte __lhs, byte __rhs) noexcept
{
    return static_cast<byte>(
      static_cast<unsigned char>(
         static_cast<unsigned int>(__lhs) ^ static_cast<unsigned int>(__rhs)
    ));
}
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr byte& operator^=(byte& __lhs, byte __rhs) noexcept
{ return __lhs = __lhs ^ __rhs; }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr byte operator~ (byte __b) noexcept
{
    return static_cast<byte>(
      static_cast<unsigned char>(
        ~static_cast<unsigned int>(__b)
    ));
}
template <class _Tp>
using _EnableByteOverload = __enable_if_t<is_integral<_Tp>::value, byte>;
template <class _Integer>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _EnableByteOverload<_Integer> &
  operator<<=(byte& __lhs, _Integer __shift) noexcept
  { return __lhs = __lhs << __shift; }
template <class _Integer>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _EnableByteOverload<_Integer>
  operator<< (byte __lhs, _Integer __shift) noexcept
  { return static_cast<byte>(static_cast<unsigned char>(static_cast<unsigned int>(__lhs) << __shift)); }
template <class _Integer>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _EnableByteOverload<_Integer> &
  operator>>=(byte& __lhs, _Integer __shift) noexcept
  { return __lhs = __lhs >> __shift; }
template <class _Integer>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _EnableByteOverload<_Integer>
  operator>> (byte __lhs, _Integer __shift) noexcept
  { return static_cast<byte>(static_cast<unsigned char>(static_cast<unsigned int>(__lhs) >> __shift)); }
template <class _Integer, class = _EnableByteOverload<_Integer> >
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _Integer
  to_integer(byte __b) noexcept { return static_cast<_Integer>(__b); }
}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
namespace __comp_detail {
enum _ClassifyCompCategory : unsigned {
  _None,
  _PartialOrd,
  _WeakOrd,
  _StrongOrd,
  _CCC_Size
};
template <class _Tp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _ClassifyCompCategory __type_to_enum() noexcept {
  if (is_same_v<_Tp, partial_ordering>)
    return _PartialOrd;
  if (is_same_v<_Tp, weak_ordering>)
    return _WeakOrd;
  if (is_same_v<_Tp, strong_ordering>)
    return _StrongOrd;
  return _None;
}
template <size_t _Size>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _ClassifyCompCategory
__compute_comp_type(const _ClassifyCompCategory (&__types)[_Size]) {
  int __seen[_CCC_Size] = {};
  for (auto __type : __types)
    ++__seen[__type];
  if (__seen[_None])
    return _None;
  if (__seen[_PartialOrd])
    return _PartialOrd;
  if (__seen[_WeakOrd])
    return _WeakOrd;
  return _StrongOrd;
}
template <class ..._Ts, bool _False = false>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr auto __get_comp_type() {
  using _CCC = _ClassifyCompCategory;
  constexpr _CCC __type_kinds[] = {_StrongOrd, __type_to_enum<_Ts>()...};
  constexpr _CCC __cat = __comp_detail::__compute_comp_type(__type_kinds);
  if constexpr (__cat == _None)
    return void();
  else if constexpr (__cat == _PartialOrd)
    return partial_ordering::equivalent;
  else if constexpr (__cat == _WeakOrd)
    return weak_ordering::equivalent;
  else if constexpr (__cat == _StrongOrd)
    return strong_ordering::equivalent;
  else
    static_assert(_False, "unhandled case");
}
}
template<class... _Ts>
struct common_comparison_category {
  using type = decltype(__comp_detail::__get_comp_type<_Ts...>());
};
template<class... _Ts>
using common_comparison_category_t = typename common_comparison_category<_Ts...>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct remove_reference {
  using type __attribute__((__nodebug__)) = __remove_reference_t(_Tp);
};
template <class _Tp>
using __libcpp_remove_reference_t = __remove_reference_t(_Tp);
template <class _Tp>
using remove_reference_t = __libcpp_remove_reference_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
using __make_const_lvalue_ref = const __libcpp_remove_reference_t<_Tp>&;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
_Tp&& __declval(int);
template <class _Tp>
_Tp __declval(long);
template <class _Tp>
decltype(std::__declval<_Tp>(0)) declval() noexcept;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template<class, class, class>
struct __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __compare_three_way_result { };
template<class _Tp, class _Up>
struct __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __compare_three_way_result<_Tp, _Up, decltype(
  std::declval<__make_const_lvalue_ref<_Tp>>() <=> std::declval<__make_const_lvalue_ref<_Up>>(), void()
)> {
    using type = decltype(std::declval<__make_const_lvalue_ref<_Tp>>() <=> std::declval<__make_const_lvalue_ref<_Up>>());
};
template<class _Tp, class _Up = _Tp>
struct compare_three_way_result : __compare_three_way_result<_Tp, _Up, void> { };
template<class _Tp, class _Up = _Tp>
using compare_three_way_result_t = typename compare_three_way_result<_Tp, _Up>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_array : public false_type {};
template <class _Tp>
struct is_array<_Tp[]> : public true_type {};
template <class _Tp, size_t _Np>
struct is_array<_Tp[_Np]> : public true_type {};
template <class _Tp>
inline constexpr bool is_array_v = is_array<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_const : _BoolConstant<__is_const(_Tp)> {};
template <class _Tp>
inline constexpr bool is_const_v = __is_const(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_lvalue_reference : _BoolConstant<__is_lvalue_reference(_Tp)> {};
template <class _Tp>
struct is_rvalue_reference : _BoolConstant<__is_rvalue_reference(_Tp)> {};
template <class _Tp>
struct is_reference : _BoolConstant<__is_reference(_Tp)> {};
template <class _Tp>
inline constexpr bool is_reference_v = __is_reference(_Tp);
template <class _Tp>
inline constexpr bool is_lvalue_reference_v = __is_lvalue_reference(_Tp);
template <class _Tp>
inline constexpr bool is_rvalue_reference_v = __is_rvalue_reference(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_function : integral_constant<bool, __is_function(_Tp)> {};
template <class _Tp>
inline constexpr bool is_function_v = is_function<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_void : _BoolConstant<__is_void(_Tp)> {};
template <class _Tp>
inline constexpr bool is_void_v = __is_void(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _T1, class _T2>
struct is_convertible : public integral_constant<bool, __is_convertible(_T1, _T2)> {};
template <class _From, class _To>
inline constexpr bool is_convertible_v = is_convertible<_From, _To>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _From, class _To>
concept convertible_to = is_convertible_v<_From, _To> && requires { static_cast<_To>(std::declval<_From>()); };
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Up>
concept __same_as_impl = _IsSame<_Tp, _Up>::value;
template <class _Tp, class _Up>
concept same_as = __same_as_impl<_Tp, _Up> && __same_as_impl<_Up, _Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <bool>
struct _IfImpl;
template <>
struct _IfImpl<true> {
  template <class _IfRes, class _ElseRes>
  using _Select __attribute__((__nodebug__)) = _IfRes;
};
template <>
struct _IfImpl<false> {
  template <class _IfRes, class _ElseRes>
  using _Select __attribute__((__nodebug__)) = _ElseRes;
};
template <bool _Cond, class _IfRes, class _ElseRes>
using _If __attribute__((__nodebug__)) = typename _IfImpl<_Cond>::template _Select<_IfRes, _ElseRes>;
template <bool _Bp, class _If, class _Then>
struct conditional {
  using type __attribute__((__nodebug__)) = _If;
};
template <class _If, class _Then>
struct conditional<false, _If, _Then> {
  using type __attribute__((__nodebug__)) = _Then;
};
template <bool _Bp, class _IfRes, class _ElseRes>
using conditional_t __attribute__((__nodebug__)) = typename conditional<_Bp, _IfRes, _ElseRes>::type;
template <bool _Bp, class _If, class _Then>
using __conditional_t __attribute__((__nodebug__)) = typename conditional<_Bp, _If, _Then>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct __libcpp_is_referenceable : integral_constant<bool, __is_referenceable(_Tp)> {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
using __add_pointer_t = __add_pointer(_Tp);
template <class _Tp>
struct add_pointer {
  using type __attribute__((__nodebug__)) = __add_pointer_t<_Tp>;
};
template <class _Tp>
using add_pointer_t = __add_pointer_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct remove_extent {
  using type __attribute__((__nodebug__)) = __remove_extent(_Tp);
};
template <class _Tp>
using __remove_extent_t = __remove_extent(_Tp);
template <class _Tp>
using remove_extent_t = __remove_extent_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
using __decay_t __attribute__((__nodebug__)) = __decay(_Tp);
template <class _Tp>
struct decay {
  using type __attribute__((__nodebug__)) = __decay_t<_Tp>;
};
template <class _Tp>
using decay_t = __decay_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
using __remove_cvref_t __attribute__((__nodebug__)) = __remove_cvref(_Tp);
template <class _Tp, class _Up>
struct __is_same_uncvref : _IsSame<__remove_cvref_t<_Tp>, __remove_cvref_t<_Up> > {};
template <class _Tp>
struct remove_cvref {
  using type __attribute__((__nodebug__)) = __remove_cvref_t<_Tp>;
};
template <class _Tp>
using remove_cvref_t = __remove_cvref_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class...>
using void_t = void;
template <class...>
using __void_t = void;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Up>
using __cond_type = decltype(false ? std::declval<_Tp>() : std::declval<_Up>());
template <class _Tp, class _Up, class = void>
struct __common_type3 {};
template <class _Tp, class _Up>
struct __common_type3<_Tp, _Up, void_t<__cond_type<const _Tp&, const _Up&>>> {
  using type = remove_cvref_t<__cond_type<const _Tp&, const _Up&>>;
};
template <class _Tp, class _Up, class = void>
struct __common_type2_imp : __common_type3<_Tp, _Up> {};
template <class _Tp, class _Up>
struct __common_type2_imp<_Tp, _Up, __void_t<decltype(true ? std::declval<_Tp>() : std::declval<_Up>())> > {
  typedef __attribute__((__nodebug__)) __decay_t<decltype(true ? std::declval<_Tp>() : std::declval<_Up>())> type;
};
template <class, class = void>
struct __common_type_impl {};
template <class... _Tp>
struct __common_types;
template <class... _Tp>
struct common_type;
template <class _Tp, class _Up>
struct __common_type_impl< __common_types<_Tp, _Up>, __void_t<typename common_type<_Tp, _Up>::type> > {
  typedef typename common_type<_Tp, _Up>::type type;
};
template <class _Tp, class _Up, class _Vp, class... _Rest>
struct __common_type_impl<__common_types<_Tp, _Up, _Vp, _Rest...>, __void_t<typename common_type<_Tp, _Up>::type> >
    : __common_type_impl<__common_types<typename common_type<_Tp, _Up>::type, _Vp, _Rest...> > {};
template <>
struct common_type<> {};
template <class _Tp>
struct common_type<_Tp> : public common_type<_Tp, _Tp> {};
template <class _Tp, class _Up>
struct common_type<_Tp, _Up>
    : conditional<_IsSame<_Tp, __decay_t<_Tp> >::value && _IsSame<_Up, __decay_t<_Up> >::value,
                  __common_type2_imp<_Tp, _Up>,
                  common_type<__decay_t<_Tp>, __decay_t<_Up> > >::type {};
template <class _Tp, class _Up, class _Vp, class... _Rest>
struct common_type<_Tp, _Up, _Vp, _Rest...>
    : __common_type_impl<__common_types<_Tp, _Up, _Vp, _Rest...> > {};
template <class... _Tp>
using common_type_t = typename common_type<_Tp...>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct add_const {
  typedef __attribute__((__nodebug__)) const _Tp type;
};
template <class _Tp>
using add_const_t = typename add_const<_Tp>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct add_cv {
  typedef __attribute__((__nodebug__)) const volatile _Tp type;
};
template <class _Tp>
using add_cv_t = typename add_cv<_Tp>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct add_volatile {
  typedef __attribute__((__nodebug__)) volatile _Tp type;
};
template <class _Tp>
using add_volatile_t = typename add_volatile<_Tp>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _From, class _To>
struct __copy_cv {
  using type = _To;
};
template <class _From, class _To>
struct __copy_cv<const _From, _To> {
  using type = typename add_const<_To>::type;
};
template <class _From, class _To>
struct __copy_cv<volatile _From, _To> {
  using type = typename add_volatile<_To>::type;
};
template <class _From, class _To>
struct __copy_cv<const volatile _From, _To> {
  using type = typename add_cv<_To>::type;
};
template <class _From, class _To>
using __copy_cv_t = typename __copy_cv<_From, _To>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
using __add_lvalue_reference_t = __add_lvalue_reference(_Tp);
template <class _Tp>
struct add_lvalue_reference {
  using type __attribute__((__nodebug__)) = __add_lvalue_reference_t<_Tp>;
};
template <class _Tp>
using add_lvalue_reference_t = __add_lvalue_reference_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
using __add_rvalue_reference_t = __add_rvalue_reference(_Tp);
template <class _Tp>
struct add_rvalue_reference {
  using type = __add_rvalue_reference_t<_Tp>;
};
template <class _Tp>
using add_rvalue_reference_t = __add_rvalue_reference_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _From, class _To>
struct __copy_cvref {
  using type = __copy_cv_t<_From, _To>;
};
template <class _From, class _To>
struct __copy_cvref<_From&, _To> {
  using type = __add_lvalue_reference_t<__copy_cv_t<_From, _To> >;
};
template <class _From, class _To>
struct __copy_cvref<_From&&, _To> {
  using type = __add_rvalue_reference_t<__copy_cv_t<_From, _To> >;
};
template <class _From, class _To>
using __copy_cvref_t = typename __copy_cvref<_From, _To>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Xp, class _Yp>
using __cond_res = decltype(false ? std::declval<_Xp (&)()>()() : std::declval<_Yp (&)()>()());
template <class _Tp>
struct __xref {
  template <class _Up>
  using __apply = __copy_cvref_t<_Tp, _Up>;
};
template <class _Ap, class _Bp, class _Xp = remove_reference_t<_Ap>, class _Yp = remove_reference_t<_Bp>>
struct __common_ref;
template <class _Xp, class _Yp>
using __common_ref_t = typename __common_ref<_Xp, _Yp>::__type;
template <class _Xp, class _Yp>
using __cv_cond_res = __cond_res<__copy_cv_t<_Xp, _Yp>&, __copy_cv_t<_Yp, _Xp>&>;
template <class _Ap, class _Bp, class _Xp, class _Yp>
  requires
    requires { typename __cv_cond_res<_Xp, _Yp>; } &&
    is_reference_v<__cv_cond_res<_Xp, _Yp>>
struct __common_ref<_Ap&, _Bp&, _Xp, _Yp> {
  using __type = __cv_cond_res<_Xp, _Yp>;
};
template <class _Xp, class _Yp>
using __common_ref_C = remove_reference_t<__common_ref_t<_Xp&, _Yp&>>&&;
template <class _Ap, class _Bp, class _Xp, class _Yp>
  requires
    requires { typename __common_ref_C<_Xp, _Yp>; } &&
    is_convertible_v<_Ap&&, __common_ref_C<_Xp, _Yp>> &&
    is_convertible_v<_Bp&&, __common_ref_C<_Xp, _Yp>>
struct __common_ref<_Ap&&, _Bp&&, _Xp, _Yp> {
  using __type = __common_ref_C<_Xp, _Yp>;
};
template <class _Tp, class _Up>
using __common_ref_D = __common_ref_t<const _Tp&, _Up&>;
template <class _Ap, class _Bp, class _Xp, class _Yp>
  requires
    requires { typename __common_ref_D<_Xp, _Yp>; } &&
    is_convertible_v<_Ap&&, __common_ref_D<_Xp, _Yp>>
struct __common_ref<_Ap&&, _Bp&, _Xp, _Yp> {
  using __type = __common_ref_D<_Xp, _Yp>;
};
template <class _Ap, class _Bp, class _Xp, class _Yp>
struct __common_ref<_Ap&, _Bp&&, _Xp, _Yp> : __common_ref<_Bp&&, _Ap&> {};
template <class _Ap, class _Bp, class _Xp, class _Yp>
struct __common_ref {};
template <class...>
struct common_reference;
template <class... _Types>
using common_reference_t = typename common_reference<_Types...>::type;
template <>
struct common_reference<> {};
template <class _Tp>
struct common_reference<_Tp> {
  using type = _Tp;
};
template <class _Tp, class _Up>
struct __common_reference_sub_bullet3;
template <class _Tp, class _Up>
struct __common_reference_sub_bullet2 : __common_reference_sub_bullet3<_Tp, _Up> {};
template <class _Tp, class _Up>
struct __common_reference_sub_bullet1 : __common_reference_sub_bullet2<_Tp, _Up> {};
template <class _Tp, class _Up>
struct common_reference<_Tp, _Up> : __common_reference_sub_bullet1<_Tp, _Up> {};
template <class _Tp, class _Up>
  requires is_reference_v<_Tp> && is_reference_v<_Up> && requires { typename __common_ref_t<_Tp, _Up>; }
struct __common_reference_sub_bullet1<_Tp, _Up> {
  using type = __common_ref_t<_Tp, _Up>;
};
template <class, class, template <class> class, template <class> class>
struct basic_common_reference {};
template <class _Tp, class _Up>
using __basic_common_reference_t =
    typename basic_common_reference<remove_cvref_t<_Tp>,
                                    remove_cvref_t<_Up>,
                                    __xref<_Tp>::template __apply,
                                    __xref<_Up>::template __apply>::type;
template <class _Tp, class _Up>
  requires requires { typename __basic_common_reference_t<_Tp, _Up>; }
struct __common_reference_sub_bullet2<_Tp, _Up> {
  using type = __basic_common_reference_t<_Tp, _Up>;
};
template <class _Tp, class _Up>
  requires requires { typename __cond_res<_Tp, _Up>; }
struct __common_reference_sub_bullet3<_Tp, _Up> {
  using type = __cond_res<_Tp, _Up>;
};
template <class _Tp, class _Up>
struct __common_reference_sub_bullet3 : common_type<_Tp, _Up> {};
template <class _Tp, class _Up, class _Vp, class... _Rest>
  requires requires { typename common_reference_t<_Tp, _Up>; }
struct common_reference<_Tp, _Up, _Vp, _Rest...> : common_reference<common_reference_t<_Tp, _Up>, _Vp, _Rest...> {};
template <class...>
struct common_reference {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Up>
concept common_reference_with =
    same_as<common_reference_t<_Tp, _Up>, common_reference_t<_Up, _Tp>> &&
    convertible_to<_Tp, common_reference_t<_Tp, _Up>> && convertible_to<_Up, common_reference_t<_Tp, _Up>>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _Tp&&
forward([[_Clang::__lifetimebound__]] __libcpp_remove_reference_t<_Tp>& __t) noexcept {
  return static_cast<_Tp&&>(__t);
}
template <class _Tp>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _Tp&&
forward([[_Clang::__lifetimebound__]] __libcpp_remove_reference_t<_Tp>&& __t) noexcept {
  static_assert(!is_lvalue_reference<_Tp>::value, "cannot forward an rvalue as an lvalue");
  return static_cast<_Tp&&>(__t);
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
concept __boolean_testable_impl = convertible_to<_Tp, bool>;
template <class _Tp>
concept __boolean_testable = __boolean_testable_impl<_Tp> && requires(_Tp&& __t) {
  { !std::forward<_Tp>(__t) } -> __boolean_testable_impl;
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Up>
concept __weakly_equality_comparable_with =
    requires(__make_const_lvalue_ref<_Tp> __t, __make_const_lvalue_ref<_Up> __u) {
      { __t == __u } -> __boolean_testable;
      { __t != __u } -> __boolean_testable;
      { __u == __t } -> __boolean_testable;
      { __u != __t } -> __boolean_testable;
    };
template <class _Tp>
concept equality_comparable = __weakly_equality_comparable_with<_Tp, _Tp>;
template <class _Tp, class _Up>
concept equality_comparable_with =
    equality_comparable<_Tp> && equality_comparable<_Up> &&
    common_reference_with<__make_const_lvalue_ref<_Tp>, __make_const_lvalue_ref<_Up>> &&
    equality_comparable<
        common_reference_t<
            __make_const_lvalue_ref<_Tp>,
            __make_const_lvalue_ref<_Up>>> &&
    __weakly_equality_comparable_with<_Tp, _Up>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Up>
concept __partially_ordered_with = requires(__make_const_lvalue_ref<_Tp> __t, __make_const_lvalue_ref<_Up> __u) {
  { __t < __u } -> __boolean_testable;
  { __t > __u } -> __boolean_testable;
  { __t <= __u } -> __boolean_testable;
  { __t >= __u } -> __boolean_testable;
  { __u < __t } -> __boolean_testable;
  { __u > __t } -> __boolean_testable;
  { __u <= __t } -> __boolean_testable;
  { __u >= __t } -> __boolean_testable;
};
template <class _Tp>
concept totally_ordered = equality_comparable<_Tp> && __partially_ordered_with<_Tp, _Tp>;
template <class _Tp, class _Up>
concept totally_ordered_with =
    totally_ordered<_Tp> && totally_ordered<_Up> &&
    equality_comparable_with<_Tp, _Up> &&
    totally_ordered<
        common_reference_t<
            __make_const_lvalue_ref<_Tp>,
            __make_const_lvalue_ref<_Up>>> &&
    __partially_ordered_with<_Tp, _Up>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template<class _Tp, class _Cat>
concept __compares_as =
  same_as<common_comparison_category_t<_Tp, _Cat>, _Cat>;
template<class _Tp, class _Cat = partial_ordering>
concept three_way_comparable =
  __weakly_equality_comparable_with<_Tp, _Tp> &&
  __partially_ordered_with<_Tp, _Tp> &&
  requires(__make_const_lvalue_ref<_Tp> __a, __make_const_lvalue_ref<_Tp> __b) {
    { __a <=> __b } -> __compares_as<_Cat>;
  };
template<class _Tp, class _Up, class _Cat = partial_ordering>
concept three_way_comparable_with =
  three_way_comparable<_Tp, _Cat> &&
  three_way_comparable<_Up, _Cat> &&
  common_reference_with<__make_const_lvalue_ref<_Tp>, __make_const_lvalue_ref<_Up>> &&
  three_way_comparable<common_reference_t<__make_const_lvalue_ref<_Tp>, __make_const_lvalue_ref<_Up>>, _Cat> &&
  __weakly_equality_comparable_with<_Tp, _Up> &&
  __partially_ordered_with<_Tp, _Up> &&
  requires(__make_const_lvalue_ref<_Tp> __t, __make_const_lvalue_ref<_Up> __u) {
    { __t <=> __u } -> __compares_as<_Cat>;
    { __u <=> __t } -> __compares_as<_Cat>;
  };
}}
extern "C" {
        typedef unsigned __int64 uintptr_t;
        typedef char* va_list;
    void __cdecl __va_start(va_list* , ...);
}
    extern "C++"
    {
        template <typename _Ty>
        struct __vcrt_va_list_is_reference
        {
            enum : bool { __the_value = false };
        };
        template <typename _Ty>
        struct __vcrt_va_list_is_reference<_Ty&>
        {
            enum : bool { __the_value = true };
        };
        template <typename _Ty>
        struct __vcrt_va_list_is_reference<_Ty&&>
        {
            enum : bool { __the_value = true };
        };
        template <typename _Ty>
        struct __vcrt_assert_va_start_is_not_reference
        {
            static_assert(!__vcrt_va_list_is_reference<_Ty>::__the_value,
                "va_start argument must not have reference type and must not be parenthesized");
        };
    }
extern "C" {
}
extern "C" {
}
 extern "C" {
    typedef unsigned __int64 size_t;
    typedef __int64 ptrdiff_t;
    typedef __int64 intptr_t;
    typedef bool __vcrt_bool;
    extern "C++"
    {
        template <typename _CountofType, size_t _SizeOfArray>
        char (*__countof_helper(__unaligned _CountofType (&_Array)[_SizeOfArray]))[_SizeOfArray];
    }
    void __cdecl __security_init_cookie(void);
        void __cdecl __security_check_cookie( uintptr_t _StackCookie);
        __declspec(noreturn) void __cdecl __report_gsfailure( uintptr_t _StackCookie);
extern uintptr_t __security_cookie;
}
 extern "C" {
extern "C++"
{
    template<bool _Enable, typename _Ty>
    struct _CrtEnableIf;
    template<typename _Ty>
    struct _CrtEnableIf<true, _Ty>
    {
        typedef _Ty _Type;
    };
}
    typedef bool __crt_bool;
             void __cdecl _invalid_parameter_noinfo(void);
         __declspec(noreturn) void __cdecl _invalid_parameter_noinfo_noreturn(void);
__declspec(noreturn)
         void __cdecl _invoke_watson(
               wchar_t const*,
               wchar_t const*,
               wchar_t const*,
               unsigned int,
               uintptr_t);
typedef int errno_t;
typedef unsigned short wint_t;
typedef unsigned short wctype_t;
typedef long __time32_t;
typedef __int64 __time64_t;
typedef struct __crt_locale_data_public
{
      unsigned short const* _locale_pctype;
                        int _locale_mb_cur_max;
               unsigned int _locale_lc_codepage;
} __crt_locale_data_public;
typedef struct __crt_locale_pointers
{
    struct __crt_locale_data* locinfo;
    struct __crt_multibyte_data* mbcinfo;
} __crt_locale_pointers;
typedef __crt_locale_pointers* _locale_t;
typedef struct _Mbstatet
{
    unsigned long _Wchar;
    unsigned short _Byte, _State;
} _Mbstatet;
typedef _Mbstatet mbstate_t;
        typedef __time64_t time_t;
    typedef size_t rsize_t;
}
 extern "C" {
typedef void (__cdecl* terminate_handler )();
typedef void (__cdecl* terminate_function)();
             __declspec(noreturn) void __cdecl abort();
             __declspec(noreturn) void __cdecl terminate() throw();
                 terminate_handler __cdecl set_terminate(
                     terminate_handler _NewTerminateHandler
            ) throw();
                 terminate_handler __cdecl _get_terminate();
}
 extern "C" {
struct _EXCEPTION_POINTERS;
        typedef void (__cdecl* _se_translator_function)(unsigned int, struct _EXCEPTION_POINTERS*);
                 _se_translator_function __cdecl _set_se_translator(
                     _se_translator_function _NewSETranslator
            );
    extern "C++" {
        class type_info;
    }
             int __cdecl _is_exception_typeof(
             type_info const& _Type,
             _EXCEPTION_POINTERS* _ExceptionPtr
        );
             bool __cdecl __uncaught_exception();
             int __cdecl __uncaught_exceptions();
}
 extern "C" {
struct __std_exception_data
{
    char const* _What;
    bool _DoFree;
};
         void __cdecl __std_exception_copy(
          __std_exception_data const* _From,
          __std_exception_data* _To
    );
         void __cdecl __std_exception_destroy(
            __std_exception_data* _Data
    );
}
namespace std {
class exception
{
public:
    exception() noexcept
        : _Data()
    {
    }
    explicit exception(char const* const _Message) noexcept
        : _Data()
    {
        __std_exception_data _InitData = { _Message, true };
        __std_exception_copy(&_InitData, &_Data);
    }
    exception(char const* const _Message, int) noexcept
        : _Data()
    {
        _Data._What = _Message;
    }
    exception(exception const& _Other) noexcept
        : _Data()
    {
        __std_exception_copy(&_Other._Data, &_Data);
    }
    exception& operator=(exception const& _Other) noexcept
    {
        if (this == &_Other)
        {
            return *this;
        }
        __std_exception_destroy(&_Data);
        __std_exception_copy(&_Other._Data, &_Data);
        return *this;
    }
    virtual ~exception() noexcept
    {
        __std_exception_destroy(&_Data);
    }
    [[nodiscard]] virtual char const* what() const
    {
        return _Data._What ? _Data._What : "Unknown exception";
    }
private:
    __std_exception_data _Data;
};
class bad_exception
    : public exception
{
public:
    bad_exception() noexcept
        : exception("bad exception", 1)
    {
    }
};
class bad_alloc
    : public exception
{
public:
    bad_alloc() noexcept
        : exception("bad allocation", 1)
    {
    }
private:
    friend class bad_array_new_length;
    bad_alloc(char const* const _Message) noexcept
        : exception(_Message, 1)
    {
    }
};
class bad_array_new_length
    : public bad_alloc
{
public:
    bad_array_new_length() noexcept
        : bad_alloc("bad array new length")
    {
    }
};
}
namespace std {
}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_volatile : _BoolConstant<__is_volatile(_Tp)> {};
template <class _Tp>
inline constexpr bool is_volatile_v = __is_volatile(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp,
          bool = is_const<__libcpp_remove_reference_t<_Tp> >::value,
          bool = is_volatile<__libcpp_remove_reference_t<_Tp> >::value>
struct __apply_cv_impl {
  template <class _Up>
  using __apply __attribute__((__nodebug__)) = _Up;
};
template <class _Tp>
struct __apply_cv_impl<_Tp, true, false> {
  template <class _Up>
  using __apply __attribute__((__nodebug__)) = const _Up;
};
template <class _Tp>
struct __apply_cv_impl<_Tp, false, true> {
  template <class _Up>
  using __apply __attribute__((__nodebug__)) = volatile _Up;
};
template <class _Tp>
struct __apply_cv_impl<_Tp, true, true> {
  template <class _Up>
  using __apply __attribute__((__nodebug__)) = const volatile _Up;
};
template <class _Tp>
struct __apply_cv_impl<_Tp&, false, false> {
  template <class _Up>
  using __apply __attribute__((__nodebug__)) = _Up&;
};
template <class _Tp>
struct __apply_cv_impl<_Tp&, true, false> {
  template <class _Up>
  using __apply __attribute__((__nodebug__)) = const _Up&;
};
template <class _Tp>
struct __apply_cv_impl<_Tp&, false, true> {
  template <class _Up>
  using __apply __attribute__((__nodebug__)) = volatile _Up&;
};
template <class _Tp>
struct __apply_cv_impl<_Tp&, true, true> {
  template <class _Up>
  using __apply __attribute__((__nodebug__)) = const volatile _Up&;
};
template <class _Tp, class _Up>
using __apply_cv_t __attribute__((__nodebug__)) = typename __apply_cv_impl<_Tp>::template __apply<_Up>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Bp, class _Dp>
struct is_base_of : public integral_constant<bool, __is_base_of(_Bp, _Dp)> {};
template <class _Bp, class _Dp>
inline constexpr bool is_base_of_v = __is_base_of(_Bp, _Dp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Up, class = void>
struct __is_core_convertible : public false_type {};
template <class _Tp, class _Up>
struct __is_core_convertible<_Tp, _Up, decltype(static_cast<void (*)(_Up)>(0)(static_cast<_Tp (*)()>(0)()))>
    : public true_type {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct __libcpp_is_member_pointer {
  enum { __is_member = false, __is_func = false, __is_obj = false };
};
template <class _Tp, class _Up>
struct __libcpp_is_member_pointer<_Tp _Up::*> {
  enum {
    __is_member = true,
    __is_func = is_function<_Tp>::value,
    __is_obj = !__is_func,
  };
};
template <class _Tp>
struct is_member_function_pointer : _BoolConstant<__is_member_function_pointer(_Tp)> {};
template <class _Tp>
inline constexpr bool is_member_function_pointer_v = __is_member_function_pointer(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_member_object_pointer : _BoolConstant<__is_member_object_pointer(_Tp)> {};
template <class _Tp>
inline constexpr bool is_member_object_pointer_v = __is_member_object_pointer(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
class reference_wrapper;
template <class _Tp>
struct __is_reference_wrapper_impl : public false_type {};
template <class _Tp>
struct __is_reference_wrapper_impl<reference_wrapper<_Tp> > : public true_type {};
template <class _Tp>
struct __is_reference_wrapper : public __is_reference_wrapper_impl<__remove_cv_t<_Tp> > {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
struct __nat {
  __nat() = delete;
  __nat(const __nat&) = delete;
  __nat& operator=(const __nat&) = delete;
  ~__nat() = delete;
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
struct __any {
  __any(...);
};
template <class _MP, bool _IsMemberFunctionPtr, bool _IsMemberObjectPtr>
struct __member_pointer_traits_imp {};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...), true, false> {
  typedef _Class _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...), true, false> {
  typedef _Class _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...) const, true, false> {
  typedef _Class const _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...) const, true, false> {
  typedef _Class const _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...) volatile, true, false> {
  typedef _Class volatile _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...) volatile, true, false> {
  typedef _Class volatile _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...) const volatile, true, false> {
  typedef _Class const volatile _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...) const volatile, true, false> {
  typedef _Class const volatile _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...)&, true, false> {
  typedef _Class& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...)&, true, false> {
  typedef _Class& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...) const&, true, false> {
  typedef _Class const& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...) const&, true, false> {
  typedef _Class const& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...) volatile&, true, false> {
  typedef _Class volatile& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...) volatile&, true, false> {
  typedef _Class volatile& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...) const volatile&, true, false> {
  typedef _Class const volatile& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...) const volatile&, true, false> {
  typedef _Class const volatile& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...)&&, true, false> {
  typedef _Class&& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...)&&, true, false> {
  typedef _Class&& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...) const&&, true, false> {
  typedef _Class const&& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...) const&&, true, false> {
  typedef _Class const&& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...) volatile&&, true, false> {
  typedef _Class volatile&& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...) volatile&&, true, false> {
  typedef _Class volatile&& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param...) const volatile&&, true, false> {
  typedef _Class const volatile&& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param...);
};
template <class _Rp, class _Class, class... _Param>
struct __member_pointer_traits_imp<_Rp (_Class::*)(_Param..., ...) const volatile&&, true, false> {
  typedef _Class const volatile&& _ClassType;
  typedef _Rp _ReturnType;
  typedef _Rp(_FnType)(_Param..., ...);
};
template <class _Rp, class _Class>
struct __member_pointer_traits_imp<_Rp _Class::*, false, true> {
  typedef _Class _ClassType;
  typedef _Rp _ReturnType;
};
template <class _MP>
struct __member_pointer_traits
    : public __member_pointer_traits_imp<__remove_cv_t<_MP>,
                                         is_member_function_pointer<_MP>::value,
                                         is_member_object_pointer<_MP>::value> {
};
template <class _DecayedFp>
struct __member_pointer_class_type {};
template <class _Ret, class _ClassType>
struct __member_pointer_class_type<_Ret _ClassType::*> {
  typedef _ClassType type;
};
template <class _Fp,
          class _A0,
          class _DecayFp = __decay_t<_Fp>,
          class _DecayA0 = __decay_t<_A0>,
          class _ClassT = typename __member_pointer_class_type<_DecayFp>::type>
using __enable_if_bullet1 =
    typename enable_if<is_member_function_pointer<_DecayFp>::value && is_base_of<_ClassT, _DecayA0>::value >::type;
template <class _Fp, class _A0, class _DecayFp = __decay_t<_Fp>, class _DecayA0 = __decay_t<_A0> >
using __enable_if_bullet2 =
    typename enable_if<is_member_function_pointer<_DecayFp>::value && __is_reference_wrapper<_DecayA0>::value >::type;
template <class _Fp,
          class _A0,
          class _DecayFp = __decay_t<_Fp>,
          class _DecayA0 = __decay_t<_A0>,
          class _ClassT = typename __member_pointer_class_type<_DecayFp>::type>
using __enable_if_bullet3 =
    typename enable_if<is_member_function_pointer<_DecayFp>::value && !is_base_of<_ClassT, _DecayA0>::value &&
                       !__is_reference_wrapper<_DecayA0>::value >::type;
template <class _Fp,
          class _A0,
          class _DecayFp = __decay_t<_Fp>,
          class _DecayA0 = __decay_t<_A0>,
          class _ClassT = typename __member_pointer_class_type<_DecayFp>::type>
using __enable_if_bullet4 =
    typename enable_if<is_member_object_pointer<_DecayFp>::value && is_base_of<_ClassT, _DecayA0>::value >::type;
template <class _Fp, class _A0, class _DecayFp = __decay_t<_Fp>, class _DecayA0 = __decay_t<_A0> >
using __enable_if_bullet5 =
    typename enable_if<is_member_object_pointer<_DecayFp>::value && __is_reference_wrapper<_DecayA0>::value >::type;
template <class _Fp,
          class _A0,
          class _DecayFp = __decay_t<_Fp>,
          class _DecayA0 = __decay_t<_A0>,
          class _ClassT = typename __member_pointer_class_type<_DecayFp>::type>
using __enable_if_bullet6 =
    typename enable_if<is_member_object_pointer<_DecayFp>::value && !is_base_of<_ClassT, _DecayA0>::value &&
                       !__is_reference_wrapper<_DecayA0>::value >::type;
template <class... _Args>
__nat __invoke(__any, _Args&&... __args);
template <class _Fp, class _A0, class... _Args, class = __enable_if_bullet1<_Fp, _A0> >
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
decltype((std::declval<_A0>().*std::declval<_Fp>())(std::declval<_Args>()...))
__invoke(_Fp&& __f, _A0&& __a0, _Args&&... __args)
    noexcept(noexcept((static_cast<_A0&&>(__a0).*__f)(static_cast<_Args&&>(__args)...)))
               { return (static_cast<_A0&&>(__a0).*__f)(static_cast<_Args&&>(__args)...); }
template <class _Fp, class _A0, class... _Args, class = __enable_if_bullet2<_Fp, _A0> >
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
decltype((std::declval<_A0>().get().*std::declval<_Fp>())(std::declval<_Args>()...))
__invoke(_Fp&& __f, _A0&& __a0, _Args&&... __args)
    noexcept(noexcept((__a0.get().*__f)(static_cast<_Args&&>(__args)...)))
               { return (__a0.get().*__f)(static_cast<_Args&&>(__args)...); }
template <class _Fp, class _A0, class... _Args, class = __enable_if_bullet3<_Fp, _A0> >
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
decltype(((*std::declval<_A0>()).*std::declval<_Fp>())(std::declval<_Args>()...))
__invoke(_Fp&& __f, _A0&& __a0, _Args&&... __args)
    noexcept(noexcept(((*static_cast<_A0&&>(__a0)).*__f)(static_cast<_Args&&>(__args)...)))
               { return ((*static_cast<_A0&&>(__a0)).*__f)(static_cast<_Args&&>(__args)...); }
template <class _Fp, class _A0, class = __enable_if_bullet4<_Fp, _A0> >
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
decltype(std::declval<_A0>().*std::declval<_Fp>())
__invoke(_Fp&& __f, _A0&& __a0)
    noexcept(noexcept(static_cast<_A0&&>(__a0).*__f))
               { return static_cast<_A0&&>(__a0).*__f; }
template <class _Fp, class _A0, class = __enable_if_bullet5<_Fp, _A0> >
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
decltype(std::declval<_A0>().get().*std::declval<_Fp>())
__invoke(_Fp&& __f, _A0&& __a0)
    noexcept(noexcept(__a0.get().*__f))
               { return __a0.get().*__f; }
template <class _Fp, class _A0, class = __enable_if_bullet6<_Fp, _A0> >
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
decltype((*std::declval<_A0>()).*std::declval<_Fp>())
__invoke(_Fp&& __f, _A0&& __a0)
    noexcept(noexcept((*static_cast<_A0&&>(__a0)).*__f))
               { return (*static_cast<_A0&&>(__a0)).*__f; }
template <class _Fp, class... _Args>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
decltype(std::declval<_Fp>()(std::declval<_Args>()...))
__invoke(_Fp&& __f, _Args&&... __args)
    noexcept(noexcept(static_cast<_Fp&&>(__f)(static_cast<_Args&&>(__args)...)))
               { return static_cast<_Fp&&>(__f)(static_cast<_Args&&>(__args)...); }
template <class _Ret, class _Fp, class... _Args>
struct __invokable_r {
  template <class _XFp, class... _XArgs>
  static decltype(std::__invoke(std::declval<_XFp>(), std::declval<_XArgs>()...)) __try_call(int);
  template <class _XFp, class... _XArgs>
  static __nat __try_call(...);
  using _Result = decltype(__try_call<_Fp, _Args...>(0));
  using type = __conditional_t<_IsNotSame<_Result, __nat>::value,
                               __conditional_t<is_void<_Ret>::value, true_type, __is_core_convertible<_Result, _Ret> >,
                               false_type>;
  static const bool value = type::value;
};
template <class _Fp, class... _Args>
using __invokable = __invokable_r<void, _Fp, _Args...>;
template <bool _IsInvokable, bool _IsCVVoid, class _Ret, class _Fp, class... _Args>
struct __nothrow_invokable_r_imp {
  static const bool value = false;
};
template <class _Ret, class _Fp, class... _Args>
struct __nothrow_invokable_r_imp<true, false, _Ret, _Fp, _Args...> {
  typedef __nothrow_invokable_r_imp _ThisT;
  template <class _Tp>
  static void __test_noexcept(_Tp) noexcept;
  static const bool value =
      noexcept(_ThisT::__test_noexcept<_Ret>(std::__invoke(std::declval<_Fp>(), std::declval<_Args>()...)));
};
template <class _Ret, class _Fp, class... _Args>
struct __nothrow_invokable_r_imp<true, true, _Ret, _Fp, _Args...> {
  static const bool value = noexcept(std::__invoke(std::declval<_Fp>(), std::declval<_Args>()...));
};
template <class _Ret, class _Fp, class... _Args>
using __nothrow_invokable_r =
    __nothrow_invokable_r_imp<__invokable_r<_Ret, _Fp, _Args...>::value, is_void<_Ret>::value, _Ret, _Fp, _Args...>;
template <class _Fp, class... _Args>
using __nothrow_invokable = __nothrow_invokable_r_imp<__invokable<_Fp, _Args...>::value, true, void, _Fp, _Args...>;
template <class _Fp, class... _Args>
struct __invoke_of
    : public enable_if<__invokable<_Fp, _Args...>::value, typename __invokable_r<void, _Fp, _Args...>::_Result> {};
template <class _Ret, bool = is_void<_Ret>::value>
struct __invoke_void_return_wrapper {
  template <class... _Args>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr static _Ret __call(_Args&&... __args) {
    return std::__invoke(std::forward<_Args>(__args)...);
  }
};
template <class _Ret>
struct __invoke_void_return_wrapper<_Ret, true> {
  template <class... _Args>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr static void __call(_Args&&... __args) {
    std::__invoke(std::forward<_Args>(__args)...);
  }
};
template <class _Fn, class... _Args>
struct is_invocable : integral_constant<bool, __invokable<_Fn, _Args...>::value> {};
template <class _Ret, class _Fn, class... _Args>
struct is_invocable_r : integral_constant<bool, __invokable_r<_Ret, _Fn, _Args...>::value> {};
template <class _Fn, class... _Args>
inline constexpr bool is_invocable_v = is_invocable<_Fn, _Args...>::value;
template <class _Ret, class _Fn, class... _Args>
inline constexpr bool is_invocable_r_v = is_invocable_r<_Ret, _Fn, _Args...>::value;
template <class _Fn, class... _Args>
struct is_nothrow_invocable : integral_constant<bool, __nothrow_invokable<_Fn, _Args...>::value> {
};
template <class _Ret, class _Fn, class... _Args>
struct is_nothrow_invocable_r
    : integral_constant<bool, __nothrow_invokable_r<_Ret, _Fn, _Args...>::value> {};
template <class _Fn, class... _Args>
inline constexpr bool is_nothrow_invocable_v = is_nothrow_invocable<_Fn, _Args...>::value;
template <class _Ret, class _Fn, class... _Args>
inline constexpr bool is_nothrow_invocable_r_v = is_nothrow_invocable_r<_Ret, _Fn, _Args...>::value;
template <class _Fn, class... _Args>
struct invoke_result : __invoke_of<_Fn, _Args...> {};
template <class _Fn, class... _Args>
using invoke_result_t = typename invoke_result<_Fn, _Args...>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Fn, class ..._Args>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr invoke_result_t<_Fn, _Args...>
invoke(_Fn&& __f, _Args&&... __args)
    noexcept(is_nothrow_invocable_v<_Fn, _Args...>)
{
    return std::__invoke(std::forward<_Fn>(__f), std::forward<_Args>(__args)...);
}
template <class _Result, class _Fn, class... _Args>
  requires is_invocable_r_v<_Result, _Fn, _Args...>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _Result
invoke_r(_Fn&& __f, _Args&&... __args) noexcept(is_nothrow_invocable_r_v<_Result, _Fn, _Args...>) {
    if constexpr (is_void_v<_Result>) {
        static_cast<void>(std::invoke(std::forward<_Fn>(__f), std::forward<_Args>(__args)...));
    } else {
        static_assert(true,
            "Returning from invoke_r would bind a temporary object to the reference return type, "
            "which would result in a dangling reference.");
        return std::invoke(std::forward<_Fn>(__f), std::forward<_Args>(__args)...);
    }
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Arg, class _Result> struct __unary_function_keep_layout_base {
};
template <class _Arg, class _Result>
using __unary_function = __unary_function_keep_layout_base<_Arg, _Result>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class>
struct hash;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class...>
class tuple;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, size_t _Size>
struct array;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <size_t...> struct __tuple_indices;
template <class _IdxType, _IdxType... _Values>
struct __integer_sequence {
  template <template <class _OIdxType, _OIdxType...> class _ToIndexSeq, class _ToIndexType>
  using __convert = _ToIndexSeq<_ToIndexType, _Values...>;
  template <size_t _Sp>
  using __to_tuple_indices = __tuple_indices<(_Values + _Sp)...>;
};
template <size_t _Ep, size_t _Sp>
using __make_indices_imp =
    typename __make_integer_seq<__integer_sequence, size_t, _Ep - _Sp>::template
    __to_tuple_indices<_Sp>;
template<class _Tp, _Tp... _Ip>
struct integer_sequence
{
    typedef _Tp value_type;
    static_assert( is_integral<_Tp>::value,
                  "std::integer_sequence can only be instantiated with an integral type" );
    static
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    constexpr
    size_t
    size() noexcept { return sizeof...(_Ip); }
};
template<size_t... _Ip>
    using index_sequence = integer_sequence<size_t, _Ip...>;
template <class _Tp, _Tp _Ep>
using __make_integer_sequence __attribute__((__nodebug__)) = __make_integer_seq<integer_sequence, _Tp, _Ep>;
template<class _Tp, _Tp _Np>
    using make_integer_sequence = __make_integer_sequence<_Tp, _Np>;
template<size_t _Np>
    using make_index_sequence = make_integer_sequence<size_t, _Np>;
template<class... _Tp>
    using index_sequence_for = make_index_sequence<sizeof...(_Tp)>;
template <size_t... _Index, class _Function>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr void __for_each_index_sequence(index_sequence<_Index...>, _Function __func) {
    (__func.template operator()<_Index>(), ...);
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <size_t...> struct __tuple_indices {};
template <size_t _Ep, size_t _Sp = 0>
struct __make_tuple_indices
{
    static_assert(_Sp <= _Ep, "__make_tuple_indices input error");
    typedef __make_indices_imp<_Ep, _Sp> type;
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class ..._Tp> struct __tuple_types {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <size_t _Ip, class _Tp> struct tuple_element;
template <size_t _Ip, class _Tp>
struct tuple_element<_Ip, const _Tp>
{
    typedef __attribute__((__nodebug__)) typename add_const<typename tuple_element<_Ip, _Tp>::type>::type type;
};
template <size_t _Ip, class _Tp>
struct tuple_element<_Ip, volatile _Tp>
{
    typedef __attribute__((__nodebug__)) typename add_volatile<typename tuple_element<_Ip, _Tp>::type>::type type;
};
template <size_t _Ip, class _Tp>
struct tuple_element<_Ip, const volatile _Tp>
{
    typedef __attribute__((__nodebug__)) typename add_cv<typename tuple_element<_Ip, _Tp>::type>::type type;
};
template <size_t _Ip, class ..._Types>
struct tuple_element<_Ip, __tuple_types<_Types...> >
{
    static_assert(_Ip < sizeof...(_Types), "tuple_element index out of range");
    typedef __attribute__((__nodebug__)) __type_pack_element<_Ip, _Types...> type;
};
template <size_t _Ip, class ..._Tp>
using tuple_element_t __attribute__((__nodebug__)) = typename tuple_element <_Ip, _Tp...>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp> struct tuple_size;
template <class _Tp, class...>
using __enable_if_tuple_size_imp = _Tp;
template <class _Tp>
struct tuple_size<__enable_if_tuple_size_imp<
    const _Tp,
    __enable_if_t<!is_volatile<_Tp>::value>,
    integral_constant<size_t, sizeof(tuple_size<_Tp>)>>>
    : public integral_constant<size_t, tuple_size<_Tp>::value> {};
template <class _Tp>
struct tuple_size<__enable_if_tuple_size_imp<
    volatile _Tp,
    __enable_if_t<!is_const<_Tp>::value>,
    integral_constant<size_t, sizeof(tuple_size<_Tp>)>>>
    : public integral_constant<size_t, tuple_size<_Tp>::value> {};
template <class _Tp>
struct tuple_size<__enable_if_tuple_size_imp<
    const volatile _Tp,
    integral_constant<size_t, sizeof(tuple_size<_Tp>)>>>
    : public integral_constant<size_t, tuple_size<_Tp>::value> {};
template <class ..._Tp>
struct tuple_size<tuple<_Tp...> >
    : public integral_constant<size_t, sizeof...(_Tp)>
{
};
template <class ..._Tp>
struct tuple_size<__tuple_types<_Tp...> >
    : public integral_constant<size_t, sizeof...(_Tp)>
{
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _TupleTypes, class _TupleIndices>
struct __make_tuple_types_flat;
template <template <class...> class _Tuple, class ..._Types, size_t ..._Idx>
struct __make_tuple_types_flat<_Tuple<_Types...>, __tuple_indices<_Idx...>> {
  template <class _Tp>
  using __apply_quals __attribute__((__nodebug__)) = __tuple_types<__apply_cv_t<_Tp, __type_pack_element<_Idx, _Types...>>...>;
};
template <class _Vt, size_t _Np, size_t ..._Idx>
struct __make_tuple_types_flat<array<_Vt, _Np>, __tuple_indices<_Idx...>> {
  template <size_t>
  using __value_type = _Vt;
  template <class _Tp>
  using __apply_quals = __tuple_types<__apply_cv_t<_Tp, __value_type<_Idx>>...>;
};
template <class _Tp, size_t _Ep = tuple_size<__libcpp_remove_reference_t<_Tp> >::value,
          size_t _Sp = 0,
          bool _SameSize = (_Ep == tuple_size<__libcpp_remove_reference_t<_Tp> >::value)>
struct __make_tuple_types
{
    static_assert(_Sp <= _Ep, "__make_tuple_types input error");
    using _RawTp = __remove_cv_t<__libcpp_remove_reference_t<_Tp> >;
    using _Maker = __make_tuple_types_flat<_RawTp, typename __make_tuple_indices<_Ep, _Sp>::type>;
    using type = typename _Maker::template __apply_quals<_Tp>;
};
template <class ..._Types, size_t _Ep>
struct __make_tuple_types<tuple<_Types...>, _Ep, 0, true> {
  typedef __attribute__((__nodebug__)) __tuple_types<_Types...> type;
};
template <class ..._Types, size_t _Ep>
struct __make_tuple_types<__tuple_types<_Types...>, _Ep, 0, true> {
  typedef __attribute__((__nodebug__)) __tuple_types<_Types...> type;
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class, class>
struct pair;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp> struct __tuple_like_ext : false_type {};
template <class _Tp> struct __tuple_like_ext<const _Tp> : public __tuple_like_ext<_Tp> {};
template <class _Tp> struct __tuple_like_ext<volatile _Tp> : public __tuple_like_ext<_Tp> {};
template <class _Tp> struct __tuple_like_ext<const volatile _Tp> : public __tuple_like_ext<_Tp> {};
template <class... _Tp> struct __tuple_like_ext<tuple<_Tp...> > : true_type {};
template <class _T1, class _T2> struct __tuple_like_ext<pair<_T1, _T2> > : true_type {};
template <class _Tp, size_t _Size> struct __tuple_like_ext<array<_Tp, _Size> > : true_type {};
template <class... _Tp> struct __tuple_like_ext<__tuple_types<_Tp...> > : true_type {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Up>
struct is_assignable : _BoolConstant<__is_assignable(_Tp, _Up)> {};
template <class _Tp, class _Arg>
inline constexpr bool is_assignable_v = __is_assignable(_Tp, _Arg);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class... _Args>
struct is_constructible : public integral_constant<bool, __is_constructible(_Tp, _Args...)> {};
template <class _Tp, class... _Args>
inline constexpr bool is_constructible_v = __is_constructible(_Tp, _Args...);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <bool ..._Preds>
struct __all_dummy;
template <bool ..._Pred>
struct __all : _IsSame<__all_dummy<_Pred...>, __all_dummy<((void)_Pred, true)...>> {};
struct __tuple_sfinae_base {
  template <template <class, class...> class _Trait,
            class ..._LArgs, class ..._RArgs>
  static auto __do_test(__tuple_types<_LArgs...>, __tuple_types<_RArgs...>)
    -> __all<__enable_if_t<_Trait<_LArgs, _RArgs>::value, bool>{true}...>;
  template <template <class...> class>
  static auto __do_test(...) -> false_type;
  template <class _FromArgs, class _ToArgs>
  using __constructible = decltype(__do_test<is_constructible>(_ToArgs{}, _FromArgs{}));
  template <class _FromArgs, class _ToArgs>
  using __convertible = decltype(__do_test<is_convertible>(_FromArgs{}, _ToArgs{}));
  template <class _FromArgs, class _ToArgs>
  using __assignable = decltype(__do_test<is_assignable>(_ToArgs{}, _FromArgs{}));
};
template <class _Tp, class _Up, bool = __tuple_like_ext<__libcpp_remove_reference_t<_Tp> >::value,
                                bool = __tuple_like_ext<_Up>::value>
struct __tuple_convertible
    : public false_type {};
template <class _Tp, class _Up>
struct __tuple_convertible<_Tp, _Up, true, true>
    : public __tuple_sfinae_base::__convertible<
      typename __make_tuple_types<_Tp>::type
    , typename __make_tuple_types<_Up>::type
    >
{};
template <class _Tp, class _Up, bool = __tuple_like_ext<__libcpp_remove_reference_t<_Tp> >::value,
                                bool = __tuple_like_ext<_Up>::value>
struct __tuple_constructible
    : public false_type {};
template <class _Tp, class _Up>
struct __tuple_constructible<_Tp, _Up, true, true>
    : public __tuple_sfinae_base::__constructible<
      typename __make_tuple_types<_Tp>::type
    , typename __make_tuple_types<_Up>::type
    >
{};
template <class _Tp, class _Up, bool = __tuple_like_ext<__libcpp_remove_reference_t<_Tp> >::value,
                                bool = __tuple_like_ext<_Up>::value>
struct __tuple_assignable
    : public false_type {};
template <class _Tp, class _Up>
struct __tuple_assignable<_Tp, _Up, true, true>
    : public __tuple_sfinae_base::__assignable<
      typename __make_tuple_types<_Tp>::type
    , typename __make_tuple_types<_Up&>::type
    >
{};
template <size_t _Ip, class ..._Tp>
struct tuple_element<_Ip, tuple<_Tp...> >
{
    typedef __attribute__((__nodebug__)) typename tuple_element<_Ip, __tuple_types<_Tp...> >::type type;
};
struct __check_tuple_constructor_fail {
    static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __enable_explicit_default() { return false; }
    static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __enable_implicit_default() { return false; }
    template <class ...>
    static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __enable_explicit() { return false; }
    template <class ...>
    static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __enable_implicit() { return false; }
    template <class ...>
    static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __enable_assign() { return false; }
};
template <bool _CanCopy, bool _CanMove>
struct __sfinae_ctor_base {};
template <>
struct __sfinae_ctor_base<false, false> {
  __sfinae_ctor_base() = default;
  __sfinae_ctor_base(__sfinae_ctor_base const&) = delete;
  __sfinae_ctor_base(__sfinae_ctor_base &&) = delete;
  __sfinae_ctor_base& operator=(__sfinae_ctor_base const&) = default;
  __sfinae_ctor_base& operator=(__sfinae_ctor_base&&) = default;
};
template <>
struct __sfinae_ctor_base<true, false> {
  __sfinae_ctor_base() = default;
  __sfinae_ctor_base(__sfinae_ctor_base const&) = default;
  __sfinae_ctor_base(__sfinae_ctor_base &&) = delete;
  __sfinae_ctor_base& operator=(__sfinae_ctor_base const&) = default;
  __sfinae_ctor_base& operator=(__sfinae_ctor_base&&) = default;
};
template <>
struct __sfinae_ctor_base<false, true> {
  __sfinae_ctor_base() = default;
  __sfinae_ctor_base(__sfinae_ctor_base const&) = delete;
  __sfinae_ctor_base(__sfinae_ctor_base &&) = default;
  __sfinae_ctor_base& operator=(__sfinae_ctor_base const&) = default;
  __sfinae_ctor_base& operator=(__sfinae_ctor_base&&) = default;
};
template <bool _CanCopy, bool _CanMove>
struct __sfinae_assign_base {};
template <>
struct __sfinae_assign_base<false, false> {
  __sfinae_assign_base() = default;
  __sfinae_assign_base(__sfinae_assign_base const&) = default;
  __sfinae_assign_base(__sfinae_assign_base &&) = default;
  __sfinae_assign_base& operator=(__sfinae_assign_base const&) = delete;
  __sfinae_assign_base& operator=(__sfinae_assign_base&&) = delete;
};
template <>
struct __sfinae_assign_base<true, false> {
  __sfinae_assign_base() = default;
  __sfinae_assign_base(__sfinae_assign_base const&) = default;
  __sfinae_assign_base(__sfinae_assign_base &&) = default;
  __sfinae_assign_base& operator=(__sfinae_assign_base const&) = default;
  __sfinae_assign_base& operator=(__sfinae_assign_base&&) = delete;
};
template <>
struct __sfinae_assign_base<false, true> {
  __sfinae_assign_base() = default;
  __sfinae_assign_base(__sfinae_assign_base const&) = default;
  __sfinae_assign_base(__sfinae_assign_base &&) = default;
  __sfinae_assign_base& operator=(__sfinae_assign_base const&) = delete;
  __sfinae_assign_base& operator=(__sfinae_assign_base&&) = default;
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_copy_constructible
    : public integral_constant<bool, __is_constructible(_Tp, __add_lvalue_reference_t<typename add_const<_Tp>::type>)> {
};
template <class _Tp>
inline constexpr bool is_copy_constructible_v = is_copy_constructible<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_default_constructible : public integral_constant<bool, __is_constructible(_Tp)> {};
template <class _Tp>
inline constexpr bool is_default_constructible_v = __is_constructible(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_enum : public integral_constant<bool, __is_enum(_Tp)> {};
template <class _Tp>
inline constexpr bool is_enum_v = __is_enum(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_move_constructible
    : public integral_constant<bool, __is_constructible(_Tp, __add_rvalue_reference_t<_Tp>)> {};
template <class _Tp>
inline constexpr bool is_move_constructible_v = is_move_constructible<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, bool = is_enum<_Tp>::value>
struct __underlying_type_impl;
template <class _Tp>
struct __underlying_type_impl<_Tp, false> {};
template <class _Tp>
struct __underlying_type_impl<_Tp, true> {
  typedef __underlying_type(_Tp) type;
};
template <class _Tp>
struct underlying_type : __underlying_type_impl<_Tp, is_enum<_Tp>::value> {};
template <class _Tp>
using underlying_type_t = typename underlying_type<_Tp>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template < class _Tp, class... _Args>
struct is_nothrow_constructible
    : public integral_constant<bool, __is_nothrow_constructible(_Tp, _Args...)> {};
template <class _Tp, class... _Args>
inline constexpr bool is_nothrow_constructible_v = is_nothrow_constructible<_Tp, _Args...>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_nothrow_move_constructible
    : public integral_constant<bool, __is_nothrow_constructible(_Tp, __add_rvalue_reference_t<_Tp>)> {};
template <class _Tp>
inline constexpr bool is_nothrow_move_constructible_v = is_nothrow_move_constructible<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr __libcpp_remove_reference_t<_Tp>&&
move([[_Clang::__lifetimebound__]] _Tp&& __t) noexcept {
  typedef __attribute__((__nodebug__)) __libcpp_remove_reference_t<_Tp> _Up;
  return static_cast<_Up&&>(__t);
}
template <class _Tp>
using __move_if_noexcept_result_t =
    __conditional_t<!is_nothrow_move_constructible<_Tp>::value && is_copy_constructible<_Tp>::value, const _Tp&, _Tp&&>;
template <class _Tp>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr __move_if_noexcept_result_t<_Tp>
move_if_noexcept([[_Clang::__lifetimebound__]] _Tp& __x) noexcept {
  return std::move(__x);
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Up>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto __synth_three_way(const _Tp& __t, const _Up& __u)
  requires requires {
    { __t < __u } -> __boolean_testable;
    { __u < __t } -> __boolean_testable;
  }
{
  if constexpr (three_way_comparable_with<_Tp, _Up>) {
    return __t <=> __u;
  } else {
    if (__t < __u)
      return weak_ordering::less;
    if (__u < __t)
      return weak_ordering::greater;
    return weak_ordering::equivalent;
  }
}
template <class _Tp, class _Up = _Tp>
using __synth_three_way_result = decltype(std::__synth_three_way(std::declval<_Tp&>(), std::declval<_Up&>()));
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Up>
concept __different_from = !same_as<remove_cvref_t<_Tp>, remove_cvref_t<_Up>>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Lhs, class _Rhs>
concept assignable_from =
    is_lvalue_reference_v<_Lhs> &&
    common_reference_with<__make_const_lvalue_ref<_Lhs>, __make_const_lvalue_ref<_Rhs>> &&
    requires(_Lhs __lhs, _Rhs&& __rhs) {
      { __lhs = std::forward<_Rhs>(__rhs) } -> same_as<_Lhs>;
    };
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct remove_all_extents {
  using type __attribute__((__nodebug__)) = __remove_all_extents(_Tp);
};
template <class _Tp>
using __remove_all_extents_t = __remove_all_extents(_Tp);
template <class _Tp>
using remove_all_extents_t = __remove_all_extents_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_destructible : _BoolConstant<__is_destructible(_Tp)> {};
template <class _Tp>
inline constexpr bool is_destructible_v = __is_destructible(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp> struct __libcpp_is_floating_point : public false_type {};
template <> struct __libcpp_is_floating_point<float> : public true_type {};
template <> struct __libcpp_is_floating_point<double> : public true_type {};
template <> struct __libcpp_is_floating_point<long double> : public true_type {};
template <class _Tp>
struct is_floating_point : public __libcpp_is_floating_point<__remove_cv_t<_Tp> > {};
template <class _Tp>
inline constexpr bool is_floating_point_v = is_floating_point<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_arithmetic
    : public integral_constant<bool, is_integral<_Tp>::value || is_floating_point<_Tp>::value> {};
template <class _Tp>
inline constexpr bool is_arithmetic_v = is_arithmetic<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_member_pointer : _BoolConstant<__is_member_pointer(_Tp)> {};
template <class _Tp>
inline constexpr bool is_member_pointer_v = __is_member_pointer(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct __is_nullptr_t_impl : public false_type {};
template <>
struct __is_nullptr_t_impl<nullptr_t> : public true_type {};
template <class _Tp>
struct __is_nullptr_t : public __is_nullptr_t_impl<__remove_cv_t<_Tp> > {};
template <class _Tp>
struct is_null_pointer : public __is_nullptr_t_impl<__remove_cv_t<_Tp> > {};
template <class _Tp>
inline constexpr bool is_null_pointer_v = is_null_pointer<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_pointer : _BoolConstant<__is_pointer(_Tp)> {};
template <class _Tp>
inline constexpr bool is_pointer_v = __is_pointer(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_scalar : _BoolConstant<__is_scalar(_Tp)> {};
template <class _Tp>
inline constexpr bool is_scalar_v = __is_scalar(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <bool, class _Tp>
struct __libcpp_is_nothrow_destructible;
template <class _Tp>
struct __libcpp_is_nothrow_destructible<false, _Tp> : public false_type {};
template <class _Tp>
struct __libcpp_is_nothrow_destructible<true, _Tp>
    : public integral_constant<bool, noexcept(std::declval<_Tp>().~_Tp()) > {};
template <class _Tp>
struct is_nothrow_destructible
    : public __libcpp_is_nothrow_destructible<is_destructible<_Tp>::value, _Tp> {};
template <class _Tp, size_t _Ns>
struct is_nothrow_destructible<_Tp[_Ns]> : public is_nothrow_destructible<_Tp> {};
template <class _Tp>
struct is_nothrow_destructible<_Tp&> : public true_type {};
template <class _Tp>
struct is_nothrow_destructible<_Tp&&> : public true_type {};
template <class _Tp>
inline constexpr bool is_nothrow_destructible_v = is_nothrow_destructible<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
concept destructible = is_nothrow_destructible_v<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class... _Args>
concept constructible_from = destructible<_Tp> && is_constructible_v<_Tp, _Args...>;
template <class _Tp>
concept __default_initializable = requires { ::new _Tp; };
template <class _Tp>
concept default_initializable = constructible_from<_Tp> && requires { _Tp{}; } && __default_initializable<_Tp>;
template <class _Tp>
concept move_constructible = constructible_from<_Tp, _Tp> && convertible_to<_Tp, _Tp>;
template <class _Tp>
concept copy_constructible =
    move_constructible<_Tp> &&
    constructible_from<_Tp, _Tp&> && convertible_to<_Tp&, _Tp> &&
    constructible_from<_Tp, const _Tp&> && convertible_to<const _Tp&, _Tp> &&
    constructible_from<_Tp, const _Tp> && convertible_to<const _Tp, _Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_class : public integral_constant<bool, __is_class(_Tp)> {};
template <class _Tp>
inline constexpr bool is_class_v = __is_class(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_union : public integral_constant<bool, __is_union(_Tp)> {};
template <class _Tp>
inline constexpr bool is_union_v = __is_union(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
concept __class_or_enum = is_class_v<_Tp> || is_union_v<_Tp> || is_enum_v<_Tp>;
template <class _Tp>
concept __workaround_52970 = is_class_v<__remove_cvref_t<_Tp>> || is_union_v<__remove_cvref_t<_Tp>>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, size_t _Dim = 0>
struct extent : integral_constant<size_t, __array_extent(_Tp, _Dim)> {};
template <class _Tp, unsigned _Ip = 0>
inline constexpr size_t extent_v = __array_extent(_Tp, _Ip);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_nothrow_move_assignable
    : public integral_constant<bool,
                               __is_nothrow_assignable(__add_lvalue_reference_t<_Tp>, __add_rvalue_reference_t<_Tp>)> {
};
template <class _Tp>
inline constexpr bool is_nothrow_move_assignable_v = is_nothrow_move_assignable<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class _Arg>
struct is_nothrow_assignable : public integral_constant<bool, __is_nothrow_assignable(_Tp, _Arg)> {
};
template <class _Tp, class _Arg>
inline constexpr bool is_nothrow_assignable_v = __is_nothrow_assignable(_Tp, _Arg);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template<class _T1, class _T2 = _T1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
_T1 exchange(_T1& __obj, _T2&& __new_value)
    noexcept(is_nothrow_move_constructible<_T1>::value && is_nothrow_assignable<_T1&, _T2>::value)
{
    _T1 __old_value = std::move(__obj);
    __obj = std::forward<_T2>(__new_value);
    return __old_value;
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_move_assignable
    : public integral_constant<bool, __is_assignable(__add_lvalue_reference_t<_Tp>, __add_rvalue_reference_t<_Tp>)> {};
template <class _Tp>
inline constexpr bool is_move_assignable_v = is_move_assignable<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct __is_swappable;
template <class _Tp>
struct __is_nothrow_swappable;
template <class _Tp>
using __swap_result_t = typename enable_if<is_move_constructible<_Tp>::value && is_move_assignable<_Tp>::value>::type;
template <class _Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr __swap_result_t<_Tp> swap(_Tp& __x, _Tp& __y)
    noexcept(is_nothrow_move_constructible<_Tp>::value&& is_nothrow_move_assignable<_Tp>::value);
template <class _Tp, size_t _Np>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    typename enable_if<__is_swappable<_Tp>::value>::type swap(_Tp (&__a)[_Np], _Tp (&__b)[_Np])
        noexcept(__is_nothrow_swappable<_Tp>::value);
namespace __detail {
template <class _Tp, class _Up = _Tp, bool _NotVoid = !is_void<_Tp>::value && !is_void<_Up>::value>
struct __swappable_with {
  template <class _LHS, class _RHS>
  static decltype(swap(std::declval<_LHS>(), std::declval<_RHS>())) __test_swap(int);
  template <class, class>
  static __nat __test_swap(long);
  typedef decltype((__test_swap<_Tp, _Up>(0))) __swap1;
  typedef decltype((__test_swap<_Up, _Tp>(0))) __swap2;
  static const bool value = _IsNotSame<__swap1, __nat>::value && _IsNotSame<__swap2, __nat>::value;
};
template <class _Tp, class _Up>
struct __swappable_with<_Tp, _Up, false> : false_type {};
template <class _Tp, class _Up = _Tp, bool _Swappable = __swappable_with<_Tp, _Up>::value>
struct __nothrow_swappable_with {
  static const bool value =
      noexcept(swap(std::declval<_Tp>(), std::declval<_Up>()))&& noexcept(
          swap(std::declval<_Up>(), std::declval<_Tp>()));
};
template <class _Tp, class _Up>
struct __nothrow_swappable_with<_Tp, _Up, false> : false_type {};
}
template <class _Tp>
struct __is_swappable : public integral_constant<bool, __detail::__swappable_with<_Tp&>::value> {};
template <class _Tp>
struct __is_nothrow_swappable : public integral_constant<bool, __detail::__nothrow_swappable_with<_Tp&>::value> {};
template <class _Tp, class _Up>
struct is_swappable_with
    : public integral_constant<bool, __detail::__swappable_with<_Tp, _Up>::value> {};
template <class _Tp>
struct is_swappable
    : public __conditional_t<__libcpp_is_referenceable<_Tp>::value,
                             is_swappable_with<__add_lvalue_reference_t<_Tp>, __add_lvalue_reference_t<_Tp> >,
                             false_type> {};
template <class _Tp, class _Up>
struct is_nothrow_swappable_with
    : public integral_constant<bool, __detail::__nothrow_swappable_with<_Tp, _Up>::value> {};
template <class _Tp>
struct is_nothrow_swappable
    : public __conditional_t<__libcpp_is_referenceable<_Tp>::value,
                             is_nothrow_swappable_with<__add_lvalue_reference_t<_Tp>, __add_lvalue_reference_t<_Tp> >,
                             false_type> {};
template <class _Tp, class _Up>
inline constexpr bool is_swappable_with_v = is_swappable_with<_Tp, _Up>::value;
template <class _Tp>
inline constexpr bool is_swappable_v = is_swappable<_Tp>::value;
template <class _Tp, class _Up>
inline constexpr bool is_nothrow_swappable_with_v = is_nothrow_swappable_with<_Tp, _Up>::value;
template <class _Tp>
inline constexpr bool is_nothrow_swappable_v = is_nothrow_swappable<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
using __swap_result_t = typename enable_if<is_move_constructible<_Tp>::value && is_move_assignable<_Tp>::value>::type;
template <class _Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __swap_result_t<_Tp> constexpr swap(_Tp& __x, _Tp& __y)
    noexcept(is_nothrow_move_constructible<_Tp>::value&& is_nothrow_move_assignable<_Tp>::value) {
  _Tp __t(std::move(__x));
  __x = std::move(__y);
  __y = std::move(__t);
}
template <class _Tp, size_t _Np>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr typename enable_if<__is_swappable<_Tp>::value>::type
swap(_Tp (&__a)[_Np], _Tp (&__b)[_Np]) noexcept(__is_nothrow_swappable<_Tp>::value) {
  for (size_t __i = 0; __i != _Np; ++__i) {
    swap(__a[__i], __b[__i]);
  }
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
namespace ranges {
namespace __swap {
template <class _Tp>
void swap(_Tp&, _Tp&) = delete;
template <class _Tp, class _Up>
concept __unqualified_swappable_with =
    (__class_or_enum<remove_cvref_t<_Tp>> || __class_or_enum<remove_cvref_t<_Up>>) &&
    requires(_Tp&& __t, _Up&& __u) {
        swap(std::forward<_Tp>(__t), std::forward<_Up>(__u));
    };
struct __fn;
template <class _Tp, class _Up, size_t _Size>
concept __swappable_arrays =
    !__unqualified_swappable_with<_Tp (&)[_Size], _Up (&)[_Size]> &&
    extent_v<_Tp> == extent_v<_Up> &&
    requires(_Tp (&__t)[_Size], _Up (&__u)[_Size], const __fn& __swap) {
        __swap(__t[0], __u[0]);
    };
template <class _Tp>
concept __exchangeable =
    !__unqualified_swappable_with<_Tp&, _Tp&> && move_constructible<_Tp> && assignable_from<_Tp&, _Tp>;
struct __fn {
  template <class _Tp, class _Up>
    requires __unqualified_swappable_with<_Tp, _Up>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr void operator()(_Tp&& __t, _Up&& __u) const
      noexcept(noexcept(swap(std::forward<_Tp>(__t), std::forward<_Up>(__u)))) {
    swap(std::forward<_Tp>(__t), std::forward<_Up>(__u));
  }
  template <class _Tp, class _Up, size_t _Size>
    requires __swappable_arrays<_Tp, _Up, _Size>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr void operator()(_Tp (&__t)[_Size], _Up (&__u)[_Size]) const
      noexcept(noexcept((*this)(*__t, *__u))) {
    for (size_t __i = 0; __i < _Size; ++__i) {
      (*this)(__t[__i], __u[__i]);
    }
  }
  template <__exchangeable _Tp>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr void operator()(_Tp& __x, _Tp& __y) const
      noexcept(is_nothrow_move_constructible_v<_Tp>&& is_nothrow_move_assignable_v<_Tp>) {
    __y = std::exchange(__x, std::move(__y));
  }
};
}
inline namespace __cpo {
inline constexpr auto swap = __swap::__fn{};
}
}
template <class _Tp>
concept swappable = requires(_Tp& __a, _Tp& __b) { ranges::swap(__a, __b); };
template <class _Tp, class _Up>
concept swappable_with = common_reference_with<_Tp, _Up> && requires(_Tp&& __t, _Up&& __u) {
  ranges::swap(std::forward<_Tp>(__t), std::forward<_Tp>(__t));
  ranges::swap(std::forward<_Up>(__u), std::forward<_Up>(__u));
  ranges::swap(std::forward<_Tp>(__t), std::forward<_Up>(__u));
  ranges::swap(std::forward<_Up>(__u), std::forward<_Tp>(__t));
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_object : _BoolConstant<__is_object(_Tp)> {};
template <class _Tp>
inline constexpr bool is_object_v = __is_object(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
concept movable = is_object_v<_Tp> && move_constructible<_Tp> && assignable_from<_Tp&, _Tp> && swappable<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
concept copyable =
    copy_constructible<_Tp> &&
    movable<_Tp> &&
    assignable_from<_Tp&, _Tp&> &&
    assignable_from<_Tp&, const _Tp&> &&
    assignable_from<_Tp&, const _Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_signed : _BoolConstant<__is_signed(_Tp)> {};
template <class _Tp>
inline constexpr bool is_signed_v = __is_signed(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp> struct __libcpp_is_signed_integer : public false_type {};
template <> struct __libcpp_is_signed_integer<signed char> : public true_type {};
template <> struct __libcpp_is_signed_integer<signed short> : public true_type {};
template <> struct __libcpp_is_signed_integer<signed int> : public true_type {};
template <> struct __libcpp_is_signed_integer<signed long> : public true_type {};
template <> struct __libcpp_is_signed_integer<signed long long> : public true_type {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp> struct __libcpp_is_unsigned_integer : public false_type {};
template <> struct __libcpp_is_unsigned_integer<unsigned char> : public true_type {};
template <> struct __libcpp_is_unsigned_integer<unsigned short> : public true_type {};
template <> struct __libcpp_is_unsigned_integer<unsigned int> : public true_type {};
template <> struct __libcpp_is_unsigned_integer<unsigned long> : public true_type {};
template <> struct __libcpp_is_unsigned_integer<unsigned long long> : public true_type {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
concept integral = is_integral_v<_Tp>;
template <class _Tp>
concept signed_integral = integral<_Tp> && is_signed_v<_Tp>;
template <class _Tp>
concept unsigned_integral = integral<_Tp> && !signed_integral<_Tp>;
template <class _Tp>
concept floating_point = is_floating_point_v<_Tp>;
template <class _Tp>
concept __libcpp_unsigned_integer = __libcpp_is_unsigned_integer<_Tp>::value;
template <class _Tp>
concept __libcpp_signed_integer = __libcpp_is_signed_integer<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Dp, class _Bp>
concept derived_from = is_base_of_v<_Bp, _Dp> && is_convertible_v<const volatile _Dp*, const volatile _Bp*>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Fn, class... _Args>
concept invocable = requires(_Fn&& __fn, _Args&&... __args) {
  std::invoke(std::forward<_Fn>(__fn), std::forward<_Args>(__args)...);
};
template <class _Fn, class... _Args>
concept regular_invocable = invocable<_Fn, _Args...>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Fn, class... _Args>
concept predicate = regular_invocable<_Fn, _Args...> && __boolean_testable<invoke_result_t<_Fn, _Args...>>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
concept semiregular = copyable<_Tp> && default_initializable<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
concept regular = semiregular<_Tp> && equality_comparable<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Rp, class _Tp, class _Up>
concept relation =
    predicate<_Rp, _Tp, _Tp> && predicate<_Rp, _Up, _Up> && predicate<_Rp, _Tp, _Up> && predicate<_Rp, _Up, _Tp>;
template <class _Rp, class _Tp, class _Up>
concept equivalence_relation = relation<_Rp, _Tp, _Up>;
template <class _Rp, class _Tp, class _Up>
concept strict_weak_order = relation<_Rp, _Tp, _Up>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <template <class...> class _Templ, class... _Args, class = _Templ<_Args...> >
true_type __sfinae_test_impl(int);
template <template <class...> class, class...>
false_type __sfinae_test_impl(...);
template <template <class...> class _Templ, class... _Args>
using _IsValidExpansion __attribute__((__nodebug__)) = decltype(std::__sfinae_test_impl<_Templ, _Args...>(0));
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
using __test_for_primary_template = __enable_if_t<_IsSame<_Tp, typename _Tp::__primary_template>::value>;
template <class _Tp>
using __is_primary_template = _IsValidExpansion<__test_for_primary_template, _Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Hp, class _Tp>
struct __type_list {
  typedef _Hp _Head;
  typedef _Tp _Tail;
};
template <class _TypeList, size_t _Size, bool = _Size <= sizeof(typename _TypeList::_Head)>
struct __find_first;
template <class _Hp, class _Tp, size_t _Size>
struct __find_first<__type_list<_Hp, _Tp>, _Size, true> {
  typedef __attribute__((__nodebug__)) _Hp type;
};
template <class _Hp, class _Tp, size_t _Size>
struct __find_first<__type_list<_Hp, _Tp>, _Size, false> {
  typedef __attribute__((__nodebug__)) typename __find_first<_Tp, _Size>::type type;
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
using __make_signed_t = __make_signed(_Tp);
template <class _Tp>
struct make_signed {
  using type __attribute__((__nodebug__)) = __make_signed_t<_Tp>;
};
template <class _Tp>
using make_signed_t = __make_signed_t<_Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template<class> struct incrementable_traits {};
template<class _Tp>
requires is_object_v<_Tp>
struct incrementable_traits<_Tp*> {
  using difference_type = ptrdiff_t;
};
template<class _Ip>
struct incrementable_traits<const _Ip> : incrementable_traits<_Ip> {};
template<class _Tp>
concept __has_member_difference_type = requires { typename _Tp::difference_type; };
template<__has_member_difference_type _Tp>
struct incrementable_traits<_Tp> {
  using difference_type = typename _Tp::difference_type;
};
template<class _Tp>
concept __has_integral_minus =
  requires(const _Tp& __x, const _Tp& __y) {
    { __x - __y } -> integral;
  };
template<__has_integral_minus _Tp>
requires (!__has_member_difference_type<_Tp>)
struct incrementable_traits<_Tp> {
  using difference_type = make_signed_t<decltype(std::declval<_Tp>() - std::declval<_Tp>())>;
};
template <class>
struct iterator_traits;
template <class _Ip>
using iter_difference_t = typename conditional_t<__is_primary_template<iterator_traits<remove_cvref_t<_Ip> > >::value,
                                                 incrementable_traits<remove_cvref_t<_Ip> >,
                                                 iterator_traits<remove_cvref_t<_Ip> > >::difference_type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template<class> struct __cond_value_type {};
template<class _Tp>
requires is_object_v<_Tp>
struct __cond_value_type<_Tp> { using value_type = remove_cv_t<_Tp>; };
template<class _Tp>
concept __has_member_value_type = requires { typename _Tp::value_type; };
template<class _Tp>
concept __has_member_element_type = requires { typename _Tp::element_type; };
template<class> struct indirectly_readable_traits {};
template<class _Ip>
requires is_array_v<_Ip>
struct indirectly_readable_traits<_Ip> {
  using value_type = remove_cv_t<remove_extent_t<_Ip>>;
};
template<class _Ip>
struct indirectly_readable_traits<const _Ip> : indirectly_readable_traits<_Ip> {};
template<class _Tp>
struct indirectly_readable_traits<_Tp*> : __cond_value_type<_Tp> {};
template<__has_member_value_type _Tp>
struct indirectly_readable_traits<_Tp>
  : __cond_value_type<typename _Tp::value_type> {};
template<__has_member_element_type _Tp>
struct indirectly_readable_traits<_Tp>
  : __cond_value_type<typename _Tp::element_type> {};
template<__has_member_value_type _Tp>
  requires __has_member_element_type<_Tp>
struct indirectly_readable_traits<_Tp> {};
template<__has_member_value_type _Tp>
  requires __has_member_element_type<_Tp> &&
           same_as<remove_cv_t<typename _Tp::element_type>,
                   remove_cv_t<typename _Tp::value_type>>
struct indirectly_readable_traits<_Tp>
  : __cond_value_type<typename _Tp::value_type> {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <bool>
struct _OrImpl;
template <>
struct _OrImpl<true> {
  template <class _Res, class _First, class... _Rest>
  using _Result __attribute__((__nodebug__)) =
      typename _OrImpl<!bool(_First::value) && sizeof...(_Rest) != 0>::template _Result<_First, _Rest...>;
};
template <>
struct _OrImpl<false> {
  template <class _Res, class...>
  using _Result = _Res;
};
template <class... _Args>
using _Or __attribute__((__nodebug__)) = typename _OrImpl<sizeof...(_Args) != 0>::template _Result<false_type, _Args...>;
template <class... _Args>
struct disjunction : _Or<_Args...> {};
template <class... _Args>
inline constexpr bool disjunction_v = _Or<_Args...>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
using __with_reference = _Tp&;
template <class _Tp>
concept __can_reference = requires {
  typename __with_reference<_Tp>;
};
template <class _Tp>
concept __dereferenceable = requires(_Tp& __t) {
  { *__t } -> __can_reference;
};
template<__dereferenceable _Tp>
using iter_reference_t = decltype(*std::declval<_Tp&>());
template <class _Iter>
struct iterator_traits;
struct input_iterator_tag {};
struct output_iterator_tag {};
struct forward_iterator_tag : public input_iterator_tag {};
struct bidirectional_iterator_tag : public forward_iterator_tag {};
struct random_access_iterator_tag : public bidirectional_iterator_tag {};
struct contiguous_iterator_tag : public random_access_iterator_tag {};
template <class _Iter>
struct __iter_traits_cache {
  using type = _If<
    __is_primary_template<iterator_traits<_Iter> >::value,
    _Iter,
    iterator_traits<_Iter>
  >;
};
template <class _Iter>
using _ITER_TRAITS = typename __iter_traits_cache<_Iter>::type;
struct __iter_concept_concept_test {
  template <class _Iter>
  using _Apply = typename _ITER_TRAITS<_Iter>::iterator_concept;
};
struct __iter_concept_category_test {
  template <class _Iter>
  using _Apply = typename _ITER_TRAITS<_Iter>::iterator_category;
};
struct __iter_concept_random_fallback {
  template <class _Iter>
  using _Apply = __enable_if_t<
                          __is_primary_template<iterator_traits<_Iter> >::value,
                          random_access_iterator_tag
                        >;
};
template <class _Iter, class _Tester> struct __test_iter_concept
    : _IsValidExpansion<_Tester::template _Apply, _Iter>,
      _Tester
{
};
template <class _Iter>
struct __iter_concept_cache {
  using type = _Or<
    __test_iter_concept<_Iter, __iter_concept_concept_test>,
    __test_iter_concept<_Iter, __iter_concept_category_test>,
    __test_iter_concept<_Iter, __iter_concept_random_fallback>
  >;
};
template <class _Iter>
using _ITER_CONCEPT = typename __iter_concept_cache<_Iter>::type::template _Apply<_Iter>;
template <class _Tp>
struct __has_iterator_typedefs
{
private:
    template <class _Up> static false_type __test(...);
    template <class _Up> static true_type __test(__void_t<typename _Up::iterator_category>* = nullptr,
                                                 __void_t<typename _Up::difference_type>* = nullptr,
                                                 __void_t<typename _Up::value_type>* = nullptr,
                                                 __void_t<typename _Up::reference>* = nullptr,
                                                 __void_t<typename _Up::pointer>* = nullptr);
public:
    static const bool value = decltype(__test<_Tp>(0,0,0,0,0))::value;
};
template <class _Tp>
struct __has_iterator_category
{
private:
    template <class _Up> static false_type __test(...);
    template <class _Up> static true_type __test(typename _Up::iterator_category* = nullptr);
public:
    static const bool value = decltype(__test<_Tp>(nullptr))::value;
};
template <class _Tp>
struct __has_iterator_concept
{
private:
    template <class _Up> static false_type __test(...);
    template <class _Up> static true_type __test(typename _Up::iterator_concept* = nullptr);
public:
    static const bool value = decltype(__test<_Tp>(nullptr))::value;
};
namespace __iterator_traits_detail {
template<class _Ip>
concept __cpp17_iterator =
  requires(_Ip __i) {
    { *__i } -> __can_reference;
    { ++__i } -> same_as<_Ip&>;
    { *__i++ } -> __can_reference;
  } &&
  copyable<_Ip>;
template<class _Ip>
concept __cpp17_input_iterator =
  __cpp17_iterator<_Ip> &&
  equality_comparable<_Ip> &&
  requires(_Ip __i) {
    typename incrementable_traits<_Ip>::difference_type;
    typename indirectly_readable_traits<_Ip>::value_type;
    typename common_reference_t<iter_reference_t<_Ip>&&,
                                typename indirectly_readable_traits<_Ip>::value_type&>;
    typename common_reference_t<decltype(*__i++)&&,
                                typename indirectly_readable_traits<_Ip>::value_type&>;
    requires signed_integral<typename incrementable_traits<_Ip>::difference_type>;
  };
template<class _Ip>
concept __cpp17_forward_iterator =
  __cpp17_input_iterator<_Ip> &&
  constructible_from<_Ip> &&
  is_reference_v<iter_reference_t<_Ip>> &&
  same_as<remove_cvref_t<iter_reference_t<_Ip>>,
          typename indirectly_readable_traits<_Ip>::value_type> &&
  requires(_Ip __i) {
    { __i++ } -> convertible_to<_Ip const&>;
    { *__i++ } -> same_as<iter_reference_t<_Ip>>;
  };
template<class _Ip>
concept __cpp17_bidirectional_iterator =
  __cpp17_forward_iterator<_Ip> &&
  requires(_Ip __i) {
    { --__i } -> same_as<_Ip&>;
    { __i-- } -> convertible_to<_Ip const&>;
    { *__i-- } -> same_as<iter_reference_t<_Ip>>;
  };
template<class _Ip>
concept __cpp17_random_access_iterator =
  __cpp17_bidirectional_iterator<_Ip> &&
  totally_ordered<_Ip> &&
  requires(_Ip __i, typename incrementable_traits<_Ip>::difference_type __n) {
    { __i += __n } -> same_as<_Ip&>;
    { __i -= __n } -> same_as<_Ip&>;
    { __i + __n } -> same_as<_Ip>;
    { __n + __i } -> same_as<_Ip>;
    { __i - __n } -> same_as<_Ip>;
    { __i - __i } -> same_as<decltype(__n)>;
    { __i[__n] } -> convertible_to<iter_reference_t<_Ip>>;
  };
}
template<class _Ip>
concept __has_member_reference = requires { typename _Ip::reference; };
template<class _Ip>
concept __has_member_pointer = requires { typename _Ip::pointer; };
template<class _Ip>
concept __has_member_iterator_category = requires { typename _Ip::iterator_category; };
template<class _Ip>
concept __specifies_members = requires {
    typename _Ip::value_type;
    typename _Ip::difference_type;
    requires __has_member_reference<_Ip>;
    requires __has_member_iterator_category<_Ip>;
  };
template<class>
struct __iterator_traits_member_pointer_or_void {
  using type = void;
};
template<__has_member_pointer _Tp>
struct __iterator_traits_member_pointer_or_void<_Tp> {
  using type = typename _Tp::pointer;
};
template<class _Tp>
concept __cpp17_iterator_missing_members =
  !__specifies_members<_Tp> &&
  __iterator_traits_detail::__cpp17_iterator<_Tp>;
template<class _Tp>
concept __cpp17_input_iterator_missing_members =
  __cpp17_iterator_missing_members<_Tp> &&
  __iterator_traits_detail::__cpp17_input_iterator<_Tp>;
template<class>
struct __iterator_traits_member_pointer_or_arrow_or_void { using type = void; };
template<__has_member_pointer _Ip>
struct __iterator_traits_member_pointer_or_arrow_or_void<_Ip> { using type = typename _Ip::pointer; };
template<class _Ip>
  requires requires(_Ip& __i) { __i.operator->(); } && (!__has_member_pointer<_Ip>)
struct __iterator_traits_member_pointer_or_arrow_or_void<_Ip> {
  using type = decltype(std::declval<_Ip&>().operator->());
};
template<class _Ip>
struct __iterator_traits_member_reference { using type = iter_reference_t<_Ip>; };
template<__has_member_reference _Ip>
struct __iterator_traits_member_reference<_Ip> { using type = typename _Ip::reference; };
template<class _Ip>
struct __deduce_iterator_category {
  using type = input_iterator_tag;
};
template<__iterator_traits_detail::__cpp17_random_access_iterator _Ip>
struct __deduce_iterator_category<_Ip> {
  using type = random_access_iterator_tag;
};
template<__iterator_traits_detail::__cpp17_bidirectional_iterator _Ip>
struct __deduce_iterator_category<_Ip> {
  using type = bidirectional_iterator_tag;
};
template<__iterator_traits_detail::__cpp17_forward_iterator _Ip>
struct __deduce_iterator_category<_Ip> {
  using type = forward_iterator_tag;
};
template<class _Ip>
struct __iterator_traits_iterator_category : __deduce_iterator_category<_Ip> {};
template<__has_member_iterator_category _Ip>
struct __iterator_traits_iterator_category<_Ip> {
  using type = typename _Ip::iterator_category;
};
template<class>
struct __iterator_traits_difference_type { using type = void; };
template<class _Ip>
requires requires { typename incrementable_traits<_Ip>::difference_type; }
struct __iterator_traits_difference_type<_Ip> {
  using type = typename incrementable_traits<_Ip>::difference_type;
};
template<class>
struct __iterator_traits {};
template<__specifies_members _Ip>
struct __iterator_traits<_Ip> {
  using iterator_category = typename _Ip::iterator_category;
  using value_type = typename _Ip::value_type;
  using difference_type = typename _Ip::difference_type;
  using pointer = typename __iterator_traits_member_pointer_or_void<_Ip>::type;
  using reference = typename _Ip::reference;
};
template<__cpp17_input_iterator_missing_members _Ip>
struct __iterator_traits<_Ip> {
  using iterator_category = typename __iterator_traits_iterator_category<_Ip>::type;
  using value_type = typename indirectly_readable_traits<_Ip>::value_type;
  using difference_type = typename incrementable_traits<_Ip>::difference_type;
  using pointer = typename __iterator_traits_member_pointer_or_arrow_or_void<_Ip>::type;
  using reference = typename __iterator_traits_member_reference<_Ip>::type;
};
template<__cpp17_iterator_missing_members _Ip>
struct __iterator_traits<_Ip> {
  using iterator_category = output_iterator_tag;
  using value_type = void;
  using difference_type = typename __iterator_traits_difference_type<_Ip>::type;
  using pointer = void;
  using reference = void;
};
template<class _Ip>
struct iterator_traits : __iterator_traits<_Ip> {
  using __primary_template = iterator_traits;
};
template<class _Tp>
requires is_object_v<_Tp>
struct iterator_traits<_Tp*>
{
    typedef ptrdiff_t difference_type;
    typedef __remove_cv_t<_Tp> value_type;
    typedef _Tp* pointer;
    typedef _Tp& reference;
    typedef random_access_iterator_tag iterator_category;
    typedef contiguous_iterator_tag iterator_concept;
};
template <class _Tp, class _Up, bool = __has_iterator_category<iterator_traits<_Tp> >::value>
struct __has_iterator_category_convertible_to
    : is_convertible<typename iterator_traits<_Tp>::iterator_category, _Up>
{};
template <class _Tp, class _Up>
struct __has_iterator_category_convertible_to<_Tp, _Up, false> : false_type {};
template <class _Tp, class _Up, bool = __has_iterator_concept<_Tp>::value>
struct __has_iterator_concept_convertible_to
    : is_convertible<typename _Tp::iterator_concept, _Up>
{};
template <class _Tp, class _Up>
struct __has_iterator_concept_convertible_to<_Tp, _Up, false> : false_type {};
template <class _Tp>
using __has_input_iterator_category = __has_iterator_category_convertible_to<_Tp, input_iterator_tag>;
template <class _Tp>
using __has_forward_iterator_category = __has_iterator_category_convertible_to<_Tp, forward_iterator_tag>;
template <class _Tp>
using __has_bidirectional_iterator_category = __has_iterator_category_convertible_to<_Tp, bidirectional_iterator_tag>;
template <class _Tp>
using __has_random_access_iterator_category = __has_iterator_category_convertible_to<_Tp, random_access_iterator_tag>;
template <class _Tp>
struct __libcpp_is_contiguous_iterator : _Or<
    __has_iterator_category_convertible_to<_Tp, contiguous_iterator_tag>,
    __has_iterator_concept_convertible_to<_Tp, contiguous_iterator_tag>
> {};
template <class _Up>
struct __libcpp_is_contiguous_iterator<_Up*> : true_type {};
template <class _Iter>
class __wrap_iter;
template <class _Tp>
using __has_exactly_input_iterator_category
    = integral_constant<bool,
         __has_iterator_category_convertible_to<_Tp, input_iterator_tag>::value &&
        !__has_iterator_category_convertible_to<_Tp, forward_iterator_tag>::value>;
template <class _Tp>
using __has_exactly_forward_iterator_category
    = integral_constant<bool,
         __has_iterator_category_convertible_to<_Tp, forward_iterator_tag>::value &&
        !__has_iterator_category_convertible_to<_Tp, bidirectional_iterator_tag>::value>;
template <class _Tp>
using __has_exactly_bidirectional_iterator_category
    = integral_constant<bool,
         __has_iterator_category_convertible_to<_Tp, bidirectional_iterator_tag>::value &&
        !__has_iterator_category_convertible_to<_Tp, random_access_iterator_tag>::value>;
template<class _InputIterator>
using __iter_value_type = typename iterator_traits<_InputIterator>::value_type;
template<class _InputIterator>
using __iter_key_type = __remove_const_t<typename iterator_traits<_InputIterator>::value_type::first_type>;
template<class _InputIterator>
using __iter_mapped_type = typename iterator_traits<_InputIterator>::value_type::second_type;
template<class _InputIterator>
using __iter_to_alloc_type = pair<
    typename add_const<typename iterator_traits<_InputIterator>::value_type::first_type>::type,
    typename iterator_traits<_InputIterator>::value_type::second_type>;
template <class _Iter>
using __iterator_category_type = typename iterator_traits<_Iter>::iterator_category;
template <class _Iter>
using __iterator_pointer_type = typename iterator_traits<_Iter>::pointer;
template <class _Iter>
using __iter_diff_t = typename iterator_traits<_Iter>::difference_type;
template <class _Iter>
using __iter_reference = typename iterator_traits<_Iter>::reference;
template <class _Ip>
using iter_value_t = typename conditional_t<__is_primary_template<iterator_traits<remove_cvref_t<_Ip> > >::value,
                                            indirectly_readable_traits<remove_cvref_t<_Ip> >,
                                            iterator_traits<remove_cvref_t<_Ip> > >::value_type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
namespace ranges {
namespace __iter_move {
void iter_move();
template <class _Tp>
concept __unqualified_iter_move =
  __class_or_enum<remove_cvref_t<_Tp>> &&
  requires (_Tp&& __t) {
    iter_move(std::forward<_Tp>(__t));
  };
template<class _Tp>
concept __move_deref =
  !__unqualified_iter_move<_Tp> &&
  requires (_Tp&& __t) {
    *__t;
    requires is_lvalue_reference_v<decltype(*__t)>;
  };
template<class _Tp>
concept __just_deref =
  !__unqualified_iter_move<_Tp> &&
  !__move_deref<_Tp> &&
  requires (_Tp&& __t) {
    *__t;
    requires (!is_lvalue_reference_v<decltype(*__t)>);
  };
struct __fn {
  template<class _Ip>
    requires __unqualified_iter_move<_Ip>
  [[nodiscard]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr decltype(auto) operator()(_Ip&& __i) const
    noexcept(noexcept(iter_move(std::forward<_Ip>(__i))))
  {
    return iter_move(std::forward<_Ip>(__i));
  }
  template<class _Ip>
    requires __move_deref<_Ip>
  [[nodiscard]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto operator()(_Ip&& __i) const
    noexcept(noexcept(std::move(*std::forward<_Ip>(__i))))
    -> decltype( std::move(*std::forward<_Ip>(__i)))
    { return std::move(*std::forward<_Ip>(__i)); }
  template<class _Ip>
    requires __just_deref<_Ip>
  [[nodiscard]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto operator()(_Ip&& __i) const
    noexcept(noexcept(*std::forward<_Ip>(__i)))
    -> decltype( *std::forward<_Ip>(__i))
    { return *std::forward<_Ip>(__i); }
};
}
inline namespace __cpo {
  inline constexpr auto iter_move = __iter_move::__fn{};
}
}
template<__dereferenceable _Tp>
  requires requires(_Tp& __t) { { ranges::iter_move(__t) } -> __can_reference; }
using iter_rvalue_reference_t = decltype(ranges::iter_move(std::declval<_Tp&>()));
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
inline constexpr
__attribute__((__no_sanitize__("cfi"))) __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
_Tp*
addressof(_Tp& __x) noexcept
{
    return __builtin_addressof(__x);
}
template <class _Tp> _Tp* addressof(const _Tp&&) noexcept = delete;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class...>
using __expand_to_true = true_type;
template <class... _Pred>
__expand_to_true<__enable_if_t<_Pred::value>...> __and_helper(int);
template <class...>
false_type __and_helper(...);
template <class... _Pred>
using _And __attribute__((__nodebug__)) = decltype(std::__and_helper<_Pred...>(0));
template <class...>
struct conjunction : true_type {};
template <class _Arg>
struct conjunction<_Arg> : _Arg {};
template <class _Arg, class... _Args>
struct conjunction<_Arg, _Args...> : conditional_t<!bool(_Arg::value), _Arg, conjunction<_Args...>> {};
template <class... _Args>
inline constexpr bool conjunction_v = conjunction<_Args...>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, class = void>
struct __has_element_type : false_type {};
template <class _Tp>
struct __has_element_type<_Tp, __void_t<typename _Tp::element_type> > : true_type {};
template <class _Ptr, bool = __has_element_type<_Ptr>::value>
struct __pointer_traits_element_type;
template <class _Ptr>
struct __pointer_traits_element_type<_Ptr, true>
{
    typedef __attribute__((__nodebug__)) typename _Ptr::element_type type;
};
template <template <class, class...> class _Sp, class _Tp, class ..._Args>
struct __pointer_traits_element_type<_Sp<_Tp, _Args...>, true>
{
    typedef __attribute__((__nodebug__)) typename _Sp<_Tp, _Args...>::element_type type;
};
template <template <class, class...> class _Sp, class _Tp, class ..._Args>
struct __pointer_traits_element_type<_Sp<_Tp, _Args...>, false>
{
    typedef __attribute__((__nodebug__)) _Tp type;
};
template <class _Tp, class = void>
struct __has_difference_type : false_type {};
template <class _Tp>
struct __has_difference_type<_Tp, __void_t<typename _Tp::difference_type> > : true_type {};
template <class _Ptr, bool = __has_difference_type<_Ptr>::value>
struct __pointer_traits_difference_type
{
    typedef __attribute__((__nodebug__)) ptrdiff_t type;
};
template <class _Ptr>
struct __pointer_traits_difference_type<_Ptr, true>
{
    typedef __attribute__((__nodebug__)) typename _Ptr::difference_type type;
};
template <class _Tp, class _Up>
struct __has_rebind
{
private:
    template <class _Xp> static false_type __test(...);
    template <class _Xp> static true_type __test(typename _Xp::template rebind<_Up>* = 0);
public:
    static const bool value = decltype(__test<_Tp>(0))::value;
};
template <class _Tp, class _Up, bool = __has_rebind<_Tp, _Up>::value>
struct __pointer_traits_rebind
{
    typedef __attribute__((__nodebug__)) typename _Tp::template rebind<_Up> type;
};
template <template <class, class...> class _Sp, class _Tp, class ..._Args, class _Up>
struct __pointer_traits_rebind<_Sp<_Tp, _Args...>, _Up, true>
{
    typedef __attribute__((__nodebug__)) typename _Sp<_Tp, _Args...>::template rebind<_Up> type;
};
template <template <class, class...> class _Sp, class _Tp, class ..._Args, class _Up>
struct __pointer_traits_rebind<_Sp<_Tp, _Args...>, _Up, false>
{
    typedef _Sp<_Up, _Args...> type;
};
template <class _Ptr>
struct pointer_traits
{
    typedef _Ptr pointer;
    typedef typename __pointer_traits_element_type<pointer>::type element_type;
    typedef typename __pointer_traits_difference_type<pointer>::type difference_type;
    template <class _Up> using rebind = typename __pointer_traits_rebind<pointer, _Up>::type;
private:
    struct __nat {};
public:
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    static pointer pointer_to(__conditional_t<is_void<element_type>::value, __nat, element_type>& __r)
        {return pointer::pointer_to(__r);}
};
template <class _Tp>
struct pointer_traits<_Tp*>
{
    typedef _Tp* pointer;
    typedef _Tp element_type;
    typedef ptrdiff_t difference_type;
    template <class _Up> using rebind = _Up*;
private:
    struct __nat {};
public:
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    static pointer pointer_to(__conditional_t<is_void<element_type>::value, __nat, element_type>& __r) noexcept
        {return std::addressof(__r);}
};
template <class _From, class _To>
using __rebind_pointer_t = typename pointer_traits<_From>::template rebind<_To>;
template <class _Pointer, class = void>
struct __to_address_helper;
template <class _Tp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
_Tp* __to_address(_Tp* __p) noexcept {
    static_assert(!is_function<_Tp>::value, "_Tp is a function type");
    return __p;
}
template <class _Pointer, class = void>
struct _HasToAddress : false_type {};
template <class _Pointer>
struct _HasToAddress<_Pointer,
    decltype((void)pointer_traits<_Pointer>::to_address(std::declval<const _Pointer&>()))
> : true_type {};
template <class _Pointer, class = void>
struct _HasArrow : false_type {};
template <class _Pointer>
struct _HasArrow<_Pointer,
    decltype((void)std::declval<const _Pointer&>().operator->())
> : true_type {};
template <class _Pointer>
struct _IsFancyPointer {
  static const bool value = _HasArrow<_Pointer>::value || _HasToAddress<_Pointer>::value;
};
template <class _Pointer, class = __enable_if_t<
    _And<is_class<_Pointer>, _IsFancyPointer<_Pointer> >::value
> >
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
__decay_t<decltype(__to_address_helper<_Pointer>::__call(std::declval<const _Pointer&>()))>
__to_address(const _Pointer& __p) noexcept {
    return __to_address_helper<_Pointer>::__call(__p);
}
template <class _Pointer, class>
struct __to_address_helper {
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    static decltype(std::__to_address(std::declval<const _Pointer&>().operator->()))
    __call(const _Pointer& __p) noexcept {
        return std::__to_address(__p.operator->());
    }
};
template <class _Pointer>
struct __to_address_helper<_Pointer, decltype((void)pointer_traits<_Pointer>::to_address(std::declval<const _Pointer&>()))> {
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    static decltype(pointer_traits<_Pointer>::to_address(std::declval<const _Pointer&>()))
    __call(const _Pointer& __p) noexcept {
        return pointer_traits<_Pointer>::to_address(__p);
    }
};
template <class _Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
auto to_address(_Tp *__p) noexcept {
    return std::__to_address(__p);
}
template <class _Pointer>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
auto to_address(const _Pointer& __p) noexcept -> decltype(std::__to_address(__p)) {
    return std::__to_address(__p);
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template<class _In>
concept __indirectly_readable_impl =
  requires(const _In __i) {
    typename iter_value_t<_In>;
    typename iter_reference_t<_In>;
    typename iter_rvalue_reference_t<_In>;
    { *__i } -> same_as<iter_reference_t<_In>>;
    { ranges::iter_move(__i) } -> same_as<iter_rvalue_reference_t<_In>>;
  } &&
  common_reference_with<iter_reference_t<_In>&&, iter_value_t<_In>&> &&
  common_reference_with<iter_reference_t<_In>&&, iter_rvalue_reference_t<_In>&&> &&
  common_reference_with<iter_rvalue_reference_t<_In>&&, const iter_value_t<_In>&>;
template<class _In>
concept indirectly_readable = __indirectly_readable_impl<remove_cvref_t<_In>>;
template<indirectly_readable _Tp>
using iter_common_reference_t = common_reference_t<iter_reference_t<_Tp>, iter_value_t<_Tp>&>;
template<class _Out, class _Tp>
concept indirectly_writable =
  requires(_Out&& __o, _Tp&& __t) {
    *__o = std::forward<_Tp>(__t);
    *std::forward<_Out>(__o) = std::forward<_Tp>(__t);
    const_cast<const iter_reference_t<_Out>&&>(*__o) = std::forward<_Tp>(__t);
    const_cast<const iter_reference_t<_Out>&&>(*std::forward<_Out>(__o)) = std::forward<_Tp>(__t);
  };
template<class _Tp>
concept __integer_like = integral<_Tp> && !same_as<_Tp, bool>;
template<class _Tp>
concept __signed_integer_like = signed_integral<_Tp>;
template<class _Ip>
concept weakly_incrementable =
  !same_as<_Ip, bool> &&
  movable<_Ip> &&
  requires(_Ip __i) {
    typename iter_difference_t<_Ip>;
    requires __signed_integer_like<iter_difference_t<_Ip>>;
    { ++__i } -> same_as<_Ip&>;
    __i++;
  };
template<class _Ip>
concept incrementable =
  regular<_Ip> &&
  weakly_incrementable<_Ip> &&
  requires(_Ip __i) {
    { __i++ } -> same_as<_Ip>;
  };
template<class _Ip>
concept input_or_output_iterator =
  requires(_Ip __i) {
    { *__i } -> __can_reference;
  } &&
  weakly_incrementable<_Ip>;
template<class _Sp, class _Ip>
concept sentinel_for =
  semiregular<_Sp> &&
  input_or_output_iterator<_Ip> &&
  __weakly_equality_comparable_with<_Sp, _Ip>;
template<class, class>
inline constexpr bool disable_sized_sentinel_for = false;
template<class _Sp, class _Ip>
concept sized_sentinel_for =
  sentinel_for<_Sp, _Ip> &&
  !disable_sized_sentinel_for<remove_cv_t<_Sp>, remove_cv_t<_Ip>> &&
  requires(const _Ip& __i, const _Sp& __s) {
    { __s - __i } -> same_as<iter_difference_t<_Ip>>;
    { __i - __s } -> same_as<iter_difference_t<_Ip>>;
  };
template<class _Ip>
concept input_iterator =
  input_or_output_iterator<_Ip> &&
  indirectly_readable<_Ip> &&
  requires { typename _ITER_CONCEPT<_Ip>; } &&
  derived_from<_ITER_CONCEPT<_Ip>, input_iterator_tag>;
template<class _Ip, class _Tp>
concept output_iterator =
  input_or_output_iterator<_Ip> &&
  indirectly_writable<_Ip, _Tp> &&
  requires (_Ip __it, _Tp&& __t) {
    *__it++ = std::forward<_Tp>(__t);
  };
template<class _Ip>
concept forward_iterator =
  input_iterator<_Ip> &&
  derived_from<_ITER_CONCEPT<_Ip>, forward_iterator_tag> &&
  incrementable<_Ip> &&
  sentinel_for<_Ip, _Ip>;
template<class _Ip>
concept bidirectional_iterator =
  forward_iterator<_Ip> &&
  derived_from<_ITER_CONCEPT<_Ip>, bidirectional_iterator_tag> &&
  requires(_Ip __i) {
    { --__i } -> same_as<_Ip&>;
    { __i-- } -> same_as<_Ip>;
  };
template<class _Ip>
concept random_access_iterator =
  bidirectional_iterator<_Ip> &&
  derived_from<_ITER_CONCEPT<_Ip>, random_access_iterator_tag> &&
  totally_ordered<_Ip> &&
  sized_sentinel_for<_Ip, _Ip> &&
  requires(_Ip __i, const _Ip __j, const iter_difference_t<_Ip> __n) {
    { __i += __n } -> same_as<_Ip&>;
    { __j + __n } -> same_as<_Ip>;
    { __n + __j } -> same_as<_Ip>;
    { __i -= __n } -> same_as<_Ip&>;
    { __j - __n } -> same_as<_Ip>;
    { __j[__n] } -> same_as<iter_reference_t<_Ip>>;
  };
template<class _Ip>
concept contiguous_iterator =
  random_access_iterator<_Ip> &&
  derived_from<_ITER_CONCEPT<_Ip>, contiguous_iterator_tag> &&
  is_lvalue_reference_v<iter_reference_t<_Ip>> &&
  same_as<iter_value_t<_Ip>, remove_cvref_t<iter_reference_t<_Ip>>> &&
  requires(const _Ip& __i) {
    { std::to_address(__i) } -> same_as<add_pointer_t<iter_reference_t<_Ip>>>;
  };
template<class _Ip>
concept __has_arrow = input_iterator<_Ip> && (is_pointer_v<_Ip> || requires(_Ip __i) { __i.operator->(); });
template<class _Fp, class _It>
concept indirectly_unary_invocable =
  indirectly_readable<_It> &&
  copy_constructible<_Fp> &&
  invocable<_Fp&, iter_value_t<_It>&> &&
  invocable<_Fp&, iter_reference_t<_It>> &&
  invocable<_Fp&, iter_common_reference_t<_It>> &&
  common_reference_with<
    invoke_result_t<_Fp&, iter_value_t<_It>&>,
    invoke_result_t<_Fp&, iter_reference_t<_It>>>;
template<class _Fp, class _It>
concept indirectly_regular_unary_invocable =
  indirectly_readable<_It> &&
  copy_constructible<_Fp> &&
  regular_invocable<_Fp&, iter_value_t<_It>&> &&
  regular_invocable<_Fp&, iter_reference_t<_It>> &&
  regular_invocable<_Fp&, iter_common_reference_t<_It>> &&
  common_reference_with<
    invoke_result_t<_Fp&, iter_value_t<_It>&>,
    invoke_result_t<_Fp&, iter_reference_t<_It>>>;
template<class _Fp, class _It>
concept indirect_unary_predicate =
  indirectly_readable<_It> &&
  copy_constructible<_Fp> &&
  predicate<_Fp&, iter_value_t<_It>&> &&
  predicate<_Fp&, iter_reference_t<_It>> &&
  predicate<_Fp&, iter_common_reference_t<_It>>;
template<class _Fp, class _It1, class _It2>
concept indirect_binary_predicate =
  indirectly_readable<_It1> && indirectly_readable<_It2> &&
  copy_constructible<_Fp> &&
  predicate<_Fp&, iter_value_t<_It1>&, iter_value_t<_It2>&> &&
  predicate<_Fp&, iter_value_t<_It1>&, iter_reference_t<_It2>> &&
  predicate<_Fp&, iter_reference_t<_It1>, iter_value_t<_It2>&> &&
  predicate<_Fp&, iter_reference_t<_It1>, iter_reference_t<_It2>> &&
  predicate<_Fp&, iter_common_reference_t<_It1>, iter_common_reference_t<_It2>>;
template<class _Fp, class _It1, class _It2 = _It1>
concept indirect_equivalence_relation =
  indirectly_readable<_It1> && indirectly_readable<_It2> &&
  copy_constructible<_Fp> &&
  equivalence_relation<_Fp&, iter_value_t<_It1>&, iter_value_t<_It2>&> &&
  equivalence_relation<_Fp&, iter_value_t<_It1>&, iter_reference_t<_It2>> &&
  equivalence_relation<_Fp&, iter_reference_t<_It1>, iter_value_t<_It2>&> &&
  equivalence_relation<_Fp&, iter_reference_t<_It1>, iter_reference_t<_It2>> &&
  equivalence_relation<_Fp&, iter_common_reference_t<_It1>, iter_common_reference_t<_It2>>;
template<class _Fp, class _It1, class _It2 = _It1>
concept indirect_strict_weak_order =
  indirectly_readable<_It1> && indirectly_readable<_It2> &&
  copy_constructible<_Fp> &&
  strict_weak_order<_Fp&, iter_value_t<_It1>&, iter_value_t<_It2>&> &&
  strict_weak_order<_Fp&, iter_value_t<_It1>&, iter_reference_t<_It2>> &&
  strict_weak_order<_Fp&, iter_reference_t<_It1>, iter_value_t<_It2>&> &&
  strict_weak_order<_Fp&, iter_reference_t<_It1>, iter_reference_t<_It2>> &&
  strict_weak_order<_Fp&, iter_common_reference_t<_It1>, iter_common_reference_t<_It2>>;
template<class _Fp, class... _Its>
  requires (indirectly_readable<_Its> && ...) && invocable<_Fp, iter_reference_t<_Its>...>
using indirect_result_t = invoke_result_t<_Fp, iter_reference_t<_Its>...>;
template<class _In, class _Out>
concept indirectly_movable =
  indirectly_readable<_In> &&
  indirectly_writable<_Out, iter_rvalue_reference_t<_In>>;
template<class _In, class _Out>
concept indirectly_movable_storable =
  indirectly_movable<_In, _Out> &&
  indirectly_writable<_Out, iter_value_t<_In>> &&
  movable<iter_value_t<_In>> &&
  constructible_from<iter_value_t<_In>, iter_rvalue_reference_t<_In>> &&
  assignable_from<iter_value_t<_In>&, iter_rvalue_reference_t<_In>>;
template<class _In, class _Out>
concept indirectly_copyable =
  indirectly_readable<_In> &&
  indirectly_writable<_Out, iter_reference_t<_In>>;
template<class _In, class _Out>
concept indirectly_copyable_storable =
  indirectly_copyable<_In, _Out> &&
  indirectly_writable<_Out, iter_value_t<_In>&> &&
  indirectly_writable<_Out, const iter_value_t<_In>&> &&
  indirectly_writable<_Out, iter_value_t<_In>&&> &&
  indirectly_writable<_Out, const iter_value_t<_In>&&> &&
  copyable<iter_value_t<_In>> &&
  constructible_from<iter_value_t<_In>, iter_reference_t<_In>> &&
  assignable_from<iter_value_t<_In>&, iter_reference_t<_In>>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
namespace ranges {
enum class subrange_kind : bool { unsized, sized };
template <input_or_output_iterator _Iter, sentinel_for<_Iter> _Sent, subrange_kind _Kind>
  requires(_Kind == subrange_kind::sized || !sized_sentinel_for<_Sent, _Iter>)
class subrange;
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <size_t _Ip, class ..._Tp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
typename tuple_element<_Ip, tuple<_Tp...> >::type&
get(tuple<_Tp...>&) noexcept;
template <size_t _Ip, class ..._Tp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
const typename tuple_element<_Ip, tuple<_Tp...> >::type&
get(const tuple<_Tp...>&) noexcept;
template <size_t _Ip, class ..._Tp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
typename tuple_element<_Ip, tuple<_Tp...> >::type&&
get(tuple<_Tp...>&&) noexcept;
template <size_t _Ip, class ..._Tp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
const typename tuple_element<_Ip, tuple<_Tp...> >::type&&
get(const tuple<_Tp...>&&) noexcept;
template <size_t _Ip, class _T1, class _T2>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
typename tuple_element<_Ip, pair<_T1, _T2> >::type&
get(pair<_T1, _T2>&) noexcept;
template <size_t _Ip, class _T1, class _T2>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
const typename tuple_element<_Ip, pair<_T1, _T2> >::type&
get(const pair<_T1, _T2>&) noexcept;
template <size_t _Ip, class _T1, class _T2>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
typename tuple_element<_Ip, pair<_T1, _T2> >::type&&
get(pair<_T1, _T2>&&) noexcept;
template <size_t _Ip, class _T1, class _T2>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
const typename tuple_element<_Ip, pair<_T1, _T2> >::type&&
get(const pair<_T1, _T2>&&) noexcept;
template <size_t _Ip, class _Tp, size_t _Size>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
_Tp&
get(array<_Tp, _Size>&) noexcept;
template <size_t _Ip, class _Tp, size_t _Size>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
const _Tp&
get(const array<_Tp, _Size>&) noexcept;
template <size_t _Ip, class _Tp, size_t _Size>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
_Tp&&
get(array<_Tp, _Size>&&) noexcept;
template <size_t _Ip, class _Tp, size_t _Size>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
const _Tp&&
get(const array<_Tp, _Size>&&) noexcept;
namespace ranges {
template <size_t _Index, class _Iter, class _Sent, subrange_kind _Kind>
  requires((_Index == 0 && copyable<_Iter>) || _Index == 1)
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto get(const subrange<_Iter, _Sent, _Kind>& __subrange);
template <size_t _Index, class _Iter, class _Sent, subrange_kind _Kind>
  requires(_Index < 2)
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto get(subrange<_Iter, _Sent, _Kind>&& __subrange);
}
using ranges::get;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct __tuple_like_impl : false_type {};
template <class... _Tp>
struct __tuple_like_impl<tuple<_Tp...> > : true_type {};
template <class _T1, class _T2>
struct __tuple_like_impl<pair<_T1, _T2> > : true_type {};
template <class _Tp, size_t _Size>
struct __tuple_like_impl<array<_Tp, _Size> > : true_type {};
template <class _Ip, class _Sp, ranges::subrange_kind _Kp>
struct __tuple_like_impl<ranges::subrange<_Ip, _Sp, _Kp> > : true_type {};
template <class _Tp>
concept __tuple_like = __tuple_like_impl<remove_cvref_t<_Tp>>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
concept __pair_like = __tuple_like<_Tp> && tuple_size<remove_cvref_t<_Tp>>::value == 2;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_copy_assignable
    : public integral_constant<
          bool,
          __is_assignable(__add_lvalue_reference_t<_Tp>, __add_lvalue_reference_t<typename add_const<_Tp>::type>)> {};
template <class _Tp>
inline constexpr bool is_copy_assignable_v = is_copy_assignable<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
void __test_implicit_default_constructible(_Tp);
template <class _Tp, class = void, class = typename is_default_constructible<_Tp>::type>
struct __is_implicitly_default_constructible : false_type {};
template <class _Tp>
struct __is_implicitly_default_constructible<_Tp,
                                             decltype(std::__test_implicit_default_constructible<_Tp const&>({})),
                                             true_type> : true_type {};
template <class _Tp>
struct __is_implicitly_default_constructible<_Tp,
                                             decltype(std::__test_implicit_default_constructible<_Tp const&>({})),
                                             false_type> : false_type {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_nothrow_copy_assignable
    : public integral_constant<bool,
                               __is_nothrow_assignable(__add_lvalue_reference_t<_Tp>,
                                                       __add_lvalue_reference_t<typename add_const<_Tp>::type>)> {};
template <class _Tp>
inline constexpr bool is_nothrow_copy_assignable_v = is_nothrow_copy_assignable<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_nothrow_copy_constructible
    : public integral_constant<
          bool,
          __is_nothrow_constructible(_Tp, typename add_lvalue_reference<typename add_const<_Tp>::type>::type)> {};
template <class _Tp>
inline constexpr bool is_nothrow_copy_constructible_v = is_nothrow_copy_constructible<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_nothrow_default_constructible
    : public integral_constant<bool, __is_nothrow_constructible(_Tp)> {};
template <class _Tp>
inline constexpr bool is_nothrow_default_constructible_v = __is_nothrow_constructible(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct __unwrap_reference {
  typedef __attribute__((__nodebug__)) _Tp type;
};
template <class _Tp>
class reference_wrapper;
template <class _Tp>
struct __unwrap_reference<reference_wrapper<_Tp> > {
  typedef __attribute__((__nodebug__)) _Tp& type;
};
template <class _Tp>
struct decay;
template <class _Tp>
struct unwrap_reference : __unwrap_reference<_Tp> {};
template <class _Tp>
using unwrap_reference_t = typename unwrap_reference<_Tp>::type;
template <class _Tp>
struct unwrap_ref_decay : unwrap_reference<__decay_t<_Tp> > {};
template <class _Tp>
using unwrap_ref_decay_t = typename unwrap_ref_decay<_Tp>::type;
template <class _Tp>
struct __unwrap_ref_decay
    : unwrap_ref_decay<_Tp>
{
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
struct piecewise_construct_t { explicit piecewise_construct_t() = default; };
inline constexpr piecewise_construct_t piecewise_construct = piecewise_construct_t();
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class, class>
struct __non_trivially_copyable_base {
  constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  __non_trivially_copyable_base() noexcept {}
  constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  __non_trivially_copyable_base(__non_trivially_copyable_base const&) noexcept {}
};
template <class _Tp>
struct __is_specialization_of_subrange : false_type {};
template <class _Iter, class _Sent, ranges::subrange_kind _Kind>
struct __is_specialization_of_subrange<ranges::subrange<_Iter, _Sent, _Kind>> : true_type {};
template <class _T1, class _T2>
struct pair
{
    using first_type = _T1;
    using second_type = _T2;
    _T1 first;
    _T2 second;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) pair(pair const&) = default;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) pair(pair&&) = default;
    struct _CheckArgs {
      template <int&...>
      static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __enable_explicit_default() {
          return is_default_constructible<_T1>::value
              && is_default_constructible<_T2>::value
              && !__enable_implicit_default<>();
      }
      template <int&...>
      static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __enable_implicit_default() {
          return __is_implicitly_default_constructible<_T1>::value
              && __is_implicitly_default_constructible<_T2>::value;
      }
      template <class _U1, class _U2>
      static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __is_pair_constructible() {
          return is_constructible<first_type, _U1>::value
              && is_constructible<second_type, _U2>::value;
      }
      template <class _U1, class _U2>
      static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __is_implicit() {
          return is_convertible<_U1, first_type>::value
              && is_convertible<_U2, second_type>::value;
      }
      template <class _U1, class _U2>
      static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __enable_explicit() {
          return __is_pair_constructible<_U1, _U2>() && !__is_implicit<_U1, _U2>();
      }
      template <class _U1, class _U2>
      static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __enable_implicit() {
          return __is_pair_constructible<_U1, _U2>() && __is_implicit<_U1, _U2>();
      }
    };
    template <bool _MaybeEnable>
    using _CheckArgsDep __attribute__((__nodebug__)) = typename conditional<
      _MaybeEnable, _CheckArgs, __check_tuple_constructor_fail>::type;
    template<bool _Dummy = true, typename enable_if<
            _CheckArgsDep<_Dummy>::__enable_explicit_default()
    >::type* = nullptr>
    explicit __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair() noexcept(is_nothrow_default_constructible<first_type>::value && is_nothrow_default_constructible<second_type>::value)
        : first(), second() {}
    template<bool _Dummy = true, typename enable_if<
            _CheckArgsDep<_Dummy>::__enable_implicit_default()
    >::type* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair() noexcept(is_nothrow_default_constructible<first_type>::value && is_nothrow_default_constructible<second_type>::value)
        : first(), second() {}
    template <bool _Dummy = true, typename enable_if<
             _CheckArgsDep<_Dummy>::template __enable_explicit<_T1 const&, _T2 const&>()
    >::type* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit pair(_T1 const& __t1, _T2 const& __t2)
        noexcept(is_nothrow_copy_constructible<first_type>::value && is_nothrow_copy_constructible<second_type>::value)
        : first(__t1), second(__t2) {}
    template<bool _Dummy = true, typename enable_if<
            _CheckArgsDep<_Dummy>::template __enable_implicit<_T1 const&, _T2 const&>()
    >::type* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair(_T1 const& __t1, _T2 const& __t2)
        noexcept(is_nothrow_copy_constructible<first_type>::value && is_nothrow_copy_constructible<second_type>::value)
        : first(__t1), second(__t2) {}
    template <
        class _U1 = _T1, class _U2 = _T2,
        typename enable_if<_CheckArgs::template __enable_explicit<_U1, _U2>()>::type* = nullptr
    >
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit pair(_U1&& __u1, _U2&& __u2)
        noexcept((is_nothrow_constructible<first_type, _U1>::value && is_nothrow_constructible<second_type, _U2>::value))
        : first(std::forward<_U1>(__u1)), second(std::forward<_U2>(__u2)) {}
    template <
        class _U1 = _T1, class _U2 = _T2,
        typename enable_if<_CheckArgs::template __enable_implicit<_U1, _U2>()>::type* = nullptr
    >
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair(_U1&& __u1, _U2&& __u2)
        noexcept((is_nothrow_constructible<first_type, _U1>::value && is_nothrow_constructible<second_type, _U2>::value))
        : first(std::forward<_U1>(__u1)), second(std::forward<_U2>(__u2)) {}
    template<class _U1, class _U2, __enable_if_t<
            _CheckArgs::template __is_pair_constructible<_U1&, _U2&>()
    >* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit(!_CheckArgs::template __is_implicit<_U1&, _U2&>()) pair(pair<_U1, _U2>& __p)
        noexcept((is_nothrow_constructible<first_type, _U1&>::value &&
                  is_nothrow_constructible<second_type, _U2&>::value))
        : first(__p.first), second(__p.second) {}
    template<class _U1, class _U2, typename enable_if<
            _CheckArgs::template __enable_explicit<_U1 const&, _U2 const&>()
    >::type* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit pair(pair<_U1, _U2> const& __p)
        noexcept((is_nothrow_constructible<first_type, _U1 const&>::value && is_nothrow_constructible<second_type, _U2 const&>::value))
        : first(__p.first), second(__p.second) {}
    template<class _U1, class _U2, typename enable_if<
            _CheckArgs::template __enable_implicit<_U1 const&, _U2 const&>()
    >::type* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair(pair<_U1, _U2> const& __p)
        noexcept((is_nothrow_constructible<first_type, _U1 const&>::value && is_nothrow_constructible<second_type, _U2 const&>::value))
        : first(__p.first), second(__p.second) {}
    template<class _U1, class _U2, typename enable_if<
            _CheckArgs::template __enable_explicit<_U1, _U2>()
    >::type* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit pair(pair<_U1, _U2>&&__p)
        noexcept((is_nothrow_constructible<first_type, _U1&&>::value && is_nothrow_constructible<second_type, _U2&&>::value))
        : first(std::forward<_U1>(__p.first)), second(std::forward<_U2>(__p.second)) {}
    template<class _U1, class _U2, typename enable_if<
            _CheckArgs::template __enable_implicit<_U1, _U2>()
    >::type* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair(pair<_U1, _U2>&& __p)
        noexcept((is_nothrow_constructible<first_type, _U1&&>::value && is_nothrow_constructible<second_type, _U2&&>::value))
        : first(std::forward<_U1>(__p.first)), second(std::forward<_U2>(__p.second)) {}
    template<class _U1, class _U2, __enable_if_t<
            _CheckArgs::template __is_pair_constructible<const _U1&&, const _U2&&>()
    >* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit(!_CheckArgs::template __is_implicit<const _U1&&, const _U2&&>())
    pair(const pair<_U1, _U2>&& __p)
        noexcept(is_nothrow_constructible<first_type, const _U1&&>::value &&
                 is_nothrow_constructible<second_type, const _U2&&>::value)
        : first(std::move(__p.first)), second(std::move(__p.second)) {}
    template <class _PairLike, bool _Enable = tuple_size<remove_cvref_t<_PairLike>>::value == 2>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr bool __pair_like_explicit_wknd() {
        if constexpr (tuple_size<remove_cvref_t<_PairLike>>::value == 2) {
            return !is_convertible_v<decltype(std::get<0>(std::declval<_PairLike&&>())), first_type> ||
                   !is_convertible_v<decltype(std::get<1>(std::declval<_PairLike&&>())), second_type>;
        }
        return false;
    }
    template <__pair_like _PairLike>
      requires(is_constructible_v<first_type, decltype(std::get<0>(std::declval<_PairLike&&>()))> &&
               is_constructible_v<second_type, decltype(std::get<1>(std::declval<_PairLike&&>()))>)
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr explicit(__pair_like_explicit_wknd<_PairLike>())
        pair(_PairLike&& __p)
        : first(std::get<0>(std::forward<_PairLike>(__p))), second(std::get<1>(std::forward<_PairLike>(__p))) {}
    template <class... _Args1, class... _Args2>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair(piecewise_construct_t __pc,
         tuple<_Args1...> __first_args, tuple<_Args2...> __second_args)
        noexcept((is_nothrow_constructible<first_type, _Args1...>::value && is_nothrow_constructible<second_type, _Args2...>::value))
        : pair(__pc, __first_args, __second_args,
                typename __make_tuple_indices<sizeof...(_Args1)>::type(),
                typename __make_tuple_indices<sizeof...(_Args2) >::type()) {}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair& operator=(__conditional_t<
                        is_copy_assignable<first_type>::value &&
                        is_copy_assignable<second_type>::value,
                    pair, __nat> const& __p)
        noexcept(is_nothrow_copy_assignable<first_type>::value && is_nothrow_copy_assignable<second_type>::value)
    {
        first = __p.first;
        second = __p.second;
        return *this;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair& operator=(__conditional_t<
                        is_move_assignable<first_type>::value &&
                        is_move_assignable<second_type>::value,
                    pair, __nat>&& __p)
        noexcept(is_nothrow_move_assignable<first_type>::value && is_nothrow_move_assignable<second_type>::value)
    {
        first = std::forward<first_type>(__p.first);
        second = std::forward<second_type>(__p.second);
        return *this;
    }
    template <class _U1, class _U2, __enable_if_t<
        is_assignable<first_type&, _U1 const&>::value &&
        is_assignable<second_type&, _U2 const&>::value
    >* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair& operator=(pair<_U1, _U2> const& __p) {
        first = __p.first;
        second = __p.second;
        return *this;
    }
    template <class _U1, class _U2, __enable_if_t<
        is_assignable<first_type&, _U1>::value &&
        is_assignable<second_type&, _U2>::value
    >* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair& operator=(pair<_U1, _U2>&& __p) {
        first = std::forward<_U1>(__p.first);
        second = std::forward<_U2>(__p.second);
        return *this;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const pair& operator=(pair const& __p) const
      noexcept(is_nothrow_copy_assignable_v<const first_type> &&
               is_nothrow_copy_assignable_v<const second_type>)
      requires(is_copy_assignable_v<const first_type> &&
               is_copy_assignable_v<const second_type>) {
        first = __p.first;
        second = __p.second;
        return *this;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const pair& operator=(pair&& __p) const
      noexcept(is_nothrow_assignable_v<const first_type&, first_type> &&
               is_nothrow_assignable_v<const second_type&, second_type>)
      requires(is_assignable_v<const first_type&, first_type> &&
               is_assignable_v<const second_type&, second_type>) {
        first = std::forward<first_type>(__p.first);
        second = std::forward<second_type>(__p.second);
        return *this;
    }
    template<class _U1, class _U2>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const pair& operator=(const pair<_U1, _U2>& __p) const
      requires(is_assignable_v<const first_type&, const _U1&> &&
               is_assignable_v<const second_type&, const _U2&>) {
        first = __p.first;
        second = __p.second;
        return *this;
    }
    template<class _U1, class _U2>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const pair& operator=(pair<_U1, _U2>&& __p) const
      requires(is_assignable_v<const first_type&, _U1> &&
               is_assignable_v<const second_type&, _U2>) {
        first = std::forward<_U1>(__p.first);
        second = std::forward<_U2>(__p.second);
        return *this;
    }
    template <__pair_like _PairLike>
      requires(__different_from<_PairLike, pair> &&
               !__is_specialization_of_subrange<remove_cvref_t<_PairLike>>::value &&
               is_assignable_v<first_type&, decltype(std::get<0>(std::declval<_PairLike>()))> &&
               is_assignable_v<second_type&, decltype(std::get<1>(std::declval<_PairLike>()))>)
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr pair& operator=(_PairLike&& __p) {
        first = std::get<0>(std::forward<_PairLike>(__p));
        second = std::get<1>(std::forward<_PairLike>(__p));
        return *this;
    }
    template <__pair_like _PairLike>
      requires(__different_from<_PairLike, pair> &&
               !__is_specialization_of_subrange<remove_cvref_t<_PairLike>>::value &&
               is_assignable_v<first_type const&, decltype(std::get<0>(std::declval<_PairLike>()))> &&
               is_assignable_v<second_type const&, decltype(std::get<1>(std::declval<_PairLike>()))>)
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr pair const& operator=(_PairLike&& __p) const {
        first = std::get<0>(std::forward<_PairLike>(__p));
        second = std::get<1>(std::forward<_PairLike>(__p));
        return *this;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    void
    swap(pair& __p) noexcept(__is_nothrow_swappable<first_type>::value && __is_nothrow_swappable<second_type>::value)
    {
        using std::swap;
        swap(first, __p.first);
        swap(second, __p.second);
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    void swap(const pair& __p) const
        noexcept(__is_nothrow_swappable<const first_type>::value &&
                 __is_nothrow_swappable<const second_type>::value)
    {
        using std::swap;
        swap(first, __p.first);
        swap(second, __p.second);
    }
private:
    template <class... _Args1, class... _Args2, size_t... _I1, size_t... _I2>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    pair(piecewise_construct_t,
         tuple<_Args1...>& __first_args, tuple<_Args2...>& __second_args,
         __tuple_indices<_I1...>, __tuple_indices<_I2...>);
};
template<class _T1, class _T2>
pair(_T1, _T2) -> pair<_T1, _T2>;
template <class _T1, class _T2, class _U1, class _U2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
bool
operator==(const pair<_T1,_T2>& __x, const pair<_U1,_U2>& __y)
{
    return __x.first == __y.first && __x.second == __y.second;
}
template <class _T1, class _T2, class _U1, class _U2>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
common_comparison_category_t<
        __synth_three_way_result<_T1, _U1>,
        __synth_three_way_result<_T2, _U2> >
operator<=>(const pair<_T1,_T2>& __x, const pair<_U1,_U2>& __y)
{
    if (auto __c = std::__synth_three_way(__x.first, __y.first); __c != 0) {
      return __c;
    }
    return std::__synth_three_way(__x.second, __y.second);
}
template <class _T1, class _T2, class _U1, class _U2, template<class> class _TQual, template<class> class _UQual>
    requires requires { typename pair<common_reference_t<_TQual<_T1>, _UQual<_U1>>,
                                      common_reference_t<_TQual<_T2>, _UQual<_U2>>>; }
struct basic_common_reference<pair<_T1, _T2>, pair<_U1, _U2>, _TQual, _UQual> {
    using type = pair<common_reference_t<_TQual<_T1>, _UQual<_U1>>,
                      common_reference_t<_TQual<_T2>, _UQual<_U2>>>;
};
template <class _T1, class _T2, class _U1, class _U2>
    requires requires { typename pair<common_type_t<_T1, _U1>, common_type_t<_T2, _U2>>; }
struct common_type<pair<_T1, _T2>, pair<_U1, _U2>> {
    using type = pair<common_type_t<_T1, _U1>, common_type_t<_T2, _U2>>;
};
template <class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
typename enable_if
<
    __is_swappable<_T1>::value &&
    __is_swappable<_T2>::value,
    void
>::type
swap(pair<_T1, _T2>& __x, pair<_T1, _T2>& __y)
                     noexcept((__is_nothrow_swappable<_T1>::value && __is_nothrow_swappable<_T2>::value))
{
    __x.swap(__y);
}
template <class _T1, class _T2>
  requires (__is_swappable<const _T1>::value &&
            __is_swappable<const _T2>::value)
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
void swap(const pair<_T1, _T2>& __x, const pair<_T1, _T2>& __y)
    noexcept(noexcept(__x.swap(__y)))
{
    __x.swap(__y);
}
template <class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
pair<typename __unwrap_ref_decay<_T1>::type, typename __unwrap_ref_decay<_T2>::type>
make_pair(_T1&& __t1, _T2&& __t2)
{
    return pair<typename __unwrap_ref_decay<_T1>::type, typename __unwrap_ref_decay<_T2>::type>
               (std::forward<_T1>(__t1), std::forward<_T2>(__t2));
}
template <class _T1, class _T2>
  struct tuple_size<pair<_T1, _T2> >
    : public integral_constant<size_t, 2> {};
template <size_t _Ip, class _T1, class _T2>
struct tuple_element<_Ip, pair<_T1, _T2> >
{
    static_assert(_Ip < 2, "Index out of bounds in std::tuple_element<std::pair<T1, T2>>");
};
template <class _T1, class _T2>
struct tuple_element<0, pair<_T1, _T2> >
{
    using type __attribute__((__nodebug__)) = _T1;
};
template <class _T1, class _T2>
struct tuple_element<1, pair<_T1, _T2> >
{
    using type __attribute__((__nodebug__)) = _T2;
};
template <size_t _Ip> struct __get_pair;
template <>
struct __get_pair<0>
{
    template <class _T1, class _T2>
    static
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    _T1&
    get(pair<_T1, _T2>& __p) noexcept {return __p.first;}
    template <class _T1, class _T2>
    static
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const _T1&
    get(const pair<_T1, _T2>& __p) noexcept {return __p.first;}
    template <class _T1, class _T2>
    static
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    _T1&&
    get(pair<_T1, _T2>&& __p) noexcept {return std::forward<_T1>(__p.first);}
    template <class _T1, class _T2>
    static
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const _T1&&
    get(const pair<_T1, _T2>&& __p) noexcept {return std::forward<const _T1>(__p.first);}
};
template <>
struct __get_pair<1>
{
    template <class _T1, class _T2>
    static
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    _T2&
    get(pair<_T1, _T2>& __p) noexcept {return __p.second;}
    template <class _T1, class _T2>
    static
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const _T2&
    get(const pair<_T1, _T2>& __p) noexcept {return __p.second;}
    template <class _T1, class _T2>
    static
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    _T2&&
    get(pair<_T1, _T2>&& __p) noexcept {return std::forward<_T2>(__p.second);}
    template <class _T1, class _T2>
    static
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const _T2&&
    get(const pair<_T1, _T2>&& __p) noexcept {return std::forward<const _T2>(__p.second);}
};
template <size_t _Ip, class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
typename tuple_element<_Ip, pair<_T1, _T2> >::type&
get(pair<_T1, _T2>& __p) noexcept
{
    return __get_pair<_Ip>::get(__p);
}
template <size_t _Ip, class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
const typename tuple_element<_Ip, pair<_T1, _T2> >::type&
get(const pair<_T1, _T2>& __p) noexcept
{
    return __get_pair<_Ip>::get(__p);
}
template <size_t _Ip, class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
typename tuple_element<_Ip, pair<_T1, _T2> >::type&&
get(pair<_T1, _T2>&& __p) noexcept
{
    return __get_pair<_Ip>::get(std::move(__p));
}
template <size_t _Ip, class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
const typename tuple_element<_Ip, pair<_T1, _T2> >::type&&
get(const pair<_T1, _T2>&& __p) noexcept
{
    return __get_pair<_Ip>::get(std::move(__p));
}
template <class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1 & get(pair<_T1, _T2>& __p) noexcept
{
    return __get_pair<0>::get(__p);
}
template <class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1 const & get(pair<_T1, _T2> const& __p) noexcept
{
    return __get_pair<0>::get(__p);
}
template <class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1 && get(pair<_T1, _T2>&& __p) noexcept
{
    return __get_pair<0>::get(std::move(__p));
}
template <class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1 const && get(pair<_T1, _T2> const&& __p) noexcept
{
    return __get_pair<0>::get(std::move(__p));
}
template <class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1 & get(pair<_T2, _T1>& __p) noexcept
{
    return __get_pair<1>::get(__p);
}
template <class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1 const & get(pair<_T2, _T1> const& __p) noexcept
{
    return __get_pair<1>::get(__p);
}
template <class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1 && get(pair<_T2, _T1>&& __p) noexcept
{
    return __get_pair<1>::get(std::move(__p));
}
template <class _T1, class _T2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1 const && get(pair<_T2, _T1> const&& __p) noexcept
{
    return __get_pair<1>::get(std::move(__p));
}
}}
typedef signed char int8_t;
typedef short int16_t;
typedef int int32_t;
typedef long long int64_t;
typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef unsigned int uint32_t;
typedef unsigned long long uint64_t;
typedef signed char int_least8_t;
typedef short int_least16_t;
typedef int int_least32_t;
typedef long long int_least64_t;
typedef unsigned char uint_least8_t;
typedef unsigned short uint_least16_t;
typedef unsigned int uint_least32_t;
typedef unsigned long long uint_least64_t;
typedef signed char int_fast8_t;
typedef int int_fast16_t;
typedef int int_fast32_t;
typedef long long int_fast64_t;
typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned int uint_fast32_t;
typedef unsigned long long uint_fast64_t;
typedef long long intmax_t;
typedef unsigned long long uintmax_t;
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
using ::int8_t __attribute__((__using_if_exists__));
using ::int16_t __attribute__((__using_if_exists__));
using ::int32_t __attribute__((__using_if_exists__));
using ::int64_t __attribute__((__using_if_exists__));
using ::uint8_t __attribute__((__using_if_exists__));
using ::uint16_t __attribute__((__using_if_exists__));
using ::uint32_t __attribute__((__using_if_exists__));
using ::uint64_t __attribute__((__using_if_exists__));
using ::int_least8_t __attribute__((__using_if_exists__));
using ::int_least16_t __attribute__((__using_if_exists__));
using ::int_least32_t __attribute__((__using_if_exists__));
using ::int_least64_t __attribute__((__using_if_exists__));
using ::uint_least8_t __attribute__((__using_if_exists__));
using ::uint_least16_t __attribute__((__using_if_exists__));
using ::uint_least32_t __attribute__((__using_if_exists__));
using ::uint_least64_t __attribute__((__using_if_exists__));
using ::int_fast8_t __attribute__((__using_if_exists__));
using ::int_fast16_t __attribute__((__using_if_exists__));
using ::int_fast32_t __attribute__((__using_if_exists__));
using ::int_fast64_t __attribute__((__using_if_exists__));
using ::uint_fast8_t __attribute__((__using_if_exists__));
using ::uint_fast16_t __attribute__((__using_if_exists__));
using ::uint_fast32_t __attribute__((__using_if_exists__));
using ::uint_fast64_t __attribute__((__using_if_exists__));
using ::intptr_t __attribute__((__using_if_exists__));
using ::uintptr_t __attribute__((__using_if_exists__));
using ::intmax_t __attribute__((__using_if_exists__));
using ::uintmax_t __attribute__((__using_if_exists__));
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) inline constexpr bool is_constant_evaluated() noexcept {
  return __builtin_is_constant_evaluated();
}
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) inline constexpr bool __libcpp_is_constant_evaluated() noexcept {
  return __builtin_is_constant_evaluated();
}
}}
 extern "C" {
         extern int* __cdecl _errno(void);
         errno_t __cdecl _set_errno( int _Value);
         errno_t __cdecl _get_errno( int* _Value);
         unsigned long* __cdecl __doserrno(void);
         errno_t __cdecl _set_doserrno( unsigned long _Value);
         errno_t __cdecl _get_doserrno( unsigned long * _Value);
}
 extern "C" {
[[nodiscard]]
         void const* __cdecl memchr(
                                    void const* _Buf,
                                    int _Val,
                                    size_t _MaxCount
    );
[[nodiscard]]
int __cdecl memcmp(
                            void const* _Buf1,
                            void const* _Buf2,
                            size_t _Size
    );
void* __cdecl memcpy(
                                  void* _Dst,
                                  void const* _Src,
                                  size_t _Size
    );
         void* __cdecl memmove(
                                      void* _Dst,
                                      void const* _Src,
                                      size_t _Size
    );
void* __cdecl memset(
                                  void* _Dst,
                                  int _Val,
                                  size_t _Size
    );
[[nodiscard]]
         char const* __cdecl strchr(
           char const* _Str,
           int _Val
    );
[[nodiscard]]
         char const* __cdecl strrchr(
           char const* _Str,
           int _Ch
    );
[[nodiscard]]
         char const* __cdecl strstr(
           char const* _Str,
           char const* _SubStr
    );
[[nodiscard]]
         wchar_t const* __cdecl wcschr(
           wchar_t const* _Str,
           wchar_t _Ch
    );
[[nodiscard]]
         wchar_t const* __cdecl wcsrchr(
           wchar_t const* _Str,
           wchar_t _Ch
    );
[[nodiscard]]
         wchar_t const* __cdecl wcsstr(
           wchar_t const* _Str,
           wchar_t const* _SubStr
    );
}
 extern "C" {
    static __inline errno_t __cdecl memcpy_s(
                                                                 void* const _Destination,
                                                                 rsize_t const _DestinationSize,
                                                                 void const* const _Source,
                                                                 rsize_t const _SourceSize
        )
    {
        if (_SourceSize == 0)
        {
            return 0;
        }
        { int _Expr_val=!!(_Destination != 0); if (!(_Expr_val)) { (*_errno()) = 22; _invalid_parameter_noinfo(); return 22; } };
        if (_Source == 0 || _DestinationSize < _SourceSize)
        {
            memset(_Destination, 0, _DestinationSize);
            { int _Expr_val=!!(_Source != 0); if (!(_Expr_val)) { (*_errno()) = 22; _invalid_parameter_noinfo(); return 22; } };
            { int _Expr_val=!!(_DestinationSize >= _SourceSize); if (!(_Expr_val)) { (*_errno()) = 34; _invalid_parameter_noinfo(); return 34; } };
            return 22;
        }
        memcpy(_Destination, _Source, _SourceSize);
        return 0;
    }
    static __inline errno_t __cdecl memmove_s(
                                                                 void* const _Destination,
                                                                 rsize_t const _DestinationSize,
                                                                 void const* const _Source,
                                                                 rsize_t const _SourceSize
        )
    {
        if (_SourceSize == 0)
        {
            return 0;
        }
        { int _Expr_val=!!(_Destination != 0); if (!(_Expr_val)) { (*_errno()) = 22; _invalid_parameter_noinfo(); return 22; } };
        { int _Expr_val=!!(_Source != 0); if (!(_Expr_val)) { (*_errno()) = 22; _invalid_parameter_noinfo(); return 22; } };
        { int _Expr_val=!!(_DestinationSize >= _SourceSize); if (!(_Expr_val)) { (*_errno()) = 34; _invalid_parameter_noinfo(); return 34; } };
        memmove(_Destination, _Source, _SourceSize);
        return 0;
    }
}
 extern "C" {
         int __cdecl _memicmp(
                                void const* _Buf1,
                                void const* _Buf2,
                                size_t _Size
    );
         int __cdecl _memicmp_l(
                                void const* _Buf1,
                                void const* _Buf2,
                                size_t _Size,
                                _locale_t _Locale
    );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_memccpy" ". See online help for details."))
             void* __cdecl memccpy(
                                      void* _Dst,
                                      void const* _Src,
                                      int _Val,
                                      size_t _Size
        );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_memicmp" ". See online help for details."))
             int __cdecl memicmp(
                                    void const* _Buf1,
                                    void const* _Buf2,
                                    size_t _Size
        );
    extern "C++"
    inline void* __cdecl memchr(
                                 void* _Pv,
                                 int _C,
                                 size_t _N
        )
    {
        void const* const _Pvc = _Pv;
        return const_cast<void*>(memchr(_Pvc, _C, _N));
    }
}
 extern "C" {
             errno_t __cdecl wcscat_s(
                                        wchar_t* _Destination,
             rsize_t _SizeInWords,
               wchar_t const* _Source
        );
             errno_t __cdecl wcscpy_s(
                                     wchar_t* _Destination,
             rsize_t _SizeInWords,
               wchar_t const* _Source
        );
             errno_t __cdecl wcsncat_s(
                                        wchar_t* _Destination,
                                        rsize_t _SizeInWords,
                                        wchar_t const* _Source,
                                        rsize_t _MaxCount
        );
             errno_t __cdecl wcsncpy_s(
                                     wchar_t* _Destination,
                                     rsize_t _SizeInWords,
                                     wchar_t const* _Source,
                                     rsize_t _MaxCount
        );
             wchar_t* __cdecl wcstok_s(
                                      wchar_t* _String,
                                      wchar_t const* _Delimiter,
                                      wchar_t** _Context
        );
         __declspec(allocator) wchar_t* __cdecl _wcsdup(
           wchar_t const* _String
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl wcscat_s(wchar_t (&_Destination)[_Size], wchar_t const* _Source) throw() { return wcscat_s(_Destination, _Size, _Source); } }
    __declspec(deprecated("This function or variable may be unsafe. Consider using " "wcscat_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl wcscat( wchar_t *_Destination, wchar_t const* _Source);
         int __cdecl wcscmp(
           wchar_t const* _String1,
           wchar_t const* _String2
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl wcscpy_s(wchar_t (&_Destination)[_Size], wchar_t const* _Source) throw() { return wcscpy_s(_Destination, _Size, _Source); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "wcscpy_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl wcscpy( wchar_t *_Destination, wchar_t const* _Source);
         size_t __cdecl wcscspn(
           wchar_t const* _String,
           wchar_t const* _Control
    );
         size_t __cdecl wcslen(
           wchar_t const* _String
    );
         size_t __cdecl wcsnlen(
                               wchar_t const* _Source,
                               size_t _MaxCount
    );
    static __inline size_t __cdecl wcsnlen_s(
                                   wchar_t const* _Source,
                                   size_t _MaxCount
        )
    {
        return (_Source == 0) ? 0 : wcsnlen(_Source, _MaxCount);
    }
extern "C++" { template <size_t _Size> inline errno_t __cdecl wcsncat_s(wchar_t (&_Destination)[_Size], wchar_t const* _Source, size_t _Count) throw() { return wcsncat_s(_Destination, _Size, _Source, _Count); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "wcsncat_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl wcsncat( wchar_t *_Destination, wchar_t const* _Source, size_t _Count);
         int __cdecl wcsncmp(
                               wchar_t const* _String1,
                               wchar_t const* _String2,
                               size_t _MaxCount
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl wcsncpy_s(wchar_t (&_Destination)[_Size], wchar_t const* _Source, size_t _Count) throw() { return wcsncpy_s(_Destination, _Size, _Source, _Count); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "wcsncpy_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl wcsncpy( wchar_t *_Destination, wchar_t const* _Source, size_t _Count);
         wchar_t const* __cdecl wcspbrk(
           wchar_t const* _String,
           wchar_t const* _Control
    );
         size_t __cdecl wcsspn(
           wchar_t const* _String,
           wchar_t const* _Control
    );
               __declspec(deprecated("This function or variable may be unsafe. Consider using " "wcstok_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         wchar_t* __cdecl wcstok(
                                      wchar_t* _String,
                                      wchar_t const* _Delimiter,
                                      wchar_t** _Context
    );
                   __declspec(deprecated("This function or variable may be unsafe. Consider using " "wcstok_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
    static __inline wchar_t* __cdecl _wcstok(
                      wchar_t* const _String,
                      wchar_t const* const _Delimiter
        )
    {
        return wcstok(_String, _Delimiter, 0);
    }
        extern "C++" __declspec(deprecated("wcstok has been changed to conform with the ISO C standard, " "adding an extra context parameter. To use the legacy Microsoft " "wcstok, define _CRT_NON_CONFORMING_WCSTOK."))
        inline wchar_t* __cdecl wcstok(
                          wchar_t* _String,
                          wchar_t const* _Delimiter
            ) throw()
        {
            return wcstok(_String, _Delimiter, 0);
        }
               __declspec(deprecated("This function or variable may be unsafe. Consider using " "_wcserror_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         wchar_t* __cdecl _wcserror(
         int _ErrorNumber
    );
         errno_t __cdecl _wcserror_s(
                                     wchar_t* _Buffer,
                                     size_t _SizeInWords,
                                     int _ErrorNumber
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _wcserror_s(wchar_t (&_Buffer)[_Size], int _Error) throw() { return _wcserror_s(_Buffer, _Size, _Error); } }
               __declspec(deprecated("This function or variable may be unsafe. Consider using " "__wcserror_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         wchar_t* __cdecl __wcserror(
               wchar_t const* _String
    );
                            errno_t __cdecl __wcserror_s(
                                     wchar_t* _Buffer,
                                     size_t _SizeInWords,
                                     wchar_t const* _ErrorMessage
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl __wcserror_s(wchar_t (&_Buffer)[_Size], wchar_t const* _ErrorMessage) throw() { return __wcserror_s(_Buffer, _Size, _ErrorMessage); } }
                        int __cdecl _wcsicmp(
           wchar_t const* _String1,
           wchar_t const* _String2
    );
                        int __cdecl _wcsicmp_l(
             wchar_t const* _String1,
             wchar_t const* _String2,
             _locale_t _Locale
    );
                        int __cdecl _wcsnicmp(
                               wchar_t const* _String1,
                               wchar_t const* _String2,
                               size_t _MaxCount
    );
                        int __cdecl _wcsnicmp_l(
                               wchar_t const* _String1,
                               wchar_t const* _String2,
                               size_t _MaxCount,
                               _locale_t _Locale
    );
                            errno_t __cdecl _wcsnset_s(
                                    wchar_t* _Destination,
                                    size_t _SizeInWords,
                                    wchar_t _Value,
                                    size_t _MaxCount
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _wcsnset_s(wchar_t (&_Destination)[_Size], wchar_t _Value, size_t _MaxCount) throw() { return _wcsnset_s(_Destination, _Size, _Value, _MaxCount); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_wcsnset_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl _wcsnset( wchar_t *_String, wchar_t _Value, size_t _MaxCount);
         wchar_t* __cdecl _wcsrev(
              wchar_t* _String
    );
                            errno_t __cdecl _wcsset_s(
                                    wchar_t* _Destination,
                                    size_t _SizeInWords,
                                    wchar_t _Value
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _wcsset_s(wchar_t (&_String)[_Size], wchar_t _Value) throw() { return _wcsset_s(_String, _Size, _Value); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_wcsset_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl _wcsset( wchar_t *_String, wchar_t _Value);
                            errno_t __cdecl _wcslwr_s(
                                    wchar_t* _String,
                                    size_t _SizeInWords
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _wcslwr_s(wchar_t (&_String)[_Size]) throw() { return _wcslwr_s(_String, _Size); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_wcslwr_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl _wcslwr( wchar_t *_String);
         errno_t __cdecl _wcslwr_s_l(
                                    wchar_t* _String,
                                    size_t _SizeInWords,
                                    _locale_t _Locale
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _wcslwr_s_l(wchar_t (&_String)[_Size], _locale_t _Locale) throw() { return _wcslwr_s_l(_String, _Size, _Locale); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_wcslwr_s_l" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl _wcslwr_l( wchar_t *_String, _locale_t _Locale);
         errno_t __cdecl _wcsupr_s(
                             wchar_t* _String,
                             size_t _Size
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _wcsupr_s(wchar_t (&_String)[_Size]) throw() { return _wcsupr_s(_String, _Size); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_wcsupr_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl _wcsupr( wchar_t *_String);
         errno_t __cdecl _wcsupr_s_l(
                             wchar_t* _String,
                             size_t _Size,
                             _locale_t _Locale
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _wcsupr_s_l(wchar_t (&_String)[_Size], _locale_t _Locale) throw() { return _wcsupr_s_l(_String, _Size, _Locale); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_wcsupr_s_l" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl _wcsupr_l( wchar_t *_String, _locale_t _Locale);
         size_t __cdecl wcsxfrm(
                                              wchar_t* _Destination,
                                              wchar_t const* _Source,
                                              size_t _MaxCount
    );
         size_t __cdecl _wcsxfrm_l(
                                              wchar_t* _Destination,
                                              wchar_t const* _Source,
                                              size_t _MaxCount,
                                              _locale_t _Locale
    );
         int __cdecl wcscoll(
           wchar_t const* _String1,
           wchar_t const* _String2
    );
         int __cdecl _wcscoll_l(
             wchar_t const* _String1,
             wchar_t const* _String2,
             _locale_t _Locale
    );
         int __cdecl _wcsicoll(
           wchar_t const* _String1,
           wchar_t const* _String2
    );
         int __cdecl _wcsicoll_l(
             wchar_t const* _String1,
             wchar_t const* _String2,
             _locale_t _Locale
    );
         int __cdecl _wcsncoll(
                               wchar_t const* _String1,
                               wchar_t const* _String2,
                               size_t _MaxCount
    );
         int __cdecl _wcsncoll_l(
                               wchar_t const* _String1,
                               wchar_t const* _String2,
                               size_t _MaxCount,
                               _locale_t _Locale
    );
         int __cdecl _wcsnicoll(
                               wchar_t const* _String1,
                               wchar_t const* _String2,
                               size_t _MaxCount
    );
         int __cdecl _wcsnicoll_l(
                               wchar_t const* _String1,
                               wchar_t const* _String2,
                               size_t _MaxCount,
                               _locale_t _Locale
    );
extern "C++" {
    inline wchar_t* __cdecl wcschr( wchar_t* _String, wchar_t _C)
    {
        return const_cast<wchar_t*>(wcschr(static_cast<wchar_t const*>(_String), _C));
    }
    inline wchar_t* __cdecl wcspbrk( wchar_t* _String, wchar_t const* _Control)
    {
        return const_cast<wchar_t*>(wcspbrk(static_cast<wchar_t const*>(_String), _Control));
    }
    inline wchar_t* __cdecl wcsrchr( wchar_t* _String, wchar_t _C)
    {
        return const_cast<wchar_t*>(wcsrchr(static_cast<wchar_t const*>(_String), _C));
    }
    inline wchar_t* __cdecl wcsstr( wchar_t* _String, wchar_t const*_SubStr)
    {
        return const_cast<wchar_t*>(wcsstr(static_cast<wchar_t const*>(_String), _SubStr));
    }
}
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_wcsdup" ". See online help for details."))
             wchar_t* __cdecl wcsdup(
               wchar_t const* _String
        );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_wcsicmp" ". See online help for details."))
             int __cdecl wcsicmp(
               wchar_t const* _String1,
               wchar_t const* _String2
        );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_wcsnicmp" ". See online help for details."))
             int __cdecl wcsnicmp(
                                   wchar_t const* _String1,
                                   wchar_t const* _String2,
                                   size_t _MaxCount
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_wcsnset" ". See online help for details."))
             wchar_t* __cdecl wcsnset(
                                     wchar_t* _String,
                                     wchar_t _Value,
                                     size_t _MaxCount
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_wcsrev" ". See online help for details."))
             wchar_t* __cdecl wcsrev(
                  wchar_t* _String
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_wcsset" ". See online help for details."))
             wchar_t* __cdecl wcsset(
                  wchar_t* _String,
                  wchar_t _Value
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_wcslwr" ". See online help for details."))
             wchar_t* __cdecl wcslwr(
                  wchar_t* _String
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_wcsupr" ". See online help for details."))
             wchar_t* __cdecl wcsupr(
                  wchar_t* _String
        );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_wcsicoll" ". See online help for details."))
             int __cdecl wcsicoll(
               wchar_t const* _String1,
               wchar_t const* _String2
        );
}
 extern "C" {
             errno_t __cdecl strcpy_s(
                                     char* _Destination,
                                     rsize_t _SizeInBytes,
                                     char const* _Source
        );
             errno_t __cdecl strcat_s(
                                        char* _Destination,
                                        rsize_t _SizeInBytes,
                                        char const* _Source
        );
             errno_t __cdecl strerror_s(
                                     char* _Buffer,
                                     size_t _SizeInBytes,
                                     int _ErrorNumber);
             errno_t __cdecl strncat_s(
                                        char* _Destination,
                                        rsize_t _SizeInBytes,
                                        char const* _Source,
                                        rsize_t _MaxCount
        );
             errno_t __cdecl strncpy_s(
                                     char* _Destination,
                                     rsize_t _SizeInBytes,
                                     char const* _Source,
                                     rsize_t _MaxCount
        );
             char* __cdecl strtok_s(
                                      char* _String,
                                      char const* _Delimiter,
                                      char** _Context
        );
         void* __cdecl _memccpy(
                                      void* _Dst,
                                      void const* _Src,
                                      int _Val,
                                      size_t _MaxCount
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl strcat_s(char (&_Destination)[_Size], char const* _Source) throw() { return strcat_s(_Destination, _Size, _Source); } }
    __declspec(deprecated("This function or variable may be unsafe. Consider using " "strcat_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl strcat( char *_Destination, char const* _Source);
int __cdecl strcmp(
           char const* _Str1,
           char const* _Str2
    );
         int __cdecl _strcmpi(
           char const* _String1,
           char const* _String2
    );
         int __cdecl strcoll(
           char const* _String1,
           char const* _String2
    );
         int __cdecl _strcoll_l(
             char const* _String1,
             char const* _String2,
             _locale_t _Locale
    );
char* __cdecl strcpy(
                                                 char* _Dest,
                                                 char const* _Source
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl strcpy_s(char (&_Destination)[_Size], char const* _Source) throw() { return strcpy_s(_Destination, _Size, _Source); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "strcpy_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl strcpy( char *_Destination, char const* _Source);
         size_t __cdecl strcspn(
           char const* _Str,
           char const* _Control
    );
         __declspec(allocator) char* __cdecl _strdup(
               char const* _Source
    );
               __declspec(deprecated("This function or variable may be unsafe. Consider using " "_strerror_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         char* __cdecl _strerror(
               char const* _ErrorMessage
    );
         errno_t __cdecl _strerror_s(
                                 char* _Buffer,
                                 size_t _SizeInBytes,
                                 char const* _ErrorMessage
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _strerror_s(char (&_Buffer)[_Size], char const* _ErrorMessage) throw() { return _strerror_s(_Buffer, _Size, _ErrorMessage); } }
               __declspec(deprecated("This function or variable may be unsafe. Consider using " "strerror_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         char* __cdecl strerror(
         int _ErrorMessage
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl strerror_s(char (&_Buffer)[_Size], int _ErrorMessage) throw() { return strerror_s(_Buffer, _Size, _ErrorMessage); } }
         int __cdecl _stricmp(
           char const* _String1,
           char const* _String2
    );
         int __cdecl _stricoll(
           char const* _String1,
           char const* _String2
    );
         int __cdecl _stricoll_l(
             char const* _String1,
             char const* _String2,
             _locale_t _Locale
    );
         int __cdecl _stricmp_l(
             char const* _String1,
             char const* _String2,
             _locale_t _Locale
    );
size_t __cdecl strlen(
           char const* _Str
    );
         errno_t __cdecl _strlwr_s(
                             char* _String,
                             size_t _Size
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _strlwr_s(char (&_String)[_Size]) throw() { return _strlwr_s(_String, _Size); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_strlwr_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl _strlwr( char *_String);
         errno_t __cdecl _strlwr_s_l(
                             char* _String,
                             size_t _Size,
                             _locale_t _Locale
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _strlwr_s_l(char (&_String)[_Size], _locale_t _Locale) throw() { return _strlwr_s_l(_String, _Size, _Locale); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_strlwr_s_l" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl _strlwr_l( char *_String, _locale_t _Locale);
         char* __cdecl strncat(
                              char* _Dest,
                              char const* _Source,
                              size_t _Count
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl strncat_s(char (&_Destination)[_Size], char const* _Source, size_t _Count) throw() { return strncat_s(_Destination, _Size, _Source, _Count); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "strncat_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl strncat( char *_Destination, char const* _Source, size_t _Count);
         int __cdecl strncmp(
                               char const* _Str1,
                               char const* _Str2,
                               size_t _MaxCount
    );
         int __cdecl _strnicmp(
                               char const* _String1,
                               char const* _String2,
                               size_t _MaxCount
    );
         int __cdecl _strnicmp_l(
                               char const* _String1,
                               char const* _String2,
                               size_t _MaxCount,
                               _locale_t _Locale
    );
         int __cdecl _strnicoll(
                               char const* _String1,
                               char const* _String2,
                               size_t _MaxCount
    );
         int __cdecl _strnicoll_l(
                               char const* _String1,
                               char const* _String2,
                               size_t _MaxCount,
                               _locale_t _Locale
    );
         int __cdecl _strncoll(
                               char const* _String1,
                               char const* _String2,
                               size_t _MaxCount
    );
         int __cdecl _strncoll_l(
                               char const* _String1,
                               char const* _String2,
                               size_t _MaxCount,
                               _locale_t _Locale
    );
         size_t __cdecl __strncnt(
                            char const* _String,
                            size_t _Count
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl strncpy_s(char (&_Destination)[_Size], char const* _Source, size_t _Count) throw() { return strncpy_s(_Destination, _Size, _Source, _Count); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "strncpy_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl strncpy( char *_Destination, char const* _Source, size_t _Count);
         size_t __cdecl strnlen(
                               char const* _String,
                               size_t _MaxCount
    );
    static __inline size_t __cdecl strnlen_s(
                                   char const* _String,
                                   size_t _MaxCount
        )
    {
        return _String == 0 ? 0 : strnlen(_String, _MaxCount);
    }
         char* __cdecl _strnset(
                              char* _Dest,
                              int _Val,
                              size_t _Count
    );
         errno_t __cdecl _strnset_s(
                                    char* _String,
                                    size_t _SizeInBytes,
                                    int _Value,
                                    size_t _MaxCount
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _strnset_s(char (&_Destination)[_Size], int _Value, size_t _Count) throw() { return _strnset_s(_Destination, _Size, _Value, _Count); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_strnset_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl _strnset( char *_Destination, int _Value, size_t _Count);
         char const* __cdecl strpbrk(
           char const* _Str,
           char const* _Control
    );
         char* __cdecl _strrev(
              char* _Str
    );
         errno_t __cdecl _strset_s(
                                        char* _Destination,
                                        size_t _DestinationSize,
                                        int _Value
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _strset_s(char (&_Destination)[_Size], int _Value) throw() { return _strset_s(_Destination, _Size, _Value); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_strset_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl _strset( char *_Destination, int _Value);
char* __cdecl _strset(
              char* _Dest,
              int _Value
    );
         size_t __cdecl strspn(
           char const* _Str,
           char const* _Control
    );
               __declspec(deprecated("This function or variable may be unsafe. Consider using " "strtok_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         char* __cdecl strtok(
                  char* _String,
                  char const* _Delimiter
    );
         errno_t __cdecl _strupr_s(
                             char* _String,
                             size_t _Size
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _strupr_s(char (&_String)[_Size]) throw() { return _strupr_s(_String, _Size); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_strupr_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl _strupr( char *_String);
         errno_t __cdecl _strupr_s_l(
                             char* _String,
                             size_t _Size,
                             _locale_t _Locale
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _strupr_s_l(char (&_String)[_Size], _locale_t _Locale) throw() { return _strupr_s_l(_String, _Size, _Locale); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_strupr_s_l" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl _strupr_l( char *_String, _locale_t _Locale);
         size_t __cdecl strxfrm(
                                              char* _Destination,
                                              char const* _Source,
                                              size_t _MaxCount
    );
         size_t __cdecl _strxfrm_l(
                                              char* _Destination,
                                              char const* _Source,
                                              size_t _MaxCount,
                                              _locale_t _Locale
    );
extern "C++"
{
    inline char* __cdecl strchr( char* const _String, int const _Ch)
    {
        return const_cast<char*>(strchr(static_cast<char const*>(_String), _Ch));
    }
    inline char* __cdecl strpbrk( char* const _String, char const* const _Control)
    {
        return const_cast<char*>(strpbrk(static_cast<char const*>(_String), _Control));
    }
    inline char* __cdecl strrchr( char* const _String, int const _Ch)
    {
        return const_cast<char*>(strrchr(static_cast<char const*>(_String), _Ch));
    }
    inline char* __cdecl strstr( char* const _String, char const* const _SubString)
    {
        return const_cast<char*>(strstr(static_cast<char const*>(_String), _SubString));
    }
}
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_strdup" ". See online help for details."))
             char* __cdecl strdup(
                   char const* _String
        );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_strcmpi" ". See online help for details."))
             int __cdecl strcmpi(
               char const* _String1,
               char const* _String2
        );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_stricmp" ". See online help for details."))
             int __cdecl stricmp(
               char const* _String1,
               char const* _String2
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_strlwr" ". See online help for details."))
             char* __cdecl strlwr(
                  char* _String
        );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_strnicmp" ". See online help for details."))
             int __cdecl strnicmp(
                                   char const* _String1,
                                   char const* _String2,
                                   size_t _MaxCount
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_strnset" ". See online help for details."))
             char* __cdecl strnset(
                                     char* _String,
                                     int _Value,
                                     size_t _MaxCount
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_strrev" ". See online help for details."))
             char* __cdecl strrev(
                  char* _String
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_strset" ". See online help for details."))
    char* __cdecl strset(
                  char* _String,
                  int _Value);
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_strupr" ". See online help for details."))
             char* __cdecl strupr(
                  char* _String
        );
}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
using ::size_t __attribute__((__using_if_exists__));
using ::memcpy __attribute__((__using_if_exists__));
using ::memmove __attribute__((__using_if_exists__));
using ::strcpy __attribute__((__using_if_exists__));
using ::strncpy __attribute__((__using_if_exists__));
using ::strcat __attribute__((__using_if_exists__));
using ::strncat __attribute__((__using_if_exists__));
using ::memcmp __attribute__((__using_if_exists__));
using ::strcmp __attribute__((__using_if_exists__));
using ::strncmp __attribute__((__using_if_exists__));
using ::strcoll __attribute__((__using_if_exists__));
using ::strxfrm __attribute__((__using_if_exists__));
using ::memchr __attribute__((__using_if_exists__));
using ::strchr __attribute__((__using_if_exists__));
using ::strcspn __attribute__((__using_if_exists__));
using ::strpbrk __attribute__((__using_if_exists__));
using ::strrchr __attribute__((__using_if_exists__));
using ::strspn __attribute__((__using_if_exists__));
using ::strstr __attribute__((__using_if_exists__));
using ::strtok __attribute__((__using_if_exists__));
using ::memset __attribute__((__using_if_exists__));
using ::strerror __attribute__((__using_if_exists__));
using ::strlen __attribute__((__using_if_exists__));
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
enum float_round_style
{
    round_indeterminate = -1,
    round_toward_zero = 0,
    round_to_nearest = 1,
    round_toward_infinity = 2,
    round_toward_neg_infinity = 3
};
enum float_denorm_style
{
    denorm_indeterminate = -1,
    denorm_absent = 0,
    denorm_present = 1
};
template <class _Tp, bool = is_arithmetic<_Tp>::value>
class __libcpp_numeric_limits
{
protected:
    typedef _Tp type;
    static constexpr const bool is_specialized = false;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type min() noexcept {return type();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type max() noexcept {return type();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type lowest() noexcept {return type();}
    static constexpr const int digits = 0;
    static constexpr const int digits10 = 0;
    static constexpr const int max_digits10 = 0;
    static constexpr const bool is_signed = false;
    static constexpr const bool is_integer = false;
    static constexpr const bool is_exact = false;
    static constexpr const int radix = 0;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type epsilon() noexcept {return type();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type round_error() noexcept {return type();}
    static constexpr const int min_exponent = 0;
    static constexpr const int min_exponent10 = 0;
    static constexpr const int max_exponent = 0;
    static constexpr const int max_exponent10 = 0;
    static constexpr const bool has_infinity = false;
    static constexpr const bool has_quiet_NaN = false;
    static constexpr const bool has_signaling_NaN = false;
    static constexpr const float_denorm_style has_denorm = denorm_absent;
    static constexpr const bool has_denorm_loss = false;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type infinity() noexcept {return type();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type quiet_NaN() noexcept {return type();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type signaling_NaN() noexcept {return type();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type denorm_min() noexcept {return type();}
    static constexpr const bool is_iec559 = false;
    static constexpr const bool is_bounded = false;
    static constexpr const bool is_modulo = false;
    static constexpr const bool traps = false;
    static constexpr const bool tinyness_before = false;
    static constexpr const float_round_style round_style = round_toward_zero;
};
template <class _Tp, int __digits, bool _IsSigned>
struct __libcpp_compute_min
{
    static constexpr const _Tp value = _Tp(_Tp(1) << __digits);
};
template <class _Tp, int __digits>
struct __libcpp_compute_min<_Tp, __digits, false>
{
    static constexpr const _Tp value = _Tp(0);
};
template <class _Tp>
class __libcpp_numeric_limits<_Tp, true>
{
protected:
    typedef _Tp type;
    static constexpr const bool is_specialized = true;
    static constexpr const bool is_signed = type(-1) < type(0);
    static constexpr const int digits = static_cast<int>(sizeof(type) * 8 - is_signed);
    static constexpr const int digits10 = digits * 3 / 10;
    static constexpr const int max_digits10 = 0;
    static constexpr const type __min = __libcpp_compute_min<type, digits, is_signed>::value;
    static constexpr const type __max = is_signed ? type(type(~0) ^ __min) : type(~0);
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type min() noexcept {return __min;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type max() noexcept {return __max;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type lowest() noexcept {return min();}
    static constexpr const bool is_integer = true;
    static constexpr const bool is_exact = true;
    static constexpr const int radix = 2;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type epsilon() noexcept {return type(0);}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type round_error() noexcept {return type(0);}
    static constexpr const int min_exponent = 0;
    static constexpr const int min_exponent10 = 0;
    static constexpr const int max_exponent = 0;
    static constexpr const int max_exponent10 = 0;
    static constexpr const bool has_infinity = false;
    static constexpr const bool has_quiet_NaN = false;
    static constexpr const bool has_signaling_NaN = false;
    static constexpr const float_denorm_style has_denorm = denorm_absent;
    static constexpr const bool has_denorm_loss = false;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type infinity() noexcept {return type(0);}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type quiet_NaN() noexcept {return type(0);}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type signaling_NaN() noexcept {return type(0);}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type denorm_min() noexcept {return type(0);}
    static constexpr const bool is_iec559 = false;
    static constexpr const bool is_bounded = true;
    static constexpr const bool is_modulo = !std::is_signed<_Tp>::value;
    static constexpr const bool traps = true;
    static constexpr const bool tinyness_before = false;
    static constexpr const float_round_style round_style = round_toward_zero;
};
template <>
class __libcpp_numeric_limits<bool, true>
{
protected:
    typedef bool type;
    static constexpr const bool is_specialized = true;
    static constexpr const bool is_signed = false;
    static constexpr const int digits = 1;
    static constexpr const int digits10 = 0;
    static constexpr const int max_digits10 = 0;
    static constexpr const type __min = false;
    static constexpr const type __max = true;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type min() noexcept {return __min;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type max() noexcept {return __max;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type lowest() noexcept {return min();}
    static constexpr const bool is_integer = true;
    static constexpr const bool is_exact = true;
    static constexpr const int radix = 2;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type epsilon() noexcept {return type(0);}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type round_error() noexcept {return type(0);}
    static constexpr const int min_exponent = 0;
    static constexpr const int min_exponent10 = 0;
    static constexpr const int max_exponent = 0;
    static constexpr const int max_exponent10 = 0;
    static constexpr const bool has_infinity = false;
    static constexpr const bool has_quiet_NaN = false;
    static constexpr const bool has_signaling_NaN = false;
    static constexpr const float_denorm_style has_denorm = denorm_absent;
    static constexpr const bool has_denorm_loss = false;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type infinity() noexcept {return type(0);}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type quiet_NaN() noexcept {return type(0);}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type signaling_NaN() noexcept {return type(0);}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type denorm_min() noexcept {return type(0);}
    static constexpr const bool is_iec559 = false;
    static constexpr const bool is_bounded = true;
    static constexpr const bool is_modulo = false;
    static constexpr const bool traps = false;
    static constexpr const bool tinyness_before = false;
    static constexpr const float_round_style round_style = round_toward_zero;
};
template <>
class __libcpp_numeric_limits<float, true>
{
protected:
    typedef float type;
    static constexpr const bool is_specialized = true;
    static constexpr const bool is_signed = true;
    static constexpr const int digits = 24;
    static constexpr const int digits10 = 6;
    static constexpr const int max_digits10 = 2+(digits * 30103l)/100000l;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type min() noexcept {return 1.17549435e-38F;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type max() noexcept {return 3.40282347e+38F;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type lowest() noexcept {return -max();}
    static constexpr const bool is_integer = false;
    static constexpr const bool is_exact = false;
    static constexpr const int radix = 2;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type epsilon() noexcept {return 1.19209290e-7F;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type round_error() noexcept {return 0.5F;}
    static constexpr const int min_exponent = (-125);
    static constexpr const int min_exponent10 = (-37);
    static constexpr const int max_exponent = 128;
    static constexpr const int max_exponent10 = 38;
    static constexpr const bool has_infinity = true;
    static constexpr const bool has_quiet_NaN = true;
    static constexpr const bool has_signaling_NaN = true;
    static constexpr const float_denorm_style has_denorm = denorm_present;
    static constexpr const bool has_denorm_loss = false;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type infinity() noexcept {return __builtin_huge_valf();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type quiet_NaN() noexcept {return __builtin_nanf("");}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type signaling_NaN() noexcept {return __builtin_nansf("");}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type denorm_min() noexcept {return 1.40129846e-45F;}
    static constexpr const bool is_iec559 = true;
    static constexpr const bool is_bounded = true;
    static constexpr const bool is_modulo = false;
    static constexpr const bool traps = false;
    static constexpr const bool tinyness_before = false;
    static constexpr const float_round_style round_style = round_to_nearest;
};
template <>
class __libcpp_numeric_limits<double, true>
{
protected:
    typedef double type;
    static constexpr const bool is_specialized = true;
    static constexpr const bool is_signed = true;
    static constexpr const int digits = 53;
    static constexpr const int digits10 = 15;
    static constexpr const int max_digits10 = 2+(digits * 30103l)/100000l;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type min() noexcept {return 2.2250738585072014e-308;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type max() noexcept {return 1.7976931348623157e+308;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type lowest() noexcept {return -max();}
    static constexpr const bool is_integer = false;
    static constexpr const bool is_exact = false;
    static constexpr const int radix = 2;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type epsilon() noexcept {return 2.2204460492503131e-16;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type round_error() noexcept {return 0.5;}
    static constexpr const int min_exponent = (-1021);
    static constexpr const int min_exponent10 = (-307);
    static constexpr const int max_exponent = 1024;
    static constexpr const int max_exponent10 = 308;
    static constexpr const bool has_infinity = true;
    static constexpr const bool has_quiet_NaN = true;
    static constexpr const bool has_signaling_NaN = true;
    static constexpr const float_denorm_style has_denorm = denorm_present;
    static constexpr const bool has_denorm_loss = false;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type infinity() noexcept {return __builtin_huge_val();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type quiet_NaN() noexcept {return __builtin_nan("");}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type signaling_NaN() noexcept {return __builtin_nans("");}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type denorm_min() noexcept {return 4.9406564584124654e-324;}
    static constexpr const bool is_iec559 = true;
    static constexpr const bool is_bounded = true;
    static constexpr const bool is_modulo = false;
    static constexpr const bool traps = false;
    static constexpr const bool tinyness_before = false;
    static constexpr const float_round_style round_style = round_to_nearest;
};
template <>
class __libcpp_numeric_limits<long double, true>
{
protected:
    typedef long double type;
    static constexpr const bool is_specialized = true;
    static constexpr const bool is_signed = true;
    static constexpr const int digits = 53;
    static constexpr const int digits10 = 15;
    static constexpr const int max_digits10 = 2+(digits * 30103l)/100000l;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type min() noexcept {return 2.2250738585072014e-308L;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type max() noexcept {return 1.7976931348623157e+308L;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type lowest() noexcept {return -max();}
    static constexpr const bool is_integer = false;
    static constexpr const bool is_exact = false;
    static constexpr const int radix = 2;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type epsilon() noexcept {return 2.2204460492503131e-16L;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type round_error() noexcept {return 0.5L;}
    static constexpr const int min_exponent = (-1021);
    static constexpr const int min_exponent10 = (-307);
    static constexpr const int max_exponent = 1024;
    static constexpr const int max_exponent10 = 308;
    static constexpr const bool has_infinity = true;
    static constexpr const bool has_quiet_NaN = true;
    static constexpr const bool has_signaling_NaN = true;
    static constexpr const float_denorm_style has_denorm = denorm_present;
    static constexpr const bool has_denorm_loss = false;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type infinity() noexcept {return __builtin_huge_vall();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type quiet_NaN() noexcept {return __builtin_nanl("");}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type signaling_NaN() noexcept {return __builtin_nansl("");}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type denorm_min() noexcept {return 4.9406564584124654e-324L;}
    static constexpr const bool is_iec559 = true;
    static constexpr const bool is_bounded = true;
    static constexpr const bool is_modulo = false;
    static constexpr const bool traps = false;
    static constexpr const bool tinyness_before = false;
    static constexpr const float_round_style round_style = round_to_nearest;
};
template <class _Tp>
class numeric_limits
    : private __libcpp_numeric_limits<__remove_cv_t<_Tp> >
{
    typedef __libcpp_numeric_limits<__remove_cv_t<_Tp> > __base;
    typedef typename __base::type type;
public:
    static constexpr const bool is_specialized = __base::is_specialized;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type min() noexcept {return __base::min();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type max() noexcept {return __base::max();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type lowest() noexcept {return __base::lowest();}
    static constexpr const int digits = __base::digits;
    static constexpr const int digits10 = __base::digits10;
    static constexpr const int max_digits10 = __base::max_digits10;
    static constexpr const bool is_signed = __base::is_signed;
    static constexpr const bool is_integer = __base::is_integer;
    static constexpr const bool is_exact = __base::is_exact;
    static constexpr const int radix = __base::radix;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type epsilon() noexcept {return __base::epsilon();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type round_error() noexcept {return __base::round_error();}
    static constexpr const int min_exponent = __base::min_exponent;
    static constexpr const int min_exponent10 = __base::min_exponent10;
    static constexpr const int max_exponent = __base::max_exponent;
    static constexpr const int max_exponent10 = __base::max_exponent10;
    static constexpr const bool has_infinity = __base::has_infinity;
    static constexpr const bool has_quiet_NaN = __base::has_quiet_NaN;
    static constexpr const bool has_signaling_NaN = __base::has_signaling_NaN;
    static constexpr const float_denorm_style has_denorm = __base::has_denorm;
    static constexpr const bool has_denorm_loss = __base::has_denorm_loss;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type infinity() noexcept {return __base::infinity();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type quiet_NaN() noexcept {return __base::quiet_NaN();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type signaling_NaN() noexcept {return __base::signaling_NaN();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type denorm_min() noexcept {return __base::denorm_min();}
    static constexpr const bool is_iec559 = __base::is_iec559;
    static constexpr const bool is_bounded = __base::is_bounded;
    static constexpr const bool is_modulo = __base::is_modulo;
    static constexpr const bool traps = __base::traps;
    static constexpr const bool tinyness_before = __base::tinyness_before;
    static constexpr const float_round_style round_style = __base::round_style;
};
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::is_specialized;
template <class _Tp>
    constexpr const int numeric_limits<_Tp>::digits;
template <class _Tp>
    constexpr const int numeric_limits<_Tp>::digits10;
template <class _Tp>
    constexpr const int numeric_limits<_Tp>::max_digits10;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::is_signed;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::is_integer;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::is_exact;
template <class _Tp>
    constexpr const int numeric_limits<_Tp>::radix;
template <class _Tp>
    constexpr const int numeric_limits<_Tp>::min_exponent;
template <class _Tp>
    constexpr const int numeric_limits<_Tp>::min_exponent10;
template <class _Tp>
    constexpr const int numeric_limits<_Tp>::max_exponent;
template <class _Tp>
    constexpr const int numeric_limits<_Tp>::max_exponent10;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::has_infinity;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::has_quiet_NaN;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::has_signaling_NaN;
template <class _Tp>
    constexpr const float_denorm_style numeric_limits<_Tp>::has_denorm;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::has_denorm_loss;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::is_iec559;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::is_bounded;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::is_modulo;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::traps;
template <class _Tp>
    constexpr const bool numeric_limits<_Tp>::tinyness_before;
template <class _Tp>
    constexpr const float_round_style numeric_limits<_Tp>::round_style;
template <class _Tp>
class numeric_limits<const _Tp>
    : private numeric_limits<_Tp>
{
    typedef numeric_limits<_Tp> __base;
    typedef _Tp type;
public:
    static constexpr const bool is_specialized = __base::is_specialized;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type min() noexcept {return __base::min();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type max() noexcept {return __base::max();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type lowest() noexcept {return __base::lowest();}
    static constexpr const int digits = __base::digits;
    static constexpr const int digits10 = __base::digits10;
    static constexpr const int max_digits10 = __base::max_digits10;
    static constexpr const bool is_signed = __base::is_signed;
    static constexpr const bool is_integer = __base::is_integer;
    static constexpr const bool is_exact = __base::is_exact;
    static constexpr const int radix = __base::radix;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type epsilon() noexcept {return __base::epsilon();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type round_error() noexcept {return __base::round_error();}
    static constexpr const int min_exponent = __base::min_exponent;
    static constexpr const int min_exponent10 = __base::min_exponent10;
    static constexpr const int max_exponent = __base::max_exponent;
    static constexpr const int max_exponent10 = __base::max_exponent10;
    static constexpr const bool has_infinity = __base::has_infinity;
    static constexpr const bool has_quiet_NaN = __base::has_quiet_NaN;
    static constexpr const bool has_signaling_NaN = __base::has_signaling_NaN;
    static constexpr const float_denorm_style has_denorm = __base::has_denorm;
    static constexpr const bool has_denorm_loss = __base::has_denorm_loss;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type infinity() noexcept {return __base::infinity();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type quiet_NaN() noexcept {return __base::quiet_NaN();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type signaling_NaN() noexcept {return __base::signaling_NaN();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type denorm_min() noexcept {return __base::denorm_min();}
    static constexpr const bool is_iec559 = __base::is_iec559;
    static constexpr const bool is_bounded = __base::is_bounded;
    static constexpr const bool is_modulo = __base::is_modulo;
    static constexpr const bool traps = __base::traps;
    static constexpr const bool tinyness_before = __base::tinyness_before;
    static constexpr const float_round_style round_style = __base::round_style;
};
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::is_specialized;
template <class _Tp>
    constexpr const int numeric_limits<const _Tp>::digits;
template <class _Tp>
    constexpr const int numeric_limits<const _Tp>::digits10;
template <class _Tp>
    constexpr const int numeric_limits<const _Tp>::max_digits10;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::is_signed;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::is_integer;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::is_exact;
template <class _Tp>
    constexpr const int numeric_limits<const _Tp>::radix;
template <class _Tp>
    constexpr const int numeric_limits<const _Tp>::min_exponent;
template <class _Tp>
    constexpr const int numeric_limits<const _Tp>::min_exponent10;
template <class _Tp>
    constexpr const int numeric_limits<const _Tp>::max_exponent;
template <class _Tp>
    constexpr const int numeric_limits<const _Tp>::max_exponent10;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::has_infinity;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::has_quiet_NaN;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::has_signaling_NaN;
template <class _Tp>
    constexpr const float_denorm_style numeric_limits<const _Tp>::has_denorm;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::has_denorm_loss;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::is_iec559;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::is_bounded;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::is_modulo;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::traps;
template <class _Tp>
    constexpr const bool numeric_limits<const _Tp>::tinyness_before;
template <class _Tp>
    constexpr const float_round_style numeric_limits<const _Tp>::round_style;
template <class _Tp>
class numeric_limits<volatile _Tp>
    : private numeric_limits<_Tp>
{
    typedef numeric_limits<_Tp> __base;
    typedef _Tp type;
public:
    static constexpr const bool is_specialized = __base::is_specialized;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type min() noexcept {return __base::min();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type max() noexcept {return __base::max();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type lowest() noexcept {return __base::lowest();}
    static constexpr const int digits = __base::digits;
    static constexpr const int digits10 = __base::digits10;
    static constexpr const int max_digits10 = __base::max_digits10;
    static constexpr const bool is_signed = __base::is_signed;
    static constexpr const bool is_integer = __base::is_integer;
    static constexpr const bool is_exact = __base::is_exact;
    static constexpr const int radix = __base::radix;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type epsilon() noexcept {return __base::epsilon();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type round_error() noexcept {return __base::round_error();}
    static constexpr const int min_exponent = __base::min_exponent;
    static constexpr const int min_exponent10 = __base::min_exponent10;
    static constexpr const int max_exponent = __base::max_exponent;
    static constexpr const int max_exponent10 = __base::max_exponent10;
    static constexpr const bool has_infinity = __base::has_infinity;
    static constexpr const bool has_quiet_NaN = __base::has_quiet_NaN;
    static constexpr const bool has_signaling_NaN = __base::has_signaling_NaN;
    static constexpr const float_denorm_style has_denorm = __base::has_denorm;
    static constexpr const bool has_denorm_loss = __base::has_denorm_loss;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type infinity() noexcept {return __base::infinity();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type quiet_NaN() noexcept {return __base::quiet_NaN();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type signaling_NaN() noexcept {return __base::signaling_NaN();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type denorm_min() noexcept {return __base::denorm_min();}
    static constexpr const bool is_iec559 = __base::is_iec559;
    static constexpr const bool is_bounded = __base::is_bounded;
    static constexpr const bool is_modulo = __base::is_modulo;
    static constexpr const bool traps = __base::traps;
    static constexpr const bool tinyness_before = __base::tinyness_before;
    static constexpr const float_round_style round_style = __base::round_style;
};
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::is_specialized;
template <class _Tp>
    constexpr const int numeric_limits<volatile _Tp>::digits;
template <class _Tp>
    constexpr const int numeric_limits<volatile _Tp>::digits10;
template <class _Tp>
    constexpr const int numeric_limits<volatile _Tp>::max_digits10;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::is_signed;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::is_integer;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::is_exact;
template <class _Tp>
    constexpr const int numeric_limits<volatile _Tp>::radix;
template <class _Tp>
    constexpr const int numeric_limits<volatile _Tp>::min_exponent;
template <class _Tp>
    constexpr const int numeric_limits<volatile _Tp>::min_exponent10;
template <class _Tp>
    constexpr const int numeric_limits<volatile _Tp>::max_exponent;
template <class _Tp>
    constexpr const int numeric_limits<volatile _Tp>::max_exponent10;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::has_infinity;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::has_quiet_NaN;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::has_signaling_NaN;
template <class _Tp>
    constexpr const float_denorm_style numeric_limits<volatile _Tp>::has_denorm;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::has_denorm_loss;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::is_iec559;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::is_bounded;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::is_modulo;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::traps;
template <class _Tp>
    constexpr const bool numeric_limits<volatile _Tp>::tinyness_before;
template <class _Tp>
    constexpr const float_round_style numeric_limits<volatile _Tp>::round_style;
template <class _Tp>
class numeric_limits<const volatile _Tp>
    : private numeric_limits<_Tp>
{
    typedef numeric_limits<_Tp> __base;
    typedef _Tp type;
public:
    static constexpr const bool is_specialized = __base::is_specialized;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type min() noexcept {return __base::min();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type max() noexcept {return __base::max();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type lowest() noexcept {return __base::lowest();}
    static constexpr const int digits = __base::digits;
    static constexpr const int digits10 = __base::digits10;
    static constexpr const int max_digits10 = __base::max_digits10;
    static constexpr const bool is_signed = __base::is_signed;
    static constexpr const bool is_integer = __base::is_integer;
    static constexpr const bool is_exact = __base::is_exact;
    static constexpr const int radix = __base::radix;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type epsilon() noexcept {return __base::epsilon();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type round_error() noexcept {return __base::round_error();}
    static constexpr const int min_exponent = __base::min_exponent;
    static constexpr const int min_exponent10 = __base::min_exponent10;
    static constexpr const int max_exponent = __base::max_exponent;
    static constexpr const int max_exponent10 = __base::max_exponent10;
    static constexpr const bool has_infinity = __base::has_infinity;
    static constexpr const bool has_quiet_NaN = __base::has_quiet_NaN;
    static constexpr const bool has_signaling_NaN = __base::has_signaling_NaN;
    static constexpr const float_denorm_style has_denorm = __base::has_denorm;
    static constexpr const bool has_denorm_loss = __base::has_denorm_loss;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type infinity() noexcept {return __base::infinity();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type quiet_NaN() noexcept {return __base::quiet_NaN();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type signaling_NaN() noexcept {return __base::signaling_NaN();}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr type denorm_min() noexcept {return __base::denorm_min();}
    static constexpr const bool is_iec559 = __base::is_iec559;
    static constexpr const bool is_bounded = __base::is_bounded;
    static constexpr const bool is_modulo = __base::is_modulo;
    static constexpr const bool traps = __base::traps;
    static constexpr const bool tinyness_before = __base::tinyness_before;
    static constexpr const float_round_style round_style = __base::round_style;
};
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::is_specialized;
template <class _Tp>
    constexpr const int numeric_limits<const volatile _Tp>::digits;
template <class _Tp>
    constexpr const int numeric_limits<const volatile _Tp>::digits10;
template <class _Tp>
    constexpr const int numeric_limits<const volatile _Tp>::max_digits10;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::is_signed;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::is_integer;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::is_exact;
template <class _Tp>
    constexpr const int numeric_limits<const volatile _Tp>::radix;
template <class _Tp>
    constexpr const int numeric_limits<const volatile _Tp>::min_exponent;
template <class _Tp>
    constexpr const int numeric_limits<const volatile _Tp>::min_exponent10;
template <class _Tp>
    constexpr const int numeric_limits<const volatile _Tp>::max_exponent;
template <class _Tp>
    constexpr const int numeric_limits<const volatile _Tp>::max_exponent10;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::has_infinity;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::has_quiet_NaN;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::has_signaling_NaN;
template <class _Tp>
    constexpr const float_denorm_style numeric_limits<const volatile _Tp>::has_denorm;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::has_denorm_loss;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::is_iec559;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::is_bounded;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::is_modulo;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::traps;
template <class _Tp>
    constexpr const bool numeric_limits<const volatile _Tp>::tinyness_before;
template <class _Tp>
    constexpr const float_round_style numeric_limits<const volatile _Tp>::round_style;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Size>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
_Size
__loadword(const void* __p)
{
    _Size __r;
    std::memcpy(&__r, __p, sizeof(__r));
    return __r;
}
template <class _Size, size_t = sizeof(_Size)*8>
struct __murmur2_or_cityhash;
template <class _Size>
struct __murmur2_or_cityhash<_Size, 32>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __attribute__((__no_sanitize__("unsigned-integer-overflow")))
    _Size operator()(const void* __key, _Size __len) const {
      const _Size __m = 0x5bd1e995;
      const _Size __r = 24;
      _Size __h = __len;
      const unsigned char* __data = static_cast<const unsigned char*>(__key);
      for (; __len >= 4; __data += 4, __len -= 4)
      {
          _Size __k = std::__loadword<_Size>(__data);
          __k *= __m;
          __k ^= __k >> __r;
          __k *= __m;
          __h *= __m;
          __h ^= __k;
      }
      switch (__len)
      {
      case 3:
          __h ^= static_cast<_Size>(__data[2] << 16);
          [[fallthrough]];
      case 2:
          __h ^= static_cast<_Size>(__data[1] << 8);
          [[fallthrough]];
      case 1:
          __h ^= __data[0];
          __h *= __m;
      }
      __h ^= __h >> 13;
      __h *= __m;
      __h ^= __h >> 15;
      return __h;
    }
};
template <class _Size>
struct __murmur2_or_cityhash<_Size, 64>
{
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __attribute__((__no_sanitize__("unsigned-integer-overflow")))
  _Size operator()(const void* __key, _Size __len) const {
    const char* __s = static_cast<const char*>(__key);
    if (__len <= 32) {
        if (__len <= 16) {
        return __hash_len_0_to_16(__s, __len);
        } else {
        return __hash_len_17_to_32(__s, __len);
        }
    } else if (__len <= 64) {
        return __hash_len_33_to_64(__s, __len);
    }
    _Size __x = std::__loadword<_Size>(__s + __len - 40);
    _Size __y = std::__loadword<_Size>(__s + __len - 16) +
                std::__loadword<_Size>(__s + __len - 56);
    _Size __z = __hash_len_16(std::__loadword<_Size>(__s + __len - 48) + __len,
                            std::__loadword<_Size>(__s + __len - 24));
    pair<_Size, _Size> __v = __weak_hash_len_32_with_seeds(__s + __len - 64, __len, __z);
    pair<_Size, _Size> __w = __weak_hash_len_32_with_seeds(__s + __len - 32, __y + __k1, __x);
    __x = __x * __k1 + std::__loadword<_Size>(__s);
    __len = (__len - 1) & ~static_cast<_Size>(63);
    do {
        __x = __rotate(__x + __y + __v.first + std::__loadword<_Size>(__s + 8), 37) * __k1;
        __y = __rotate(__y + __v.second + std::__loadword<_Size>(__s + 48), 42) * __k1;
        __x ^= __w.second;
        __y += __v.first + std::__loadword<_Size>(__s + 40);
        __z = __rotate(__z + __w.first, 33) * __k1;
        __v = __weak_hash_len_32_with_seeds(__s, __v.second * __k1, __x + __w.first);
        __w = __weak_hash_len_32_with_seeds(__s + 32, __z + __w.second,
                                            __y + std::__loadword<_Size>(__s + 16));
        std::swap(__z, __x);
        __s += 64;
        __len -= 64;
    } while (__len != 0);
    return __hash_len_16(
        __hash_len_16(__v.first, __w.first) + __shift_mix(__y) * __k1 + __z,
        __hash_len_16(__v.second, __w.second) + __x);
  }
  private:
    static const _Size __k0 = 0xc3a5c85c97cb3127ULL;
    static const _Size __k1 = 0xb492b66fbe98f273ULL;
    static const _Size __k2 = 0x9ae16a3b2f90404fULL;
    static const _Size __k3 = 0xc949d7c7509e6557ULL;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static _Size __rotate(_Size __val, int __shift) {
    return __shift == 0 ? __val : ((__val >> __shift) | (__val << (64 - __shift)));
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static _Size __rotate_by_at_least_1(_Size __val, int __shift) {
    return (__val >> __shift) | (__val << (64 - __shift));
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static _Size __shift_mix(_Size __val) {
    return __val ^ (__val >> 47);
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __attribute__((__no_sanitize__("unsigned-integer-overflow")))
  static _Size __hash_len_16(_Size __u, _Size __v) {
    const _Size __mul = 0x9ddfea08eb382d69ULL;
    _Size __a = (__u ^ __v) * __mul;
    __a ^= (__a >> 47);
    _Size __b = (__v ^ __a) * __mul;
    __b ^= (__b >> 47);
    __b *= __mul;
    return __b;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __attribute__((__no_sanitize__("unsigned-integer-overflow")))
  static _Size __hash_len_0_to_16(const char* __s, _Size __len) {
    if (__len > 8) {
      const _Size __a = std::__loadword<_Size>(__s);
      const _Size __b = std::__loadword<_Size>(__s + __len - 8);
      return __hash_len_16(__a, __rotate_by_at_least_1(__b + __len, __len)) ^ __b;
    }
    if (__len >= 4) {
      const uint32_t __a = std::__loadword<uint32_t>(__s);
      const uint32_t __b = std::__loadword<uint32_t>(__s + __len - 4);
      return __hash_len_16(__len + (static_cast<_Size>(__a) << 3), __b);
    }
    if (__len > 0) {
      const unsigned char __a = static_cast<unsigned char>(__s[0]);
      const unsigned char __b = static_cast<unsigned char>(__s[__len >> 1]);
      const unsigned char __c = static_cast<unsigned char>(__s[__len - 1]);
      const uint32_t __y = static_cast<uint32_t>(__a) +
                           (static_cast<uint32_t>(__b) << 8);
      const uint32_t __z = __len + (static_cast<uint32_t>(__c) << 2);
      return __shift_mix(__y * __k2 ^ __z * __k3) * __k2;
    }
    return __k2;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __attribute__((__no_sanitize__("unsigned-integer-overflow")))
  static _Size __hash_len_17_to_32(const char *__s, _Size __len) {
    const _Size __a = std::__loadword<_Size>(__s) * __k1;
    const _Size __b = std::__loadword<_Size>(__s + 8);
    const _Size __c = std::__loadword<_Size>(__s + __len - 8) * __k2;
    const _Size __d = std::__loadword<_Size>(__s + __len - 16) * __k0;
    return __hash_len_16(__rotate(__a - __b, 43) + __rotate(__c, 30) + __d,
                         __a + __rotate(__b ^ __k3, 20) - __c + __len);
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __attribute__((__no_sanitize__("unsigned-integer-overflow")))
  static pair<_Size, _Size> __weak_hash_len_32_with_seeds(
      _Size __w, _Size __x, _Size __y, _Size __z, _Size __a, _Size __b)
  {
    __a += __w;
    __b = __rotate(__b + __a + __z, 21);
    const _Size __c = __a;
    __a += __x;
    __a += __y;
    __b += __rotate(__a, 44);
    return pair<_Size, _Size>(__a + __z, __b + __c);
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __attribute__((__no_sanitize__("unsigned-integer-overflow")))
  static pair<_Size, _Size> __weak_hash_len_32_with_seeds(
      const char* __s, _Size __a, _Size __b)
  {
    return __weak_hash_len_32_with_seeds(std::__loadword<_Size>(__s),
                                         std::__loadword<_Size>(__s + 8),
                                         std::__loadword<_Size>(__s + 16),
                                         std::__loadword<_Size>(__s + 24),
                                         __a,
                                         __b);
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __attribute__((__no_sanitize__("unsigned-integer-overflow")))
  static _Size __hash_len_33_to_64(const char *__s, size_t __len) {
    _Size __z = std::__loadword<_Size>(__s + 24);
    _Size __a = std::__loadword<_Size>(__s) +
                (__len + std::__loadword<_Size>(__s + __len - 16)) * __k0;
    _Size __b = __rotate(__a + __z, 52);
    _Size __c = __rotate(__a, 37);
    __a += std::__loadword<_Size>(__s + 8);
    __c += __rotate(__a, 7);
    __a += std::__loadword<_Size>(__s + 16);
    _Size __vf = __a + __z;
    _Size __vs = __b + __rotate(__a, 31) + __c;
    __a = std::__loadword<_Size>(__s + 16) + std::__loadword<_Size>(__s + __len - 32);
    __z += std::__loadword<_Size>(__s + __len - 8);
    __b = __rotate(__a + __z, 52);
    __c = __rotate(__a, 37);
    __a += std::__loadword<_Size>(__s + __len - 24);
    __c += __rotate(__a, 7);
    __a += std::__loadword<_Size>(__s + __len - 16);
    _Size __wf = __a + __z;
    _Size __ws = __b + __rotate(__a, 31) + __c;
    _Size __r = __shift_mix((__vf + __ws) * __k2 + (__wf + __vs) * __k0);
    return __shift_mix(__r * __k0 + __vs) * __k2;
  }
};
template <class _Tp, size_t = sizeof(_Tp) / sizeof(size_t)>
struct __scalar_hash;
template <class _Tp>
struct __scalar_hash<_Tp, 0>
    : public __unary_function<_Tp, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(_Tp __v) const noexcept
    {
        union
        {
            _Tp __t;
            size_t __a;
        } __u;
        __u.__a = 0;
        __u.__t = __v;
        return __u.__a;
    }
};
template <class _Tp>
struct __scalar_hash<_Tp, 1>
    : public __unary_function<_Tp, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(_Tp __v) const noexcept
    {
        union
        {
            _Tp __t;
            size_t __a;
        } __u;
        __u.__t = __v;
        return __u.__a;
    }
};
template <class _Tp>
struct __scalar_hash<_Tp, 2>
    : public __unary_function<_Tp, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(_Tp __v) const noexcept
    {
        union
        {
            _Tp __t;
            struct
            {
                size_t __a;
                size_t __b;
            } __s;
        } __u;
        __u.__t = __v;
        return __murmur2_or_cityhash<size_t>()(&__u, sizeof(__u));
    }
};
template <class _Tp>
struct __scalar_hash<_Tp, 3>
    : public __unary_function<_Tp, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(_Tp __v) const noexcept
    {
        union
        {
            _Tp __t;
            struct
            {
                size_t __a;
                size_t __b;
                size_t __c;
            } __s;
        } __u;
        __u.__t = __v;
        return __murmur2_or_cityhash<size_t>()(&__u, sizeof(__u));
    }
};
template <class _Tp>
struct __scalar_hash<_Tp, 4>
    : public __unary_function<_Tp, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(_Tp __v) const noexcept
    {
        union
        {
            _Tp __t;
            struct
            {
                size_t __a;
                size_t __b;
                size_t __c;
                size_t __d;
            } __s;
        } __u;
        __u.__t = __v;
        return __murmur2_or_cityhash<size_t>()(&__u, sizeof(__u));
    }
};
struct _PairT {
  size_t first;
  size_t second;
};
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
inline size_t __hash_combine(size_t __lhs, size_t __rhs) noexcept {
    typedef __scalar_hash<_PairT> _HashT;
    const _PairT __p = {__lhs, __rhs};
    return _HashT()(__p);
}
template<class _Tp>
struct hash<_Tp*>
    : public __unary_function<_Tp*, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(_Tp* __v) const noexcept
    {
        union
        {
            _Tp* __t;
            size_t __a;
        } __u;
        __u.__t = __v;
        return __murmur2_or_cityhash<size_t>()(&__u, sizeof(__u));
    }
};
template <>
struct hash<bool>
    : public __unary_function<bool, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(bool __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<char>
    : public __unary_function<char, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(char __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<signed char>
    : public __unary_function<signed char, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(signed char __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<unsigned char>
    : public __unary_function<unsigned char, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(unsigned char __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<char8_t>
    : public __unary_function<char8_t, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(char8_t __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<char16_t>
    : public __unary_function<char16_t, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(char16_t __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<char32_t>
    : public __unary_function<char32_t, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(char32_t __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<wchar_t>
    : public __unary_function<wchar_t, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(wchar_t __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<short>
    : public __unary_function<short, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(short __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<unsigned short>
    : public __unary_function<unsigned short, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(unsigned short __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<int>
    : public __unary_function<int, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(int __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<unsigned int>
    : public __unary_function<unsigned int, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(unsigned int __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<long>
    : public __unary_function<long, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(long __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<unsigned long>
    : public __unary_function<unsigned long, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(unsigned long __v) const noexcept {return static_cast<size_t>(__v);}
};
template <>
struct hash<long long>
    : public __scalar_hash<long long>
{
};
template <>
struct hash<unsigned long long>
    : public __scalar_hash<unsigned long long>
{
};
template <>
struct hash<float>
    : public __scalar_hash<float>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(float __v) const noexcept
    {
       if (__v == 0.0f)
           return 0;
        return __scalar_hash<float>::operator()(__v);
    }
};
template <>
struct hash<double>
    : public __scalar_hash<double>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(double __v) const noexcept
    {
       if (__v == 0.0)
           return 0;
        return __scalar_hash<double>::operator()(__v);
    }
};
template <>
struct hash<long double>
    : public __scalar_hash<long double>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(long double __v) const noexcept
    {
        if (__v == 0.0L)
            return 0;
        union
        {
            long double __t;
            struct
            {
                size_t __a;
                size_t __b;
            } __s;
        } __u;
        __u.__s.__a = 0;
        __u.__s.__b = 0;
        __u.__t = __v;
        return __u.__s.__a ^ __u.__s.__b;
    }
};
template <class _Tp, bool = is_enum<_Tp>::value>
struct __enum_hash
    : public __unary_function<_Tp, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(_Tp __v) const noexcept
    {
        typedef typename underlying_type<_Tp>::type type;
        return hash<type>()(static_cast<type>(__v));
    }
};
template <class _Tp>
struct __enum_hash<_Tp, false> {
    __enum_hash() = delete;
    __enum_hash(__enum_hash const&) = delete;
    __enum_hash& operator=(__enum_hash const&) = delete;
};
template <class _Tp>
struct hash : public __enum_hash<_Tp>
{
};
template <>
struct hash<nullptr_t>
  : public __unary_function<nullptr_t, size_t>
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    size_t operator()(nullptr_t) const noexcept {
        return 662607004ull;
    }
};
template <class _Key, class _Hash>
using __check_hash_requirements __attribute__((__nodebug__)) = integral_constant<bool,
    is_copy_constructible<_Hash>::value &&
    is_move_constructible<_Hash>::value &&
    __invokable_r<size_t, _Hash, _Key const&>::value
>;
template <class _Key, class _Hash = hash<_Key> >
using __has_enabled_hash __attribute__((__nodebug__)) = integral_constant<bool,
    __check_hash_requirements<_Key, _Hash>::value &&
    is_default_constructible<_Hash>::value
>;
template <class _Type, class>
using __enable_hash_helper_imp __attribute__((__nodebug__)) = _Type;
template <class _Type, class ..._Keys>
using __enable_hash_helper __attribute__((__nodebug__)) = __enable_hash_helper_imp<_Type,
  typename enable_if<__all<__has_enabled_hash<_Keys>::value...>::value>::type
>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Arg1, class _Arg2, class _Result> struct __binary_function_keep_layout_base {
};
template <class _Arg1, class _Arg2, class _Result>
using __binary_function = __binary_function_keep_layout_base<_Arg1, _Arg2, _Result>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Pred, class _Lhs, class _Rhs>
struct __is_trivial_plus_operation : false_type {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Pred, class _Lhs, class _Rhs>
struct __is_trivial_equality_predicate : false_type {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp = void>
struct plus
    : __binary_function<_Tp, _Tp, _Tp>
{
    typedef _Tp __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    _Tp operator()(const _Tp& __x, const _Tp& __y) const
        {return __x + __y;}
};
template <class... _Tag> [[maybe_unused]] plus(typename _Tag::__allow_ctad...)->plus<_Tag...>;
template <class _Tp>
struct __is_trivial_plus_operation<plus<_Tp>, _Tp, _Tp> : true_type {};
template <class _Tp, class _Up>
struct __is_trivial_plus_operation<plus<>, _Tp, _Up> : true_type {};
template <>
struct plus<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) + std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) + std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) + std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct minus
    : __binary_function<_Tp, _Tp, _Tp>
{
    typedef _Tp __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    _Tp operator()(const _Tp& __x, const _Tp& __y) const
        {return __x - __y;}
};
template <class... _Tag> [[maybe_unused]] minus(typename _Tag::__allow_ctad...)->minus<_Tag...>;
template <>
struct minus<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) - std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) - std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) - std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct multiplies
    : __binary_function<_Tp, _Tp, _Tp>
{
    typedef _Tp __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    _Tp operator()(const _Tp& __x, const _Tp& __y) const
        {return __x * __y;}
};
template <class... _Tag> [[maybe_unused]] multiplies(typename _Tag::__allow_ctad...)->multiplies<_Tag...>;
template <>
struct multiplies<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) * std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) * std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) * std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct divides
    : __binary_function<_Tp, _Tp, _Tp>
{
    typedef _Tp __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    _Tp operator()(const _Tp& __x, const _Tp& __y) const
        {return __x / __y;}
};
template <class... _Tag> [[maybe_unused]] divides(typename _Tag::__allow_ctad...)->divides<_Tag...>;
template <>
struct divides<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) / std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) / std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) / std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct modulus
    : __binary_function<_Tp, _Tp, _Tp>
{
    typedef _Tp __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    _Tp operator()(const _Tp& __x, const _Tp& __y) const
        {return __x % __y;}
};
template <class... _Tag> [[maybe_unused]] modulus(typename _Tag::__allow_ctad...)->modulus<_Tag...>;
template <>
struct modulus<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) % std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) % std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) % std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct negate
    : __unary_function<_Tp, _Tp>
{
    typedef _Tp __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    _Tp operator()(const _Tp& __x) const
        {return -__x;}
};
template <class... _Tag> [[maybe_unused]] negate(typename _Tag::__allow_ctad...)->negate<_Tag...>;
template <>
struct negate<void>
{
    template <class _Tp>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_Tp&& __x) const
        noexcept(noexcept(- std::forward<_Tp>(__x)))
        -> decltype( - std::forward<_Tp>(__x))
        { return - std::forward<_Tp>(__x); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct bit_and
    : __binary_function<_Tp, _Tp, _Tp>
{
    typedef _Tp __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    _Tp operator()(const _Tp& __x, const _Tp& __y) const
        {return __x & __y;}
};
template <class... _Tag> [[maybe_unused]] bit_and(typename _Tag::__allow_ctad...)->bit_and<_Tag...>;
template <>
struct bit_and<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) & std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) & std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) & std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct bit_not
    : __unary_function<_Tp, _Tp>
{
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    _Tp operator()(const _Tp& __x) const
        {return ~__x;}
};
template <class... _Tag> [[maybe_unused]] bit_not(typename _Tag::__allow_ctad...)->bit_not<_Tag...>;
template <>
struct bit_not<void>
{
    template <class _Tp>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_Tp&& __x) const
        noexcept(noexcept(~std::forward<_Tp>(__x)))
        -> decltype( ~std::forward<_Tp>(__x))
        { return ~std::forward<_Tp>(__x); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct bit_or
    : __binary_function<_Tp, _Tp, _Tp>
{
    typedef _Tp __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    _Tp operator()(const _Tp& __x, const _Tp& __y) const
        {return __x | __y;}
};
template <class... _Tag> [[maybe_unused]] bit_or(typename _Tag::__allow_ctad...)->bit_or<_Tag...>;
template <>
struct bit_or<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) | std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) | std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) | std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct bit_xor
    : __binary_function<_Tp, _Tp, _Tp>
{
    typedef _Tp __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    _Tp operator()(const _Tp& __x, const _Tp& __y) const
        {return __x ^ __y;}
};
template <class... _Tag> [[maybe_unused]] bit_xor(typename _Tag::__allow_ctad...)->bit_xor<_Tag...>;
template <>
struct bit_xor<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) ^ std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) ^ std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) ^ std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct equal_to
    : __binary_function<_Tp, _Tp, bool>
{
    typedef bool __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    bool operator()(const _Tp& __x, const _Tp& __y) const
        {return __x == __y;}
};
template <class... _Tag> [[maybe_unused]] equal_to(typename _Tag::__allow_ctad...)->equal_to<_Tag...>;
template <>
struct equal_to<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) == std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) == std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) == std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp>
struct __is_trivial_equality_predicate<equal_to<_Tp>, _Tp, _Tp> : true_type {};
template <class _Tp>
struct __is_trivial_equality_predicate<equal_to<>, _Tp, _Tp> : true_type {};
template <class _Tp = void>
struct not_equal_to
    : __binary_function<_Tp, _Tp, bool>
{
    typedef bool __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    bool operator()(const _Tp& __x, const _Tp& __y) const
        {return __x != __y;}
};
template <class... _Tag> [[maybe_unused]] not_equal_to(typename _Tag::__allow_ctad...)->not_equal_to<_Tag...>;
template <>
struct not_equal_to<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) != std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) != std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) != std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct less
    : __binary_function<_Tp, _Tp, bool>
{
    typedef bool __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    bool operator()(const _Tp& __x, const _Tp& __y) const
        {return __x < __y;}
};
template <class... _Tag> [[maybe_unused]] less(typename _Tag::__allow_ctad...)->less<_Tag...>;
template <>
struct less<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) < std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) < std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) < std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct less_equal
    : __binary_function<_Tp, _Tp, bool>
{
    typedef bool __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    bool operator()(const _Tp& __x, const _Tp& __y) const
        {return __x <= __y;}
};
template <class... _Tag> [[maybe_unused]] less_equal(typename _Tag::__allow_ctad...)->less_equal<_Tag...>;
template <>
struct less_equal<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) <= std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) <= std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) <= std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct greater_equal
    : __binary_function<_Tp, _Tp, bool>
{
    typedef bool __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    bool operator()(const _Tp& __x, const _Tp& __y) const
        {return __x >= __y;}
};
template <class... _Tag> [[maybe_unused]] greater_equal(typename _Tag::__allow_ctad...)->greater_equal<_Tag...>;
template <>
struct greater_equal<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) >= std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) >= std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) >= std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct greater
    : __binary_function<_Tp, _Tp, bool>
{
    typedef bool __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    bool operator()(const _Tp& __x, const _Tp& __y) const
        {return __x > __y;}
};
template <class... _Tag> [[maybe_unused]] greater(typename _Tag::__allow_ctad...)->greater<_Tag...>;
template <>
struct greater<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) > std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) > std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) > std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct logical_and
    : __binary_function<_Tp, _Tp, bool>
{
    typedef bool __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    bool operator()(const _Tp& __x, const _Tp& __y) const
        {return __x && __y;}
};
template <class... _Tag> [[maybe_unused]] logical_and(typename _Tag::__allow_ctad...)->logical_and<_Tag...>;
template <>
struct logical_and<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) && std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) && std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) && std::forward<_T2>(__u); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct logical_not
    : __unary_function<_Tp, bool>
{
    typedef bool __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    bool operator()(const _Tp& __x) const
        {return !__x;}
};
template <class... _Tag> [[maybe_unused]] logical_not(typename _Tag::__allow_ctad...)->logical_not<_Tag...>;
template <>
struct logical_not<void>
{
    template <class _Tp>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_Tp&& __x) const
        noexcept(noexcept(!std::forward<_Tp>(__x)))
        -> decltype( !std::forward<_Tp>(__x))
        { return !std::forward<_Tp>(__x); }
    typedef void is_transparent;
};
template <class _Tp = void>
struct logical_or
    : __binary_function<_Tp, _Tp, bool>
{
    typedef bool __result_type;
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    bool operator()(const _Tp& __x, const _Tp& __y) const
        {return __x || __y;}
};
template <class... _Tag> [[maybe_unused]] logical_or(typename _Tag::__allow_ctad...)->logical_or<_Tag...>;
template <>
struct logical_or<void>
{
    template <class _T1, class _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) || std::forward<_T2>(__u)))
        -> decltype( std::forward<_T1>(__t) || std::forward<_T2>(__u))
        { return std::forward<_T1>(__t) || std::forward<_T2>(__u); }
    typedef void is_transparent;
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp, bool>
struct __dependent_type : public _Tp {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_trivially_copy_assignable
    : public integral_constant<bool,
                               __is_trivially_assignable(__add_lvalue_reference_t<_Tp>,
                                                         __add_lvalue_reference_t<typename add_const<_Tp>::type>)> {};
template <class _Tp>
inline constexpr bool is_trivially_copy_assignable_v = is_trivially_copy_assignable<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_trivially_copy_constructible
    : public integral_constant<bool, __is_trivially_constructible(_Tp, __add_lvalue_reference_t<const _Tp>)> {};
template <class _Tp>
inline constexpr bool is_trivially_copy_constructible_v = is_trivially_copy_constructible<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_trivially_destructible
    : public integral_constant<bool, __is_trivially_destructible(_Tp)> {};
template <class _Tp>
inline constexpr bool is_trivially_destructible_v = is_trivially_destructible<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_trivially_move_assignable
    : public integral_constant<
          bool,
          __is_trivially_assignable(__add_lvalue_reference_t<_Tp>, __add_rvalue_reference_t<_Tp>)> {};
template <class _Tp>
inline constexpr bool is_trivially_move_assignable_v = is_trivially_move_assignable<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_trivially_move_constructible
    : public integral_constant<bool, __is_trivially_constructible(_Tp, __add_rvalue_reference_t<_Tp>)> {};
template <class _Tp>
inline constexpr bool is_trivially_move_constructible_v = is_trivially_move_constructible<_Tp>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct __type_identity {
  typedef _Tp type;
};
template <class _Tp>
using __type_identity_t __attribute__((__nodebug__)) = typename __type_identity<_Tp>::type;
template <class _Tp>
struct type_identity {
  typedef _Tp type;
};
template <class _Tp>
using type_identity_t = typename type_identity<_Tp>::type;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
struct in_place_t {
  explicit in_place_t() = default;
};
inline constexpr in_place_t in_place{};
template <class _Tp>
struct in_place_type_t {
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit in_place_type_t() = default;
};
template <class _Tp>
inline constexpr in_place_type_t<_Tp> in_place_type{};
template <size_t _Idx>
struct in_place_index_t {
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit in_place_index_t() = default;
};
template <size_t _Idx>
inline constexpr in_place_index_t<_Idx> in_place_index{};
template <class _Tp> struct __is_inplace_type_imp : false_type {};
template <class _Tp> struct __is_inplace_type_imp<in_place_type_t<_Tp>> : true_type {};
template <class _Tp>
using __is_inplace_type = __is_inplace_type_imp<__remove_cvref_t<_Tp>>;
template <class _Tp> struct __is_inplace_index_imp : false_type {};
template <size_t _Idx> struct __is_inplace_index_imp<in_place_index_t<_Idx>> : true_type {};
template <class _Tp>
using __is_inplace_index = __is_inplace_index_imp<__remove_cvref_t<_Tp>>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
struct monostate {};
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool operator==(monostate, monostate) noexcept { return true; }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr strong_ordering operator<=>(monostate, monostate) noexcept {
  return strong_ordering::equal;
}
template <>
struct hash<monostate> {
  using argument_type = monostate;
  using result_type = size_t;
  inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) result_type operator()(const argument_type&) const noexcept {
    return 66740831;
  }
};
}}
namespace std
{
template<class _Ep>
class initializer_list
{
    const _Ep* __begin_;
    size_t __size_;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    constexpr
    initializer_list(const _Ep* __b, size_t __s) noexcept
        : __begin_(__b),
          __size_(__s)
        {}
public:
    typedef _Ep value_type;
    typedef const _Ep& reference;
    typedef const _Ep& const_reference;
    typedef size_t size_type;
    typedef const _Ep* iterator;
    typedef const _Ep* const_iterator;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    constexpr
    initializer_list() noexcept : __begin_(nullptr), __size_(0) {}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    constexpr
    size_t size() const noexcept {return __size_;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    constexpr
    const _Ep* begin() const noexcept {return __begin_;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    constexpr
    const _Ep* end() const noexcept {return __begin_ + __size_;}
};
template<class _Ep>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr
const _Ep*
begin(initializer_list<_Ep> __il) noexcept
{
    return __il.begin();
}
template<class _Ep>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr
const _Ep*
end(initializer_list<_Ep> __il) noexcept
{
    return __il.end();
}
}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct alignment_of : public integral_constant<size_t, alignof(_Tp)> {};
template <class _Tp>
inline constexpr size_t alignment_of_v = alignof(_Tp);
}}
 extern "C" {
         __declspec(allocator) __declspec(restrict)
void* __cdecl _calloc_base(
         size_t _Count,
         size_t _Size
    );
                            __declspec(allocator) __declspec(restrict)
void* __cdecl calloc(
                            size_t _Count,
                            size_t _Size
    );
         int __cdecl _callnewh(
         size_t _Size
    );
         __declspec(allocator)
void* __cdecl _expand(
                            void* _Block,
                            size_t _Size
    );
void __cdecl _free_base(
                                   void* _Block
    );
void __cdecl free(
                                   void* _Block
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl _malloc_base(
         size_t _Size
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl malloc(
                            size_t _Size
    );
size_t __cdecl _msize(
                  void* _Block
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl _realloc_base(
                                    void* _Block,
                                    size_t _Size
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl realloc(
                                   void* _Block,
                                   size_t _Size
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl _recalloc(
                                   void* _Block,
                                   size_t _Count,
                                   size_t _Size
    );
void __cdecl _aligned_free(
                                   void* _Block
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl _aligned_malloc(
                            size_t _Size,
                            size_t _Alignment
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl _aligned_offset_malloc(
                            size_t _Size,
                            size_t _Alignment,
                            size_t _Offset
    );
size_t __cdecl _aligned_msize(
                  void* _Block,
                  size_t _Alignment,
                  size_t _Offset
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl _aligned_offset_realloc(
                                   void* _Block,
                                   size_t _Size,
                                   size_t _Alignment,
                                   size_t _Offset
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl _aligned_offset_recalloc(
                                   void* _Block,
                                   size_t _Count,
                                   size_t _Size,
                                   size_t _Alignment,
                                   size_t _Offset
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl _aligned_realloc(
                                   void* _Block,
                                   size_t _Size,
                                   size_t _Alignment
    );
         __declspec(allocator) __declspec(restrict)
void* __cdecl _aligned_recalloc(
                                   void* _Block,
                                   size_t _Count,
                                   size_t _Size,
                                   size_t _Alignment
    );
}
 extern "C" {
             void* __cdecl bsearch_s(
                                                           void const* _Key,
                                                           void const* _Base,
                                                           rsize_t _NumOfElements,
                                                           rsize_t _SizeOfElements,
             int (__cdecl* _PtFuncCompare)(void*, void const*, void const*),
                                                           void* _Context
        );
             void __cdecl qsort_s(
                                                                void* _Base,
                                                                rsize_t _NumOfElements,
                                                                rsize_t _SizeOfElements,
             int (__cdecl* _PtFuncCompare)(void*, void const*, void const*),
                                                                void* _Context
        );
         void* __cdecl bsearch(
                                                       void const* _Key,
                                                       void const* _Base,
                                                       size_t _NumOfElements,
                                                       size_t _SizeOfElements,
         int (__cdecl* _PtFuncCompare)(void const*, void const*)
    );
         void __cdecl qsort(
                                                            void* _Base,
                                                            size_t _NumOfElements,
                                                            size_t _SizeOfElements,
         int (__cdecl* _PtFuncCompare)(void const*, void const*)
    );
         void* __cdecl _lfind_s(
                                                          void const* _Key,
                                                          void const* _Base,
                                                          unsigned int* _NumOfElements,
                                                          size_t _SizeOfElements,
         int (__cdecl* _PtFuncCompare)(void*, void const*, void const*),
                                                          void* _Context
    );
         void* __cdecl _lfind(
                                                          void const* _Key,
                                                          void const* _Base,
                                                          unsigned int* _NumOfElements,
                                                          unsigned int _SizeOfElements,
         int (__cdecl* _PtFuncCompare)(void const*, void const*)
    );
         void* __cdecl _lsearch_s(
                                                                void const* _Key,
                                                                void* _Base,
                                                                unsigned int* _NumOfElements,
                                                                size_t _SizeOfElements,
         int (__cdecl* _PtFuncCompare)(void*, void const*, void const*),
                                                                void* _Context
    );
         void* __cdecl _lsearch(
                                                                void const* _Key,
                                                                void* _Base,
                                                                unsigned int* _NumOfElements,
                                                                unsigned int _SizeOfElements,
         int (__cdecl* _PtFuncCompare)(void const*, void const*)
    );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_lfind" ". See online help for details."))
             void* __cdecl lfind(
                                                              void const* _Key,
                                                              void const* _Base,
                                                              unsigned int* _NumOfElements,
                                                              unsigned int _SizeOfElements,
             int (__cdecl* _PtFuncCompare)(void const*, void const*)
        );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_lsearch" ". See online help for details."))
             void* __cdecl lsearch(
                                                                   void const* _Key,
                                                                   void* _Base,
                                                                   unsigned int* _NumOfElements,
                                                                   unsigned int _SizeOfElements,
             int (__cdecl* _PtFuncCompare)(void const*, void const*)
        );
}
 extern "C" {
         errno_t __cdecl _itow_s(
                                 int _Value,
                                 wchar_t* _Buffer,
                                 size_t _BufferCount,
                                 int _Radix
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _itow_s(int _Value, wchar_t (&_Buffer)[_Size], int _Radix) throw() { return _itow_s(_Value, _Buffer, _Size, _Radix); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_itow_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl _itow(int _Value, wchar_t *_Buffer, int _Radix);
         errno_t __cdecl _ltow_s(
                                 long _Value,
                                 wchar_t* _Buffer,
                                 size_t _BufferCount,
                                 int _Radix
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _ltow_s(long _Value, wchar_t (&_Buffer)[_Size], int _Radix) throw() { return _ltow_s(_Value, _Buffer, _Size, _Radix); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_ltow_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl _ltow(long _Value, wchar_t *_Buffer, int _Radix);
         errno_t __cdecl _ultow_s(
                                 unsigned long _Value,
                                 wchar_t* _Buffer,
                                 size_t _BufferCount,
                                 int _Radix
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _ultow_s(unsigned long _Value, wchar_t (&_Buffer)[_Size], int _Radix) throw() { return _ultow_s(_Value, _Buffer, _Size, _Radix); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_ultow_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t* __cdecl _ultow(unsigned long _Value, wchar_t *_Buffer, int _Radix);
         double __cdecl wcstod(
                             wchar_t const* _String,
                             wchar_t** _EndPtr
    );
         double __cdecl _wcstod_l(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             _locale_t _Locale
    );
         long __cdecl wcstol(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix
    );
         long __cdecl _wcstol_l(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         long long __cdecl wcstoll(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix
    );
         long long __cdecl _wcstoll_l(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         unsigned long __cdecl wcstoul(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix
    );
         unsigned long __cdecl _wcstoul_l(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         unsigned long long __cdecl wcstoull(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix
    );
         unsigned long long __cdecl _wcstoull_l(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         long double __cdecl wcstold(
                             wchar_t const* _String,
                             wchar_t** _EndPtr
    );
         long double __cdecl _wcstold_l(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             _locale_t _Locale
    );
         float __cdecl wcstof(
                             wchar_t const* _String,
                             wchar_t** _EndPtr
    );
         float __cdecl _wcstof_l(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             _locale_t _Locale
    );
         double __cdecl _wtof(
           wchar_t const* _String
    );
         double __cdecl _wtof_l(
             wchar_t const* _String,
             _locale_t _Locale
    );
         int __cdecl _wtoi(
           wchar_t const* _String
    );
         int __cdecl _wtoi_l(
             wchar_t const* _String,
             _locale_t _Locale
    );
         long __cdecl _wtol(
           wchar_t const* _String
    );
         long __cdecl _wtol_l(
             wchar_t const* _String,
             _locale_t _Locale
    );
         long long __cdecl _wtoll(
           wchar_t const* _String
    );
         long long __cdecl _wtoll_l(
             wchar_t const* _String,
             _locale_t _Locale
    );
         errno_t __cdecl _i64tow_s(
                                 __int64 _Value,
                                 wchar_t* _Buffer,
                                 size_t _BufferCount,
                                 int _Radix
    );
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_i64tow_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         wchar_t* __cdecl _i64tow(
                           __int64 _Value,
                           wchar_t* _Buffer,
                           int _Radix
    );
         errno_t __cdecl _ui64tow_s(
                                 unsigned __int64 _Value,
                                 wchar_t* _Buffer,
                                 size_t _BufferCount,
                                 int _Radix
    );
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_ui64tow_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         wchar_t* __cdecl _ui64tow(
                           unsigned __int64 _Value,
                           wchar_t* _Buffer,
                           int _Radix
    );
         __int64 __cdecl _wtoi64(
           wchar_t const* _String
    );
         __int64 __cdecl _wtoi64_l(
             wchar_t const* _String,
             _locale_t _Locale
    );
         __int64 __cdecl _wcstoi64(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix
    );
         __int64 __cdecl _wcstoi64_l(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         unsigned __int64 __cdecl _wcstoui64(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix
    );
         unsigned __int64 __cdecl _wcstoui64_l(
                             wchar_t const* _String,
                             wchar_t** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         __declspec(allocator) wchar_t* __cdecl _wfullpath(
                                     wchar_t* _Buffer,
                                     wchar_t const* _Path,
                                     size_t _BufferCount
    );
         errno_t __cdecl _wmakepath_s(
                                 wchar_t* _Buffer,
                                 size_t _BufferCount,
                                 wchar_t const* _Drive,
                                 wchar_t const* _Dir,
                                 wchar_t const* _Filename,
                                 wchar_t const* _Ext
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _wmakepath_s(wchar_t (&_Buffer)[_Size], wchar_t const* _Drive, wchar_t const* _Dir, wchar_t const* _Filename, wchar_t const* _Ext) throw() { return _wmakepath_s(_Buffer, _Size, _Drive, _Dir, _Filename, _Ext); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_wmakepath_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) void __cdecl _wmakepath( wchar_t *_Buffer, wchar_t const* _Drive, wchar_t const* _Dir, wchar_t const* _Filename, wchar_t const* _Ext);
         void __cdecl _wperror(
               wchar_t const* _ErrMsg
    );
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_wsplitpath_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         void __cdecl _wsplitpath(
                             wchar_t const* _FullPath,
                             wchar_t* _Drive,
                             wchar_t* _Dir,
                             wchar_t* _Filename,
                             wchar_t* _Ext
    );
         errno_t __cdecl _wsplitpath_s(
                                       wchar_t const* _FullPath,
                                       wchar_t* _Drive,
                                       size_t _DriveCount,
                                       wchar_t* _Dir,
                                       size_t _DirCount,
                                       wchar_t* _Filename,
                                       size_t _FilenameCount,
                                       wchar_t* _Ext,
                                       size_t _ExtCount
    );
extern "C++" { template <size_t _DriveSize, size_t _DirSize, size_t _NameSize, size_t _ExtSize> inline errno_t __cdecl _wsplitpath_s( wchar_t const* _Path, wchar_t (&_Drive)[_DriveSize], wchar_t (&_Dir)[_DirSize], wchar_t (&_Name)[_NameSize], wchar_t (&_Ext)[_ExtSize] ) throw() { return _wsplitpath_s(_Path, _Drive, _DriveSize, _Dir, _DirSize, _Name, _NameSize, _Ext, _ExtSize); } }
             errno_t __cdecl _wdupenv_s(
                                                                                    wchar_t** _Buffer,
                                                                                    size_t* _BufferCount,
                                                                                    wchar_t const* _VarName
        );
                   __declspec(deprecated("This function or variable may be unsafe. Consider using " "_wdupenv_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
             wchar_t* __cdecl _wgetenv(
               wchar_t const* _VarName
        );
             errno_t __cdecl _wgetenv_s(
                                         size_t* _RequiredCount,
                                         wchar_t* _Buffer,
                                         size_t _BufferCount,
                                         wchar_t const* _VarName
        );
    extern "C++" { template <size_t _Size> inline errno_t __cdecl _wgetenv_s(size_t* _RequiredCount, wchar_t (&_Buffer)[_Size], wchar_t const* _VarName) throw() { return _wgetenv_s(_RequiredCount, _Buffer, _Size, _VarName); } }
             int __cdecl _wputenv(
               wchar_t const* _EnvString
        );
             errno_t __cdecl _wputenv_s(
               wchar_t const* _Name,
               wchar_t const* _Value
        );
             errno_t __cdecl _wsearchenv_s(
                                     wchar_t const* _Filename,
                                     wchar_t const* _VarName,
                                     wchar_t* _Buffer,
                                     size_t _BufferCount
        );
    extern "C++" { template <size_t _Size> inline errno_t __cdecl _wsearchenv_s(wchar_t const* _Filename, wchar_t const* _VarName, wchar_t (&_ResultPath)[_Size]) throw() { return _wsearchenv_s(_Filename, _VarName, _ResultPath, _Size); } }
    __declspec(deprecated("This function or variable may be unsafe. Consider using " "_wsearchenv_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) void __cdecl _wsearchenv(wchar_t const* _Filename, wchar_t const* _VarName, wchar_t *_ResultPath);
             int __cdecl _wsystem(
                   wchar_t const* _Command
        );
}
 extern "C" {
}
 extern "C" {
         void __cdecl _swab(
                                                                     char* _Buf1,
                                                                     char* _Buf2,
                                                                     int _SizeInBytes
    );
         __declspec(noreturn) void __cdecl exit( int _Code);
         __declspec(noreturn) void __cdecl _exit( int _Code);
         __declspec(noreturn) void __cdecl _Exit( int _Code);
         __declspec(noreturn) void __cdecl quick_exit( int _Code);
         __declspec(noreturn) void __cdecl abort(void);
         unsigned int __cdecl _set_abort_behavior(
         unsigned int _Flags,
         unsigned int _Mask
    );
    typedef int (__cdecl* _onexit_t)(void);
    int __cdecl atexit(void (__cdecl*)(void));
    _onexit_t __cdecl _onexit( _onexit_t _Func);
int __cdecl at_quick_exit(void (__cdecl*)(void));
    typedef void (__cdecl* _purecall_handler)(void);
    typedef void (__cdecl* _invalid_parameter_handler)(
        wchar_t const*,
        wchar_t const*,
        wchar_t const*,
        unsigned int,
        uintptr_t
        );
             _purecall_handler __cdecl _set_purecall_handler(
                 _purecall_handler _Handler
        );
             _purecall_handler __cdecl _get_purecall_handler(void);
             _invalid_parameter_handler __cdecl _set_invalid_parameter_handler(
                 _invalid_parameter_handler _Handler
        );
             _invalid_parameter_handler __cdecl _get_invalid_parameter_handler(void);
             _invalid_parameter_handler __cdecl _set_thread_local_invalid_parameter_handler(
                 _invalid_parameter_handler _Handler
        );
             _invalid_parameter_handler __cdecl _get_thread_local_invalid_parameter_handler(void);
                            int __cdecl _set_error_mode( int _Mode);
         int* __cdecl _errno(void);
         errno_t __cdecl _set_errno( int _Value);
         errno_t __cdecl _get_errno( int* _Value);
         unsigned long* __cdecl __doserrno(void);
         errno_t __cdecl _set_doserrno( unsigned long _Value);
         errno_t __cdecl _get_doserrno( unsigned long * _Value);
         __declspec(deprecated("This function or variable may be unsafe. Consider using " "strerror" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char** __cdecl __sys_errlist(void);
         __declspec(deprecated("This function or variable may be unsafe. Consider using " "strerror" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) int * __cdecl __sys_nerr(void);
         void __cdecl perror( char const* _ErrMsg);
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_get_pgmptr" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char** __cdecl __p__pgmptr (void);
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_get_wpgmptr" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) wchar_t** __cdecl __p__wpgmptr(void);
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_get_fmode" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) int* __cdecl __p__fmode (void);
         errno_t __cdecl _get_pgmptr ( char** _Value);
         errno_t __cdecl _get_wpgmptr( wchar_t** _Value);
         errno_t __cdecl _set_fmode ( int _Mode );
         errno_t __cdecl _get_fmode ( int* _PMode);
typedef struct _div_t
{
    int quot;
    int rem;
} div_t;
typedef struct _ldiv_t
{
    long quot;
    long rem;
} ldiv_t;
typedef struct _lldiv_t
{
    long long quot;
    long long rem;
} lldiv_t;
               int __cdecl abs ( int _Number);
               long __cdecl labs ( long _Number);
               long long __cdecl llabs ( long long _Number);
               __int64 __cdecl _abs64( __int64 _Number);
               unsigned short __cdecl _byteswap_ushort( unsigned short _Number);
               unsigned long __cdecl _byteswap_ulong ( unsigned long _Number);
               unsigned __int64 __cdecl _byteswap_uint64( unsigned __int64 _Number);
                        div_t __cdecl div ( int _Numerator, int _Denominator);
                        ldiv_t __cdecl ldiv ( long _Numerator, long _Denominator);
                        lldiv_t __cdecl lldiv( long long _Numerator, long long _Denominator);
unsigned int __cdecl _rotl(
         unsigned int _Value,
         int _Shift
    );
unsigned long __cdecl _lrotl(
         unsigned long _Value,
         int _Shift
    );
unsigned __int64 __cdecl _rotl64(
         unsigned __int64 _Value,
         int _Shift
    );
unsigned int __cdecl _rotr(
         unsigned int _Value,
         int _Shift
    );
unsigned long __cdecl _lrotr(
         unsigned long _Value,
         int _Shift
    );
unsigned __int64 __cdecl _rotr64(
         unsigned __int64 _Value,
         int _Shift
    );
         void __cdecl srand( unsigned int _Seed);
                        int __cdecl rand(void);
extern "C++"
{
    inline long abs(long const _X) throw()
    {
        return labs(_X);
    }
    inline long long abs(long long const _X) throw()
    {
        return llabs(_X);
    }
    inline ldiv_t div(long const _A1, long const _A2) throw()
    {
        return ldiv(_A1, _A2);
    }
    inline lldiv_t div(long long const _A1, long long const _A2) throw()
    {
        return lldiv(_A1, _A2);
    }
}
    typedef struct
    {
        unsigned char ld[10];
    } _LDOUBLE;
typedef struct
{
    double x;
} _CRT_DOUBLE;
typedef struct
{
    float f;
} _CRT_FLOAT;
typedef struct
{
    long double x;
} _LONGDOUBLE;
typedef struct
{
    unsigned char ld12[12];
} _LDBL12;
                                           double __cdecl atof ( char const* _String);
                                           int __cdecl atoi ( char const* _String);
                                           long __cdecl atol ( char const* _String);
                                           long long __cdecl atoll ( char const* _String);
                                           __int64 __cdecl _atoi64( char const* _String);
                        double __cdecl _atof_l ( char const* _String, _locale_t _Locale);
                        int __cdecl _atoi_l ( char const* _String, _locale_t _Locale);
                        long __cdecl _atol_l ( char const* _String, _locale_t _Locale);
                        long long __cdecl _atoll_l ( char const* _String, _locale_t _Locale);
                        __int64 __cdecl _atoi64_l( char const* _String, _locale_t _Locale);
                        int __cdecl _atoflt ( _CRT_FLOAT* _Result, char const* _String);
                        int __cdecl _atodbl ( _CRT_DOUBLE* _Result, char* _String);
                        int __cdecl _atoldbl( _LDOUBLE* _Result, char* _String);
         int __cdecl _atoflt_l(
             _CRT_FLOAT* _Result,
             char const* _String,
             _locale_t _Locale
    );
         int __cdecl _atodbl_l(
             _CRT_DOUBLE* _Result,
             char* _String,
             _locale_t _Locale
    );
         int __cdecl _atoldbl_l(
             _LDOUBLE* _Result,
             char* _String,
             _locale_t _Locale
    );
         float __cdecl strtof(
                             char const* _String,
                             char** _EndPtr
    );
         float __cdecl _strtof_l(
                             char const* _String,
                             char** _EndPtr,
                             _locale_t _Locale
    );
         double __cdecl strtod(
                             char const* _String,
                             char** _EndPtr
    );
         double __cdecl _strtod_l(
                             char const* _String,
                             char** _EndPtr,
                             _locale_t _Locale
    );
         long double __cdecl strtold(
                             char const* _String,
                             char** _EndPtr
    );
         long double __cdecl _strtold_l(
                             char const* _String,
                             char** _EndPtr,
                             _locale_t _Locale
    );
         long __cdecl strtol(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix
    );
         long __cdecl _strtol_l(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         long long __cdecl strtoll(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix
    );
         long long __cdecl _strtoll_l(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         unsigned long __cdecl strtoul(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix
    );
         unsigned long __cdecl _strtoul_l(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         unsigned long long __cdecl strtoull(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix
    );
         unsigned long long __cdecl _strtoull_l(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         __int64 __cdecl _strtoi64(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix
    );
         __int64 __cdecl _strtoi64_l(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         unsigned __int64 __cdecl _strtoui64(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix
    );
         unsigned __int64 __cdecl _strtoui64_l(
                             char const* _String,
                             char** _EndPtr,
                             int _Radix,
                             _locale_t _Locale
    );
         errno_t __cdecl _itoa_s(
                                 int _Value,
                                 char* _Buffer,
                                 size_t _BufferCount,
                                 int _Radix
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _itoa_s(int _Value, char (&_Buffer)[_Size], int _Radix) throw() { return _itoa_s(_Value, _Buffer, _Size, _Radix); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_itoa_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl _itoa(int _Value, char *_Buffer, int _Radix);
         errno_t __cdecl _ltoa_s(
                                 long _Value,
                                 char* _Buffer,
                                 size_t _BufferCount,
                                 int _Radix
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _ltoa_s(long _Value, char (&_Buffer)[_Size], int _Radix) throw() { return _ltoa_s(_Value, _Buffer, _Size, _Radix); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_ltoa_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl _ltoa(long _Value, char *_Buffer, int _Radix);
         errno_t __cdecl _ultoa_s(
                                 unsigned long _Value,
                                 char* _Buffer,
                                 size_t _BufferCount,
                                 int _Radix
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _ultoa_s(unsigned long _Value, char (&_Buffer)[_Size], int _Radix) throw() { return _ultoa_s(_Value, _Buffer, _Size, _Radix); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_ultoa_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) char* __cdecl _ultoa(unsigned long _Value, char *_Buffer, int _Radix);
         errno_t __cdecl _i64toa_s(
                                 __int64 _Value,
                                 char* _Buffer,
                                 size_t _BufferCount,
                                 int _Radix
    );
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_i64toa_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         char* __cdecl _i64toa(
                           __int64 _Value,
                           char* _Buffer,
                           int _Radix
    );
         errno_t __cdecl _ui64toa_s(
                                 unsigned __int64 _Value,
                                 char* _Buffer,
                                 size_t _BufferCount,
                                 int _Radix
    );
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_ui64toa_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         char* __cdecl _ui64toa(
                           unsigned __int64 _Value,
                           char* _Buffer,
                           int _Radix
    );
         errno_t __cdecl _ecvt_s(
                                 char* _Buffer,
          size_t _BufferCount,
          double _Value,
          int _DigitCount,
          int* _PtDec,
          int* _PtSign
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _ecvt_s(char (&_Buffer)[_Size], double _Value, int _DigitCount, int* _PtDec, int* _PtSign) throw() { return _ecvt_s(_Buffer, _Size, _Value, _DigitCount, _PtDec, _PtSign); } }
               __declspec(deprecated("This function or variable may be unsafe. Consider using " "_ecvt_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         char* __cdecl _ecvt(
          double _Value,
          int _DigitCount,
          int* _PtDec,
          int* _PtSign
    );
         errno_t __cdecl _fcvt_s(
                                 char* _Buffer,
                                 size_t _BufferCount,
                                 double _Value,
                                 int _FractionalDigitCount,
                                 int* _PtDec,
                                 int* _PtSign
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _fcvt_s(char (&_Buffer)[_Size], double _Value, int _FractionalDigitCount, int* _PtDec, int* _PtSign) throw() { return _fcvt_s(_Buffer, _Size, _Value, _FractionalDigitCount, _PtDec, _PtSign); } }
               __declspec(deprecated("This function or variable may be unsafe. Consider using " "_fcvt_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         char* __cdecl _fcvt(
          double _Value,
          int _FractionalDigitCount,
          int* _PtDec,
          int* _PtSign
    );
         errno_t __cdecl _gcvt_s(
                                 char* _Buffer,
                                 size_t _BufferCount,
                                 double _Value,
                                 int _DigitCount
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _gcvt_s(char (&_Buffer)[_Size], double _Value, int _DigitCount) throw() { return _gcvt_s(_Buffer, _Size, _Value, _DigitCount); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_gcvt_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         char* __cdecl _gcvt(
                           double _Value,
                           int _DigitCount,
                           char* _Buffer
    );
             int __cdecl ___mb_cur_max_func(void);
             int __cdecl ___mb_cur_max_l_func(_locale_t);
         int __cdecl mblen(
                                                char const* _Ch,
                                                size_t _MaxCount
    );
         int __cdecl _mblen_l(
                                                char const* _Ch,
                                                size_t _MaxCount,
                                                _locale_t _Locale
    );
         size_t __cdecl _mbstrlen(
           char const* _String
    );
         size_t __cdecl _mbstrlen_l(
             char const* _String,
             _locale_t _Locale
    );
         size_t __cdecl _mbstrnlen(
           char const* _String,
           size_t _MaxCount
    );
         size_t __cdecl _mbstrnlen_l(
             char const* _String,
             size_t _MaxCount,
             _locale_t _Locale
    );
         int __cdecl mbtowc(
                                         wchar_t* _DstCh,
                                         char const* _SrcCh,
                                         size_t _SrcSizeInBytes
    );
         int __cdecl _mbtowc_l(
                                         wchar_t* _DstCh,
                                         char const* _SrcCh,
                                         size_t _SrcSizeInBytes,
                                         _locale_t _Locale
    );
         errno_t __cdecl mbstowcs_s(
                                                              size_t* _PtNumOfCharConverted,
                                                              wchar_t* _DstBuf,
                                                              size_t _SizeInWords,
                                                              char const* _SrcBuf,
                                                              size_t _MaxCount
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl mbstowcs_s(size_t* _PtNumOfCharConverted, wchar_t (&_Dest)[_Size], char const* _Source, size_t _MaxCount) throw() { return mbstowcs_s(_PtNumOfCharConverted, _Dest, _Size, _Source, _MaxCount); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "mbstowcs_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) size_t __cdecl mbstowcs( wchar_t *_Dest, char const* _Source, size_t _MaxCount);
         errno_t __cdecl _mbstowcs_s_l(
                                                              size_t* _PtNumOfCharConverted,
                                                              wchar_t* _DstBuf,
                                                              size_t _SizeInWords,
                                                              char const* _SrcBuf,
                                                              size_t _MaxCount,
                                                              _locale_t _Locale
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _mbstowcs_s_l(size_t* _PtNumOfCharConverted, wchar_t (&_Dest)[_Size], char const* _Source, size_t _MaxCount, _locale_t _Locale) throw() { return _mbstowcs_s_l(_PtNumOfCharConverted, _Dest, _Size, _Source, _MaxCount, _Locale); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_mbstowcs_s_l" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) size_t __cdecl _mbstowcs_l( wchar_t *_Dest, char const* _Source, size_t _MaxCount, _locale_t _Locale);
__declspec(deprecated("This function or variable may be unsafe. Consider using " "wctomb_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         int __cdecl wctomb(
                                   char* _MbCh,
                                   wchar_t _WCh
    );
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_wctomb_s_l" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         int __cdecl _wctomb_l(
                             char* _MbCh,
                             wchar_t _WCh,
                             _locale_t _Locale
    );
             errno_t __cdecl wctomb_s(
                                                                 int* _SizeConverted,
                                                                 char* _MbCh,
                                                                 rsize_t _SizeInBytes,
                                                                 wchar_t _WCh
        );
         errno_t __cdecl _wctomb_s_l(
                                     int* _SizeConverted,
                                     char* _MbCh,
                                     size_t _SizeInBytes,
                                     wchar_t _WCh,
                                     _locale_t _Locale);
         errno_t __cdecl wcstombs_s(
                                                                       size_t* _PtNumOfCharConverted,
                                                                       char* _Dst,
                                                                       size_t _DstSizeInBytes,
                                                                       wchar_t const* _Src,
                                                                       size_t _MaxCountInBytes
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl wcstombs_s(size_t* _PtNumOfCharConverted, char (&_Dest)[_Size], wchar_t const* _Source, size_t _MaxCount) throw() { return wcstombs_s(_PtNumOfCharConverted, _Dest, _Size, _Source, _MaxCount); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "wcstombs_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) size_t __cdecl wcstombs( char *_Dest, wchar_t const* _Source, size_t _MaxCount);
         errno_t __cdecl _wcstombs_s_l(
                                                                       size_t* _PtNumOfCharConverted,
                                                                       char* _Dst,
                                                                       size_t _DstSizeInBytes,
                                                                       wchar_t const* _Src,
                                                                       size_t _MaxCountInBytes,
                                                                       _locale_t _Locale
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _wcstombs_s_l(size_t* _PtNumOfCharConverted, char (&_Dest)[_Size], wchar_t const* _Source, size_t _MaxCount, _locale_t _Locale) throw() { return _wcstombs_s_l(_PtNumOfCharConverted, _Dest, _Size, _Source, _MaxCount, _Locale); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_wcstombs_s_l" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) size_t __cdecl _wcstombs_l( char *_Dest, wchar_t const* _Source, size_t _MaxCount, _locale_t _Locale);
         __declspec(allocator) char* __cdecl _fullpath(
                                     char* _Buffer,
                                     char const* _Path,
                                     size_t _BufferCount
    );
         errno_t __cdecl _makepath_s(
                                 char* _Buffer,
                                 size_t _BufferCount,
                                 char const* _Drive,
                                 char const* _Dir,
                                 char const* _Filename,
                                 char const* _Ext
    );
extern "C++" { template <size_t _Size> inline errno_t __cdecl _makepath_s(char (&_Buffer)[_Size], char const* _Drive, char const* _Dir, char const* _Filename, char const* _Ext) throw() { return _makepath_s(_Buffer, _Size, _Drive, _Dir, _Filename, _Ext); } }
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_makepath_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) void __cdecl _makepath( char *_Buffer, char const* _Drive, char const* _Dir, char const* _Filename, char const* _Ext);
__declspec(deprecated("This function or variable may be unsafe. Consider using " "_splitpath_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
         void __cdecl _splitpath(
                             char const* _FullPath,
                             char* _Drive,
                             char* _Dir,
                             char* _Filename,
                             char* _Ext
    );
         errno_t __cdecl _splitpath_s(
                                       char const* _FullPath,
                                       char* _Drive,
                                       size_t _DriveCount,
                                       char* _Dir,
                                       size_t _DirCount,
                                       char* _Filename,
                                       size_t _FilenameCount,
                                       char* _Ext,
                                       size_t _ExtCount
    );
extern "C++" { template <size_t _DriveSize, size_t _DirSize, size_t _NameSize, size_t _ExtSize> inline errno_t __cdecl _splitpath_s( char const* _Dest, char (&_Drive)[_DriveSize], char (&_Dir)[_DirSize], char (&_Name)[_NameSize], char (&_Ext)[_ExtSize] ) throw() { return _splitpath_s(_Dest, _Drive, _DriveSize, _Dir, _DirSize, _Name, _NameSize, _Ext, _ExtSize); } }
             errno_t __cdecl getenv_s(
                                         size_t* _RequiredCount,
                                         char* _Buffer,
                                         rsize_t _BufferCount,
                                         char const* _VarName
        );
             int* __cdecl __p___argc (void);
             char*** __cdecl __p___argv (void);
             wchar_t*** __cdecl __p___wargv(void);
             char*** __cdecl __p__environ (void);
             wchar_t*** __cdecl __p__wenviron(void);
                   __declspec(deprecated("This function or variable may be unsafe. Consider using " "_dupenv_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
             char* __cdecl getenv(
               char const* _VarName
        );
    extern "C++" { template <size_t _Size> inline errno_t __cdecl getenv_s(size_t* _RequiredCount, char (&_Buffer)[_Size], char const* _VarName) throw() { return getenv_s(_RequiredCount, _Buffer, _Size, _VarName); } }
             errno_t __cdecl _dupenv_s(
                                                                                    char** _Buffer,
                                                                                    size_t* _BufferCount,
                                                                                    char const* _VarName
        );
             int __cdecl system(
                   char const* _Command
        );
             int __cdecl _putenv(
               char const* _EnvString
        );
             errno_t __cdecl _putenv_s(
               char const* _Name,
               char const* _Value
        );
             errno_t __cdecl _searchenv_s(
                                     char const* _Filename,
                                     char const* _VarName,
                                     char* _Buffer,
                                     size_t _BufferCount
        );
    extern "C++" { template <size_t _Size> inline errno_t __cdecl _searchenv_s(char const* _Filename, char const* _VarName, char (&_Buffer)[_Size]) throw() { return _searchenv_s(_Filename, _VarName, _Buffer, _Size); } }
    __declspec(deprecated("This function or variable may be unsafe. Consider using " "_searchenv_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details.")) void __cdecl _searchenv(char const* _Filename, char const* _VarName, char *_Buffer);
    __declspec(deprecated("This function or variable has been superceded by newer library " "or operating system functionality. Consider using " "SetErrorMode" " " "instead. See online help for details."))
             void __cdecl _seterrormode(
             int _Mode
        );
    __declspec(deprecated("This function or variable has been superceded by newer library " "or operating system functionality. Consider using " "Beep" " " "instead. See online help for details."))
             void __cdecl _beep(
             unsigned _Frequency,
             unsigned _Duration
        );
    __declspec(deprecated("This function or variable has been superceded by newer library " "or operating system functionality. Consider using " "Sleep" " " "instead. See online help for details."))
             void __cdecl _sleep(
             unsigned long _Duration
        );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_ecvt" ". See online help for details.")) __declspec(deprecated("This function or variable may be unsafe. Consider using " "_ecvt_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
             char* __cdecl ecvt(
              double _Value,
              int _DigitCount,
              int* _PtDec,
              int* _PtSign
        );
                   __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_fcvt" ". See online help for details.")) __declspec(deprecated("This function or variable may be unsafe. Consider using " "_fcvt_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
             char* __cdecl fcvt(
              double _Value,
              int _FractionalDigitCount,
              int* _PtDec,
              int* _PtSign
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_gcvt" ". See online help for details.")) __declspec(deprecated("This function or variable may be unsafe. Consider using " "_fcvt_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
             char* __cdecl gcvt(
                               double _Value,
                               int _DigitCount,
                               char* _DstBuf
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_itoa" ". See online help for details.")) __declspec(deprecated("This function or variable may be unsafe. Consider using " "_itoa_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
             char* __cdecl itoa(
                               int _Value,
                               char* _Buffer,
                               int _Radix
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_ltoa" ". See online help for details.")) __declspec(deprecated("This function or variable may be unsafe. Consider using " "_ltoa_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
             char* __cdecl ltoa(
                               long _Value,
                               char* _Buffer,
                               int _Radix
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_swab" ". See online help for details."))
             void __cdecl swab(
                                        char* _Buf1,
                                        char* _Buf2,
                                        int _SizeInBytes
        );
    __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_ultoa" ". See online help for details.")) __declspec(deprecated("This function or variable may be unsafe. Consider using " "_ultoa_s" " instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. " "See online help for details."))
             char* __cdecl ultoa(
                               unsigned long _Value,
                               char* _Buffer,
                               int _Radix
        );
                       __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_putenv" ". See online help for details."))
                 int __cdecl putenv(
                   char const* _EnvString
            );
    _onexit_t __cdecl onexit( _onexit_t _Func);
}
extern "C++" {
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float abs(float __lcpp_x) noexcept {
  return __builtin_fabsf(__lcpp_x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double abs(double __lcpp_x) noexcept {
  return __builtin_fabs(__lcpp_x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double
abs(long double __lcpp_x) noexcept {
  return __builtin_fabsl(__lcpp_x);
}
}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
using ::size_t __attribute__((__using_if_exists__));
using ::div_t __attribute__((__using_if_exists__));
using ::ldiv_t __attribute__((__using_if_exists__));
using ::lldiv_t __attribute__((__using_if_exists__));
using ::atof __attribute__((__using_if_exists__));
using ::atoi __attribute__((__using_if_exists__));
using ::atol __attribute__((__using_if_exists__));
using ::atoll __attribute__((__using_if_exists__));
using ::strtod __attribute__((__using_if_exists__));
using ::strtof __attribute__((__using_if_exists__));
using ::strtold __attribute__((__using_if_exists__));
using ::strtol __attribute__((__using_if_exists__));
using ::strtoll __attribute__((__using_if_exists__));
using ::strtoul __attribute__((__using_if_exists__));
using ::strtoull __attribute__((__using_if_exists__));
using ::rand __attribute__((__using_if_exists__));
using ::srand __attribute__((__using_if_exists__));
using ::calloc __attribute__((__using_if_exists__));
using ::free __attribute__((__using_if_exists__));
using ::malloc __attribute__((__using_if_exists__));
using ::realloc __attribute__((__using_if_exists__));
using ::abort __attribute__((__using_if_exists__));
using ::atexit __attribute__((__using_if_exists__));
using ::exit __attribute__((__using_if_exists__));
using ::_Exit __attribute__((__using_if_exists__));
using ::getenv __attribute__((__using_if_exists__));
using ::system __attribute__((__using_if_exists__));
using ::bsearch __attribute__((__using_if_exists__));
using ::qsort __attribute__((__using_if_exists__));
using ::abs __attribute__((__using_if_exists__));
using ::labs __attribute__((__using_if_exists__));
using ::llabs __attribute__((__using_if_exists__));
using ::div __attribute__((__using_if_exists__));
using ::ldiv __attribute__((__using_if_exists__));
using ::lldiv __attribute__((__using_if_exists__));
using ::mblen __attribute__((__using_if_exists__));
using ::mbtowc __attribute__((__using_if_exists__));
using ::wctomb __attribute__((__using_if_exists__));
using ::mbstowcs __attribute__((__using_if_exists__));
using ::wcstombs __attribute__((__using_if_exists__));
using ::at_quick_exit __attribute__((__using_if_exists__));
using ::quick_exit __attribute__((__using_if_exists__));
using ::aligned_alloc __attribute__((__using_if_exists__));
}}
extern "C++" {
namespace std
{
    enum class align_val_t : size_t {};
}
    namespace std
    {
        struct nothrow_t {
            explicit nothrow_t() = default;
        };
            extern nothrow_t const nothrow;
    }
[[nodiscard]] __declspec(allocator)
void* __cdecl operator new(
    size_t _Size
    );
[[nodiscard]] __declspec(allocator)
void* __cdecl operator new(
    size_t _Size,
    ::std::nothrow_t const&
    ) noexcept;
[[nodiscard]] __declspec(allocator)
void* __cdecl operator new[](
    size_t _Size
    );
[[nodiscard]] __declspec(allocator)
void* __cdecl operator new[](
    size_t _Size,
    ::std::nothrow_t const&
    ) noexcept;
void __cdecl operator delete(
    void* _Block
    ) noexcept;
void __cdecl operator delete(
    void* _Block,
    ::std::nothrow_t const&
    ) noexcept;
void __cdecl operator delete[](
    void* _Block
    ) noexcept;
void __cdecl operator delete[](
    void* _Block,
    ::std::nothrow_t const&
    ) noexcept;
void __cdecl operator delete(
    void* _Block,
    size_t _Size
    ) noexcept;
void __cdecl operator delete[](
    void* _Block,
    size_t _Size
    ) noexcept;
[[nodiscard]] __declspec(allocator)
void* __cdecl operator new(
    size_t _Size,
    ::std::align_val_t _Al
    );
[[nodiscard]] __declspec(allocator)
void* __cdecl operator new(
    size_t _Size,
    ::std::align_val_t _Al,
    ::std::nothrow_t const&
    ) noexcept;
[[nodiscard]] __declspec(allocator)
void* __cdecl operator new[](
    size_t _Size,
    ::std::align_val_t _Al
    );
[[nodiscard]] __declspec(allocator)
void* __cdecl operator new[](
    size_t _Size,
    ::std::align_val_t _Al,
    ::std::nothrow_t const&
    ) noexcept;
void __cdecl operator delete(
    void* _Block,
    ::std::align_val_t _Al
    ) noexcept;
void __cdecl operator delete(
    void* _Block,
    ::std::align_val_t _Al,
    ::std::nothrow_t const&
    ) noexcept;
void __cdecl operator delete[](
    void* _Block,
    ::std::align_val_t _Al
    ) noexcept;
void __cdecl operator delete[](
    void* _Block,
    ::std::align_val_t _Al,
    ::std::nothrow_t const&
    ) noexcept;
void __cdecl operator delete(
    void* _Block,
    size_t _Size,
    ::std::align_val_t _Al
    ) noexcept;
void __cdecl operator delete[](
    void* _Block,
    size_t _Size,
    ::std::align_val_t _Al
    ) noexcept;
    [[nodiscard]]
    inline void* __cdecl operator new(size_t _Size,
                                void* _Where) noexcept
    {
        (void)_Size;
        return _Where;
    }
    inline void __cdecl operator delete(void*, void*) noexcept
    {
        return;
    }
    [[nodiscard]]
    inline void* __cdecl operator new[](size_t _Size,
                                void* _Where) noexcept
    {
        (void)_Size;
        return _Where;
    }
    inline void __cdecl operator delete[](void*, void*) noexcept
    {
    }
}
extern "C++" {
    [[nodiscard]]
    __declspec(allocator) void* __cdecl operator new(
               size_t _Size,
               int _BlockUse,
               char const* _FileName,
               int _LineNumber
        );
    [[nodiscard]]
    __declspec(allocator) void* __cdecl operator new[](
               size_t _Size,
               int _BlockUse,
               char const* _FileName,
               int _LineNumber
        );
    void __cdecl operator delete(
        void* _Block,
        int _BlockUse,
        char const* _FileName,
        int _LineNumber
        ) noexcept;
    void __cdecl operator delete[](
        void* _Block,
        int _BlockUse,
        char const* _FileName,
        int _LineNumber
        ) noexcept;
}
        namespace std
        {
            typedef void (__cdecl* new_handler)();
                     new_handler __cdecl set_new_handler( new_handler _NewHandler) throw();
        }
        using std::new_handler;
        using std::set_new_handler;
 extern "C" {
typedef int (__cdecl* _PNH)(size_t);
_PNH __cdecl _query_new_handler(void);
_PNH __cdecl _set_new_handler( _PNH _NewHandler);
         int __cdecl _query_new_mode(void);
         int __cdecl _set_new_mode( int _NewMode);
}
namespace std
{
[[noreturn]] void __throw_bad_alloc();
[[noreturn]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
void __throw_bad_array_new_length()
{
    ::std::__libcpp_verbose_abort("bad_array_new_length was thrown in -fno-exceptions mode");
}
struct destroying_delete_t {
  explicit destroying_delete_t() = default;
};
inline constexpr destroying_delete_t destroying_delete{};
}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
constexpr inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) bool __is_overaligned_for_new(size_t __align) noexcept {
  return __align > 16ULL;
}
template <class ..._Args>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
void* __libcpp_operator_new(_Args ...__args) {
  return __builtin_operator_new(__args...);
}
template <class ..._Args>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
void __libcpp_operator_delete(_Args ...__args) {
  __builtin_operator_delete(__args...);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
void *__libcpp_allocate(size_t __size, size_t __align) {
  if (__is_overaligned_for_new(__align)) {
    const align_val_t __align_val = static_cast<align_val_t>(__align);
    return __libcpp_operator_new(__size, __align_val);
  }
  (void)__align;
  return __libcpp_operator_new(__size);
}
template <class ..._Args>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
void __do_deallocate_handle_size(void *__ptr, size_t __size, _Args ...__args) {
  (void)__size;
  return std::__libcpp_operator_delete(__ptr, __args...);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
void __libcpp_deallocate(void* __ptr, size_t __size, size_t __align) {
    if (__is_overaligned_for_new(__align)) {
      const align_val_t __align_val = static_cast<align_val_t>(__align);
      return __do_deallocate_handle_size(__ptr, __size, __align_val);
    } else {
      return __do_deallocate_handle_size(__ptr, __size);
    }
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) void __libcpp_deallocate_unsized(void* __ptr, size_t __align) {
    if (__is_overaligned_for_new(__align)) {
      const align_val_t __align_val = static_cast<align_val_t>(__align);
      return __libcpp_operator_delete(__ptr, __align_val);
    } else {
      return __libcpp_operator_delete(__ptr);
    }
}
template <class _Tp>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _Tp* __launder(_Tp* __p) noexcept
{
    static_assert (!(is_function<_Tp>::value), "can't launder functions" );
    static_assert (!(is_same<void, __remove_cv_t<_Tp> >::value), "can't launder cv-void" );
    return __builtin_launder(__p);
}
template <class _Tp>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _Tp* launder(_Tp* __p) noexcept
{
    return std::__launder(__p);
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct __has_allocator_type
{
private:
    template <class _Up> static false_type __test(...);
    template <class _Up> static true_type __test(typename _Up::allocator_type* = 0);
public:
    static const bool value = decltype(__test<_Tp>(0))::value;
};
template <class _Tp, class _Alloc, bool = __has_allocator_type<_Tp>::value>
struct __uses_allocator
    : public integral_constant<bool,
        is_convertible<_Alloc, typename _Tp::allocator_type>::value>
{
};
template <class _Tp, class _Alloc>
struct __uses_allocator<_Tp, _Alloc, false>
    : public false_type
{
};
template <class _Tp, class _Alloc>
struct uses_allocator
    : public __uses_allocator<_Tp, _Alloc>
{
};
template <class _Tp, class _Alloc>
inline constexpr bool uses_allocator_v = uses_allocator<_Tp, _Alloc>::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
struct allocator_arg_t { explicit allocator_arg_t() = default; };
inline constexpr allocator_arg_t allocator_arg = allocator_arg_t();
template <class _Tp, class _Alloc, class ..._Args>
struct __uses_alloc_ctor_imp
{
    typedef __attribute__((__nodebug__)) __remove_cvref_t<_Alloc> _RawAlloc;
    static const bool __ua = uses_allocator<_Tp, _RawAlloc>::value;
    static const bool __ic =
        is_constructible<_Tp, allocator_arg_t, _Alloc, _Args...>::value;
    static const int value = __ua ? 2 - __ic : 0;
};
template <class _Tp, class _Alloc, class ..._Args>
struct __uses_alloc_ctor
    : integral_constant<int, __uses_alloc_ctor_imp<_Tp, _Alloc, _Args...>::value>
    {};
template <class _Tp, class _Allocator, class... _Args>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
void __user_alloc_construct_impl (integral_constant<int, 0>, _Tp *__storage, const _Allocator &, _Args &&... __args )
{
    new (__storage) _Tp (std::forward<_Args>(__args)...);
}
template <class _Tp, class _Allocator, class... _Args>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
void __user_alloc_construct_impl (integral_constant<int, 1>, _Tp *__storage, const _Allocator &__a, _Args &&... __args )
{
    new (__storage) _Tp (allocator_arg, __a, std::forward<_Args>(__args)...);
}
template <class _Tp, class _Allocator, class... _Args>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
void __user_alloc_construct_impl (integral_constant<int, 2>, _Tp *__storage, const _Allocator &__a, _Args &&... __args )
{
    new (__storage) _Tp (std::forward<_Args>(__args)..., __a);
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_empty : public integral_constant<bool, __is_empty(_Tp)> {};
template <class _Tp>
inline constexpr bool is_empty_v = __is_empty(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct __libcpp_is_final : public integral_constant<bool, __is_final(_Tp)> {};
template <class _Tp>
struct is_final : public integral_constant<bool, __is_final(_Tp)> {};
template <class _Tp>
inline constexpr bool is_final_v = __is_final(_Tp);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <template <class...> class _Func, class... _Args>
struct _Lazy : _Func<_Args...> {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <bool _Const, class _Tp>
using __maybe_const = __conditional_t<_Const, const _Tp, _Tp>;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Pred>
struct _Not : _BoolConstant<!_Pred::value> {};
template <class _Tp>
struct negation : _Not<_Tp> {};
template <class _Tp>
inline constexpr bool negation_v = !_Tp::value;
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
struct compare_three_way
{
    template<class _T1, class _T2>
        requires three_way_comparable_with<_T1, _T2>
    constexpr __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    auto operator()(_T1&& __t, _T2&& __u) const
        noexcept(noexcept(std::forward<_T1>(__t) <=> std::forward<_T2>(__u)))
        { return std::forward<_T1>(__t) <=> std::forward<_T2>(__u); }
    using is_transparent = void;
};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct is_trivially_copyable : public integral_constant<bool, __is_trivially_copyable(_Tp)> {};
template <class _Tp>
inline constexpr bool is_trivially_copyable_v = __is_trivially_copyable(_Tp);
template <class _Tp>
inline constexpr bool __is_cheap_to_copy = is_trivially_copyable_v<_Tp> && sizeof(_Tp) <= sizeof(std::intmax_t);
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _ToType, class _FromType>
  requires(sizeof(_ToType) == sizeof(_FromType) &&
           is_trivially_copyable_v<_ToType> &&
           is_trivially_copyable_v<_FromType>)
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _ToType bit_cast(const _FromType& __from) noexcept {
  return __builtin_bit_cast(_ToType, __from);
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template<size_t _Ip> struct __priority_tag : __priority_tag<_Ip - 1> {};
template<> struct __priority_tag<0> {};
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <class _Tp>
struct __numeric_type {
  static void __test(...);
  static float __test(float);
  static double __test(char);
  static double __test(int);
  static double __test(unsigned);
  static double __test(long);
  static double __test(unsigned long);
  static double __test(long long);
  static double __test(unsigned long long);
  static double __test(double);
  static long double __test(long double);
  typedef decltype(__test(std::declval<_Tp>())) type;
  static const bool value = _IsNotSame<type, void>::value;
};
template <>
struct __numeric_type<void> {
  static const bool value = true;
};
template <class _A1,
          class _A2 = void,
          class _A3 = void,
          bool = __numeric_type<_A1>::value&& __numeric_type<_A2>::value&& __numeric_type<_A3>::value>
class __promote_imp {
public:
  static const bool value = false;
};
template <class _A1, class _A2, class _A3>
class __promote_imp<_A1, _A2, _A3, true> {
private:
  typedef typename __promote_imp<_A1>::type __type1;
  typedef typename __promote_imp<_A2>::type __type2;
  typedef typename __promote_imp<_A3>::type __type3;
public:
  typedef decltype(__type1() + __type2() + __type3()) type;
  static const bool value = true;
};
template <class _A1, class _A2>
class __promote_imp<_A1, _A2, void, true> {
private:
  typedef typename __promote_imp<_A1>::type __type1;
  typedef typename __promote_imp<_A2>::type __type2;
public:
  typedef decltype(__type1() + __type2()) type;
  static const bool value = true;
};
template <class _A1>
class __promote_imp<_A1, void, void, true> {
public:
  typedef typename __numeric_type<_A1>::type type;
  static const bool value = true;
};
template <class _A1, class _A2 = void, class _A3 = void>
class __promote : public __promote_imp<_A1, _A2, _A3> {};
}}
 extern "C" {
    struct _exception
    {
        int type;
        char* name;
        double arg1;
        double arg2;
        double retval;
    };
        struct _complex
        {
            double x, y;
        };
typedef float float_t;
typedef double double_t;
        extern double const _HUGE;
void __cdecl _fperrraise( int _Except);
                        short __cdecl _dclass( double _X);
                        short __cdecl _ldclass( long double _X);
                        short __cdecl _fdclass( float _X);
                        int __cdecl _dsign( double _X);
                        int __cdecl _ldsign( long double _X);
                        int __cdecl _fdsign( float _X);
                        int __cdecl _dpcomp( double _X, double _Y);
                        int __cdecl _ldpcomp( long double _X, long double _Y);
                        int __cdecl _fdpcomp( float _X, float _Y);
                        short __cdecl _dtest( double* _Px);
                        short __cdecl _ldtest( long double* _Px);
                        short __cdecl _fdtest( float* _Px);
         short __cdecl _d_int( double* _Px, short _Xexp);
         short __cdecl _ld_int( long double* _Px, short _Xexp);
         short __cdecl _fd_int( float* _Px, short _Xexp);
         short __cdecl _dscale( double* _Px, long _Lexp);
         short __cdecl _ldscale( long double* _Px, long _Lexp);
         short __cdecl _fdscale( float* _Px, long _Lexp);
         short __cdecl _dunscale( short* _Pex, double* _Px);
         short __cdecl _ldunscale( short* _Pex, long double* _Px);
         short __cdecl _fdunscale( short* _Pex, float* _Px);
                        short __cdecl _dexp( double* _Px, double _Y, long _Eoff);
                        short __cdecl _ldexp( long double* _Px, long double _Y, long _Eoff);
                        short __cdecl _fdexp( float* _Px, float _Y, long _Eoff);
                        short __cdecl _dnorm( unsigned short* _Ps);
                        short __cdecl _fdnorm( unsigned short* _Ps);
                        double __cdecl _dpoly( double _X, double const* _Tab, int _N);
                        long double __cdecl _ldpoly( long double _X, long double const* _Tab, int _N);
                        float __cdecl _fdpoly( float _X, float const* _Tab, int _N);
                        double __cdecl _dlog( double _X, int _Baseflag);
                        long double __cdecl _ldlog( long double _X, int _Baseflag);
                        float __cdecl _fdlog( float _X, int _Baseflag);
                        double __cdecl _dsin( double _X, unsigned int _Qoff);
                        long double __cdecl _ldsin( long double _X, unsigned int _Qoff);
                        float __cdecl _fdsin( float _X, unsigned int _Qoff);
typedef union
{
    unsigned short _Sh[4];
    double _Val;
} _double_val;
typedef union
{
    unsigned short _Sh[2];
    float _Val;
} _float_val;
typedef union
{
    unsigned short _Sh[4];
    long double _Val;
} _ldouble_val;
typedef union
{
    unsigned short _Word[4];
    float _Float;
    double _Double;
    long double _Long_double;
} _float_const;
extern const _float_const _Denorm_C, _Inf_C, _Nan_C, _Snan_C, _Hugeval_C;
extern const _float_const _FDenorm_C, _FInf_C, _FNan_C, _FSnan_C;
extern const _float_const _LDenorm_C, _LInf_C, _LNan_C, _LSnan_C;
extern const _float_const _Eps_C, _Rteps_C;
extern const _float_const _FEps_C, _FRteps_C;
extern const _float_const _LEps_C, _LRteps_C;
extern const double _Zero_C, _Xbig_C;
extern const float _FZero_C, _FXbig_C;
extern const long double _LZero_C, _LXbig_C;
extern "C++"
{
                   inline int fpclassify( float _X) throw()
    {
        return _fdtest(&_X);
    }
                   inline int fpclassify( double _X) throw()
    {
        return _dtest(&_X);
    }
                   inline int fpclassify( long double _X) throw()
    {
        return _ldtest(&_X);
    }
                   inline bool signbit( float _X) throw()
    {
        return _fdsign(_X) != 0;
    }
                   inline bool signbit( double _X) throw()
    {
        return _dsign(_X) != 0;
    }
                   inline bool signbit( long double _X) throw()
    {
        return _ldsign(_X) != 0;
    }
                   inline int _fpcomp( float _X, float _Y) throw()
    {
        return _fdpcomp(_X, _Y);
    }
                   inline int _fpcomp( double _X, double _Y) throw()
    {
        return _dpcomp(_X, _Y);
    }
                   inline int _fpcomp( long double _X, long double _Y) throw()
    {
        return _ldpcomp(_X, _Y);
    }
    template <class _Trc, class _Tre> struct _Combined_type
    {
        typedef float _Type;
    };
    template <> struct _Combined_type<float, double>
    {
        typedef double _Type;
    };
    template <> struct _Combined_type<float, long double>
    {
        typedef long double _Type;
    };
    template <class _Ty, class _T2> struct _Real_widened
    {
        typedef long double _Type;
    };
    template <> struct _Real_widened<float, float>
    {
        typedef float _Type;
    };
    template <> struct _Real_widened<float, double>
    {
        typedef double _Type;
    };
    template <> struct _Real_widened<double, float>
    {
        typedef double _Type;
    };
    template <> struct _Real_widened<double, double>
    {
        typedef double _Type;
    };
    template <class _Ty> struct _Real_type
    {
        typedef double _Type;
    };
    template <> struct _Real_type<float>
    {
        typedef float _Type;
    };
    template <> struct _Real_type<long double>
    {
        typedef long double _Type;
    };
    template <class _T1, class _T2>
                   inline int _fpcomp( _T1 _X, _T2 _Y) throw()
    {
        typedef typename _Combined_type<float,
            typename _Real_widened<
            typename _Real_type<_T1>::_Type,
            typename _Real_type<_T2>::_Type>::_Type>::_Type _Tw;
        return _fpcomp((_Tw)_X, (_Tw)_Y);
    }
    template <class _Ty>
                   inline bool isfinite( _Ty _X) throw()
    {
        return fpclassify(_X) <= 0;
    }
    template <class _Ty>
                   inline bool isinf( _Ty _X) throw()
    {
        return fpclassify(_X) == 1;
    }
    template <class _Ty>
                   inline bool isnan( _Ty _X) throw()
    {
        return fpclassify(_X) == 2;
    }
    template <class _Ty>
                   inline bool isnormal( _Ty _X) throw()
    {
        return fpclassify(_X) == (-1);
    }
    template <class _Ty1, class _Ty2>
                   inline bool isgreater( _Ty1 _X, _Ty2 _Y) throw()
    {
        return (_fpcomp(_X, _Y) & 4) != 0;
    }
    template <class _Ty1, class _Ty2>
                   inline bool isgreaterequal( _Ty1 _X, _Ty2 _Y) throw()
    {
        return (_fpcomp(_X, _Y) & (2 | 4)) != 0;
    }
    template <class _Ty1, class _Ty2>
                   inline bool isless( _Ty1 _X, _Ty2 _Y) throw()
    {
        return (_fpcomp(_X, _Y) & 1) != 0;
    }
    template <class _Ty1, class _Ty2>
                   inline bool islessequal( _Ty1 _X, _Ty2 _Y) throw()
    {
        return (_fpcomp(_X, _Y) & (1 | 2)) != 0;
    }
    template <class _Ty1, class _Ty2>
                   inline bool islessgreater( _Ty1 _X, _Ty2 _Y) throw()
    {
        return (_fpcomp(_X, _Y) & (1 | 4)) != 0;
    }
    template <class _Ty1, class _Ty2>
                   inline bool isunordered( _Ty1 _X, _Ty2 _Y) throw()
    {
        return _fpcomp(_X, _Y) == 0;
    }
}
               int __cdecl abs( int _X);
               long __cdecl labs( long _X);
               long long __cdecl llabs( long long _X);
               double __cdecl acos( double _X);
               double __cdecl asin( double _X);
               double __cdecl atan( double _X);
               double __cdecl atan2( double _Y, double _X);
               double __cdecl cos( double _X);
               double __cdecl cosh( double _X);
               double __cdecl exp( double _X);
                                  double __cdecl fabs( double _X);
               double __cdecl fmod( double _X, double _Y);
               double __cdecl log( double _X);
               double __cdecl log10( double _X);
               double __cdecl pow( double _X, double _Y);
               double __cdecl sin( double _X);
               double __cdecl sinh( double _X);
                                  double __cdecl sqrt( double _X);
               double __cdecl tan( double _X);
               double __cdecl tanh( double _X);
                        double __cdecl acosh( double _X);
                        double __cdecl asinh( double _X);
                        double __cdecl atanh( double _X);
                         double __cdecl atof( char const* _String);
                         double __cdecl _atof_l( char const* _String, _locale_t _Locale);
                        double __cdecl _cabs( struct _complex _Complex_value);
                        double __cdecl cbrt( double _X);
                        double __cdecl ceil( double _X);
                        double __cdecl _chgsign( double _X);
                        double __cdecl copysign( double _Number, double _Sign);
                        double __cdecl _copysign( double _Number, double _Sign);
                        double __cdecl erf( double _X);
                        double __cdecl erfc( double _X);
                        double __cdecl exp2( double _X);
                        double __cdecl expm1( double _X);
                        double __cdecl fdim( double _X, double _Y);
                        double __cdecl floor( double _X);
                        double __cdecl fma( double _X, double _Y, double _Z);
                        double __cdecl fmax( double _X, double _Y);
                        double __cdecl fmin( double _X, double _Y);
                        double __cdecl frexp( double _X, int* _Y);
                        double __cdecl hypot( double _X, double _Y);
                        double __cdecl _hypot( double _X, double _Y);
                        int __cdecl ilogb( double _X);
                        double __cdecl ldexp( double _X, int _Y);
                        double __cdecl lgamma( double _X);
                        long long __cdecl llrint( double _X);
                        long long __cdecl llround( double _X);
                        double __cdecl log1p( double _X);
                        double __cdecl log2( double _X);
                        double __cdecl logb( double _X);
                        long __cdecl lrint( double _X);
                        long __cdecl lround( double _X);
int __cdecl _matherr( struct _exception* _Except);
                        double __cdecl modf( double _X, double* _Y);
                        double __cdecl nan( char const*);
                        double __cdecl nearbyint( double _X);
                        double __cdecl nextafter( double _X, double _Y);
                        double __cdecl nexttoward( double _X, long double _Y);
                        double __cdecl remainder( double _X, double _Y);
                        double __cdecl remquo( double _X, double _Y, int* _Z);
                        double __cdecl rint( double _X);
                        double __cdecl round( double _X);
                        double __cdecl scalbln( double _X, long _Y);
                        double __cdecl scalbn( double _X, int _Y);
                        double __cdecl tgamma( double _X);
                        double __cdecl trunc( double _X);
                        double __cdecl _j0( double _X );
                        double __cdecl _j1( double _X );
                        double __cdecl _jn(int _X, double _Y);
                        double __cdecl _y0( double _X);
                        double __cdecl _y1( double _X);
                        double __cdecl _yn( int _X, double _Y);
                        float __cdecl acoshf( float _X);
                        float __cdecl asinhf( float _X);
                        float __cdecl atanhf( float _X);
                        float __cdecl cbrtf( float _X);
                        float __cdecl _chgsignf( float _X);
                        float __cdecl copysignf( float _Number, float _Sign);
                        float __cdecl _copysignf( float _Number, float _Sign);
                        float __cdecl erff( float _X);
                        float __cdecl erfcf( float _X);
                        float __cdecl expm1f( float _X);
                        float __cdecl exp2f( float _X);
                        float __cdecl fdimf( float _X, float _Y);
                        float __cdecl fmaf( float _X, float _Y, float _Z);
                        float __cdecl fmaxf( float _X, float _Y);
                        float __cdecl fminf( float _X, float _Y);
                        float __cdecl _hypotf( float _X, float _Y);
                        int __cdecl ilogbf( float _X);
                        float __cdecl lgammaf( float _X);
                        long long __cdecl llrintf( float _X);
                        long long __cdecl llroundf( float _X);
                        float __cdecl log1pf( float _X);
                        float __cdecl log2f( float _X);
                        float __cdecl logbf( float _X);
                        long __cdecl lrintf( float _X);
                        long __cdecl lroundf( float _X);
                        float __cdecl nanf( char const*);
                        float __cdecl nearbyintf( float _X);
                        float __cdecl nextafterf( float _X, float _Y);
                        float __cdecl nexttowardf( float _X, long double _Y);
                        float __cdecl remainderf( float _X, float _Y);
                        float __cdecl remquof( float _X, float _Y, int* _Z);
                        float __cdecl rintf( float _X);
                        float __cdecl roundf( float _X);
                        float __cdecl scalblnf( float _X, long _Y);
                        float __cdecl scalbnf( float _X, int _Y);
                        float __cdecl tgammaf( float _X);
                        float __cdecl truncf( float _X);
                            float __cdecl _logbf( float _X);
                            float __cdecl _nextafterf( float _X, float _Y);
                            int __cdecl _finitef( float _X);
                            int __cdecl _isnanf( float _X);
                            int __cdecl _fpclassf( float _X);
                            int __cdecl _set_FMA3_enable( int _Flag);
                            int __cdecl _get_FMA3_enable(void);
                            float __cdecl acosf( float _X);
                            float __cdecl asinf( float _X);
                            float __cdecl atan2f( float _Y, float _X);
                            float __cdecl atanf( float _X);
                            float __cdecl ceilf( float _X);
                            float __cdecl cosf( float _X);
                            float __cdecl coshf( float _X);
                            float __cdecl expf( float _X);
                   __inline float __cdecl fabsf( float _X)
    {
        return (float)fabs(_X);
    }
                            float __cdecl floorf( float _X);
                            float __cdecl fmodf( float _X, float _Y);
               __inline float __cdecl frexpf( float _X, int *_Y)
{
    return (float)frexp(_X, _Y);
}
               __inline float __cdecl hypotf( float _X, float _Y)
{
    return _hypotf(_X, _Y);
}
               __inline float __cdecl ldexpf( float _X, int _Y)
{
    return (float)ldexp(_X, _Y);
}
                            float __cdecl log10f( float _X);
                            float __cdecl logf( float _X);
                            float __cdecl modff( float _X, float *_Y);
                            float __cdecl powf( float _X, float _Y);
                            float __cdecl sinf( float _X);
                            float __cdecl sinhf( float _X);
                            float __cdecl sqrtf( float _X);
                            float __cdecl tanf( float _X);
                            float __cdecl tanhf( float _X);
                        long double __cdecl acoshl( long double _X);
               __inline long double __cdecl acosl( long double _X)
{
    return acos((double)_X);
}
                        long double __cdecl asinhl( long double _X);
               __inline long double __cdecl asinl( long double _X)
{
    return asin((double)_X);
}
               __inline long double __cdecl atan2l( long double _Y, long double _X)
{
    return atan2((double)_Y, (double)_X);
}
                        long double __cdecl atanhl( long double _X);
               __inline long double __cdecl atanl( long double _X)
{
    return atan((double)_X);
}
                        long double __cdecl cbrtl( long double _X);
               __inline long double __cdecl ceill( long double _X)
{
    return ceil((double)_X);
}
               __inline long double __cdecl _chgsignl( long double _X)
{
    return _chgsign((double)_X);
}
                        long double __cdecl copysignl( long double _Number, long double _Sign);
               __inline long double __cdecl _copysignl( long double _Number, long double _Sign)
{
    return _copysign((double)_Number, (double)_Sign);
}
               __inline long double __cdecl coshl( long double _X)
{
    return cosh((double)_X);
}
               __inline long double __cdecl cosl( long double _X)
{
    return cos((double)_X);
}
                        long double __cdecl erfl( long double _X);
                        long double __cdecl erfcl( long double _X);
               __inline long double __cdecl expl( long double _X)
{
    return exp((double)_X);
}
                        long double __cdecl exp2l( long double _X);
                        long double __cdecl expm1l( long double _X);
               __inline long double __cdecl fabsl( long double _X)
{
    return fabs((double)_X);
}
                        long double __cdecl fdiml( long double _X, long double _Y);
               __inline long double __cdecl floorl( long double _X)
{
    return floor((double)_X);
}
                        long double __cdecl fmal( long double _X, long double _Y, long double _Z);
                        long double __cdecl fmaxl( long double _X, long double _Y);
                        long double __cdecl fminl( long double _X, long double _Y);
               __inline long double __cdecl fmodl( long double _X, long double _Y)
{
    return fmod((double)_X, (double)_Y);
}
               __inline long double __cdecl frexpl( long double _X, int *_Y)
{
    return frexp((double)_X, _Y);
}
                        int __cdecl ilogbl( long double _X);
               __inline long double __cdecl _hypotl( long double _X, long double _Y)
{
    return _hypot((double)_X, (double)_Y);
}
               __inline long double __cdecl hypotl( long double _X, long double _Y)
{
    return _hypot((double)_X, (double)_Y);
}
               __inline long double __cdecl ldexpl( long double _X, int _Y)
{
    return ldexp((double)_X, _Y);
}
                        long double __cdecl lgammal( long double _X);
                        long long __cdecl llrintl( long double _X);
                        long long __cdecl llroundl( long double _X);
               __inline long double __cdecl logl( long double _X)
{
    return log((double)_X);
}
               __inline long double __cdecl log10l( long double _X)
{
    return log10((double)_X);
}
                        long double __cdecl log1pl( long double _X);
                        long double __cdecl log2l( long double _X);
                        long double __cdecl logbl( long double _X);
                        long __cdecl lrintl( long double _X);
                        long __cdecl lroundl( long double _X);
               __inline long double __cdecl modfl( long double _X, long double* _Y)
{
    double _F, _I;
    _F = modf((double)_X, &_I);
    *_Y = _I;
    return _F;
}
                        long double __cdecl nanl( char const*);
                        long double __cdecl nearbyintl( long double _X);
                        long double __cdecl nextafterl( long double _X, long double _Y);
                        long double __cdecl nexttowardl( long double _X, long double _Y);
               __inline long double __cdecl powl( long double _X, long double _Y)
{
    return pow((double)_X, (double)_Y);
}
                        long double __cdecl remainderl( long double _X, long double _Y);
                        long double __cdecl remquol( long double _X, long double _Y, int* _Z);
                        long double __cdecl rintl( long double _X);
                        long double __cdecl roundl( long double _X);
                        long double __cdecl scalblnl( long double _X, long _Y);
                        long double __cdecl scalbnl( long double _X, int _Y);
               __inline long double __cdecl sinhl( long double _X)
{
    return sinh((double)_X);
}
               __inline long double __cdecl sinl( long double _X)
{
    return sin((double)_X);
}
               __inline long double __cdecl sqrtl( long double _X)
{
    return sqrt((double)_X);
}
               __inline long double __cdecl tanhl( long double _X)
{
    return tanh((double)_X);
}
               __inline long double __cdecl tanl( long double _X)
{
    return tan((double)_X);
}
                        long double __cdecl tgammal( long double _X);
                        long double __cdecl truncl( long double _X);
            extern double HUGE;
        __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_j0" ". See online help for details.")) double __cdecl j0( double _X);
        __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_j1" ". See online help for details.")) double __cdecl j1( double _X);
        __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_jn" ". See online help for details.")) double __cdecl jn( int _X, double _Y);
        __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_y0" ". See online help for details.")) double __cdecl y0( double _X);
        __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_y1" ". See online help for details.")) double __cdecl y1( double _X);
        __declspec(deprecated("The POSIX name for this item is deprecated. Instead, use the ISO C " "and C++ conformant name: " "_yn" ". See online help for details.")) double __cdecl yn( int _X, double _Y);
}
extern "C++" {
template <class _A1, std::__enable_if_t<std::is_floating_point<_A1>::value, int> = 0>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) bool signbit(_A1 __x) noexcept {
  return __builtin_signbit(__x);
}
template <class _A1, std::__enable_if_t<std::is_integral<_A1>::value && std::is_signed<_A1>::value, int> = 0>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) bool signbit(_A1 __x) noexcept {
  return __x < 0;
}
template <class _A1, std::__enable_if_t<std::is_integral<_A1>::value && !std::is_signed<_A1>::value, int> = 0>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) bool signbit(_A1) noexcept {
  return false;
}
template <class _A1, std::__enable_if_t<std::is_floating_point<_A1>::value, int> = 0>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) int fpclassify(_A1 __x) noexcept {
  return __builtin_fpclassify(2, 1, (-1), (-2), 0, __x);
}
template <class _A1, std::__enable_if_t<std::is_integral<_A1>::value, int> = 0>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) int fpclassify(_A1 __x) noexcept {
  return __x == 0 ? 0 : (-1);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float acos(float __x) noexcept {return __builtin_acosf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double acos(double __x) noexcept {
  return __builtin_acos(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double acos(long double __x) noexcept {return __builtin_acosl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
acos(_A1 __x) noexcept {return __builtin_acos((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float asin(float __x) noexcept {return __builtin_asinf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double asin(double __x) noexcept {
  return __builtin_asin(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double asin(long double __x) noexcept {return __builtin_asinl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
asin(_A1 __x) noexcept {return __builtin_asin((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float atan(float __x) noexcept {return __builtin_atanf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double atan(double __x) noexcept {
  return __builtin_atan(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double atan(long double __x) noexcept {return __builtin_atanl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
atan(_A1 __x) noexcept {return __builtin_atan((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float atan2(float __y, float __x) noexcept {return __builtin_atan2f(__y, __x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double atan2(double __x, double __y) noexcept {
  return __builtin_atan2(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double atan2(long double __y, long double __x) noexcept {return __builtin_atan2l(__y, __x);}
template <class _A1, class _A2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
atan2(_A1 __y, _A2 __x) noexcept
{
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value)), "");
    return ::atan2((__result_type)__y, (__result_type)__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float ceil(float __x) noexcept {return __builtin_ceilf(__x);}
template <class = int>
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double ceil(double __x) noexcept {
  return __builtin_ceil(__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double ceil(long double __x) noexcept {return __builtin_ceill(__x);}
template <class _A1>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
ceil(_A1 __x) noexcept {return __builtin_ceil((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float cos(float __x) noexcept {return __builtin_cosf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double cos(double __x) noexcept {
  return __builtin_cos(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double cos(long double __x) noexcept {return __builtin_cosl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
cos(_A1 __x) noexcept {return __builtin_cos((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float cosh(float __x) noexcept {return __builtin_coshf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double cosh(double __x) noexcept {
  return __builtin_cosh(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double cosh(long double __x) noexcept {return __builtin_coshl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
cosh(_A1 __x) noexcept {return __builtin_cosh((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float exp(float __x) noexcept {return __builtin_expf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double exp(double __x) noexcept {
  return __builtin_exp(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double exp(long double __x) noexcept {return __builtin_expl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
exp(_A1 __x) noexcept {return __builtin_exp((double)__x);}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float fabs(float __x) noexcept {return __builtin_fabsf(__x);}
template <class = int>
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double fabs(double __x) noexcept {
  return __builtin_fabs(__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double fabs(long double __x) noexcept {return __builtin_fabsl(__x);}
template <class _A1>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
fabs(_A1 __x) noexcept {return __builtin_fabs((double)__x);}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float floor(float __x) noexcept {return __builtin_floorf(__x);}
template <class = int>
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double floor(double __x) noexcept {
  return __builtin_floor(__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double floor(long double __x) noexcept {return __builtin_floorl(__x);}
template <class _A1>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
floor(_A1 __x) noexcept {return __builtin_floor((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float fmod(float __x, float __y) noexcept {return __builtin_fmodf(__x, __y);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double fmod(double __x, double __y) noexcept {
  return __builtin_fmod(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double fmod(long double __x, long double __y) noexcept {return __builtin_fmodl(__x, __y);}
template <class _A1, class _A2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
fmod(_A1 __x, _A2 __y) noexcept
{
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value)), "");
    return ::fmod((__result_type)__x, (__result_type)__y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float frexp(float __x, int* __e) noexcept {return __builtin_frexpf(__x, __e);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double frexp(double __x, int* __e) noexcept {
  return __builtin_frexp(__x, __e);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double frexp(long double __x, int* __e) noexcept {return __builtin_frexpl(__x, __e);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
frexp(_A1 __x, int* __e) noexcept {return __builtin_frexp((double)__x, __e);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float ldexp(float __x, int __e) noexcept {return __builtin_ldexpf(__x, __e);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double ldexp(double __x, int __e) noexcept {
  return __builtin_ldexp(__x, __e);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double ldexp(long double __x, int __e) noexcept {return __builtin_ldexpl(__x, __e);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
ldexp(_A1 __x, int __e) noexcept {return __builtin_ldexp((double)__x, __e);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float log(float __x) noexcept {return __builtin_logf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double log(double __x) noexcept {
  return __builtin_log(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double log(long double __x) noexcept {return __builtin_logl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
log(_A1 __x) noexcept {return __builtin_log((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float log10(float __x) noexcept {return __builtin_log10f(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double log10(double __x) noexcept {
  return __builtin_log10(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double log10(long double __x) noexcept {return __builtin_log10l(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
log10(_A1 __x) noexcept {return __builtin_log10((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float modf(float __x, float* __y) noexcept {return __builtin_modff(__x, __y);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double modf(double __x, double* __y) noexcept {
  return __builtin_modf(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double modf(long double __x, long double* __y) noexcept {return __builtin_modfl(__x, __y);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float pow(float __x, float __y) noexcept {return __builtin_powf(__x, __y);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double pow(double __x, double __y) noexcept {
  return __builtin_pow(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double pow(long double __x, long double __y) noexcept {return __builtin_powl(__x, __y);}
template <class _A1, class _A2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
pow(_A1 __x, _A2 __y) noexcept
{
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value)), "");
    return ::pow((__result_type)__x, (__result_type)__y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float sin(float __x) noexcept {return __builtin_sinf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double sin(double __x) noexcept {
  return __builtin_sin(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double sin(long double __x) noexcept {return __builtin_sinl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
sin(_A1 __x) noexcept {return __builtin_sin((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float sinh(float __x) noexcept {return __builtin_sinhf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double sinh(double __x) noexcept {
  return __builtin_sinh(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double sinh(long double __x) noexcept {return __builtin_sinhl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
sinh(_A1 __x) noexcept {return __builtin_sinh((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float sqrt(float __x) noexcept {return __builtin_sqrtf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double sqrt(double __x) noexcept {
  return __builtin_sqrt(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double sqrt(long double __x) noexcept {return __builtin_sqrtl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
sqrt(_A1 __x) noexcept {return __builtin_sqrt((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float tan(float __x) noexcept {return __builtin_tanf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double tan(double __x) noexcept {
  return __builtin_tan(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double tan(long double __x) noexcept {return __builtin_tanl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
tan(_A1 __x) noexcept {return __builtin_tan((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float tanh(float __x) noexcept {return __builtin_tanhf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double tanh(double __x) noexcept {
  return __builtin_tanh(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double tanh(long double __x) noexcept {return __builtin_tanhl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
tanh(_A1 __x) noexcept {return __builtin_tanh((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float acosh(float __x) noexcept {return __builtin_acoshf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double acosh(double __x) noexcept {
  return __builtin_acosh(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double acosh(long double __x) noexcept {return __builtin_acoshl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
acosh(_A1 __x) noexcept {return __builtin_acosh((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float asinh(float __x) noexcept {return __builtin_asinhf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double asinh(double __x) noexcept {
  return __builtin_asinh(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double asinh(long double __x) noexcept {return __builtin_asinhl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
asinh(_A1 __x) noexcept {return __builtin_asinh((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float atanh(float __x) noexcept {return __builtin_atanhf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double atanh(double __x) noexcept {
  return __builtin_atanh(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double atanh(long double __x) noexcept {return __builtin_atanhl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
atanh(_A1 __x) noexcept {return __builtin_atanh((double)__x);}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float cbrt(float __x) noexcept {return __builtin_cbrtf(__x);}
template <class = int>
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double cbrt(double __x) noexcept {
  return __builtin_cbrt(__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double cbrt(long double __x) noexcept {return __builtin_cbrtl(__x);}
template <class _A1>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
cbrt(_A1 __x) noexcept {return __builtin_cbrt((double)__x);}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float copysign(float __x, float __y) noexcept {
  return ::__builtin_copysignf(__x, __y);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double copysign(long double __x, long double __y) noexcept {
  return ::__builtin_copysignl(__x, __y);
}
template <class _A1, class _A2>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
    copysign(_A1 __x, _A2 __y) noexcept {
  return ::__builtin_copysign(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float erf(float __x) noexcept {return __builtin_erff(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double erf(double __x) noexcept {
  return __builtin_erf(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double erf(long double __x) noexcept {return __builtin_erfl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
erf(_A1 __x) noexcept {return __builtin_erf((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float erfc(float __x) noexcept {return __builtin_erfcf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double erfc(double __x) noexcept {
  return __builtin_erfc(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double erfc(long double __x) noexcept {return __builtin_erfcl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
erfc(_A1 __x) noexcept {return __builtin_erfc((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float exp2(float __x) noexcept {return __builtin_exp2f(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double exp2(double __x) noexcept {
  return __builtin_exp2(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double exp2(long double __x) noexcept {return __builtin_exp2l(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
exp2(_A1 __x) noexcept {return __builtin_exp2((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float expm1(float __x) noexcept {return __builtin_expm1f(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double expm1(double __x) noexcept {
  return __builtin_expm1(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double expm1(long double __x) noexcept {return __builtin_expm1l(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
expm1(_A1 __x) noexcept {return __builtin_expm1((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float fdim(float __x, float __y) noexcept {return __builtin_fdimf(__x, __y);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double fdim(double __x, double __y) noexcept {
  return __builtin_fdim(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double fdim(long double __x, long double __y) noexcept {return __builtin_fdiml(__x, __y);}
template <class _A1, class _A2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
fdim(_A1 __x, _A2 __y) noexcept
{
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value)), "");
    return ::fdim((__result_type)__x, (__result_type)__y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float fma(float __x, float __y, float __z) noexcept
{
    return __builtin_fmaf(__x, __y, __z);
}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double fma(double __x, double __y, double __z) noexcept {
  return __builtin_fma(__x, __y, __z);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double fma(long double __x, long double __y, long double __z) noexcept
{
    return __builtin_fmal(__x, __y, __z);
}
template <class _A1, class _A2, class _A3>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value &&
    std::is_arithmetic<_A3>::value,
    std::__promote<_A1, _A2, _A3>
>::type
fma(_A1 __x, _A2 __y, _A3 __z) noexcept
{
    typedef typename std::__promote<_A1, _A2, _A3>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value &&
                     std::_IsSame<_A3, __result_type>::value)), "");
    return __builtin_fma((__result_type)__x, (__result_type)__y, (__result_type)__z);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float fmax(float __x, float __y) noexcept {return __builtin_fmaxf(__x, __y);}
template <class = int>
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double fmax(double __x, double __y) noexcept {
  return __builtin_fmax(__x, __y);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double fmax(long double __x, long double __y) noexcept {return __builtin_fmaxl(__x, __y);}
template <class _A1, class _A2>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
fmax(_A1 __x, _A2 __y) noexcept
{
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value)), "");
    return ::fmax((__result_type)__x, (__result_type)__y);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float fmin(float __x, float __y) noexcept {return __builtin_fminf(__x, __y);}
template <class = int>
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double fmin(double __x, double __y) noexcept {
  return __builtin_fmin(__x, __y);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double fmin(long double __x, long double __y) noexcept {return __builtin_fminl(__x, __y);}
template <class _A1, class _A2>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
fmin(_A1 __x, _A2 __y) noexcept
{
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value)), "");
    return ::fmin((__result_type)__x, (__result_type)__y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float hypot(float __x, float __y) noexcept {return __builtin_hypotf(__x, __y);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double hypot(double __x, double __y) noexcept {
  return __builtin_hypot(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double hypot(long double __x, long double __y) noexcept {return __builtin_hypotl(__x, __y);}
template <class _A1, class _A2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
hypot(_A1 __x, _A2 __y) noexcept
{
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value)), "");
    return ::hypot((__result_type)__x, (__result_type)__y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) int ilogb(float __x) noexcept {return __builtin_ilogbf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double ilogb(double __x) noexcept {
  return __builtin_ilogb(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) int ilogb(long double __x) noexcept {return __builtin_ilogbl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, int>::type
ilogb(_A1 __x) noexcept {return __builtin_ilogb((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float lgamma(float __x) noexcept {return __builtin_lgammaf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double lgamma(double __x) noexcept {
  return __builtin_lgamma(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double lgamma(long double __x) noexcept {return __builtin_lgammal(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
lgamma(_A1 __x) noexcept {return __builtin_lgamma((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long long llrint(float __x) noexcept
{
    return __builtin_llrintf(__x);
}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long long llrint(double __x) noexcept {
  return __builtin_llrint(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long long llrint(long double __x) noexcept
{
    return __builtin_llrintl(__x);
}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, long long>::type
llrint(_A1 __x) noexcept
{
    return __builtin_llrint((double)__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long long llround(float __x) noexcept
{
    return __builtin_llroundf(__x);
}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long long llround(double __x) noexcept {
  return __builtin_llround(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long long llround(long double __x) noexcept
{
    return __builtin_llroundl(__x);
}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, long long>::type
llround(_A1 __x) noexcept
{
    return __builtin_llround((double)__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float log1p(float __x) noexcept {return __builtin_log1pf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double log1p(double __x) noexcept {
  return __builtin_log1p(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double log1p(long double __x) noexcept {return __builtin_log1pl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
log1p(_A1 __x) noexcept {return __builtin_log1p((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float log2(float __x) noexcept {return __builtin_log2f(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double log2(double __x) noexcept {
  return __builtin_log2(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double log2(long double __x) noexcept {return __builtin_log2l(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
log2(_A1 __x) noexcept {return __builtin_log2((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float logb(float __x) noexcept {return __builtin_logbf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double logb(double __x) noexcept {
  return __builtin_logb(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double logb(long double __x) noexcept {return __builtin_logbl(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
logb(_A1 __x) noexcept {return __builtin_logb((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long lrint(float __x) noexcept
{
    return __builtin_lrintf(__x);
}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long lrint(double __x) noexcept {
  return __builtin_lrint(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long lrint(long double __x) noexcept
{
    return __builtin_lrintl(__x);
}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, long>::type
lrint(_A1 __x) noexcept
{
    return __builtin_lrint((double)__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long lround(float __x) noexcept
{
    return __builtin_lroundf(__x);
}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long lround(double __x) noexcept {
  return __builtin_lround(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long lround(long double __x) noexcept
{
    return __builtin_lroundl(__x);
}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, long>::type
lround(_A1 __x) noexcept
{
    return __builtin_lround((double)__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float nearbyint(float __x) noexcept {return __builtin_nearbyintf(__x);}
template <class = int>
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double nearbyint(double __x) noexcept {
  return __builtin_nearbyint(__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double nearbyint(long double __x) noexcept {return __builtin_nearbyintl(__x);}
template <class _A1>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
nearbyint(_A1 __x) noexcept {return __builtin_nearbyint((double)__x);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float nextafter(float __x, float __y) noexcept {return __builtin_nextafterf(__x, __y);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double nextafter(double __x, double __y) noexcept {
  return __builtin_nextafter(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double nextafter(long double __x, long double __y) noexcept {return __builtin_nextafterl(__x, __y);}
template <class _A1, class _A2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
nextafter(_A1 __x, _A2 __y) noexcept
{
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value)), "");
    return ::nextafter((__result_type)__x, (__result_type)__y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float nexttoward(float __x, long double __y) noexcept {return __builtin_nexttowardf(__x, __y);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double nexttoward(double __x, long double __y) noexcept {
  return __builtin_nexttoward(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double nexttoward(long double __x, long double __y) noexcept {return __builtin_nexttowardl(__x, __y);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
nexttoward(_A1 __x, long double __y) noexcept {return __builtin_nexttoward((double)__x, __y);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float remainder(float __x, float __y) noexcept {return __builtin_remainderf(__x, __y);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double remainder(double __x, double __y) noexcept {
  return __builtin_remainder(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double remainder(long double __x, long double __y) noexcept {return __builtin_remainderl(__x, __y);}
template <class _A1, class _A2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
remainder(_A1 __x, _A2 __y) noexcept
{
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value)), "");
    return ::remainder((__result_type)__x, (__result_type)__y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float remquo(float __x, float __y, int* __z) noexcept {return __builtin_remquof(__x, __y, __z);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double remquo(double __x, double __y, int* __z) noexcept {
  return __builtin_remquo(__x, __y, __z);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double remquo(long double __x, long double __y, int* __z) noexcept {return __builtin_remquol(__x, __y, __z);}
template <class _A1, class _A2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::__enable_if_t
<
    std::is_arithmetic<_A1>::value &&
    std::is_arithmetic<_A2>::value,
    std::__promote<_A1, _A2>
>::type
remquo(_A1 __x, _A2 __y, int* __z) noexcept
{
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value &&
                     std::_IsSame<_A2, __result_type>::value)), "");
    return ::remquo((__result_type)__x, (__result_type)__y, __z);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float rint(float __x) noexcept
{
    return __builtin_rintf(__x);
}
template <class = int>
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double rint(double __x) noexcept {
  return __builtin_rint(__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double rint(long double __x) noexcept
{
    return __builtin_rintl(__x);
}
template <class _A1>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
rint(_A1 __x) noexcept
{
    return __builtin_rint((double)__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float round(float __x) noexcept
{
    return __builtin_round(__x);
}
template <class = int>
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double round(double __x) noexcept {
  return __builtin_round(__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double round(long double __x) noexcept
{
    return __builtin_roundl(__x);
}
template <class _A1>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
round(_A1 __x) noexcept
{
    return __builtin_round((double)__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float scalbln(float __x, long __y) noexcept {return __builtin_scalblnf(__x, __y);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double scalbln(double __x, long __y) noexcept {
  return __builtin_scalbln(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double scalbln(long double __x, long __y) noexcept {return __builtin_scalblnl(__x, __y);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
scalbln(_A1 __x, long __y) noexcept {return __builtin_scalbln((double)__x, __y);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float scalbn(float __x, int __y) noexcept {return __builtin_scalbnf(__x, __y);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double scalbn(double __x, int __y) noexcept {
  return __builtin_scalbn(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double scalbn(long double __x, int __y) noexcept {return __builtin_scalbnl(__x, __y);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
scalbn(_A1 __x, int __y) noexcept {return __builtin_scalbn((double)__x, __y);}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float tgamma(float __x) noexcept {return __builtin_tgammaf(__x);}
template <class = int>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double tgamma(double __x) noexcept {
  return __builtin_tgamma(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double tgamma(long double __x) noexcept {return __builtin_tgammal(__x);}
template <class _A1>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
tgamma(_A1 __x) noexcept {return __builtin_tgamma((double)__x);}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float trunc(float __x) noexcept
{
    return __builtin_trunc(__x);
}
template <class = int>
[[__nodiscard__]] __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double trunc(double __x) noexcept {
  return __builtin_trunc(__x);
}
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double trunc(long double __x) noexcept
{
    return __builtin_truncl(__x);
}
template <class _A1>
[[__nodiscard__]] inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename std::enable_if<std::is_integral<_A1>::value, double>::type
trunc(_A1 __x) noexcept
{
    return __builtin_trunc((double)__x);
}
}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
using ::signbit __attribute__((__using_if_exists__));
using ::fpclassify __attribute__((__using_if_exists__));
using ::isfinite __attribute__((__using_if_exists__));
using ::isinf __attribute__((__using_if_exists__));
using ::isnan __attribute__((__using_if_exists__));
using ::isnormal __attribute__((__using_if_exists__));
using ::isgreater __attribute__((__using_if_exists__));
using ::isgreaterequal __attribute__((__using_if_exists__));
using ::isless __attribute__((__using_if_exists__));
using ::islessequal __attribute__((__using_if_exists__));
using ::islessgreater __attribute__((__using_if_exists__));
using ::isunordered __attribute__((__using_if_exists__));
using ::isunordered __attribute__((__using_if_exists__));
using ::float_t __attribute__((__using_if_exists__));
using ::double_t __attribute__((__using_if_exists__));
using ::abs __attribute__((__using_if_exists__));
using ::acos __attribute__((__using_if_exists__));
using ::acosf __attribute__((__using_if_exists__));
using ::asin __attribute__((__using_if_exists__));
using ::asinf __attribute__((__using_if_exists__));
using ::atan __attribute__((__using_if_exists__));
using ::atanf __attribute__((__using_if_exists__));
using ::atan2 __attribute__((__using_if_exists__));
using ::atan2f __attribute__((__using_if_exists__));
using ::ceil __attribute__((__using_if_exists__));
using ::ceilf __attribute__((__using_if_exists__));
using ::cos __attribute__((__using_if_exists__));
using ::cosf __attribute__((__using_if_exists__));
using ::cosh __attribute__((__using_if_exists__));
using ::coshf __attribute__((__using_if_exists__));
using ::exp __attribute__((__using_if_exists__));
using ::expf __attribute__((__using_if_exists__));
using ::fabs __attribute__((__using_if_exists__));
using ::fabsf __attribute__((__using_if_exists__));
using ::floor __attribute__((__using_if_exists__));
using ::floorf __attribute__((__using_if_exists__));
using ::fmod __attribute__((__using_if_exists__));
using ::fmodf __attribute__((__using_if_exists__));
using ::frexp __attribute__((__using_if_exists__));
using ::frexpf __attribute__((__using_if_exists__));
using ::ldexp __attribute__((__using_if_exists__));
using ::ldexpf __attribute__((__using_if_exists__));
using ::log __attribute__((__using_if_exists__));
using ::logf __attribute__((__using_if_exists__));
using ::log10 __attribute__((__using_if_exists__));
using ::log10f __attribute__((__using_if_exists__));
using ::modf __attribute__((__using_if_exists__));
using ::modff __attribute__((__using_if_exists__));
using ::pow __attribute__((__using_if_exists__));
using ::powf __attribute__((__using_if_exists__));
using ::sin __attribute__((__using_if_exists__));
using ::sinf __attribute__((__using_if_exists__));
using ::sinh __attribute__((__using_if_exists__));
using ::sinhf __attribute__((__using_if_exists__));
using ::sqrt __attribute__((__using_if_exists__));
using ::sqrtf __attribute__((__using_if_exists__));
using ::tan __attribute__((__using_if_exists__));
using ::tanf __attribute__((__using_if_exists__));
using ::tanh __attribute__((__using_if_exists__));
using ::tanhf __attribute__((__using_if_exists__));
using ::acosh __attribute__((__using_if_exists__));
using ::acoshf __attribute__((__using_if_exists__));
using ::asinh __attribute__((__using_if_exists__));
using ::asinhf __attribute__((__using_if_exists__));
using ::atanh __attribute__((__using_if_exists__));
using ::atanhf __attribute__((__using_if_exists__));
using ::cbrt __attribute__((__using_if_exists__));
using ::cbrtf __attribute__((__using_if_exists__));
using ::copysign __attribute__((__using_if_exists__));
using ::copysignf __attribute__((__using_if_exists__));
using ::erf __attribute__((__using_if_exists__));
using ::erff __attribute__((__using_if_exists__));
using ::erfc __attribute__((__using_if_exists__));
using ::erfcf __attribute__((__using_if_exists__));
using ::exp2 __attribute__((__using_if_exists__));
using ::exp2f __attribute__((__using_if_exists__));
using ::expm1 __attribute__((__using_if_exists__));
using ::expm1f __attribute__((__using_if_exists__));
using ::fdim __attribute__((__using_if_exists__));
using ::fdimf __attribute__((__using_if_exists__));
using ::fmaf __attribute__((__using_if_exists__));
using ::fma __attribute__((__using_if_exists__));
using ::fmax __attribute__((__using_if_exists__));
using ::fmaxf __attribute__((__using_if_exists__));
using ::fmin __attribute__((__using_if_exists__));
using ::fminf __attribute__((__using_if_exists__));
using ::hypot __attribute__((__using_if_exists__));
using ::hypotf __attribute__((__using_if_exists__));
using ::ilogb __attribute__((__using_if_exists__));
using ::ilogbf __attribute__((__using_if_exists__));
using ::lgamma __attribute__((__using_if_exists__));
using ::lgammaf __attribute__((__using_if_exists__));
using ::llrint __attribute__((__using_if_exists__));
using ::llrintf __attribute__((__using_if_exists__));
using ::llround __attribute__((__using_if_exists__));
using ::llroundf __attribute__((__using_if_exists__));
using ::log1p __attribute__((__using_if_exists__));
using ::log1pf __attribute__((__using_if_exists__));
using ::log2 __attribute__((__using_if_exists__));
using ::log2f __attribute__((__using_if_exists__));
using ::logb __attribute__((__using_if_exists__));
using ::logbf __attribute__((__using_if_exists__));
using ::lrint __attribute__((__using_if_exists__));
using ::lrintf __attribute__((__using_if_exists__));
using ::lround __attribute__((__using_if_exists__));
using ::lroundf __attribute__((__using_if_exists__));
using ::nan __attribute__((__using_if_exists__));
using ::nanf __attribute__((__using_if_exists__));
using ::nearbyint __attribute__((__using_if_exists__));
using ::nearbyintf __attribute__((__using_if_exists__));
using ::nextafter __attribute__((__using_if_exists__));
using ::nextafterf __attribute__((__using_if_exists__));
using ::nexttoward __attribute__((__using_if_exists__));
using ::nexttowardf __attribute__((__using_if_exists__));
using ::remainder __attribute__((__using_if_exists__));
using ::remainderf __attribute__((__using_if_exists__));
using ::remquo __attribute__((__using_if_exists__));
using ::remquof __attribute__((__using_if_exists__));
using ::rint __attribute__((__using_if_exists__));
using ::rintf __attribute__((__using_if_exists__));
using ::round __attribute__((__using_if_exists__));
using ::roundf __attribute__((__using_if_exists__));
using ::scalbln __attribute__((__using_if_exists__));
using ::scalblnf __attribute__((__using_if_exists__));
using ::scalbn __attribute__((__using_if_exists__));
using ::scalbnf __attribute__((__using_if_exists__));
using ::tgamma __attribute__((__using_if_exists__));
using ::tgammaf __attribute__((__using_if_exists__));
using ::trunc __attribute__((__using_if_exists__));
using ::truncf __attribute__((__using_if_exists__));
using ::acosl __attribute__((__using_if_exists__));
using ::asinl __attribute__((__using_if_exists__));
using ::atanl __attribute__((__using_if_exists__));
using ::atan2l __attribute__((__using_if_exists__));
using ::ceill __attribute__((__using_if_exists__));
using ::cosl __attribute__((__using_if_exists__));
using ::coshl __attribute__((__using_if_exists__));
using ::expl __attribute__((__using_if_exists__));
using ::fabsl __attribute__((__using_if_exists__));
using ::floorl __attribute__((__using_if_exists__));
using ::fmodl __attribute__((__using_if_exists__));
using ::frexpl __attribute__((__using_if_exists__));
using ::ldexpl __attribute__((__using_if_exists__));
using ::logl __attribute__((__using_if_exists__));
using ::log10l __attribute__((__using_if_exists__));
using ::modfl __attribute__((__using_if_exists__));
using ::powl __attribute__((__using_if_exists__));
using ::sinl __attribute__((__using_if_exists__));
using ::sinhl __attribute__((__using_if_exists__));
using ::sqrtl __attribute__((__using_if_exists__));
using ::tanl __attribute__((__using_if_exists__));
using ::tanhl __attribute__((__using_if_exists__));
using ::acoshl __attribute__((__using_if_exists__));
using ::asinhl __attribute__((__using_if_exists__));
using ::atanhl __attribute__((__using_if_exists__));
using ::cbrtl __attribute__((__using_if_exists__));
using ::copysignl __attribute__((__using_if_exists__));
using ::erfl __attribute__((__using_if_exists__));
using ::erfcl __attribute__((__using_if_exists__));
using ::exp2l __attribute__((__using_if_exists__));
using ::expm1l __attribute__((__using_if_exists__));
using ::fdiml __attribute__((__using_if_exists__));
using ::fmal __attribute__((__using_if_exists__));
using ::fmaxl __attribute__((__using_if_exists__));
using ::fminl __attribute__((__using_if_exists__));
using ::hypotl __attribute__((__using_if_exists__));
using ::ilogbl __attribute__((__using_if_exists__));
using ::lgammal __attribute__((__using_if_exists__));
using ::llrintl __attribute__((__using_if_exists__));
using ::llroundl __attribute__((__using_if_exists__));
using ::log1pl __attribute__((__using_if_exists__));
using ::log2l __attribute__((__using_if_exists__));
using ::logbl __attribute__((__using_if_exists__));
using ::lrintl __attribute__((__using_if_exists__));
using ::lroundl __attribute__((__using_if_exists__));
using ::nanl __attribute__((__using_if_exists__));
using ::nearbyintl __attribute__((__using_if_exists__));
using ::nextafterl __attribute__((__using_if_exists__));
using ::nexttowardl __attribute__((__using_if_exists__));
using ::remainderl __attribute__((__using_if_exists__));
using ::remquol __attribute__((__using_if_exists__));
using ::rintl __attribute__((__using_if_exists__));
using ::roundl __attribute__((__using_if_exists__));
using ::scalblnl __attribute__((__using_if_exists__));
using ::scalbnl __attribute__((__using_if_exists__));
using ::tgammal __attribute__((__using_if_exists__));
using ::truncl __attribute__((__using_if_exists__));
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float hypot( float __x, float __y, float __z ) { return sqrt(__x*__x + __y*__y + __z*__z); }
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double hypot( double __x, double __y, double __z ) { return sqrt(__x*__x + __y*__y + __z*__z); }
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double hypot( long double __x, long double __y, long double __z ) { return sqrt(__x*__x + __y*__y + __z*__z); }
template <class _A1, class _A2, class _A3>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
typename enable_if_t
<
    is_arithmetic<_A1>::value &&
    is_arithmetic<_A2>::value &&
    is_arithmetic<_A3>::value,
    __promote<_A1, _A2, _A3>
>::type
hypot(_A1 __lcpp_x, _A2 __lcpp_y, _A3 __lcpp_z) noexcept
{
    typedef typename __promote<_A1, _A2, _A3>::type __result_type;
    static_assert((!(is_same<_A1, __result_type>::value &&
                     is_same<_A2, __result_type>::value &&
                     is_same<_A3, __result_type>::value)), "");
    return std::hypot((__result_type)__lcpp_x, (__result_type)__lcpp_y, (__result_type)__lcpp_z);
}
template <class _A1>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr typename enable_if<is_floating_point<_A1>::value, bool>::type
__constexpr_isnan(_A1 __lcpp_x) noexcept
{
    return __builtin_isnan(__lcpp_x);
}
template <class _A1>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr typename enable_if<!is_floating_point<_A1>::value, bool>::type
__constexpr_isnan(_A1 __lcpp_x) noexcept
{
    return std::isnan(__lcpp_x);
}
template <class _A1>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr typename enable_if<is_floating_point<_A1>::value, bool>::type
__constexpr_isinf(_A1 __lcpp_x) noexcept
{
    return __builtin_isinf(__lcpp_x);
}
template <class _A1>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr typename enable_if<!is_floating_point<_A1>::value, bool>::type
__constexpr_isinf(_A1 __lcpp_x) noexcept
{
    return std::isinf(__lcpp_x);
}
template <class _A1>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr typename enable_if<is_floating_point<_A1>::value, bool>::type
__constexpr_isfinite(_A1 __lcpp_x) noexcept
{
    return __builtin_isfinite(__lcpp_x);
}
template <class _A1>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr typename enable_if<!is_floating_point<_A1>::value, bool>::type
__constexpr_isfinite(_A1 __lcpp_x) noexcept
{
    return __builtin_isfinite(__lcpp_x);
}
constexpr inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) float __constexpr_copysign(float __x, float __y) noexcept {
    return __builtin_copysignf(__x, __y);
}
constexpr inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) double __constexpr_copysign(double __x, double __y) noexcept {
    return __builtin_copysign(__x, __y);
}
constexpr inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) long double
__constexpr_copysign(long double __x, long double __y) noexcept {
    return __builtin_copysignl(__x, __y);
}
template <class _A1, class _A2>
constexpr inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    typename std::__enable_if_t<std::is_arithmetic<_A1>::value && std::is_arithmetic<_A2>::value,
                                std::__promote<_A1, _A2> >::type
    __constexpr_copysign(_A1 __x, _A2 __y) noexcept {
    typedef typename std::__promote<_A1, _A2>::type __result_type;
    static_assert((!(std::_IsSame<_A1, __result_type>::value && std::_IsSame<_A2, __result_type>::value)), "");
    return __builtin_copysign((__result_type)__x, (__result_type)__y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr float __constexpr_fabs(float __x) noexcept {
    return __builtin_fabsf(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr double __constexpr_fabs(double __x) noexcept {
    return __builtin_fabs(__x);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr long double __constexpr_fabs(long double __x) noexcept {
    return __builtin_fabsl(__x);
}
template <class _Tp, __enable_if_t<is_integral<_Tp>::value, int> = 0>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr double __constexpr_fabs(_Tp __x) noexcept {
    return __builtin_fabs(static_cast<double>(__x));
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr float __constexpr_fmax(float __x, float __y) noexcept {
  return __builtin_fmaxf(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr double __constexpr_fmax(double __x, double __y) noexcept {
  return __builtin_fmax(__x, __y);
}
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr long double
__constexpr_fmax(long double __x, long double __y) noexcept {
  return __builtin_fmaxl(__x, __y);
}
template <class _Tp, class _Up, __enable_if_t<is_arithmetic<_Tp>::value && is_arithmetic<_Up>::value, int> = 0>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr typename __promote<_Tp, _Up>::type
__constexpr_fmax(_Tp __x, _Up __y) noexcept {
  using __result_type = typename __promote<_Tp, _Up>::type;
  return std::__constexpr_fmax(static_cast<__result_type>(__x), static_cast<__result_type>(__y));
}
template <class _Tp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _Tp __constexpr_logb(_Tp __x) {
  if (__libcpp_is_constant_evaluated()) {
    if (__x == _Tp(0)) {
      return -numeric_limits<_Tp>::infinity();
    }
    if (std::__constexpr_isinf(__x))
      return numeric_limits<_Tp>::infinity();
    if (std::__constexpr_isnan(__x))
      return numeric_limits<_Tp>::quiet_NaN();
    __x = std::__constexpr_fabs(__x);
    unsigned long long __exp = 0;
    while (__x >= numeric_limits<_Tp>::radix) {
      __x /= numeric_limits<_Tp>::radix;
      __exp += 1;
    }
    return _Tp(__exp);
  }
  return __builtin_logb(__x);
}
template <class _Tp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _Tp __constexpr_scalbn(_Tp __x, int __exp) {
  if (__libcpp_is_constant_evaluated()) {
    if (__x == _Tp(0))
      return __x;
    if (std::__constexpr_isinf(__x))
      return __x;
    if (__exp == _Tp(0))
      return __x;
    if (std::__constexpr_isnan(__x))
      return numeric_limits<_Tp>::quiet_NaN();
    _Tp __mult(1);
    if (__exp > 0) {
      __mult = numeric_limits<_Tp>::radix;
      --__exp;
    } else {
      ++__exp;
      __exp = -__exp;
      __mult /= numeric_limits<_Tp>::radix;
    }
    while (__exp > 0) {
      if (!(__exp & 1)) {
        __mult *= __mult;
        __exp >>= 1;
      } else {
        __x *= __mult;
        --__exp;
      }
    }
    return __x;
  }
  return __builtin_scalbn(__x, __exp);
}
template <typename _Fp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
_Fp __lerp(_Fp __a, _Fp __b, _Fp __t) noexcept {
    if ((__a <= 0 && __b >= 0) || (__a >= 0 && __b <= 0))
        return __t * __b + (1 - __t) * __a;
    if (__t == 1) return __b;
    const _Fp __x = __a + __t * (__b - __a);
    if ((__t > 1) == (__b > __a))
        return __b < __x ? __x : __b;
    else
        return __x < __b ? __x : __b;
}
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr float
lerp(float __a, float __b, float __t) noexcept { return __lerp(__a, __b, __t); }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr double
lerp(double __a, double __b, double __t) noexcept { return __lerp(__a, __b, __t); }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr long double
lerp(long double __a, long double __b, long double __t) noexcept { return __lerp(__a, __b, __t); }
template <class _A1, class _A2, class _A3>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr typename enable_if_t
<
    is_arithmetic<_A1>::value &&
    is_arithmetic<_A2>::value &&
    is_arithmetic<_A3>::value,
    __promote<_A1, _A2, _A3>
>::type
lerp(_A1 __a, _A2 __b, _A3 __t) noexcept
{
    typedef typename __promote<_A1, _A2, _A3>::type __result_type;
    static_assert(!(_IsSame<_A1, __result_type>::value &&
                    _IsSame<_A2, __result_type>::value &&
                    _IsSame<_A3, __result_type>::value));
    return std::__lerp((__result_type)__a, (__result_type)__b, (__result_type)__t);
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
namespace __strong_order {
    struct __fn {
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<2>)
            noexcept(noexcept(strong_ordering(strong_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)))))
            -> decltype( strong_ordering(strong_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            { return strong_ordering(strong_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))); }
        template<class _Tp, class _Up, class _Dp = decay_t<_Tp>>
            requires is_same_v<_Dp, decay_t<_Up>> && is_floating_point_v<_Dp>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr strong_ordering
        __go(_Tp&& __t, _Up&& __u, __priority_tag<1>) noexcept
        {
            if constexpr (numeric_limits<_Dp>::is_iec559 && sizeof(_Dp) == sizeof(int32_t)) {
                int32_t __rx = std::bit_cast<int32_t>(__t);
                int32_t __ry = std::bit_cast<int32_t>(__u);
                __rx = (__rx < 0) ? (numeric_limits<int32_t>::min() - __rx - 1) : __rx;
                __ry = (__ry < 0) ? (numeric_limits<int32_t>::min() - __ry - 1) : __ry;
                return (__rx <=> __ry);
            } else if constexpr (numeric_limits<_Dp>::is_iec559 && sizeof(_Dp) == sizeof(int64_t)) {
                int64_t __rx = std::bit_cast<int64_t>(__t);
                int64_t __ry = std::bit_cast<int64_t>(__u);
                __rx = (__rx < 0) ? (numeric_limits<int64_t>::min() - __rx - 1) : __rx;
                __ry = (__ry < 0) ? (numeric_limits<int64_t>::min() - __ry - 1) : __ry;
                return (__rx <=> __ry);
            } else if (__t < __u) {
                return strong_ordering::less;
            } else if (__t > __u) {
                return strong_ordering::greater;
            } else if (__t == __u) {
                if constexpr (numeric_limits<_Dp>::radix == 2) {
                    return std::signbit(__u) <=> std::signbit(__t);
                } else {
                    if (__t == 0 || std::isinf(__t)) {
                        return std::signbit(__u) <=> std::signbit(__t);
                    } else {
                        int __texp, __uexp;
                        (void)std::frexp(__t, &__texp);
                        (void)std::frexp(__u, &__uexp);
                        return (__t < 0) ? (__texp <=> __uexp) : (__uexp <=> __texp);
                    }
                }
            } else {
                bool __t_is_nan = std::isnan(__t);
                bool __u_is_nan = std::isnan(__u);
                bool __t_is_negative = std::signbit(__t);
                bool __u_is_negative = std::signbit(__u);
                using _IntType = conditional_t<
                    sizeof(__t) == sizeof(int32_t), int32_t, conditional_t<
                    sizeof(__t) == sizeof(int64_t), int64_t, void>
                >;
                if constexpr (is_same_v<_IntType, void>) {
                    static_assert(sizeof(_Dp) == 0, "std::strong_order is unimplemented for this floating-point type");
                } else if (__t_is_nan && __u_is_nan) {
                    if (__t_is_negative != __u_is_negative) {
                        return (__u_is_negative <=> __t_is_negative);
                    } else {
                        return std::bit_cast<_IntType>(__t) <=> std::bit_cast<_IntType>(__u);
                    }
                } else if (__t_is_nan) {
                    return __t_is_negative ? strong_ordering::less : strong_ordering::greater;
                } else {
                    return __u_is_negative ? strong_ordering::greater : strong_ordering::less;
                }
            }
        }
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<0>)
            noexcept(noexcept(strong_ordering(compare_three_way()(std::forward<_Tp>(__t), std::forward<_Up>(__u)))))
            -> decltype( strong_ordering(compare_three_way()(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            { return strong_ordering(compare_three_way()(std::forward<_Tp>(__t), std::forward<_Up>(__u))); }
        template<class _Tp, class _Up>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto operator()(_Tp&& __t, _Up&& __u) const
            noexcept(noexcept(__go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<2>())))
            -> decltype( __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<2>()))
            { return __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<2>()); }
    };
}
inline namespace __cpo {
    inline constexpr auto strong_order = __strong_order::__fn{};
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
namespace __weak_order {
    struct __fn {
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<3>)
            noexcept(noexcept(weak_ordering(weak_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)))))
            -> decltype( weak_ordering(weak_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            { return weak_ordering(weak_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))); }
        template<class _Tp, class _Up, class _Dp = decay_t<_Tp>>
            requires is_same_v<_Dp, decay_t<_Up>> && is_floating_point_v<_Dp>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr weak_ordering
        __go(_Tp&& __t, _Up&& __u, __priority_tag<2>) noexcept
        {
            partial_ordering __po = (__t <=> __u);
            if (__po == partial_ordering::less) {
                return weak_ordering::less;
            } else if (__po == partial_ordering::equivalent) {
                return weak_ordering::equivalent;
            } else if (__po == partial_ordering::greater) {
                return weak_ordering::greater;
            } else {
                bool __t_is_nan = std::isnan(__t);
                bool __u_is_nan = std::isnan(__u);
                bool __t_is_negative = std::signbit(__t);
                bool __u_is_negative = std::signbit(__u);
                if (__t_is_nan && __u_is_nan) {
                    return (__u_is_negative <=> __t_is_negative);
                } else if (__t_is_nan) {
                    return __t_is_negative ? weak_ordering::less : weak_ordering::greater;
                } else {
                    return __u_is_negative ? weak_ordering::greater : weak_ordering::less;
                }
            }
        }
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<1>)
            noexcept(noexcept(weak_ordering(compare_three_way()(std::forward<_Tp>(__t), std::forward<_Up>(__u)))))
            -> decltype( weak_ordering(compare_three_way()(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            { return weak_ordering(compare_three_way()(std::forward<_Tp>(__t), std::forward<_Up>(__u))); }
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<0>)
            noexcept(noexcept(weak_ordering(std::strong_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)))))
            -> decltype( weak_ordering(std::strong_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            { return weak_ordering(std::strong_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))); }
        template<class _Tp, class _Up>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto operator()(_Tp&& __t, _Up&& __u) const
            noexcept(noexcept(__go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<3>())))
            -> decltype( __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<3>()))
            { return __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<3>()); }
    };
}
inline namespace __cpo {
    inline constexpr auto weak_order = __weak_order::__fn{};
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
namespace __partial_order {
    struct __fn {
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<2>)
            noexcept(noexcept(partial_ordering(partial_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)))))
            -> decltype( partial_ordering(partial_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            { return partial_ordering(partial_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))); }
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<1>)
            noexcept(noexcept(partial_ordering(compare_three_way()(std::forward<_Tp>(__t), std::forward<_Up>(__u)))))
            -> decltype( partial_ordering(compare_three_way()(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            { return partial_ordering(compare_three_way()(std::forward<_Tp>(__t), std::forward<_Up>(__u))); }
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<0>)
            noexcept(noexcept(partial_ordering(std::weak_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)))))
            -> decltype( partial_ordering(std::weak_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            { return partial_ordering(std::weak_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))); }
        template<class _Tp, class _Up>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto operator()(_Tp&& __t, _Up&& __u) const
            noexcept(noexcept(__go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<2>())))
            -> decltype( __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<2>()))
            { return __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<2>()); }
    };
}
inline namespace __cpo {
    inline constexpr auto partial_order = __partial_order::__fn{};
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
namespace __compare_partial_order_fallback {
    struct __fn {
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<1>)
            noexcept(noexcept(std::partial_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            -> decltype( std::partial_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)))
            { return std::partial_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)); }
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<0>)
            noexcept(noexcept(std::forward<_Tp>(__t) == std::forward<_Up>(__u) ? partial_ordering::equivalent :
                              std::forward<_Tp>(__t) < std::forward<_Up>(__u) ? partial_ordering::less :
                              std::forward<_Up>(__u) < std::forward<_Tp>(__t) ? partial_ordering::greater :
                              partial_ordering::unordered))
            -> decltype( std::forward<_Tp>(__t) == std::forward<_Up>(__u) ? partial_ordering::equivalent :
                              std::forward<_Tp>(__t) < std::forward<_Up>(__u) ? partial_ordering::less :
                              std::forward<_Up>(__u) < std::forward<_Tp>(__t) ? partial_ordering::greater :
                              partial_ordering::unordered)
        {
            return std::forward<_Tp>(__t) == std::forward<_Up>(__u) ? partial_ordering::equivalent :
                              std::forward<_Tp>(__t) < std::forward<_Up>(__u) ? partial_ordering::less :
                              std::forward<_Up>(__u) < std::forward<_Tp>(__t) ? partial_ordering::greater :
                              partial_ordering::unordered;
        }
        template<class _Tp, class _Up>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto operator()(_Tp&& __t, _Up&& __u) const
            noexcept(noexcept(__go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<1>())))
            -> decltype( __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<1>()))
            { return __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<1>()); }
    };
}
inline namespace __cpo {
    inline constexpr auto compare_partial_order_fallback = __compare_partial_order_fallback::__fn{};
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
namespace __compare_strong_order_fallback {
    struct __fn {
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<1>)
            noexcept(noexcept(std::strong_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            -> decltype( std::strong_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)))
            { return std::strong_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)); }
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<0>)
            noexcept(noexcept(std::forward<_Tp>(__t) == std::forward<_Up>(__u) ? strong_ordering::equal :
                              std::forward<_Tp>(__t) < std::forward<_Up>(__u) ? strong_ordering::less :
                              strong_ordering::greater))
            -> decltype( std::forward<_Tp>(__t) == std::forward<_Up>(__u) ? strong_ordering::equal :
                              std::forward<_Tp>(__t) < std::forward<_Up>(__u) ? strong_ordering::less :
                              strong_ordering::greater)
        {
            return std::forward<_Tp>(__t) == std::forward<_Up>(__u) ? strong_ordering::equal :
                              std::forward<_Tp>(__t) < std::forward<_Up>(__u) ? strong_ordering::less :
                              strong_ordering::greater;
        }
        template<class _Tp, class _Up>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto operator()(_Tp&& __t, _Up&& __u) const
            noexcept(noexcept(__go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<1>())))
            -> decltype( __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<1>()))
            { return __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<1>()); }
    };
}
inline namespace __cpo {
    inline constexpr auto compare_strong_order_fallback = __compare_strong_order_fallback::__fn{};
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
namespace __compare_weak_order_fallback {
    struct __fn {
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<1>)
            noexcept(noexcept(std::weak_order(std::forward<_Tp>(__t), std::forward<_Up>(__u))))
            -> decltype( std::weak_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)))
            { return std::weak_order(std::forward<_Tp>(__t), std::forward<_Up>(__u)); }
        template<class _Tp, class _Up>
            requires is_same_v<decay_t<_Tp>, decay_t<_Up>>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) static constexpr auto
        __go(_Tp&& __t, _Up&& __u, __priority_tag<0>)
            noexcept(noexcept(std::forward<_Tp>(__t) == std::forward<_Up>(__u) ? weak_ordering::equivalent :
                              std::forward<_Tp>(__t) < std::forward<_Up>(__u) ? weak_ordering::less :
                              weak_ordering::greater))
            -> decltype( std::forward<_Tp>(__t) == std::forward<_Up>(__u) ? weak_ordering::equivalent :
                              std::forward<_Tp>(__t) < std::forward<_Up>(__u) ? weak_ordering::less :
                              weak_ordering::greater)
        {
            return std::forward<_Tp>(__t) == std::forward<_Up>(__u) ? weak_ordering::equivalent :
                              std::forward<_Tp>(__t) < std::forward<_Up>(__u) ? weak_ordering::less :
                              weak_ordering::greater;
        }
        template<class _Tp, class _Up>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr auto operator()(_Tp&& __t, _Up&& __u) const
            noexcept(noexcept(__go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<1>())))
            -> decltype( __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<1>()))
            { return __go(std::forward<_Tp>(__t), std::forward<_Up>(__u), __priority_tag<1>()); }
    };
}
inline namespace __cpo {
    inline constexpr auto compare_weak_order_fallback = __compare_weak_order_fallback::__fn{};
}
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) inline constexpr bool is_eq(partial_ordering __c) noexcept { return __c == 0; }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) inline constexpr bool is_neq(partial_ordering __c) noexcept { return __c != 0; }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) inline constexpr bool is_lt(partial_ordering __c) noexcept { return __c < 0; }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) inline constexpr bool is_lteq(partial_ordering __c) noexcept { return __c <= 0; }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) inline constexpr bool is_gt(partial_ordering __c) noexcept { return __c > 0; }
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) inline constexpr bool is_gteq(partial_ordering __c) noexcept { return __c >= 0; }
}}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template <size_t _Ip, class _Hp,
          bool=is_empty<_Hp>::value && !__libcpp_is_final<_Hp>::value
         >
class __tuple_leaf;
template <size_t _Ip, class _Hp, bool _Ep>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
void swap(__tuple_leaf<_Ip, _Hp, _Ep>& __x, __tuple_leaf<_Ip, _Hp, _Ep>& __y)
    noexcept(__is_nothrow_swappable<_Hp>::value)
{
    swap(__x.get(), __y.get());
}
template <size_t _Ip, class _Hp, bool _Ep>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
void swap(const __tuple_leaf<_Ip, _Hp, _Ep>& __x, const __tuple_leaf<_Ip, _Hp, _Ep>& __y)
     noexcept(__is_nothrow_swappable<const _Hp>::value) {
  swap(__x.get(), __y.get());
}
template <size_t _Ip, class _Hp, bool>
class __tuple_leaf
{
    _Hp __value_;
    template <class _Tp>
    static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr bool __can_bind_reference() {
      return !__reference_binds_to_temporary(_Hp, _Tp);
    }
    constexpr
    __tuple_leaf& operator=(const __tuple_leaf&);
public:
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr __tuple_leaf()
             noexcept(is_nothrow_default_constructible<_Hp>::value) : __value_()
       {static_assert(!is_reference<_Hp>::value,
              "Attempted to default construct a reference element in a tuple");}
    template <class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        __tuple_leaf(integral_constant<int, 0>, const _Alloc&)
            : __value_()
        {static_assert(!is_reference<_Hp>::value,
              "Attempted to default construct a reference element in a tuple");}
    template <class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        __tuple_leaf(integral_constant<int, 1>, const _Alloc& __a)
            : __value_(allocator_arg_t(), __a)
        {static_assert(!is_reference<_Hp>::value,
              "Attempted to default construct a reference element in a tuple");}
    template <class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        __tuple_leaf(integral_constant<int, 2>, const _Alloc& __a)
            : __value_(__a)
        {static_assert(!is_reference<_Hp>::value,
              "Attempted to default construct a reference element in a tuple");}
    template <class _Tp,
              class = __enable_if_t<
                  _And<
                      _IsNotSame<__remove_cvref_t<_Tp>, __tuple_leaf>,
                      is_constructible<_Hp, _Tp>
                    >::value
                >
            >
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit __tuple_leaf(_Tp&& __t) noexcept((is_nothrow_constructible<_Hp, _Tp>::value))
            : __value_(std::forward<_Tp>(__t))
        {static_assert(__can_bind_reference<_Tp&&>(),
       "Attempted construction of reference element binds to a temporary whose lifetime has ended");}
    template <class _Tp, class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit __tuple_leaf(integral_constant<int, 0>, const _Alloc&, _Tp&& __t)
            : __value_(std::forward<_Tp>(__t))
        {static_assert(__can_bind_reference<_Tp&&>(),
       "Attempted construction of reference element binds to a temporary whose lifetime has ended");}
    template <class _Tp, class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit __tuple_leaf(integral_constant<int, 1>, const _Alloc& __a, _Tp&& __t)
            : __value_(allocator_arg_t(), __a, std::forward<_Tp>(__t))
        {static_assert(!is_reference<_Hp>::value,
            "Attempted to uses-allocator construct a reference element in a tuple");}
    template <class _Tp, class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit __tuple_leaf(integral_constant<int, 2>, const _Alloc& __a, _Tp&& __t)
            : __value_(std::forward<_Tp>(__t), __a)
        {static_assert(!is_reference<_Hp>::value,
           "Attempted to uses-allocator construct a reference element in a tuple");}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __tuple_leaf(const __tuple_leaf& __t) = default;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __tuple_leaf(__tuple_leaf&& __t) = default;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    int swap(__tuple_leaf& __t) noexcept(__is_nothrow_swappable<__tuple_leaf>::value)
    {
        std::swap(*this, __t);
        return 0;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    int swap(const __tuple_leaf& __t) const noexcept(__is_nothrow_swappable<const __tuple_leaf>::value) {
        std::swap(*this, __t);
        return 0;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _Hp& get() noexcept {return __value_;}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr const _Hp& get() const noexcept {return __value_;}
};
template <size_t _Ip, class _Hp>
class __tuple_leaf<_Ip, _Hp, true>
    : private _Hp
{
    constexpr
    __tuple_leaf& operator=(const __tuple_leaf&);
public:
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr __tuple_leaf()
             noexcept(is_nothrow_default_constructible<_Hp>::value) {}
    template <class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        __tuple_leaf(integral_constant<int, 0>, const _Alloc&) {}
    template <class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        __tuple_leaf(integral_constant<int, 1>, const _Alloc& __a)
            : _Hp(allocator_arg_t(), __a) {}
    template <class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        __tuple_leaf(integral_constant<int, 2>, const _Alloc& __a)
            : _Hp(__a) {}
    template <class _Tp,
              class = __enable_if_t<
                  _And<
                    _IsNotSame<__remove_cvref_t<_Tp>, __tuple_leaf>,
                    is_constructible<_Hp, _Tp>
                  >::value
                >
            >
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit __tuple_leaf(_Tp&& __t) noexcept((is_nothrow_constructible<_Hp, _Tp>::value))
            : _Hp(std::forward<_Tp>(__t)) {}
    template <class _Tp, class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit __tuple_leaf(integral_constant<int, 0>, const _Alloc&, _Tp&& __t)
            : _Hp(std::forward<_Tp>(__t)) {}
    template <class _Tp, class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit __tuple_leaf(integral_constant<int, 1>, const _Alloc& __a, _Tp&& __t)
            : _Hp(allocator_arg_t(), __a, std::forward<_Tp>(__t)) {}
    template <class _Tp, class _Alloc>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit __tuple_leaf(integral_constant<int, 2>, const _Alloc& __a, _Tp&& __t)
            : _Hp(std::forward<_Tp>(__t), __a) {}
    __tuple_leaf(__tuple_leaf const &) = default;
    __tuple_leaf(__tuple_leaf &&) = default;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    int
    swap(__tuple_leaf& __t) noexcept(__is_nothrow_swappable<__tuple_leaf>::value)
    {
        std::swap(*this, __t);
        return 0;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    int swap(const __tuple_leaf& __rhs) const noexcept(__is_nothrow_swappable<const __tuple_leaf>::value) {
        std::swap(*this, __rhs);
        return 0;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr _Hp& get() noexcept {return static_cast<_Hp&>(*this);}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr const _Hp& get() const noexcept {return static_cast<const _Hp&>(*this);}
};
template <class ..._Tp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
void __swallow(_Tp&&...) noexcept {}
template <class _Tp>
struct __all_default_constructible;
template <class ..._Tp>
struct __all_default_constructible<__tuple_types<_Tp...>>
    : __all<is_default_constructible<_Tp>::value...>
{ };
template<class _Indx, class ..._Tp> struct __tuple_impl;
template<size_t ..._Indx, class ..._Tp>
struct __declspec(empty_bases) __tuple_impl<__tuple_indices<_Indx...>, _Tp...>
    : public __tuple_leaf<_Indx, _Tp>...
{
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    constexpr __tuple_impl()
        noexcept(__all<is_nothrow_default_constructible<_Tp>::value...>::value) {}
    template <size_t ..._Uf, class ..._Tf,
              size_t ..._Ul, class ..._Tl, class ..._Up>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit
        __tuple_impl(__tuple_indices<_Uf...>, __tuple_types<_Tf...>,
                     __tuple_indices<_Ul...>, __tuple_types<_Tl...>,
                     _Up&&... __u)
                     noexcept((__all<is_nothrow_constructible<_Tf, _Up>::value...>::value && __all<is_nothrow_default_constructible<_Tl>::value...>::value)) :
            __tuple_leaf<_Uf, _Tf>(std::forward<_Up>(__u))...,
            __tuple_leaf<_Ul, _Tl>()...
            {}
    template <class _Alloc, size_t ..._Uf, class ..._Tf,
              size_t ..._Ul, class ..._Tl, class ..._Up>
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit
        __tuple_impl(allocator_arg_t, const _Alloc& __a,
                     __tuple_indices<_Uf...>, __tuple_types<_Tf...>,
                     __tuple_indices<_Ul...>, __tuple_types<_Tl...>,
                     _Up&&... __u) :
            __tuple_leaf<_Uf, _Tf>(__uses_alloc_ctor<_Tf, _Alloc, _Up>(), __a,
            std::forward<_Up>(__u))...,
            __tuple_leaf<_Ul, _Tl>(__uses_alloc_ctor<_Tl, _Alloc>(), __a)...
            {}
    template <class _Tuple,
              class = __enable_if_t<__tuple_constructible<_Tuple, tuple<_Tp...> >::value>
             >
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        __tuple_impl(_Tuple&& __t) noexcept((__all<is_nothrow_constructible<_Tp, typename tuple_element<_Indx, typename __make_tuple_types<_Tuple>::type>::type>::value...>::value))
            : __tuple_leaf<_Indx, _Tp>(std::forward<typename tuple_element<_Indx,
                                       typename __make_tuple_types<_Tuple>::type>::type>(std::get<_Indx>(__t)))...
            {}
    template <class _Alloc, class _Tuple,
              class = __enable_if_t<__tuple_constructible<_Tuple, tuple<_Tp...> >::value>
             >
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        __tuple_impl(allocator_arg_t, const _Alloc& __a, _Tuple&& __t)
            : __tuple_leaf<_Indx, _Tp>(__uses_alloc_ctor<_Tp, _Alloc, typename tuple_element<_Indx,
                                       typename __make_tuple_types<_Tuple>::type>::type>(), __a,
                                       std::forward<typename tuple_element<_Indx,
                                       typename __make_tuple_types<_Tuple>::type>::type>(std::get<_Indx>(__t)))...
            {}
    __tuple_impl(const __tuple_impl&) = default;
    __tuple_impl(__tuple_impl&&) = default;
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    void swap(__tuple_impl& __t)
        noexcept(__all<__is_nothrow_swappable<_Tp>::value...>::value)
    {
        std::__swallow(__tuple_leaf<_Indx, _Tp>::swap(static_cast<__tuple_leaf<_Indx, _Tp>&>(__t))...);
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    void swap(const __tuple_impl& __t) const
        noexcept(__all<__is_nothrow_swappable<const _Tp>::value...>::value)
    {
        std::__swallow(__tuple_leaf<_Indx, _Tp>::swap(static_cast<const __tuple_leaf<_Indx, _Tp>&>(__t))...);
    }
};
template<class _Dest, class _Source, size_t ..._Np>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
void __memberwise_copy_assign(_Dest& __dest, _Source const& __source, __tuple_indices<_Np...>) {
    std::__swallow(((std::get<_Np>(__dest) = std::get<_Np>(__source)), void(), 0)...);
}
template<class _Dest, class _Source, class ..._Up, size_t ..._Np>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
void __memberwise_forward_assign(_Dest& __dest, _Source&& __source, __tuple_types<_Up...>, __tuple_indices<_Np...>) {
    std::__swallow(((
        std::get<_Np>(__dest) = std::forward<_Up>(std::get<_Np>(__source))
    ), void(), 0)...);
}
template <class ..._Tp>
class tuple
{
    typedef __tuple_impl<typename __make_tuple_indices<sizeof...(_Tp)>::type, _Tp...> _BaseT;
    _BaseT __base_;
    template <size_t _Jp, class ..._Up> friend constexpr
        typename tuple_element<_Jp, tuple<_Up...> >::type& get(tuple<_Up...>&) noexcept;
    template <size_t _Jp, class ..._Up> friend constexpr
        const typename tuple_element<_Jp, tuple<_Up...> >::type& get(const tuple<_Up...>&) noexcept;
    template <size_t _Jp, class ..._Up> friend constexpr
        typename tuple_element<_Jp, tuple<_Up...> >::type&& get(tuple<_Up...>&&) noexcept;
    template <size_t _Jp, class ..._Up> friend constexpr
        const typename tuple_element<_Jp, tuple<_Up...> >::type&& get(const tuple<_Up...>&&) noexcept;
public:
    template <template<class...> class _IsImpDefault = __is_implicitly_default_constructible, __enable_if_t<
        _And<
            _IsImpDefault<_Tp>...
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple()
        noexcept(_And<is_nothrow_default_constructible<_Tp>...>::value)
    { }
    template <template<class...> class _IsImpDefault = __is_implicitly_default_constructible,
              template<class...> class _IsDefault = is_default_constructible, __enable_if_t<
        _And<
            _IsDefault<_Tp>...,
            _Not<_Lazy<_And, _IsImpDefault<_Tp>...> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple()
        noexcept(_And<is_nothrow_default_constructible<_Tp>...>::value)
    { }
    template <class _Alloc, template<class...> class _IsImpDefault = __is_implicitly_default_constructible, __enable_if_t<
        _And<
            _IsImpDefault<_Tp>...
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(allocator_arg_t, _Alloc const& __a)
      : __base_(allocator_arg_t(), __a,
                    __tuple_indices<>(), __tuple_types<>(),
                    typename __make_tuple_indices<sizeof...(_Tp), 0>::type(),
                    __tuple_types<_Tp...>()) {}
    template <class _Alloc,
              template<class...> class _IsImpDefault = __is_implicitly_default_constructible,
              template<class...> class _IsDefault = is_default_constructible, __enable_if_t<
        _And<
            _IsDefault<_Tp>...,
            _Not<_Lazy<_And, _IsImpDefault<_Tp>...> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(allocator_arg_t, _Alloc const& __a)
      : __base_(allocator_arg_t(), __a,
                    __tuple_indices<>(), __tuple_types<>(),
                    typename __make_tuple_indices<sizeof...(_Tp), 0>::type(),
                    __tuple_types<_Tp...>()) {}
    template <template<class...> class _And = _And, __enable_if_t<
        _And<
            _BoolConstant<sizeof...(_Tp) >= 1>,
            is_copy_constructible<_Tp>...,
            is_convertible<const _Tp&, _Tp>...
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(const _Tp& ... __t)
        noexcept(_And<is_nothrow_copy_constructible<_Tp>...>::value)
        : __base_(typename __make_tuple_indices<sizeof...(_Tp)>::type(),
                typename __make_tuple_types<tuple, sizeof...(_Tp)>::type(),
                typename __make_tuple_indices<0>::type(),
                typename __make_tuple_types<tuple, 0>::type(),
                __t...
               ) {}
    template <template<class...> class _And = _And, __enable_if_t<
        _And<
            _BoolConstant<sizeof...(_Tp) >= 1>,
            is_copy_constructible<_Tp>...,
            _Not<_Lazy<_And, is_convertible<const _Tp&, _Tp>...> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(const _Tp& ... __t)
        noexcept(_And<is_nothrow_copy_constructible<_Tp>...>::value)
        : __base_(typename __make_tuple_indices<sizeof...(_Tp)>::type(),
                typename __make_tuple_types<tuple, sizeof...(_Tp)>::type(),
                typename __make_tuple_indices<0>::type(),
                typename __make_tuple_types<tuple, 0>::type(),
                __t...
               ) {}
    template <class _Alloc, template<class...> class _And = _And, __enable_if_t<
        _And<
            _BoolConstant<sizeof...(_Tp) >= 1>,
            is_copy_constructible<_Tp>...,
            is_convertible<const _Tp&, _Tp>...
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(allocator_arg_t, const _Alloc& __a, const _Tp& ... __t)
        : __base_(allocator_arg_t(), __a,
                typename __make_tuple_indices<sizeof...(_Tp)>::type(),
                typename __make_tuple_types<tuple, sizeof...(_Tp)>::type(),
                typename __make_tuple_indices<0>::type(),
                typename __make_tuple_types<tuple, 0>::type(),
                __t...
               ) {}
    template <class _Alloc, template<class...> class _And = _And, __enable_if_t<
        _And<
            _BoolConstant<sizeof...(_Tp) >= 1>,
            is_copy_constructible<_Tp>...,
            _Not<_Lazy<_And, is_convertible<const _Tp&, _Tp>...> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(allocator_arg_t, const _Alloc& __a, const _Tp& ... __t)
        : __base_(allocator_arg_t(), __a,
                typename __make_tuple_indices<sizeof...(_Tp)>::type(),
                typename __make_tuple_types<tuple, sizeof...(_Tp)>::type(),
                typename __make_tuple_indices<0>::type(),
                typename __make_tuple_types<tuple, 0>::type(),
                __t...
               ) {}
    template <class ..._Up> struct _IsThisTuple : false_type { };
    template <class _Up> struct _IsThisTuple<_Up> : is_same<__remove_cvref_t<_Up>, tuple> { };
    template <class ..._Up>
    struct _EnableUTypesCtor : _And<
        _BoolConstant<sizeof...(_Tp) >= 1>,
        _Not<_IsThisTuple<_Up...> >,
        is_constructible<_Tp, _Up>...
    > { };
    template <class ..._Up, __enable_if_t<
        _And<
            _BoolConstant<sizeof...(_Up) == sizeof...(_Tp)>,
            _EnableUTypesCtor<_Up...>,
            is_convertible<_Up, _Tp>...
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(_Up&&... __u)
        noexcept((_And<is_nothrow_constructible<_Tp, _Up>...>::value))
        : __base_(typename __make_tuple_indices<sizeof...(_Up)>::type(),
                    typename __make_tuple_types<tuple, sizeof...(_Up)>::type(),
                    typename __make_tuple_indices<sizeof...(_Tp), sizeof...(_Up)>::type(),
                    typename __make_tuple_types<tuple, sizeof...(_Tp), sizeof...(_Up)>::type(),
                    std::forward<_Up>(__u)...) {}
    template <class ..._Up, __enable_if_t<
        _And<
            _BoolConstant<sizeof...(_Up) == sizeof...(_Tp)>,
            _EnableUTypesCtor<_Up...>,
            _Not<_Lazy<_And, is_convertible<_Up, _Tp>...> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(_Up&&... __u)
        noexcept((_And<is_nothrow_constructible<_Tp, _Up>...>::value))
        : __base_(typename __make_tuple_indices<sizeof...(_Up)>::type(),
                    typename __make_tuple_types<tuple, sizeof...(_Up)>::type(),
                    typename __make_tuple_indices<sizeof...(_Tp), sizeof...(_Up)>::type(),
                    typename __make_tuple_types<tuple, sizeof...(_Tp), sizeof...(_Up)>::type(),
                    std::forward<_Up>(__u)...) {}
    template <class _Alloc, class ..._Up, __enable_if_t<
        _And<
            _BoolConstant<sizeof...(_Up) == sizeof...(_Tp)>,
            _EnableUTypesCtor<_Up...>,
            is_convertible<_Up, _Tp>...
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(allocator_arg_t, const _Alloc& __a, _Up&&... __u)
        : __base_(allocator_arg_t(), __a,
                    typename __make_tuple_indices<sizeof...(_Up)>::type(),
                    typename __make_tuple_types<tuple, sizeof...(_Up)>::type(),
                    typename __make_tuple_indices<sizeof...(_Tp), sizeof...(_Up)>::type(),
                    typename __make_tuple_types<tuple, sizeof...(_Tp), sizeof...(_Up)>::type(),
                    std::forward<_Up>(__u)...) {}
    template <class _Alloc, class ..._Up, __enable_if_t<
        _And<
            _BoolConstant<sizeof...(_Up) == sizeof...(_Tp)>,
            _EnableUTypesCtor<_Up...>,
            _Not<_Lazy<_And, is_convertible<_Up, _Tp>...> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(allocator_arg_t, const _Alloc& __a, _Up&&... __u)
        : __base_(allocator_arg_t(), __a,
                    typename __make_tuple_indices<sizeof...(_Up)>::type(),
                    typename __make_tuple_types<tuple, sizeof...(_Up)>::type(),
                    typename __make_tuple_indices<sizeof...(_Tp), sizeof...(_Up)>::type(),
                    typename __make_tuple_types<tuple, sizeof...(_Tp), sizeof...(_Up)>::type(),
                    std::forward<_Up>(__u)...) {}
    tuple(const tuple&) = default;
    tuple(tuple&&) = default;
    template <class _Alloc, template<class...> class _And = _And, __enable_if_t<
        _And<is_copy_constructible<_Tp>...>::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(allocator_arg_t, const _Alloc& __alloc, const tuple& __t)
        : __base_(allocator_arg_t(), __alloc, __t)
    { }
    template <class _Alloc, template<class...> class _And = _And, __enable_if_t<
        _And<is_move_constructible<_Tp>...>::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(allocator_arg_t, const _Alloc& __alloc, tuple&& __t)
        : __base_(allocator_arg_t(), __alloc, std::move(__t))
    { }
    template <class _OtherTuple, class _DecayedOtherTuple = __remove_cvref_t<_OtherTuple>, class = void>
    struct _EnableCtorFromUTypesTuple : false_type {};
    template <class _OtherTuple, class... _Up>
    struct _EnableCtorFromUTypesTuple<_OtherTuple, tuple<_Up...>,
               __enable_if_t<sizeof...(_Up) == sizeof...(_Tp)>> : _And<
        _Not<is_same<_OtherTuple, const tuple&> >,
        _Not<is_same<_OtherTuple, tuple&&> >,
        is_constructible<_Tp, __copy_cvref_t<_OtherTuple, _Up> >...,
        _Lazy<_Or, _BoolConstant<sizeof...(_Tp) != 1>,
            _Lazy<_And,
                _Not<is_same<_Tp, _Up> >...,
                _Not<is_convertible<_OtherTuple, _Tp> >...,
                _Not<is_constructible<_Tp, _OtherTuple> >...
            >
        >
    > {};
    template <class ..._Up, __enable_if_t<
        _And<
            _EnableCtorFromUTypesTuple<const tuple<_Up...>&>,
            is_convertible<const _Up&, _Tp>...
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(const tuple<_Up...>& __t)
        noexcept((_And<is_nothrow_constructible<_Tp, const _Up&>...>::value))
        : __base_(__t)
    { }
    template <class ..._Up, __enable_if_t<
        _And<
            _EnableCtorFromUTypesTuple<const tuple<_Up...>&>,
            _Not<_Lazy<_And, is_convertible<const _Up&, _Tp>...> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(const tuple<_Up...>& __t)
        noexcept((_And<is_nothrow_constructible<_Tp, const _Up&>...>::value))
        : __base_(__t)
    { }
    template <class ..._Up, class _Alloc, __enable_if_t<
        _And<
            _EnableCtorFromUTypesTuple<const tuple<_Up...>&>,
            is_convertible<const _Up&, _Tp>...
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(allocator_arg_t, const _Alloc& __a, const tuple<_Up...>& __t)
        : __base_(allocator_arg_t(), __a, __t)
    { }
    template <class ..._Up, class _Alloc, __enable_if_t<
        _And<
            _EnableCtorFromUTypesTuple<const tuple<_Up...>&>,
            _Not<_Lazy<_And, is_convertible<const _Up&, _Tp>...> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(allocator_arg_t, const _Alloc& __a, const tuple<_Up...>& __t)
        : __base_(allocator_arg_t(), __a, __t)
    { }
    template <class... _Up, enable_if_t<
        _EnableCtorFromUTypesTuple<tuple<_Up...>&>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit(!(is_convertible_v<_Up&, _Tp> && ...))
    tuple(tuple<_Up...>& __t) : __base_(__t) {}
    template <class _Alloc, class... _Up, enable_if_t<
        _EnableCtorFromUTypesTuple<tuple<_Up...>&>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit(!(is_convertible_v<_Up&, _Tp> && ...))
    tuple(allocator_arg_t, const _Alloc& __alloc, tuple<_Up...>& __t) : __base_(allocator_arg_t(), __alloc, __t) {}
    template <class ..._Up, __enable_if_t<
        _And<
            _EnableCtorFromUTypesTuple<tuple<_Up...>&&>,
            is_convertible<_Up, _Tp>...
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(tuple<_Up...>&& __t)
        noexcept((_And<is_nothrow_constructible<_Tp, _Up>...>::value))
        : __base_(std::move(__t))
    { }
    template <class ..._Up, __enable_if_t<
        _And<
            _EnableCtorFromUTypesTuple<tuple<_Up...>&&>,
            _Not<_Lazy<_And, is_convertible<_Up, _Tp>...> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(tuple<_Up...>&& __t)
        noexcept((_And<is_nothrow_constructible<_Tp, _Up>...>::value))
        : __base_(std::move(__t))
    { }
    template <class _Alloc, class ..._Up, __enable_if_t<
        _And<
            _EnableCtorFromUTypesTuple<tuple<_Up...>&&>,
            is_convertible<_Up, _Tp>...
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(allocator_arg_t, const _Alloc& __a, tuple<_Up...>&& __t)
        : __base_(allocator_arg_t(), __a, std::move(__t))
    { }
    template <class _Alloc, class ..._Up, __enable_if_t<
        _And<
            _EnableCtorFromUTypesTuple<tuple<_Up...>&&>,
            _Not<_Lazy<_And, is_convertible<_Up, _Tp>...> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(allocator_arg_t, const _Alloc& __a, tuple<_Up...>&& __t)
        : __base_(allocator_arg_t(), __a, std::move(__t))
    { }
    template <class... _Up, enable_if_t<
        _EnableCtorFromUTypesTuple<const tuple<_Up...>&&>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit(!(is_convertible_v<const _Up&&, _Tp> && ...))
    tuple(const tuple<_Up...>&& __t) : __base_(std::move(__t)) {}
    template <class _Alloc, class... _Up, enable_if_t<
        _EnableCtorFromUTypesTuple<const tuple<_Up...>&&>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit(!(is_convertible_v<const _Up&&, _Tp> && ...))
    tuple(allocator_arg_t, const _Alloc& __alloc, const tuple<_Up...>&& __t)
        : __base_(allocator_arg_t(), __alloc, std::move(__t)) {}
    template <template <class...> class _Pred, class _Pair, class _DecayedPair = __remove_cvref_t<_Pair>, class _Tuple = tuple>
    struct _CtorPredicateFromPair : false_type{};
    template <template <class...> class _Pred, class _Pair, class _Up1, class _Up2, class _Tp1, class _Tp2>
    struct _CtorPredicateFromPair<_Pred, _Pair, pair<_Up1, _Up2>, tuple<_Tp1, _Tp2> > : _And<
        _Pred<_Tp1, __copy_cvref_t<_Pair, _Up1> >,
        _Pred<_Tp2, __copy_cvref_t<_Pair, _Up2> >
    > {};
    template <class _Pair>
    struct _EnableCtorFromPair : _CtorPredicateFromPair<is_constructible, _Pair>{};
    template <class _Pair>
    struct _NothrowConstructibleFromPair : _CtorPredicateFromPair<is_nothrow_constructible, _Pair>{};
    template <class _Pair, class _DecayedPair = __remove_cvref_t<_Pair>, class _Tuple = tuple>
    struct _BothImplicitlyConvertible : false_type{};
    template <class _Pair, class _Up1, class _Up2, class _Tp1, class _Tp2>
    struct _BothImplicitlyConvertible<_Pair, pair<_Up1, _Up2>, tuple<_Tp1, _Tp2> > : _And<
        is_convertible<__copy_cvref_t<_Pair, _Up1>, _Tp1>,
        is_convertible<__copy_cvref_t<_Pair, _Up2>, _Tp2>
    > {};
    template <class _Up1, class _Up2, template<class...> class _And = _And, __enable_if_t<
        _And<
            _EnableCtorFromPair<const pair<_Up1, _Up2>&>,
            _BothImplicitlyConvertible<const pair<_Up1, _Up2>&>
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(const pair<_Up1, _Up2>& __p)
        noexcept((_NothrowConstructibleFromPair<const pair<_Up1, _Up2>&>::value))
        : __base_(__p)
    { }
    template <class _Up1, class _Up2, template<class...> class _And = _And, __enable_if_t<
        _And<
            _EnableCtorFromPair<const pair<_Up1, _Up2>&>,
            _Not<_BothImplicitlyConvertible<const pair<_Up1, _Up2>&> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(const pair<_Up1, _Up2>& __p)
        noexcept((_NothrowConstructibleFromPair<const pair<_Up1, _Up2>&>::value))
        : __base_(__p)
    { }
    template <class _Alloc, class _Up1, class _Up2, template<class...> class _And = _And, __enable_if_t<
        _And<
            _EnableCtorFromPair<const pair<_Up1, _Up2>&>,
            _BothImplicitlyConvertible<const pair<_Up1, _Up2>&>
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(allocator_arg_t, const _Alloc& __a, const pair<_Up1, _Up2>& __p)
        : __base_(allocator_arg_t(), __a, __p)
    { }
    template <class _Alloc, class _Up1, class _Up2, template<class...> class _And = _And, __enable_if_t<
        _And<
            _EnableCtorFromPair<const pair<_Up1, _Up2>&>,
            _Not<_BothImplicitlyConvertible<const pair<_Up1, _Up2>&> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(allocator_arg_t, const _Alloc& __a, const pair<_Up1, _Up2>& __p)
        : __base_(allocator_arg_t(), __a, __p)
    { }
    template <class _U1, class _U2, enable_if_t<
        _EnableCtorFromPair<pair<_U1, _U2>&>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit(!_BothImplicitlyConvertible<pair<_U1, _U2>&>::value)
    tuple(pair<_U1, _U2>& __p) : __base_(__p) {}
    template <class _Alloc, class _U1, class _U2, enable_if_t<
        _EnableCtorFromPair<std::pair<_U1, _U2>&>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit(!_BothImplicitlyConvertible<pair<_U1, _U2>&>::value)
    tuple(allocator_arg_t, const _Alloc& __alloc, pair<_U1, _U2>& __p) : __base_(allocator_arg_t(), __alloc, __p) {}
    template <class _Up1, class _Up2, template<class...> class _And = _And, __enable_if_t<
        _And<
            _EnableCtorFromPair<pair<_Up1, _Up2>&&>,
            _BothImplicitlyConvertible<pair<_Up1, _Up2>&&>
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(pair<_Up1, _Up2>&& __p)
        noexcept((_NothrowConstructibleFromPair<pair<_Up1, _Up2>&&>::value))
        : __base_(std::move(__p))
    { }
    template <class _Up1, class _Up2, template<class...> class _And = _And, __enable_if_t<
        _And<
            _EnableCtorFromPair<pair<_Up1, _Up2>&&>,
            _Not<_BothImplicitlyConvertible<pair<_Up1, _Up2>&&> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(pair<_Up1, _Up2>&& __p)
        noexcept((_NothrowConstructibleFromPair<pair<_Up1, _Up2>&&>::value))
        : __base_(std::move(__p))
    { }
    template <class _Alloc, class _Up1, class _Up2, template<class...> class _And = _And, __enable_if_t<
        _And<
            _EnableCtorFromPair<pair<_Up1, _Up2>&&>,
            _BothImplicitlyConvertible<pair<_Up1, _Up2>&&>
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple(allocator_arg_t, const _Alloc& __a, pair<_Up1, _Up2>&& __p)
        : __base_(allocator_arg_t(), __a, std::move(__p))
    { }
    template <class _Alloc, class _Up1, class _Up2, template<class...> class _And = _And, __enable_if_t<
        _And<
            _EnableCtorFromPair<pair<_Up1, _Up2>&&>,
            _Not<_BothImplicitlyConvertible<pair<_Up1, _Up2>&&> >
        >::value
    , int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    explicit tuple(allocator_arg_t, const _Alloc& __a, pair<_Up1, _Up2>&& __p)
        : __base_(allocator_arg_t(), __a, std::move(__p))
    { }
    template <class _U1, class _U2, enable_if_t<
        _EnableCtorFromPair<const pair<_U1, _U2>&&>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit(!_BothImplicitlyConvertible<const pair<_U1, _U2>&&>::value)
    tuple(const pair<_U1, _U2>&& __p) : __base_(std::move(__p)) {}
    template <class _Alloc, class _U1, class _U2, enable_if_t<
        _EnableCtorFromPair<const pair<_U1, _U2>&&>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        explicit(!_BothImplicitlyConvertible<const pair<_U1, _U2>&&>::value)
    tuple(allocator_arg_t, const _Alloc& __alloc, const pair<_U1, _U2>&& __p)
        : __base_(allocator_arg_t(), __alloc, std::move(__p)) {}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple& operator=(_If<_And<is_copy_assignable<_Tp>...>::value, tuple, __nat> const& __tuple)
        noexcept((_And<is_nothrow_copy_assignable<_Tp>...>::value))
    {
        std::__memberwise_copy_assign(*this, __tuple,
            typename __make_tuple_indices<sizeof...(_Tp)>::type());
        return *this;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const tuple& operator=(tuple const& __tuple) const
      requires (_And<is_copy_assignable<const _Tp>...>::value) {
        std::__memberwise_copy_assign(*this, __tuple, typename __make_tuple_indices<sizeof...(_Tp)>::type());
        return *this;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const tuple& operator=(tuple&& __tuple) const
      requires (_And<is_assignable<const _Tp&, _Tp>...>::value) {
        std::__memberwise_forward_assign(*this,
                                         std::move(__tuple),
                                         __tuple_types<_Tp...>(),
                                         typename __make_tuple_indices<sizeof...(_Tp)>::type());
        return *this;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple& operator=(_If<_And<is_move_assignable<_Tp>...>::value, tuple, __nat>&& __tuple)
        noexcept((_And<is_nothrow_move_assignable<_Tp>...>::value))
    {
        std::__memberwise_forward_assign(*this, std::move(__tuple),
            __tuple_types<_Tp...>(),
            typename __make_tuple_indices<sizeof...(_Tp)>::type());
        return *this;
    }
    template<class... _Up, __enable_if_t<
        _And<
            _BoolConstant<sizeof...(_Tp) == sizeof...(_Up)>,
            is_assignable<_Tp&, _Up const&>...
        >::value
    ,int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple& operator=(tuple<_Up...> const& __tuple)
        noexcept((_And<is_nothrow_assignable<_Tp&, _Up const&>...>::value))
    {
        std::__memberwise_copy_assign(*this, __tuple,
            typename __make_tuple_indices<sizeof...(_Tp)>::type());
        return *this;
    }
    template<class... _Up, __enable_if_t<
        _And<
            _BoolConstant<sizeof...(_Tp) == sizeof...(_Up)>,
            is_assignable<_Tp&, _Up>...
        >::value
    ,int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple& operator=(tuple<_Up...>&& __tuple)
        noexcept((_And<is_nothrow_assignable<_Tp&, _Up>...>::value))
    {
        std::__memberwise_forward_assign(*this, std::move(__tuple),
            __tuple_types<_Up...>(),
            typename __make_tuple_indices<sizeof...(_Tp)>::type());
        return *this;
    }
    template <class... _UTypes, enable_if_t<
        _And<_BoolConstant<sizeof...(_Tp) == sizeof...(_UTypes)>,
             is_assignable<const _Tp&, const _UTypes&>...>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const tuple& operator=(const tuple<_UTypes...>& __u) const {
        std::__memberwise_copy_assign(*this,
                                      __u,
                                      typename __make_tuple_indices<sizeof...(_Tp)>::type());
        return *this;
    }
    template <class... _UTypes, enable_if_t<
        _And<_BoolConstant<sizeof...(_Tp) == sizeof...(_UTypes)>,
             is_assignable<const _Tp&, _UTypes>...>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const tuple& operator=(tuple<_UTypes...>&& __u) const {
        std::__memberwise_forward_assign(*this,
                                         __u,
                                         __tuple_types<_UTypes...>(),
                                         typename __make_tuple_indices<sizeof...(_Tp)>::type());
        return *this;
    }
    template <template<class...> class _Pred, bool _Const,
              class _Pair, class _DecayedPair = __remove_cvref_t<_Pair>, class _Tuple = tuple>
    struct _AssignPredicateFromPair : false_type {};
    template <template<class...> class _Pred, bool _Const,
              class _Pair, class _Up1, class _Up2, class _Tp1, class _Tp2>
    struct _AssignPredicateFromPair<_Pred, _Const, _Pair, pair<_Up1, _Up2>, tuple<_Tp1, _Tp2> > :
        _And<_Pred<__maybe_const<_Const, _Tp1>&, __copy_cvref_t<_Pair, _Up1> >,
             _Pred<__maybe_const<_Const, _Tp2>&, __copy_cvref_t<_Pair, _Up2> >
            > {};
    template <bool _Const, class _Pair>
    struct _EnableAssignFromPair : _AssignPredicateFromPair<is_assignable, _Const, _Pair> {};
    template <bool _Const, class _Pair>
    struct _NothrowAssignFromPair : _AssignPredicateFromPair<is_nothrow_assignable, _Const, _Pair> {};
    template <class _U1, class _U2, enable_if_t<
        _EnableAssignFromPair<true, const pair<_U1, _U2>&>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const tuple& operator=(const pair<_U1, _U2>& __pair) const
      noexcept(_NothrowAssignFromPair<true, const pair<_U1, _U2>&>::value) {
        std::get<0>(*this) = __pair.first;
        std::get<1>(*this) = __pair.second;
        return *this;
    }
    template <class _U1, class _U2, enable_if_t<
        _EnableAssignFromPair<true, pair<_U1, _U2>&&>::value>* = nullptr>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const tuple& operator=(pair<_U1, _U2>&& __pair) const
      noexcept(_NothrowAssignFromPair<true, pair<_U1, _U2>&&>::value) {
        std::get<0>(*this) = std::move(__pair.first);
        std::get<1>(*this) = std::move(__pair.second);
        return *this;
    }
    template<class _Up1, class _Up2, __enable_if_t<
        _EnableAssignFromPair<false, pair<_Up1, _Up2> const&>::value
    ,int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple& operator=(pair<_Up1, _Up2> const& __pair)
        noexcept((_NothrowAssignFromPair<false, pair<_Up1, _Up2> const&>::value))
    {
        std::get<0>(*this) = __pair.first;
        std::get<1>(*this) = __pair.second;
        return *this;
    }
    template<class _Up1, class _Up2, __enable_if_t<
        _EnableAssignFromPair<false, pair<_Up1, _Up2>&&>::value
    ,int> = 0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple& operator=(pair<_Up1, _Up2>&& __pair)
        noexcept((_NothrowAssignFromPair<false, pair<_Up1, _Up2>&&>::value))
    {
        std::get<0>(*this) = std::forward<_Up1>(__pair.first);
        std::get<1>(*this) = std::forward<_Up2>(__pair.second);
        return *this;
    }
    template<class _Up, size_t _Np, class = __enable_if_t<
        _And<
            _BoolConstant<_Np == sizeof...(_Tp)>,
            is_assignable<_Tp&, _Up const&>...
        >::value
    > >
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple& operator=(array<_Up, _Np> const& __array)
        noexcept((_And<is_nothrow_assignable<_Tp&, _Up const&>...>::value))
    {
        std::__memberwise_copy_assign(*this, __array,
            typename __make_tuple_indices<sizeof...(_Tp)>::type());
        return *this;
    }
    template<class _Up, size_t _Np, class = void, class = __enable_if_t<
        _And<
            _BoolConstant<_Np == sizeof...(_Tp)>,
            is_assignable<_Tp&, _Up>...
        >::value
    > >
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    tuple& operator=(array<_Up, _Np>&& __array)
        noexcept((_And<is_nothrow_assignable<_Tp&, _Up>...>::value))
    {
        std::__memberwise_forward_assign(*this, std::move(__array),
            __tuple_types<_If<true, _Up, _Tp>...>(),
            typename __make_tuple_indices<sizeof...(_Tp)>::type());
        return *this;
    }
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    void swap(tuple& __t) noexcept(__all<__is_nothrow_swappable<_Tp>::value...>::value)
        {__base_.swap(__t.__base_);}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    void swap(const tuple& __t) const noexcept(__all<is_nothrow_swappable_v<const _Tp&>...>::value) {
        __base_.swap(__t.__base_);
    }
};
template <>
class tuple<>
{
public:
    constexpr tuple() noexcept = default;
    template <class _Alloc>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        tuple(allocator_arg_t, const _Alloc&) noexcept {}
    template <class _Alloc>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        tuple(allocator_arg_t, const _Alloc&, const tuple&) noexcept {}
    template <class _Up>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        tuple(array<_Up, 0>) noexcept {}
    template <class _Alloc, class _Up>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
        tuple(allocator_arg_t, const _Alloc&, array<_Up, 0>) noexcept {}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    void swap(tuple&) noexcept {}
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr void swap(const tuple&) const noexcept {}
};
template <class... _TTypes, class... _UTypes, template<class> class _TQual, template<class> class _UQual>
    requires requires { typename tuple<common_reference_t<_TQual<_TTypes>, _UQual<_UTypes>>...>; }
struct basic_common_reference<tuple<_TTypes...>, tuple<_UTypes...>, _TQual, _UQual> {
    using type = tuple<common_reference_t<_TQual<_TTypes>, _UQual<_UTypes>>...>;
};
template <class... _TTypes, class... _UTypes>
    requires requires { typename tuple<common_type_t<_TTypes, _UTypes>...>; }
struct common_type<tuple<_TTypes...>, tuple<_UTypes...>> {
    using type = tuple<common_type_t<_TTypes, _UTypes>...>;
};
template <class ..._Tp>
tuple(_Tp...) -> tuple<_Tp...>;
template <class _Tp1, class _Tp2>
tuple(pair<_Tp1, _Tp2>) -> tuple<_Tp1, _Tp2>;
template <class _Alloc, class ..._Tp>
tuple(allocator_arg_t, _Alloc, _Tp...) -> tuple<_Tp...>;
template <class _Alloc, class _Tp1, class _Tp2>
tuple(allocator_arg_t, _Alloc, pair<_Tp1, _Tp2>) -> tuple<_Tp1, _Tp2>;
template <class _Alloc, class ..._Tp>
tuple(allocator_arg_t, _Alloc, tuple<_Tp...>) -> tuple<_Tp...>;
template <class ..._Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
__enable_if_t<__all<__is_swappable<_Tp>::value...>::value, void>
swap(tuple<_Tp...>& __t, tuple<_Tp...>& __u)
                 noexcept(__all<__is_nothrow_swappable<_Tp>::value...>::value)
    {__t.swap(__u);}
template <class... _Tp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
enable_if_t<__all<is_swappable_v<const _Tp>...>::value, void>
swap(const tuple<_Tp...>& __lhs, const tuple<_Tp...>& __rhs)
        noexcept(__all<is_nothrow_swappable_v<const _Tp>...>::value) {
    __lhs.swap(__rhs);
}
template <size_t _Ip, class ..._Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
typename tuple_element<_Ip, tuple<_Tp...> >::type&
get(tuple<_Tp...>& __t) noexcept
{
    typedef __attribute__((__nodebug__)) typename tuple_element<_Ip, tuple<_Tp...> >::type type;
    return static_cast<__tuple_leaf<_Ip, type>&>(__t.__base_).get();
}
template <size_t _Ip, class ..._Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
const typename tuple_element<_Ip, tuple<_Tp...> >::type&
get(const tuple<_Tp...>& __t) noexcept
{
    typedef __attribute__((__nodebug__)) typename tuple_element<_Ip, tuple<_Tp...> >::type type;
    return static_cast<const __tuple_leaf<_Ip, type>&>(__t.__base_).get();
}
template <size_t _Ip, class ..._Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
typename tuple_element<_Ip, tuple<_Tp...> >::type&&
get(tuple<_Tp...>&& __t) noexcept
{
    typedef __attribute__((__nodebug__)) typename tuple_element<_Ip, tuple<_Tp...> >::type type;
    return static_cast<type&&>(
             static_cast<__tuple_leaf<_Ip, type>&&>(__t.__base_).get());
}
template <size_t _Ip, class ..._Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
const typename tuple_element<_Ip, tuple<_Tp...> >::type&&
get(const tuple<_Tp...>&& __t) noexcept
{
    typedef __attribute__((__nodebug__)) typename tuple_element<_Ip, tuple<_Tp...> >::type type;
    return static_cast<const type&&>(
             static_cast<const __tuple_leaf<_Ip, type>&&>(__t.__base_).get());
}
namespace __find_detail {
static constexpr size_t __not_found = static_cast<size_t>(-1);
static constexpr size_t __ambiguous = __not_found - 1;
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr size_t __find_idx_return(size_t __curr_i, size_t __res, bool __matches) {
    return !__matches ? __res :
        (__res == __not_found ? __curr_i : __ambiguous);
}
template <size_t _Nx>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr size_t __find_idx(size_t __i, const bool (&__matches)[_Nx]) {
  return __i == _Nx ? __not_found :
      __find_detail::__find_idx_return(__i, __find_detail::__find_idx(__i + 1, __matches), __matches[__i]);
}
template <class _T1, class ..._Args>
struct __find_exactly_one_checked {
    static constexpr bool __matches[sizeof...(_Args)] = {is_same<_T1, _Args>::value...};
    static constexpr size_t value = __find_detail::__find_idx(0, __matches);
    static_assert(value != __not_found, "type not found in type list" );
    static_assert(value != __ambiguous, "type occurs more than once in type list");
};
template <class _T1>
struct __find_exactly_one_checked<_T1> {
    static_assert(!is_same<_T1, _T1>::value, "type not in empty type list");
};
}
template <typename _T1, typename... _Args>
struct __find_exactly_one_t
    : public __find_detail::__find_exactly_one_checked<_T1, _Args...> {
};
template <class _T1, class... _Args>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1& get(tuple<_Args...>& __tup) noexcept
{
    return std::get<__find_exactly_one_t<_T1, _Args...>::value>(__tup);
}
template <class _T1, class... _Args>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1 const& get(tuple<_Args...> const& __tup) noexcept
{
    return std::get<__find_exactly_one_t<_T1, _Args...>::value>(__tup);
}
template <class _T1, class... _Args>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1&& get(tuple<_Args...>&& __tup) noexcept
{
    return std::get<__find_exactly_one_t<_T1, _Args...>::value>(std::move(__tup));
}
template <class _T1, class... _Args>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _T1 const&& get(tuple<_Args...> const&& __tup) noexcept
{
    return std::get<__find_exactly_one_t<_T1, _Args...>::value>(std::move(__tup));
}
template <class ..._Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
tuple<_Tp&...>
tie(_Tp&... __t) noexcept
{
    return tuple<_Tp&...>(__t...);
}
template <class _Up>
struct __ignore_t
{
    template <class _Tp>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    const __ignore_t& operator=(_Tp&&) const {return *this;}
};
inline constexpr __ignore_t<unsigned char> ignore = __ignore_t<unsigned char>();
template <class... _Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
tuple<typename __unwrap_ref_decay<_Tp>::type...>
make_tuple(_Tp&&... __t)
{
    return tuple<typename __unwrap_ref_decay<_Tp>::type...>(std::forward<_Tp>(__t)...);
}
template <class... _Tp>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
tuple<_Tp&&...>
forward_as_tuple(_Tp&&... __t) noexcept
{
    return tuple<_Tp&&...>(std::forward<_Tp>(__t)...);
}
template <size_t _Ip>
struct __tuple_equal
{
    template <class _Tp, class _Up>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    bool operator()(const _Tp& __x, const _Up& __y)
    {
        return __tuple_equal<_Ip - 1>()(__x, __y) && std::get<_Ip-1>(__x) == std::get<_Ip-1>(__y);
    }
};
template <>
struct __tuple_equal<0>
{
    template <class _Tp, class _Up>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    bool operator()(const _Tp&, const _Up&)
    {
        return true;
    }
};
template <class ..._Tp, class ..._Up>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
bool
operator==(const tuple<_Tp...>& __x, const tuple<_Up...>& __y)
{
    static_assert (sizeof...(_Tp) == sizeof...(_Up), "Can't compare tuples of different sizes");
    return __tuple_equal<sizeof...(_Tp)>()(__x, __y);
}
template <class ..._Tp, class ..._Up, size_t ..._Is>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
auto
__tuple_compare_three_way(const tuple<_Tp...>& __x, const tuple<_Up...>& __y, index_sequence<_Is...>) {
    common_comparison_category_t<__synth_three_way_result<_Tp, _Up>...> __result = strong_ordering::equal;
    static_cast<void>(((__result = std::__synth_three_way(std::get<_Is>(__x), std::get<_Is>(__y)), __result != 0) || ...));
    return __result;
}
template <class ..._Tp, class ..._Up>
requires (sizeof...(_Tp) == sizeof...(_Up))
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
common_comparison_category_t<__synth_three_way_result<_Tp, _Up>...>
operator<=>(const tuple<_Tp...>& __x, const tuple<_Up...>& __y)
{
    return std::__tuple_compare_three_way(__x, __y, index_sequence_for<_Tp...>{});
}
template <class _Tp, class _Up> struct __tuple_cat_type;
template <class ..._Ttypes, class ..._Utypes>
struct __tuple_cat_type<tuple<_Ttypes...>, __tuple_types<_Utypes...> >
{
    typedef __attribute__((__nodebug__)) tuple<_Ttypes..., _Utypes...> type;
};
template <class _ResultTuple, bool _Is_Tuple0TupleLike, class ..._Tuples>
struct __tuple_cat_return_1
{
};
template <class ..._Types, class _Tuple0>
struct __tuple_cat_return_1<tuple<_Types...>, true, _Tuple0>
{
  using type __attribute__((__nodebug__)) = typename __tuple_cat_type<
      tuple<_Types...>,
      typename __make_tuple_types<__remove_cvref_t<_Tuple0> >::type
    >::type;
};
template <class ..._Types, class _Tuple0, class _Tuple1, class ..._Tuples>
struct __tuple_cat_return_1<tuple<_Types...>, true, _Tuple0, _Tuple1, _Tuples...>
    : public __tuple_cat_return_1<
                 typename __tuple_cat_type<
                     tuple<_Types...>,
                     typename __make_tuple_types<__remove_cvref_t<_Tuple0> >::type
                 >::type,
                 __tuple_like_ext<__libcpp_remove_reference_t<_Tuple1> >::value,
                 _Tuple1, _Tuples...>
{
};
template <class ..._Tuples> struct __tuple_cat_return;
template <class _Tuple0, class ..._Tuples>
struct __tuple_cat_return<_Tuple0, _Tuples...>
    : public __tuple_cat_return_1<tuple<>,
         __tuple_like_ext<__libcpp_remove_reference_t<_Tuple0> >::value, _Tuple0,
                                                                     _Tuples...>
{
};
template <>
struct __tuple_cat_return<>
{
    typedef __attribute__((__nodebug__)) tuple<> type;
};
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
tuple<>
tuple_cat()
{
    return tuple<>();
}
template <class _Rp, class _Indices, class _Tuple0, class ..._Tuples>
struct __tuple_cat_return_ref_imp;
template <class ..._Types, size_t ..._I0, class _Tuple0>
struct __tuple_cat_return_ref_imp<tuple<_Types...>, __tuple_indices<_I0...>, _Tuple0>
{
    typedef __attribute__((__nodebug__)) __libcpp_remove_reference_t<_Tuple0> _T0;
    typedef tuple<_Types..., __apply_cv_t<_Tuple0, typename tuple_element<_I0, _T0>::type>&&...> type;
};
template <class ..._Types, size_t ..._I0, class _Tuple0, class _Tuple1, class ..._Tuples>
struct __tuple_cat_return_ref_imp<tuple<_Types...>, __tuple_indices<_I0...>,
                                  _Tuple0, _Tuple1, _Tuples...>
    : public __tuple_cat_return_ref_imp<
         tuple<_Types..., __apply_cv_t<_Tuple0,
                                       typename tuple_element<_I0, __libcpp_remove_reference_t<_Tuple0>>::type>&&...>,
         typename __make_tuple_indices<tuple_size<__libcpp_remove_reference_t<_Tuple1> >::value>::type,
         _Tuple1, _Tuples...>
{
};
template <class _Tuple0, class ..._Tuples>
struct __tuple_cat_return_ref
    : public __tuple_cat_return_ref_imp<tuple<>,
               typename __make_tuple_indices<
                        tuple_size<__libcpp_remove_reference_t<_Tuple0> >::value
               >::type, _Tuple0, _Tuples...>
{
};
template <class _Types, class _I0, class _J0>
struct __tuple_cat;
template <class ..._Types, size_t ..._I0, size_t ..._J0>
struct __tuple_cat<tuple<_Types...>, __tuple_indices<_I0...>, __tuple_indices<_J0...> >
{
    template <class _Tuple0>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    typename __tuple_cat_return_ref<tuple<_Types...>&&, _Tuple0&&>::type
    operator()(tuple<_Types...> __t, _Tuple0&& __t0)
    {
        (void)__t;
        return std::forward_as_tuple(
            std::forward<_Types>(std::get<_I0>(__t))...,
            std::get<_J0>(std::forward<_Tuple0>(__t0))...);
    }
    template <class _Tuple0, class _Tuple1, class ..._Tuples>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
    typename __tuple_cat_return_ref<tuple<_Types...>&&, _Tuple0&&, _Tuple1&&, _Tuples&&...>::type
    operator()(tuple<_Types...> __t, _Tuple0&& __t0, _Tuple1&& __t1, _Tuples&& ...__tpls)
    {
        (void)__t;
        typedef __attribute__((__nodebug__)) __libcpp_remove_reference_t<_Tuple0> _T0;
        typedef __attribute__((__nodebug__)) __libcpp_remove_reference_t<_Tuple1> _T1;
        return __tuple_cat<tuple<_Types..., __apply_cv_t<_Tuple0, typename tuple_element<_J0, _T0>::type>&&...>,
                           typename __make_tuple_indices<sizeof...(_Types) + tuple_size<_T0>::value>::type,
                           typename __make_tuple_indices<tuple_size<_T1>::value>::type>()(
            std::forward_as_tuple(
                std::forward<_Types>(std::get<_I0>(__t))...,
                std::get<_J0>(std::forward<_Tuple0>(__t0))...),
            std::forward<_Tuple1>(__t1), std::forward<_Tuples>(__tpls)...);
    }
};
template <class _Tuple0, class... _Tuples>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
typename __tuple_cat_return<_Tuple0, _Tuples...>::type
tuple_cat(_Tuple0&& __t0, _Tuples&&... __tpls)
{
    typedef __attribute__((__nodebug__)) __libcpp_remove_reference_t<_Tuple0> _T0;
    return __tuple_cat<tuple<>, __tuple_indices<>,
                  typename __make_tuple_indices<tuple_size<_T0>::value>::type>()
                  (tuple<>(), std::forward<_Tuple0>(__t0),
                                            std::forward<_Tuples>(__tpls)...);
}
template <class ..._Tp, class _Alloc>
struct uses_allocator<tuple<_Tp...>, _Alloc>
    : true_type {};
template <class _T1, class _T2>
template <class... _Args1, class... _Args2, size_t ..._I1, size_t ..._I2>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
pair<_T1, _T2>::pair(piecewise_construct_t,
                     tuple<_Args1...>& __first_args, tuple<_Args2...>& __second_args,
                     __tuple_indices<_I1...>, __tuple_indices<_I2...>)
    : first(std::forward<_Args1>(std::get<_I1>( __first_args))...),
      second(std::forward<_Args2>(std::get<_I2>(__second_args))...)
{
}
template <class _Tp>
inline constexpr size_t tuple_size_v = tuple_size<_Tp>::value;
template <class _Fn, class _Tuple, size_t ..._Id>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr decltype(auto) __apply_tuple_impl(_Fn && __f, _Tuple && __t,
                                            __tuple_indices<_Id...>)
noexcept(noexcept(std::__invoke( std::forward<_Fn>(__f), std::get<_Id>(std::forward<_Tuple>(__t))...))) { return std::__invoke( std::forward<_Fn>(__f), std::get<_Id>(std::forward<_Tuple>(__t))...); }
template <class _Fn, class _Tuple>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr decltype(auto) apply(_Fn && __f, _Tuple && __t)
noexcept(noexcept(std::__apply_tuple_impl( std::forward<_Fn>(__f), std::forward<_Tuple>(__t), typename __make_tuple_indices<tuple_size_v<remove_reference_t<_Tuple>>>::type{}))) { return std::__apply_tuple_impl( std::forward<_Fn>(__f), std::forward<_Tuple>(__t), typename __make_tuple_indices<tuple_size_v<remove_reference_t<_Tuple>>>::type{}); }
template <class _Tp, class _Tuple, size_t... _Idx>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _Tp __make_from_tuple_impl(_Tuple&& __t, __tuple_indices<_Idx...>)
noexcept(noexcept(_Tp(std::get<_Idx>(std::forward<_Tuple>(__t))...))) { return _Tp(std::get<_Idx>(std::forward<_Tuple>(__t))...); }
template <class _Tp, class _Tuple>
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _Tp make_from_tuple(_Tuple&& __t)
noexcept(noexcept(std::__make_from_tuple_impl<_Tp>(std::forward<_Tuple>(__t), typename __make_tuple_indices<tuple_size_v<remove_reference_t<_Tuple>>>::type{}))) { return std::__make_from_tuple_impl<_Tp>(std::forward<_Tuple>(__t), typename __make_tuple_indices<tuple_size_v<remove_reference_t<_Tuple>>>::type{}); }
}}
namespace std {
class bad_variant_access : public exception {
public:
   const char* what() const noexcept override;
};
}
namespace std { inline namespace _LIBCPP_ABI_NAMESPACE {
template<class _Tp, size_t _Size>
struct __farray {
  static_assert(_Size > 0, "N-dimensional array should never be empty in std::visit");
  _Tp __buf_[_Size] = {};
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr
  const _Tp &operator[](size_t __n) const noexcept {
      return __buf_[__n];
  }
};
[[noreturn]]
inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
void __throw_bad_variant_access() {
    ::std::__libcpp_verbose_abort("bad_variant_access was thrown in -fno-exceptions mode");
}
template <class... _Types>
class variant;
template <class _Tp>
struct variant_size;
template <class _Tp>
inline constexpr size_t variant_size_v = variant_size<_Tp>::value;
template <class _Tp>
struct variant_size<const _Tp> : variant_size<_Tp> {};
template <class _Tp>
struct variant_size<volatile _Tp> : variant_size<_Tp> {};
template <class _Tp>
struct variant_size<const volatile _Tp>
    : variant_size<_Tp> {};
template <class... _Types>
struct variant_size<variant<_Types...>>
    : integral_constant<size_t, sizeof...(_Types)> {};
template <size_t _Ip, class _Tp>
struct variant_alternative;
template <size_t _Ip, class _Tp>
using variant_alternative_t = typename variant_alternative<_Ip, _Tp>::type;
template <size_t _Ip, class _Tp>
struct variant_alternative<_Ip, const _Tp>
    : add_const<variant_alternative_t<_Ip, _Tp>> {};
template <size_t _Ip, class _Tp>
struct variant_alternative<_Ip, volatile _Tp>
    : add_volatile<variant_alternative_t<_Ip, _Tp>> {};
template <size_t _Ip, class _Tp>
struct variant_alternative<_Ip, const volatile _Tp>
    : add_cv<variant_alternative_t<_Ip, _Tp>> {};
template <size_t _Ip, class... _Types>
struct variant_alternative<_Ip, variant<_Types...>> {
  static_assert(_Ip < sizeof...(_Types), "Index out of bounds in std::variant_alternative<>");
  using type = __type_pack_element<_Ip, _Types...>;
};
inline constexpr size_t variant_npos = static_cast<size_t>(-1);
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr int __choose_index_type(unsigned int __num_elem) {
  if (__num_elem < numeric_limits<unsigned char>::max())
    return 0;
  if (__num_elem < numeric_limits<unsigned short>::max())
    return 1;
  return 2;
}
template <size_t _NumAlts>
using __variant_index_t =
  std::tuple_element_t<
      __choose_index_type(_NumAlts),
      std::tuple<unsigned char, unsigned short, unsigned int>
  >;
template <class _IndexType>
constexpr _IndexType __variant_npos = static_cast<_IndexType>(-1);
template <class... _Types>
class variant;
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr variant<_Types...>&
__as_variant(variant<_Types...>& __vs) noexcept {
  return __vs;
}
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr const variant<_Types...>&
__as_variant(const variant<_Types...>& __vs) noexcept {
  return __vs;
}
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr variant<_Types...>&&
__as_variant(variant<_Types...>&& __vs) noexcept {
  return std::move(__vs);
}
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr const variant<_Types...>&&
__as_variant(const variant<_Types...>&& __vs) noexcept {
  return std::move(__vs);
}
namespace __find_detail {
template <class _Tp, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr size_t __find_index() {
  constexpr bool __matches[] = {is_same_v<_Tp, _Types>...};
  size_t __result = __not_found;
  for (size_t __i = 0; __i < sizeof...(_Types); ++__i) {
    if (__matches[__i]) {
      if (__result != __not_found) {
        return __ambiguous;
      }
      __result = __i;
    }
  }
  return __result;
}
template <size_t _Index>
struct __find_unambiguous_index_sfinae_impl
    : integral_constant<size_t, _Index> {};
template <>
struct __find_unambiguous_index_sfinae_impl<__not_found> {};
template <>
struct __find_unambiguous_index_sfinae_impl<__ambiguous> {};
template <class _Tp, class... _Types>
struct __find_unambiguous_index_sfinae
    : __find_unambiguous_index_sfinae_impl<__find_index<_Tp, _Types...>()> {};
}
namespace __variant_detail {
struct __valueless_t {};
enum class _Trait { _TriviallyAvailable, _Available, _Unavailable };
template <typename _Tp,
          template <typename> class _IsTriviallyAvailable,
          template <typename> class _IsAvailable>
constexpr _Trait __trait =
    _IsTriviallyAvailable<_Tp>::value
        ? _Trait::_TriviallyAvailable
        : _IsAvailable<_Tp>::value ? _Trait::_Available : _Trait::_Unavailable;
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _Trait __common_trait(initializer_list<_Trait> __traits) {
  _Trait __result = _Trait::_TriviallyAvailable;
  for (_Trait __t : __traits) {
    if (static_cast<int>(__t) > static_cast<int>(__result)) {
      __result = __t;
    }
  }
  return __result;
}
template <typename... _Types>
struct __traits {
  static constexpr _Trait __copy_constructible_trait =
      __variant_detail::__common_trait({__trait<_Types,
                              is_trivially_copy_constructible,
                              is_copy_constructible>...});
  static constexpr _Trait __move_constructible_trait =
      __variant_detail::__common_trait({__trait<_Types,
                              is_trivially_move_constructible,
                              is_move_constructible>...});
  static constexpr _Trait __copy_assignable_trait = __variant_detail::__common_trait(
      {__copy_constructible_trait,
       __trait<_Types, is_trivially_copy_assignable, is_copy_assignable>...});
  static constexpr _Trait __move_assignable_trait = __variant_detail::__common_trait(
      {__move_constructible_trait,
       __trait<_Types, is_trivially_move_assignable, is_move_assignable>...});
  static constexpr _Trait __destructible_trait = __variant_detail::__common_trait(
      {__trait<_Types, is_trivially_destructible, is_destructible>...});
};
namespace __access {
struct __union {
  template <class _Vp>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto&& __get_alt(_Vp&& __v, in_place_index_t<0>) {
    return std::forward<_Vp>(__v).__head;
  }
  template <class _Vp, size_t _Ip>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto&& __get_alt(_Vp&& __v, in_place_index_t<_Ip>) {
    return __get_alt(std::forward<_Vp>(__v).__tail, in_place_index<_Ip - 1>);
  }
};
struct __base {
  template <size_t _Ip, class _Vp>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto&& __get_alt(_Vp&& __v) {
    return __union::__get_alt(std::forward<_Vp>(__v).__data,
                              in_place_index<_Ip>);
  }
};
struct __variant {
  template <size_t _Ip, class _Vp>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto&& __get_alt(_Vp&& __v) {
    return __base::__get_alt<_Ip>(std::forward<_Vp>(__v).__impl_);
  }
};
}
namespace __visitation {
struct __base {
  template <class _Visitor, class... _Vs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr decltype(auto)
  __visit_alt_at(size_t __index, _Visitor&& __visitor, _Vs&&... __vs) {
    constexpr auto __fdiagonal =
        __make_fdiagonal<_Visitor&&,
                         decltype(std::forward<_Vs>(__vs).__as_base())...>();
    return __fdiagonal[__index](std::forward<_Visitor>(__visitor),
                                std::forward<_Vs>(__vs).__as_base()...);
  }
  template <class _Visitor, class... _Vs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr decltype(auto) __visit_alt(_Visitor&& __visitor,
                                              _Vs&&... __vs) {
    constexpr auto __fmatrix =
        __make_fmatrix<_Visitor&&,
                       decltype(std::forward<_Vs>(__vs).__as_base())...>();
    return __at(__fmatrix, __vs.index()...)(
        std::forward<_Visitor>(__visitor),
        std::forward<_Vs>(__vs).__as_base()...);
  }
private:
  template <class _Tp>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr const _Tp& __at(const _Tp& __elem) { return __elem; }
  template <class _Tp, size_t _Np, typename... _Indices>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto&& __at(const __farray<_Tp, _Np>& __elems,
                               size_t __index, _Indices... __indices) {
    return __at(__elems[__index], __indices...);
  }
  template <class _Fp, class... _Fs>
  static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr void __std_visit_visitor_return_type_check() {
    static_assert(
        __all<is_same_v<_Fp, _Fs>...>::value,
        "`std::visit` requires the visitor to have a single return type.");
  }
  template <class... _Fs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto __make_farray(_Fs&&... __fs) {
    __std_visit_visitor_return_type_check<__remove_cvref_t<_Fs>...>();
    using __result = __farray<common_type_t<__remove_cvref_t<_Fs>...>, sizeof...(_Fs)>;
    return __result{{std::forward<_Fs>(__fs)...}};
  }
  template <size_t... _Is>
  struct __dispatcher {
    template <class _Fp, class... _Vs>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    static constexpr decltype(auto) __dispatch(_Fp __f, _Vs... __vs) {
        return std::__invoke(
            static_cast<_Fp>(__f),
            __access::__base::__get_alt<_Is>(static_cast<_Vs>(__vs))...);
    }
  };
  template <class _Fp, class... _Vs, size_t... _Is>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto __make_dispatch(index_sequence<_Is...>) {
    return __dispatcher<_Is...>::template __dispatch<_Fp, _Vs...>;
  }
  template <size_t _Ip, class _Fp, class... _Vs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto __make_fdiagonal_impl() {
    return __make_dispatch<_Fp, _Vs...>(
        index_sequence<((void)__type_identity<_Vs>{}, _Ip)...>{});
  }
  template <class _Fp, class... _Vs, size_t... _Is>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto __make_fdiagonal_impl(index_sequence<_Is...>) {
    return __base::__make_farray(__make_fdiagonal_impl<_Is, _Fp, _Vs...>()...);
  }
  template <class _Fp, class _Vp, class... _Vs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto __make_fdiagonal() {
    constexpr size_t __np = __remove_cvref_t<_Vp>::__size();
    static_assert(__all<(__np == __remove_cvref_t<_Vs>::__size())...>::value);
    return __make_fdiagonal_impl<_Fp, _Vp, _Vs...>(make_index_sequence<__np>{});
  }
  template <class _Fp, class... _Vs, size_t... _Is>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto __make_fmatrix_impl(index_sequence<_Is...> __is) {
    return __make_dispatch<_Fp, _Vs...>(__is);
  }
  template <class _Fp, class... _Vs, size_t... _Is, size_t... _Js, class... _Ls>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto __make_fmatrix_impl(index_sequence<_Is...>,
                                            index_sequence<_Js...>,
                                            _Ls... __ls) {
    return __base::__make_farray(__make_fmatrix_impl<_Fp, _Vs...>(
        index_sequence<_Is..., _Js>{}, __ls...)...);
  }
  template <class _Fp, class... _Vs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto __make_fmatrix() {
    return __make_fmatrix_impl<_Fp, _Vs...>(
        index_sequence<>{}, make_index_sequence<__remove_cvref_t<_Vs>::__size()>{}...);
  }
};
struct __variant {
  template <class _Visitor, class... _Vs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr decltype(auto)
  __visit_alt_at(size_t __index, _Visitor&& __visitor, _Vs&&... __vs) {
    return __base::__visit_alt_at(__index,
                                  std::forward<_Visitor>(__visitor),
                                  std::forward<_Vs>(__vs).__impl_...);
  }
  template <class _Visitor, class... _Vs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr decltype(auto) __visit_alt(_Visitor&& __visitor,
                                              _Vs&&... __vs) {
    return __base::__visit_alt(
        std::forward<_Visitor>(__visitor),
        std::__as_variant(std::forward<_Vs>(__vs)).__impl_...);
  }
  template <class _Visitor, class... _Vs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr decltype(auto)
  __visit_value_at(size_t __index, _Visitor&& __visitor, _Vs&&... __vs) {
    return __visit_alt_at(
        __index,
        __make_value_visitor(std::forward<_Visitor>(__visitor)),
        std::forward<_Vs>(__vs)...);
  }
  template <class _Visitor, class... _Vs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr decltype(auto) __visit_value(_Visitor&& __visitor,
                                                _Vs&&... __vs) {
    return __visit_alt(
        __make_value_visitor(std::forward<_Visitor>(__visitor)),
        std::forward<_Vs>(__vs)...);
  }
  template <class _Rp, class _Visitor, class... _Vs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr _Rp __visit_value(_Visitor&& __visitor,
                                     _Vs&&... __vs) {
    return __visit_alt(
        __make_value_visitor<_Rp>(std::forward<_Visitor>(__visitor)),
        std::forward<_Vs>(__vs)...);
  }
private:
  template <class _Visitor, class... _Values>
  static __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr void __std_visit_exhaustive_visitor_check() {
    static_assert(is_invocable_v<_Visitor, _Values...>,
                  "`std::visit` requires the visitor to be exhaustive.");
  }
  template <class _Visitor>
  struct __value_visitor {
    template <class... _Alts>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    constexpr decltype(auto) operator()(_Alts&&... __alts) const {
      __std_visit_exhaustive_visitor_check<
          _Visitor,
          decltype((std::forward<_Alts>(__alts).__value))...>();
      return std::__invoke(std::forward<_Visitor>(__visitor),
                             std::forward<_Alts>(__alts).__value...);
    }
    _Visitor&& __visitor;
  };
  template <class _Rp, class _Visitor>
  struct __value_visitor_return_type {
    template <class... _Alts>
    __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
    constexpr _Rp operator()(_Alts&&... __alts) const {
      __std_visit_exhaustive_visitor_check<
          _Visitor,
          decltype((std::forward<_Alts>(__alts).__value))...>();
      if constexpr (is_void_v<_Rp>) {
        std::__invoke(std::forward<_Visitor>(__visitor),
                        std::forward<_Alts>(__alts).__value...);
      }
      else {
        return std::__invoke(std::forward<_Visitor>(__visitor),
                               std::forward<_Alts>(__alts).__value...);
      }
    }
    _Visitor&& __visitor;
  };
  template <class _Visitor>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto __make_value_visitor(_Visitor&& __visitor) {
    return __value_visitor<_Visitor>{std::forward<_Visitor>(__visitor)};
  }
  template <class _Rp, class _Visitor>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr auto __make_value_visitor(_Visitor&& __visitor) {
    return __value_visitor_return_type<_Rp, _Visitor>{std::forward<_Visitor>(__visitor)};
  }
};
}
template <size_t _Index, class _Tp>
struct __alt {
  using __value_type = _Tp;
  template <class... _Args>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr __alt(in_place_t, _Args&&... __args)
      : __value(std::forward<_Args>(__args)...) {}
  __value_type __value;
};
template <_Trait _DestructibleTrait, size_t _Index, class... _Types>
union __union;
template <_Trait _DestructibleTrait, size_t _Index>
union __union<_DestructibleTrait, _Index> {};
template <size_t _Index, class _Tp, class... _Types> union __union<_Trait::_TriviallyAvailable, _Index, _Tp, _Types...> { public: __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit constexpr __union(__valueless_t) noexcept : __dummy{} {} template <class... _Args> __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit constexpr __union(in_place_index_t<0>, _Args&&... __args) : __head(in_place, std::forward<_Args>(__args)...) {} template <size_t _Ip, class... _Args> __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit constexpr __union(in_place_index_t<_Ip>, _Args&&... __args) : __tail(in_place_index<_Ip - 1>, std::forward<_Args>(__args)...) {} __union(const __union&) = default; __union(__union&&) = default; ~__union() = default; __union& operator=(const __union&) = default; __union& operator=(__union&&) = default; private: char __dummy; __alt<_Index, _Tp> __head; __union<_Trait::_TriviallyAvailable, _Index + 1, _Types...> __tail; friend struct __access::__union; };
template <size_t _Index, class _Tp, class... _Types> union __union<_Trait::_Available, _Index, _Tp, _Types...> { public: __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit constexpr __union(__valueless_t) noexcept : __dummy{} {} template <class... _Args> __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit constexpr __union(in_place_index_t<0>, _Args&&... __args) : __head(in_place, std::forward<_Args>(__args)...) {} template <size_t _Ip, class... _Args> __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit constexpr __union(in_place_index_t<_Ip>, _Args&&... __args) : __tail(in_place_index<_Ip - 1>, std::forward<_Args>(__args)...) {} __union(const __union&) = default; __union(__union&&) = default; ~__union() {} __union& operator=(const __union&) = default; __union& operator=(__union&&) = default; private: char __dummy; __alt<_Index, _Tp> __head; __union<_Trait::_Available, _Index + 1, _Types...> __tail; friend struct __access::__union; };
template <size_t _Index, class _Tp, class... _Types> union __union<_Trait::_Unavailable, _Index, _Tp, _Types...> { public: __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit constexpr __union(__valueless_t) noexcept : __dummy{} {} template <class... _Args> __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit constexpr __union(in_place_index_t<0>, _Args&&... __args) : __head(in_place, std::forward<_Args>(__args)...) {} template <size_t _Ip, class... _Args> __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) explicit constexpr __union(in_place_index_t<_Ip>, _Args&&... __args) : __tail(in_place_index<_Ip - 1>, std::forward<_Args>(__args)...) {} __union(const __union&) = default; __union(__union&&) = default; ~__union() = delete; __union& operator=(const __union&) = default; __union& operator=(__union&&) = default; private: char __dummy; __alt<_Index, _Tp> __head; __union<_Trait::_Unavailable, _Index + 1, _Types...> __tail; friend struct __access::__union; };
template <_Trait _DestructibleTrait, class... _Types>
class __base {
public:
  using __index_t = __variant_index_t<sizeof...(_Types)>;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr __base(__valueless_t __tag) noexcept
      : __data(__tag), __index(__variant_npos<__index_t>) {}
  template <size_t _Ip, class... _Args>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr __base(in_place_index_t<_Ip>, _Args&&... __args)
      :
        __data(in_place_index<_Ip>, std::forward<_Args>(__args)...),
        __index(_Ip) {}
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr bool valueless_by_exception() const noexcept {
    return index() == variant_npos;
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr size_t index() const noexcept {
    return __index == __variant_npos<__index_t> ? variant_npos : __index;
  }
protected:
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr auto&& __as_base() & { return *this; }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr auto&& __as_base() && { return std::move(*this); }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr auto&& __as_base() const & { return *this; }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr auto&& __as_base() const && { return std::move(*this); }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static constexpr size_t __size() { return sizeof...(_Types); }
  __union<_DestructibleTrait, 0, _Types...> __data;
  __index_t __index;
  friend struct __access::__base;
  friend struct __visitation::__base;
};
template <class _Traits, _Trait = _Traits::__destructible_trait>
class __dtor;
template <class... _Types> class __dtor<__traits<_Types...>, _Trait::_TriviallyAvailable> : public __base<_Trait::_TriviallyAvailable, _Types...> { using __base_type = __base<_Trait::_TriviallyAvailable, _Types...>; using __index_t = typename __base_type::__index_t; public: using __base_type::__base_type; using __base_type::operator=; __dtor(const __dtor&) = default; __dtor(__dtor&&) = default; ~__dtor() = default; __dtor& operator=(const __dtor&) = default; __dtor& operator=(__dtor&&) = default; protected: inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) void __destroy() noexcept { this->__index = __variant_npos<__index_t>; } };
template <class... _Types> class __dtor<__traits<_Types...>, _Trait::_Available> : public __base<_Trait::_Available, _Types...> { using __base_type = __base<_Trait::_Available, _Types...>; using __index_t = typename __base_type::__index_t; public: using __base_type::__base_type; using __base_type::operator=; __dtor(const __dtor&) = default; __dtor(__dtor&&) = default; ~__dtor() { __destroy(); } __dtor& operator=(const __dtor&) = default; __dtor& operator=(__dtor&&) = default; protected: inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) void __destroy() noexcept { if (!this->valueless_by_exception()) { __visitation::__base::__visit_alt( [](auto& __alt) noexcept { using __alt_type = __remove_cvref_t<decltype(__alt)>; __alt.~__alt_type(); }, *this); } this->__index = __variant_npos<__index_t>; } };
template <class... _Types> class __dtor<__traits<_Types...>, _Trait::_Unavailable> : public __base<_Trait::_Unavailable, _Types...> { using __base_type = __base<_Trait::_Unavailable, _Types...>; using __index_t = typename __base_type::__index_t; public: using __base_type::__base_type; using __base_type::operator=; __dtor(const __dtor&) = default; __dtor(__dtor&&) = default; ~__dtor() = delete; __dtor& operator=(const __dtor&) = default; __dtor& operator=(__dtor&&) = default; protected: inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) void __destroy() noexcept = delete; };
template <class _Traits>
class __ctor : public __dtor<_Traits> {
  using __base_type = __dtor<_Traits>;
public:
  using __base_type::__base_type;
  using __base_type::operator=;
protected:
  template <size_t _Ip, class _Tp, class... _Args>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static _Tp& __construct_alt(__alt<_Ip, _Tp>& __a, _Args&&... __args) {
    ::new ((void*)std::addressof(__a))
        __alt<_Ip, _Tp>(in_place, std::forward<_Args>(__args)...);
    return __a.__value;
  }
  template <class _Rhs>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  static void __generic_construct(__ctor& __lhs, _Rhs&& __rhs) {
    __lhs.__destroy();
    if (!__rhs.valueless_by_exception()) {
      __visitation::__base::__visit_alt_at(
          __rhs.index(),
          [](auto& __lhs_alt, auto&& __rhs_alt) {
            __construct_alt(
                __lhs_alt,
                std::forward<decltype(__rhs_alt)>(__rhs_alt).__value);
          },
          __lhs, std::forward<_Rhs>(__rhs));
      __lhs.__index = __rhs.index();
    }
  }
};
template <class _Traits, _Trait = _Traits::__move_constructible_trait>
class __move_constructor;
template <class... _Types> class __move_constructor<__traits<_Types...>, _Trait::_TriviallyAvailable> : public __ctor<__traits<_Types...>> { using __base_type = __ctor<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __move_constructor(const __move_constructor&) = default; __move_constructor(__move_constructor&& __that) = default; ~__move_constructor() = default; __move_constructor& operator=(const __move_constructor&) = default; __move_constructor& operator=(__move_constructor&&) = default; };
template <class... _Types> class __move_constructor<__traits<_Types...>, _Trait::_Available> : public __ctor<__traits<_Types...>> { using __base_type = __ctor<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __move_constructor(const __move_constructor&) = default; __move_constructor(__move_constructor&& __that) noexcept( __all<is_nothrow_move_constructible_v<_Types>...>::value) : __move_constructor(__valueless_t{}) { this->__generic_construct(*this, std::move(__that)); } ~__move_constructor() = default; __move_constructor& operator=(const __move_constructor&) = default; __move_constructor& operator=(__move_constructor&&) = default; };
template <class... _Types> class __move_constructor<__traits<_Types...>, _Trait::_Unavailable> : public __ctor<__traits<_Types...>> { using __base_type = __ctor<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __move_constructor(const __move_constructor&) = default; __move_constructor(__move_constructor&&) = delete; ~__move_constructor() = default; __move_constructor& operator=(const __move_constructor&) = default; __move_constructor& operator=(__move_constructor&&) = default; };
template <class _Traits, _Trait = _Traits::__copy_constructible_trait>
class __copy_constructor;
template <class... _Types> class __copy_constructor<__traits<_Types...>, _Trait::_TriviallyAvailable> : public __move_constructor<__traits<_Types...>> { using __base_type = __move_constructor<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __copy_constructor(const __copy_constructor& __that) = default; __copy_constructor(__copy_constructor&&) = default; ~__copy_constructor() = default; __copy_constructor& operator=(const __copy_constructor&) = default; __copy_constructor& operator=(__copy_constructor&&) = default; };
template <class... _Types> class __copy_constructor<__traits<_Types...>, _Trait::_Available> : public __move_constructor<__traits<_Types...>> { using __base_type = __move_constructor<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __copy_constructor(const __copy_constructor& __that) : __copy_constructor(__valueless_t{}) { this->__generic_construct(*this, __that); } __copy_constructor(__copy_constructor&&) = default; ~__copy_constructor() = default; __copy_constructor& operator=(const __copy_constructor&) = default; __copy_constructor& operator=(__copy_constructor&&) = default; };
template <class... _Types> class __copy_constructor<__traits<_Types...>, _Trait::_Unavailable> : public __move_constructor<__traits<_Types...>> { using __base_type = __move_constructor<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __copy_constructor(const __copy_constructor&) = delete; __copy_constructor(__copy_constructor&&) = default; ~__copy_constructor() = default; __copy_constructor& operator=(const __copy_constructor&) = default; __copy_constructor& operator=(__copy_constructor&&) = default; };
template <class _Traits>
class __assignment : public __copy_constructor<_Traits> {
  using __base_type = __copy_constructor<_Traits>;
public:
  using __base_type::__base_type;
  using __base_type::operator=;
  template <size_t _Ip, class... _Args>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  auto& __emplace(_Args&&... __args) {
    this->__destroy();
    auto& __res = this->__construct_alt(__access::__base::__get_alt<_Ip>(*this),
                          std::forward<_Args>(__args)...);
    this->__index = _Ip;
    return __res;
  }
protected:
  template <size_t _Ip, class _Tp, class _Arg>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  void __assign_alt(__alt<_Ip, _Tp>& __a, _Arg&& __arg) {
    if (this->index() == _Ip) {
      __a.__value = std::forward<_Arg>(__arg);
    } else {
      struct {
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) void operator()(true_type) const {
          __this->__emplace<_Ip>(std::forward<_Arg>(__arg));
        }
        __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) void operator()(false_type) const {
          __this->__emplace<_Ip>(_Tp(std::forward<_Arg>(__arg)));
        }
        __assignment* __this;
        _Arg&& __arg;
      } __impl{this, std::forward<_Arg>(__arg)};
      __impl(bool_constant<is_nothrow_constructible_v<_Tp, _Arg> ||
                           !is_nothrow_move_constructible_v<_Tp>>{});
    }
  }
  template <class _That>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  void __generic_assign(_That&& __that) {
    if (this->valueless_by_exception() && __that.valueless_by_exception()) {
    } else if (__that.valueless_by_exception()) {
      this->__destroy();
    } else {
      __visitation::__base::__visit_alt_at(
          __that.index(),
          [this](auto& __this_alt, auto&& __that_alt) {
            this->__assign_alt(
                __this_alt,
                std::forward<decltype(__that_alt)>(__that_alt).__value);
          },
          *this, std::forward<_That>(__that));
    }
  }
};
template <class _Traits, _Trait = _Traits::__move_assignable_trait>
class __move_assignment;
template <class... _Types> class __move_assignment<__traits<_Types...>, _Trait::_TriviallyAvailable> : public __assignment<__traits<_Types...>> { using __base_type = __assignment<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __move_assignment(const __move_assignment&) = default; __move_assignment(__move_assignment&&) = default; ~__move_assignment() = default; __move_assignment& operator=(const __move_assignment&) = default; __move_assignment& operator=(__move_assignment&& __that) = default; };
template <class... _Types> class __move_assignment<__traits<_Types...>, _Trait::_Available> : public __assignment<__traits<_Types...>> { using __base_type = __assignment<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __move_assignment(const __move_assignment&) = default; __move_assignment(__move_assignment&&) = default; ~__move_assignment() = default; __move_assignment& operator=(const __move_assignment&) = default; __move_assignment& operator=(__move_assignment&& __that) noexcept( __all<(is_nothrow_move_constructible_v<_Types> && is_nothrow_move_assignable_v<_Types>)...>::value) { this->__generic_assign(std::move(__that)); return *this; } };
template <class... _Types> class __move_assignment<__traits<_Types...>, _Trait::_Unavailable> : public __assignment<__traits<_Types...>> { using __base_type = __assignment<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __move_assignment(const __move_assignment&) = default; __move_assignment(__move_assignment&&) = default; ~__move_assignment() = default; __move_assignment& operator=(const __move_assignment&) = default; __move_assignment& operator=(__move_assignment&&) = delete; };
template <class _Traits, _Trait = _Traits::__copy_assignable_trait>
class __copy_assignment;
template <class... _Types> class __copy_assignment<__traits<_Types...>, _Trait::_TriviallyAvailable> : public __move_assignment<__traits<_Types...>> { using __base_type = __move_assignment<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __copy_assignment(const __copy_assignment&) = default; __copy_assignment(__copy_assignment&&) = default; ~__copy_assignment() = default; __copy_assignment& operator=(const __copy_assignment& __that) = default; __copy_assignment& operator=(__copy_assignment&&) = default; };
template <class... _Types> class __copy_assignment<__traits<_Types...>, _Trait::_Available> : public __move_assignment<__traits<_Types...>> { using __base_type = __move_assignment<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __copy_assignment(const __copy_assignment&) = default; __copy_assignment(__copy_assignment&&) = default; ~__copy_assignment() = default; __copy_assignment& operator=(const __copy_assignment& __that) { this->__generic_assign(__that); return *this; } __copy_assignment& operator=(__copy_assignment&&) = default; };
template <class... _Types> class __copy_assignment<__traits<_Types...>, _Trait::_Unavailable> : public __move_assignment<__traits<_Types...>> { using __base_type = __move_assignment<__traits<_Types...>>; public: using __base_type::__base_type; using __base_type::operator=; __copy_assignment(const __copy_assignment&) = default; __copy_assignment(__copy_assignment&&) = default; ~__copy_assignment() = default; __copy_assignment& operator=(const __copy_assignment&) = delete; __copy_assignment& operator=(__copy_assignment&&) = default; };
template <class... _Types>
class __impl
    : public __copy_assignment<__traits<_Types...>> {
  using __base_type = __copy_assignment<__traits<_Types...>>;
public:
  using __base_type::__base_type;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __impl(__impl const&) = default;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __impl(__impl&&) = default;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __impl& operator=(__impl const&) = default;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) __impl& operator=(__impl&&) = default;
  template <size_t _Ip, class _Arg>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  void __assign(_Arg&& __arg) {
    this->__assign_alt(__access::__base::__get_alt<_Ip>(*this),
                       std::forward<_Arg>(__arg));
  }
  inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  void __swap(__impl& __that) {
    if (this->valueless_by_exception() && __that.valueless_by_exception()) {
    } else if (this->index() == __that.index()) {
      __visitation::__base::__visit_alt_at(
          this->index(),
          [](auto& __this_alt, auto& __that_alt) {
            using std::swap;
            swap(__this_alt.__value, __that_alt.__value);
          },
          *this,
          __that);
    } else {
      __impl* __lhs = this;
      __impl* __rhs = std::addressof(__that);
      if (__lhs->__move_nothrow() && !__rhs->__move_nothrow()) {
        std::swap(__lhs, __rhs);
      }
      __impl __tmp(std::move(*__rhs));
      this->__generic_construct(*__rhs, std::move(*__lhs));
      this->__generic_construct(*__lhs, std::move(__tmp));
    }
  }
private:
  inline __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  bool __move_nothrow() const {
    constexpr bool __results[] = {is_nothrow_move_constructible_v<_Types>...};
    return this->valueless_by_exception() || __results[this->index()];
  }
};
struct __no_narrowing_check {
  template <class _Dest, class _Source>
  using _Apply = __type_identity<_Dest>;
};
struct __narrowing_check {
  template <class _Dest>
  static auto __test_impl(_Dest (&&)[1]) -> __type_identity<_Dest>;
  template <class _Dest, class _Source>
  using _Apply __attribute__((__nodebug__)) = decltype(__test_impl<_Dest>({std::declval<_Source>()}));
};
template <class _Dest, class _Source>
using __check_for_narrowing __attribute__((__nodebug__)) =
  typename _If<
    is_arithmetic<_Dest>::value,
    __narrowing_check,
    __no_narrowing_check
  >::template _Apply<_Dest, _Source>;
template <class _Tp, size_t _Idx>
struct __overload {
  template <class _Up>
  auto operator()(_Tp, _Up&&) const -> __check_for_narrowing<_Tp, _Up>;
};
template <class _Tp, size_t>
struct __overload_bool {
  template <class _Up, class _Ap = __remove_cvref_t<_Up>>
  auto operator()(bool, _Up&&) const
      -> enable_if_t<is_same_v<_Ap, bool>, __type_identity<_Tp>>;
};
template <size_t _Idx>
struct __overload<bool, _Idx> : __overload_bool<bool, _Idx> {};
template <size_t _Idx>
struct __overload<bool const, _Idx> : __overload_bool<bool const, _Idx> {};
template <size_t _Idx>
struct __overload<bool volatile, _Idx> : __overload_bool<bool volatile, _Idx> {};
template <size_t _Idx>
struct __overload<bool const volatile, _Idx> : __overload_bool<bool const volatile, _Idx> {};
template <class ..._Bases>
struct __all_overloads : _Bases... {
  void operator()() const;
  using _Bases::operator()...;
};
template <class _IdxSeq>
struct __make_overloads_imp;
template <size_t ..._Idx>
struct __make_overloads_imp<__tuple_indices<_Idx...> > {
  template <class ..._Types>
  using _Apply __attribute__((__nodebug__)) = __all_overloads<__overload<_Types, _Idx>...>;
};
template <class ..._Types>
using _MakeOverloads __attribute__((__nodebug__)) = typename __make_overloads_imp<
    __make_indices_imp<sizeof...(_Types), 0> >::template _Apply<_Types...>;
template <class _Tp, class... _Types>
using __best_match_t =
    typename invoke_result_t<_MakeOverloads<_Types...>, _Tp, _Tp>::type;
}
template <class... _Types>
class __declspec(empty_bases) variant
    : private __sfinae_ctor_base<
          __all<is_copy_constructible_v<_Types>...>::value,
          __all<is_move_constructible_v<_Types>...>::value>,
      private __sfinae_assign_base<
          __all<(is_copy_constructible_v<_Types> &&
                 is_copy_assignable_v<_Types>)...>::value,
          __all<(is_move_constructible_v<_Types> &&
                 is_move_assignable_v<_Types>)...>::value> {
  static_assert(0 < sizeof...(_Types),
                "variant must consist of at least one alternative.");
  static_assert(__all<!is_array_v<_Types>...>::value,
                "variant can not have an array type as an alternative.");
  static_assert(__all<!is_reference_v<_Types>...>::value,
                "variant can not have a reference type as an alternative.");
  static_assert(__all<!is_void_v<_Types>...>::value,
                "variant can not have a void type as an alternative.");
  using __first_type = variant_alternative_t<0, variant>;
public:
  template <bool _Dummy = true,
            enable_if_t<__dependent_type<is_default_constructible<__first_type>,
                                         _Dummy>::value,
                        int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr variant() noexcept(is_nothrow_default_constructible_v<__first_type>)
      : __impl_(in_place_index<0>) {}
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr variant(const variant&) = default;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr variant(variant&&) = default;
  template <
      class _Arg,
      enable_if_t<!is_same_v<__remove_cvref_t<_Arg>, variant>, int> = 0,
      enable_if_t<!__is_inplace_type<__remove_cvref_t<_Arg>>::value, int> = 0,
      enable_if_t<!__is_inplace_index<__remove_cvref_t<_Arg>>::value, int> = 0,
      class _Tp = __variant_detail::__best_match_t<_Arg, _Types...>,
      size_t _Ip =
          __find_detail::__find_unambiguous_index_sfinae<_Tp, _Types...>::value,
      enable_if_t<is_constructible_v<_Tp, _Arg>, int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr variant(_Arg&& __arg) noexcept(
      is_nothrow_constructible_v<_Tp, _Arg>)
      : __impl_(in_place_index<_Ip>, std::forward<_Arg>(__arg)) {}
  template <size_t _Ip, class... _Args,
            class = enable_if_t<(_Ip < sizeof...(_Types)), int>,
            class _Tp = variant_alternative_t<_Ip, variant<_Types...>>,
            enable_if_t<is_constructible_v<_Tp, _Args...>, int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr variant(
      in_place_index_t<_Ip>,
      _Args&&... __args) noexcept(is_nothrow_constructible_v<_Tp, _Args...>)
      : __impl_(in_place_index<_Ip>, std::forward<_Args>(__args)...) {}
  template <
      size_t _Ip,
      class _Up,
      class... _Args,
      enable_if_t<(_Ip < sizeof...(_Types)), int> = 0,
      class _Tp = variant_alternative_t<_Ip, variant<_Types...>>,
      enable_if_t<is_constructible_v<_Tp, initializer_list<_Up>&, _Args...>,
                  int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr variant(
      in_place_index_t<_Ip>,
      initializer_list<_Up> __il,
      _Args&&... __args) noexcept(
      is_nothrow_constructible_v<_Tp, initializer_list<_Up>&, _Args...>)
      : __impl_(in_place_index<_Ip>, __il, std::forward<_Args>(__args)...) {}
  template <
      class _Tp,
      class... _Args,
      size_t _Ip =
          __find_detail::__find_unambiguous_index_sfinae<_Tp, _Types...>::value,
      enable_if_t<is_constructible_v<_Tp, _Args...>, int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr variant(in_place_type_t<_Tp>, _Args&&... __args) noexcept(
      is_nothrow_constructible_v<_Tp, _Args...>)
      : __impl_(in_place_index<_Ip>, std::forward<_Args>(__args)...) {}
  template <
      class _Tp,
      class _Up,
      class... _Args,
      size_t _Ip =
          __find_detail::__find_unambiguous_index_sfinae<_Tp, _Types...>::value,
      enable_if_t<is_constructible_v<_Tp, initializer_list<_Up>&, _Args...>,
                  int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  explicit constexpr variant(
      in_place_type_t<_Tp>,
      initializer_list<_Up> __il,
      _Args&&... __args) noexcept(
      is_nothrow_constructible_v<_Tp, initializer_list< _Up>&, _Args...>)
      : __impl_(in_place_index<_Ip>, __il, std::forward<_Args>(__args)...) {}
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) ~variant() = default;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr variant& operator=(const variant&) = default;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr variant& operator=(variant&&) = default;
  template <
      class _Arg,
      enable_if_t<!is_same_v<__remove_cvref_t<_Arg>, variant>, int> = 0,
      class _Tp = __variant_detail::__best_match_t<_Arg, _Types...>,
      size_t _Ip =
          __find_detail::__find_unambiguous_index_sfinae<_Tp, _Types...>::value,
      enable_if_t<is_assignable_v<_Tp&, _Arg> && is_constructible_v<_Tp, _Arg>,
                  int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  variant& operator=(_Arg&& __arg) noexcept(
      is_nothrow_assignable_v<_Tp&, _Arg> &&
      is_nothrow_constructible_v<_Tp, _Arg>) {
    __impl_.template __assign<_Ip>(std::forward<_Arg>(__arg));
    return *this;
  }
  template <
      size_t _Ip,
      class... _Args,
      enable_if_t<(_Ip < sizeof...(_Types)), int> = 0,
      class _Tp = variant_alternative_t<_Ip, variant<_Types...>>,
      enable_if_t<is_constructible_v<_Tp, _Args...>, int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  _Tp& emplace(_Args&&... __args) {
    return __impl_.template __emplace<_Ip>(std::forward<_Args>(__args)...);
  }
  template <
      size_t _Ip,
      class _Up,
      class... _Args,
      enable_if_t<(_Ip < sizeof...(_Types)), int> = 0,
      class _Tp = variant_alternative_t<_Ip, variant<_Types...>>,
      enable_if_t<is_constructible_v<_Tp, initializer_list<_Up>&, _Args...>,
                  int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  _Tp& emplace(initializer_list<_Up> __il, _Args&&... __args) {
    return __impl_.template __emplace<_Ip>(__il, std::forward<_Args>(__args)...);
  }
  template <
      class _Tp,
      class... _Args,
      size_t _Ip =
          __find_detail::__find_unambiguous_index_sfinae<_Tp, _Types...>::value,
      enable_if_t<is_constructible_v<_Tp, _Args...>, int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  _Tp& emplace(_Args&&... __args) {
    return __impl_.template __emplace<_Ip>(std::forward<_Args>(__args)...);
  }
  template <
      class _Tp,
      class _Up,
      class... _Args,
      size_t _Ip =
          __find_detail::__find_unambiguous_index_sfinae<_Tp, _Types...>::value,
      enable_if_t<is_constructible_v<_Tp, initializer_list<_Up>&, _Args...>,
                  int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  _Tp& emplace(initializer_list<_Up> __il, _Args&&... __args) {
    return __impl_.template __emplace<_Ip>(__il, std::forward<_Args>(__args)...);
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr bool valueless_by_exception() const noexcept {
    return __impl_.valueless_by_exception();
  }
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr size_t index() const noexcept { return __impl_.index(); }
  template <
      bool _Dummy = true,
      enable_if_t<
          __all<(
              __dependent_type<is_move_constructible<_Types>, _Dummy>::value &&
              __dependent_type<is_swappable<_Types>, _Dummy>::value)...>::value,
          int> = 0>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  void swap(variant& __that) noexcept(
      __all<(is_nothrow_move_constructible_v<_Types> &&
             is_nothrow_swappable_v<_Types>)...>::value) {
    __impl_.__swap(__that.__impl_);
  }
private:
  __variant_detail::__impl<_Types...> __impl_;
  friend struct __variant_detail::__access::__variant;
  friend struct __variant_detail::__visitation::__variant;
};
template <size_t _Ip, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr bool __holds_alternative(const variant<_Types...>& __v) noexcept {
  return __v.index() == _Ip;
}
template <class _Tp, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr bool holds_alternative(const variant<_Types...>& __v) noexcept {
  return std::__holds_alternative<__find_exactly_one_t<_Tp, _Types...>::value>(__v);
}
template <size_t _Ip, class _Vp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr auto&& __generic_get(_Vp&& __v) {
  using __variant_detail::__access::__variant;
  if (!std::__holds_alternative<_Ip>(__v)) {
    __throw_bad_variant_access();
  }
  return __variant::__get_alt<_Ip>(std::forward<_Vp>(__v)).__value;
}
template <size_t _Ip, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr variant_alternative_t<_Ip, variant<_Types...>>& get(
    variant<_Types...>& __v) {
  static_assert(_Ip < sizeof...(_Types));
  static_assert(!is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);
  return std::__generic_get<_Ip>(__v);
}
template <size_t _Ip, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr variant_alternative_t<_Ip, variant<_Types...>>&& get(
    variant<_Types...>&& __v) {
  static_assert(_Ip < sizeof...(_Types));
  static_assert(!is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);
  return std::__generic_get<_Ip>(std::move(__v));
}
template <size_t _Ip, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr const variant_alternative_t<_Ip, variant<_Types...>>& get(
    const variant<_Types...>& __v) {
  static_assert(_Ip < sizeof...(_Types));
  static_assert(!is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);
  return std::__generic_get<_Ip>(__v);
}
template <size_t _Ip, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr const variant_alternative_t<_Ip, variant<_Types...>>&& get(
    const variant<_Types...>&& __v) {
  static_assert(_Ip < sizeof...(_Types));
  static_assert(!is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);
  return std::__generic_get<_Ip>(std::move(__v));
}
template <class _Tp, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _Tp& get(variant<_Types...>& __v) {
  static_assert(!is_void_v<_Tp>);
  return std::get<__find_exactly_one_t<_Tp, _Types...>::value>(__v);
}
template <class _Tp, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _Tp&& get(variant<_Types...>&& __v) {
  static_assert(!is_void_v<_Tp>);
  return std::get<__find_exactly_one_t<_Tp, _Types...>::value>(
      std::move(__v));
}
template <class _Tp, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr const _Tp& get(const variant<_Types...>& __v) {
  static_assert(!is_void_v<_Tp>);
  return std::get<__find_exactly_one_t<_Tp, _Types...>::value>(__v);
}
template <class _Tp, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr const _Tp&& get(const variant<_Types...>&& __v) {
  static_assert(!is_void_v<_Tp>);
  return std::get<__find_exactly_one_t<_Tp, _Types...>::value>(
      std::move(__v));
}
template <size_t _Ip, class _Vp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr auto* __generic_get_if(_Vp* __v) noexcept {
  using __variant_detail::__access::__variant;
  return __v && std::__holds_alternative<_Ip>(*__v)
             ? std::addressof(__variant::__get_alt<_Ip>(*__v).__value)
             : nullptr;
}
template <size_t _Ip, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr add_pointer_t<variant_alternative_t<_Ip, variant<_Types...>>>
get_if(variant<_Types...>* __v) noexcept {
  static_assert(_Ip < sizeof...(_Types));
  static_assert(!is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);
  return std::__generic_get_if<_Ip>(__v);
}
template <size_t _Ip, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr add_pointer_t<const variant_alternative_t<_Ip, variant<_Types...>>>
get_if(const variant<_Types...>* __v) noexcept {
  static_assert(_Ip < sizeof...(_Types));
  static_assert(!is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);
  return std::__generic_get_if<_Ip>(__v);
}
template <class _Tp, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr add_pointer_t<_Tp>
get_if(variant<_Types...>* __v) noexcept {
  static_assert(!is_void_v<_Tp>);
  return std::get_if<__find_exactly_one_t<_Tp, _Types...>::value>(__v);
}
template <class _Tp, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr add_pointer_t<const _Tp>
get_if(const variant<_Types...>* __v) noexcept {
  static_assert(!is_void_v<_Tp>);
  return std::get_if<__find_exactly_one_t<_Tp, _Types...>::value>(__v);
}
template <class _Operator>
struct __convert_to_bool {
  template <class _T1, class _T2>
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  constexpr bool operator()(_T1 && __t1, _T2&& __t2) const {
    static_assert(is_convertible<decltype(_Operator{}(std::forward<_T1>(__t1), std::forward<_T2>(__t2))), bool>::value,
        "the relational operator does not return a type which is implicitly convertible to bool");
    return _Operator{}(std::forward<_T1>(__t1), std::forward<_T2>(__t2));
  }
};
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr bool operator==(const variant<_Types...>& __lhs,
                          const variant<_Types...>& __rhs) {
  using __variant_detail::__visitation::__variant;
  if (__lhs.index() != __rhs.index()) return false;
  if (__lhs.valueless_by_exception()) return true;
  return __variant::__visit_value_at(__lhs.index(), __convert_to_bool<equal_to<>>{}, __lhs, __rhs);
}
template <class... _Types> requires (three_way_comparable<_Types> && ...)
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000"))) constexpr common_comparison_category_t<compare_three_way_result_t<_Types>...>
operator<=>(const variant<_Types...>& __lhs, const variant<_Types...>& __rhs) {
  using __variant_detail::__visitation::__variant;
  using __result_t = common_comparison_category_t<compare_three_way_result_t<_Types>...>;
  if (__lhs.valueless_by_exception() && __rhs.valueless_by_exception())
    return strong_ordering::equal;
  if (__lhs.valueless_by_exception())
    return strong_ordering::less;
  if (__rhs.valueless_by_exception())
    return strong_ordering::greater;
  if (auto __c = __lhs.index() <=> __rhs.index(); __c != 0)
    return __c;
  auto __three_way = []<class _Type>(const _Type& __v, const _Type& __w) -> __result_t { return __v <=> __w; };
  return __variant::__visit_value_at(__lhs.index(), __three_way, __lhs, __rhs);
}
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr bool operator!=(const variant<_Types...>& __lhs,
                          const variant<_Types...>& __rhs) {
  using __variant_detail::__visitation::__variant;
  if (__lhs.index() != __rhs.index()) return true;
  if (__lhs.valueless_by_exception()) return false;
  return __variant::__visit_value_at(
      __lhs.index(), __convert_to_bool<not_equal_to<>>{}, __lhs, __rhs);
}
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr bool operator<(const variant<_Types...>& __lhs,
                         const variant<_Types...>& __rhs) {
  using __variant_detail::__visitation::__variant;
  if (__rhs.valueless_by_exception()) return false;
  if (__lhs.valueless_by_exception()) return true;
  if (__lhs.index() < __rhs.index()) return true;
  if (__lhs.index() > __rhs.index()) return false;
  return __variant::__visit_value_at(__lhs.index(), __convert_to_bool<less<>>{}, __lhs, __rhs);
}
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr bool operator>(const variant<_Types...>& __lhs,
                         const variant<_Types...>& __rhs) {
  using __variant_detail::__visitation::__variant;
  if (__lhs.valueless_by_exception()) return false;
  if (__rhs.valueless_by_exception()) return true;
  if (__lhs.index() > __rhs.index()) return true;
  if (__lhs.index() < __rhs.index()) return false;
  return __variant::__visit_value_at(__lhs.index(), __convert_to_bool<greater<>>{}, __lhs, __rhs);
}
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr bool operator<=(const variant<_Types...>& __lhs,
                          const variant<_Types...>& __rhs) {
  using __variant_detail::__visitation::__variant;
  if (__lhs.valueless_by_exception()) return true;
  if (__rhs.valueless_by_exception()) return false;
  if (__lhs.index() < __rhs.index()) return true;
  if (__lhs.index() > __rhs.index()) return false;
  return __variant::__visit_value_at(
      __lhs.index(), __convert_to_bool<less_equal<>>{}, __lhs, __rhs);
}
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr bool operator>=(const variant<_Types...>& __lhs,
                          const variant<_Types...>& __rhs) {
  using __variant_detail::__visitation::__variant;
  if (__rhs.valueless_by_exception()) return true;
  if (__lhs.valueless_by_exception()) return false;
  if (__lhs.index() > __rhs.index()) return true;
  if (__lhs.index() < __rhs.index()) return false;
  return __variant::__visit_value_at(
      __lhs.index(), __convert_to_bool<greater_equal<>>{}, __lhs, __rhs);
}
template <class... _Vs>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr void __throw_if_valueless(_Vs&&... __vs) {
  const bool __valueless =
      (... || std::__as_variant(__vs).valueless_by_exception());
  if (__valueless) {
    __throw_bad_variant_access();
  }
}
template <
    class _Visitor, class... _Vs,
    typename = void_t<decltype(std::__as_variant(std::declval<_Vs>()))...> >
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr decltype(auto) visit(_Visitor&& __visitor, _Vs&&... __vs) {
  using __variant_detail::__visitation::__variant;
  std::__throw_if_valueless(std::forward<_Vs>(__vs)...);
  return __variant::__visit_value(std::forward<_Visitor>(__visitor),
                                  std::forward<_Vs>(__vs)...);
}
template <
    class _Rp, class _Visitor, class... _Vs,
    typename = void_t<decltype(std::__as_variant(std::declval<_Vs>()))...> >
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr _Rp visit(_Visitor&& __visitor, _Vs&&... __vs) {
  using __variant_detail::__visitation::__variant;
  std::__throw_if_valueless(std::forward<_Vs>(__vs)...);
  return __variant::__visit_value<_Rp>(std::forward<_Visitor>(__visitor),
                                       std::forward<_Vs>(__vs)...);
}
template <class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
auto swap(variant<_Types...>& __lhs, variant<_Types...>& __rhs)
  noexcept(noexcept(__lhs.swap(__rhs)))
  -> decltype( __lhs.swap(__rhs))
  { return __lhs.swap(__rhs); }
template <class... _Types>
struct hash<
    __enable_hash_helper<variant<_Types...>, remove_const_t<_Types>...>> {
  using argument_type = variant<_Types...>;
  using result_type = size_t;
  __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
  result_type operator()(const argument_type& __v) const {
    using __variant_detail::__visitation::__variant;
    size_t __res =
        __v.valueless_by_exception()
               ? 299792458
               : __variant::__visit_alt(
                     [](const auto& __alt) {
                       using __alt_type = __remove_cvref_t<decltype(__alt)>;
                       using __value_type = remove_const_t<
                         typename __alt_type::__value_type>;
                       return hash<__value_type>{}(__alt.__value);
                     },
                     __v);
    return std::__hash_combine(__res, hash<size_t>{}(__v.index()));
  }
};
template <size_t _Ip, class _Vp>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr auto&& __unchecked_get(_Vp&& __v) noexcept {
  using __variant_detail::__access::__variant;
  return __variant::__get_alt<_Ip>(std::forward<_Vp>(__v)).__value;
}
template <class _Tp, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr auto&& __unchecked_get(const variant<_Types...>& __v) noexcept {
  return std::__unchecked_get<__find_exactly_one_t<_Tp, _Types...>::value>(__v);
}
template <class _Tp, class... _Types>
 __attribute__((__exclude_from_explicit_instantiation__)) __attribute__((__abi_tag__("v170000")))
constexpr auto&& __unchecked_get(variant<_Types...>& __v) noexcept {
  return std::__unchecked_get<__find_exactly_one_t<_Tp, _Types...>::value>(__v);
}
}}
struct foo {
 ~foo() {}
};
int main() {
 std::variant<foo> v;
}
